/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Substitute the type names.  */
#define YYSTYPE         LUXCORE_PARSERLXS_YYSTYPE
/* Substitute the variable and function names.  */
#define yyparse         luxcore_parserlxs_yyparse
#define yylex           luxcore_parserlxs_yylex
#define yyerror         luxcore_parserlxs_yyerror
#define yydebug         luxcore_parserlxs_yydebug
#define yynerrs         luxcore_parserlxs_yynerrs
#define yylval          luxcore_parserlxs_yylval
#define yychar          luxcore_parserlxs_yychar

/* First part of user prologue.  */
#line 22 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"


#include <stdarg.h>
#include <sstream>
#include <vector>

#include <boost/foreach.hpp>
#include <boost/algorithm/string/replace.hpp>
	
#include "luxcore/luxcore.h"
#include "luxcore/luxcoreimpl.h"

using namespace std;
using namespace luxrays;
using namespace luxcore;

namespace luxcore { namespace parselxs {

Properties *renderConfigProps = NULL;
Properties *sceneProps = NULL;

Properties overwriteProps;
Transform worldToCamera;

static string GetLuxCoreValidName(const string &name) {
	string validName = name;

	// Replace any "." in the name with 2x"__"
	boost::replace_all(validName, ".", "__");

	return validName;
}

// This is a copy of slg::FresnelPreset() but with different behavior when the
// preset is unknown.
void FresnelPreset(const string &presetName, Spectrum *eta, Spectrum *k) {
	if (presetName == "amorphous carbon") {
		*eta = Spectrum(2.94553471f, 2.22816062f, 1.98665321f);
		*k = Spectrum(.876640677f, .799504995f, .821194172f);
	} else if (presetName == "silver") {
		*eta = Spectrum(.155706137f, .115924977f, .138897374f);
		*k = Spectrum(4.88647795f, 3.12787175f, 2.17797375f);
	} else if (presetName == "gold") {
		*eta = Spectrum(.117958963f, .354153246f, 1.4389739f);
		*k = Spectrum(4.03164577f, 2.39416027f, 1.61966884f);
	} else if (presetName == "copper") {
		*eta = Spectrum(.134794354f, .928983212f, 1.10887861f);
		*k = Spectrum(3.98125982f, 2.440979f, 2.16473627f);
	} else if (presetName == "aluminium") {
		*eta = Spectrum(.69700277f, .879832864f, .5301736f);
		*k = Spectrum(9.30200672f, 6.27604008f, 4.89433956f);
	} else {
		LC_LOG("Unknown metal type '" << presetName << "'. Using default (aluminium).");

		*eta = Spectrum(.69700277f, .879832864f, .5301736f);
		*k = Spectrum(9.30200672f, 6.27604008f, 4.89433956f);
	}
}

//------------------------------------------------------------------------------
// RenderOptions
//------------------------------------------------------------------------------

class GraphicsState {
public:
	GraphicsState() {
		areaLightName = "";
		materialName = "";
		interiorVolumeName = "";
		exteriorVolumeName = "";
		currentLightGroup = 0;
	}
	~GraphicsState() {
	}

	string areaLightName, materialName, interiorVolumeName, exteriorVolumeName;
	Properties areaLightProps, materialProps, interiorVolumeProps, exteriorVolumeProps;

	u_int currentLightGroup;
};

// The GraphicsState stack
static vector<GraphicsState> graphicsStatesStack;
static GraphicsState currentGraphicsState;
// The transformations stack
static vector<Transform> transformsStack;
static Transform currentTransform;
// The named coordinate systems
static boost::unordered_map<string, Transform> namedCoordinateSystems;
// The light groups
static u_int freeLightGroupIndex;
static boost::unordered_map<string, u_int> namedLightGroups;
// The named Materials
static boost::unordered_map<string, Properties> namedMaterials;
// The named Volumes
static boost::unordered_map<string, Properties> namedVolumes;
// The named Textures
static boost::unordered_set<string> namedTextures;
// The named Object
static boost::unordered_map<string, vector<string> > namedObjectShapes;
static boost::unordered_map<string, vector<string> > namedObjectMaterials;
static boost::unordered_map<string, vector<Transform> > namedObjectTransforms;
static string currentObjectName;
static u_int freeObjectID, freeLightID;

void ResetParser() {
	overwriteProps.Clear();

	*renderConfigProps <<
			Property("opencl.platform.index")(-1) <<
			Property("opencl.cpu.use")(false) <<
			Property("opencl.gpu.use")(true) <<
			Property("renderengine.type")("PATHOCL") <<
			Property("sampler.type")("RANDOM") <<
			Property("film.filter.type")("BLACKMANHARRIS") <<
			Property("accelerator.instances.enable")(false);

	graphicsStatesStack.clear();
	currentGraphicsState = GraphicsState();
	transformsStack.clear();
	currentTransform = Transform();

	namedCoordinateSystems.clear();
	freeLightGroupIndex = 1;
	namedLightGroups.clear();
	namedMaterials.clear();
	namedVolumes.clear();
	namedTextures.clear();
	namedObjectShapes.clear();
	namedObjectMaterials.clear();
	namedObjectTransforms.clear();
	currentObjectName = "";
	freeObjectID = 0;
	freeLightID = 0;
}

static Properties GetTextureMapping2D(const string &prefix, const Properties &props) {
	const string type = props.Get(Property("mapping")("uv")).Get<string>();
	
	if (type == "uv") {
		return Property(prefix + ".mapping.type")("uvmapping2d") <<
				Property(prefix + ".mapping.uvscale")(props.Get(Property("uscale")(1.f)).Get<float>(),
					props.Get(Property("vscale")(1.f)).Get<float>()) <<
				Property(prefix + ".mapping.uvdelta")(props.Get(Property("udelta")(0.f)).Get<float>(),
					props.Get(Property("udelta")(0.f)).Get<float>());
	} else {
		LC_LOG("LuxCore supports only texture coordinate mapping 2D with 'uv' (i.e. not " << type << "). Ignoring the mapping.");
		return Properties();
	}
}

static Properties GetTextureMapping3D(const string &prefix, const Transform &tex2World, const Properties &props) {
	const string type = props.Get(Property("coordinates")("uv")).Get<string>();

	if (type == "uv") {
		return Property(prefix + ".mapping.type")("uvmapping3d") <<
				Property(prefix + ".mapping.transformation")(tex2World.mInv);
	} else if (type == "global") {
		return Property(prefix + ".mapping.type")("globalmapping3d") <<
				Property(prefix + ".mapping.transformation")(tex2World.mInv);
	} else {
		LC_LOG("LuxCore supports only texture coordinate mapping 3D with 'uv' and 'global' (i.e. not " << type << "). Ignoring the mapping.");
		return Properties();
	}
}

static Property GetTexture(const string &luxCoreName, const Property defaultProp, const Properties &props) {
	Property prop = props.Get(defaultProp);
	if (prop.GetValueType(0) == PropertyValue::STRING_VAL) {
		// It is a texture name
		string texName = GetLuxCoreValidName(prop.Get<string>());

		return Property(luxCoreName)(texName);
	} else
		return prop.Renamed(luxCoreName);
}

static void DefineMaterial(const string &name, const Properties &matProps,
		const Properties &lightProps,
		const string &interiorVolumeName, const string &exteriorVolumeName) {
	const string prefix = "scene.materials." + name;

	//--------------------------------------------------------------------------
	// Material definition
	//--------------------------------------------------------------------------

	const string type = matProps.Get(Property("type")("matte")).Get<string>();
	if (type == "matte") {
		if (matProps.IsDefined("sigma")) {
			*sceneProps <<
				Property(prefix + ".type")("roughmatte") <<
				GetTexture(prefix + ".kd", Property("Kd")(Spectrum(.9f)), matProps) <<
				GetTexture(prefix + ".sigma", Property("sigma")(0.f), matProps);
		} else {
			*sceneProps <<
				Property(prefix + ".type")("matte") <<
				GetTexture(prefix + ".kd", Property("Kd")(Spectrum(.9f)), matProps);
		}
	} else if (type == "mirror") {
		*sceneProps <<
				Property(prefix + ".type")("mirror") <<
				GetTexture(prefix + ".kr", Property("Kr")(Spectrum(1.f)), matProps);
	} else if (type == "glass") {
		const bool isArchitectural = matProps.Get(Property("architectural")(false)).Get<bool>();

		*sceneProps <<
				Property(prefix + ".type")(isArchitectural ? "archglass" : "glass") <<
				GetTexture(prefix + ".kr", Property("Kr")(Spectrum(1.f)), matProps) <<
				GetTexture(prefix + ".kt", Property("Kt")(Spectrum(1.f)), matProps) <<
				Property(prefix +".ioroutside")(1.f) <<
				GetTexture(prefix + ".iorinside", Property("index")(1.5f), matProps);
	} else if (type == "metal") {
		string presetName = matProps.Get("name").Get<string>();
		Spectrum n, k;
		FresnelPreset(presetName, &n, &k);

		*sceneProps <<
				Property(prefix + ".type")("metal2") <<
				Property(prefix + ".n")(n) <<
				Property(prefix + ".k")(k) <<
				GetTexture(prefix + ".uroughness", Property("uroughness")(.1f), matProps) <<
				GetTexture(prefix + ".vroughness", Property("vroughness")(.1f), matProps);
	} else if (type == "mattetranslucent") {
		if (matProps.Get(Property("energyconserving")(false)).Get<bool>() == false)
			LC_LOG("Mattetranslucent with energyconserving=false is not supported, using energyconservin.");
		if (matProps.IsDefined("sigma")) {
			*sceneProps <<
				Property(prefix + ".type")("roughmattetranslucent") <<
				GetTexture(prefix + ".kr", Property("Kr")(Spectrum(.9f)), matProps) <<
				GetTexture(prefix + ".kt", Property("Kt")(Spectrum(1.f)), matProps) <<
				GetTexture(prefix + ".sigma", Property("sigma")(0.f), matProps);
		} else {
			*sceneProps <<
				Property(prefix + ".type")("mattetranslucent") <<
				GetTexture(prefix + ".kr", Property("Kr")(Spectrum(1.f)), matProps) <<
				GetTexture(prefix + ".kt", Property("Kt")(Spectrum(1.f)), matProps);
		}
	} else if (type == "null") {
		*sceneProps <<
				Property(prefix + ".type")("null");
	} else if (type == "mix") {
		*sceneProps <<
				Property(prefix + ".type")("mix") <<
				GetTexture(prefix + ".amount", Property("amount")(.5f), matProps) <<
				Property(prefix + ".material1")(GetLuxCoreValidName(matProps.Get(Property("namedmaterial1")("")).Get<string>())) <<
				Property(prefix + ".material2")(GetLuxCoreValidName(matProps.Get(Property("namedmaterial2")("")).Get<string>()));
	} else if (type == "glossy") {
		if (matProps.Get(Property("separable")(true)).Get<bool>()) {
			if (matProps.IsDefined("sigma")) {
				*sceneProps <<
					Property(prefix + "~~base.type")("roughmatte") <<
					GetTexture(prefix + "~~base.kd", Property("Kd")(Spectrum(.9f)), matProps) <<
					GetTexture(prefix + "~~base.sigma", Property("sigma")(0.f), matProps);
			} else {
				*sceneProps <<
					Property(prefix + "~~base.type")("matte") <<
					GetTexture(prefix + "~~base.kd", Property("Kd")(Spectrum(.9f)), matProps);
			}
			*sceneProps <<
					Property(prefix + ".type")("glossycoating") <<
					Property(prefix + ".base")(name + "~~base") <<
					GetTexture(prefix + ".ks", Property("Ks")(.5f), matProps) <<
					GetTexture(prefix + ".ka", Property("Ka")(0.f), matProps) <<
					GetTexture(prefix + ".uroughness", Property("uroughness")(.1f), matProps) <<
					GetTexture(prefix + ".vroughness", Property("vroughness")(.1f), matProps) <<
					GetTexture(prefix + ".d", Property("d")(0.f), matProps) <<
					GetTexture(prefix + ".index", Property("index")(0.f), matProps) <<
					Property(prefix +".multibounce")(matProps.Get(Property("multibounce")(false)).Get<bool>());
		} else {
			*sceneProps <<
					Property(prefix + ".type")("glossy2") <<
					GetTexture(prefix + ".kd", Property("Kd")(.5f), matProps) <<
					GetTexture(prefix + ".ks", Property("Ks")(.5f), matProps) <<
					GetTexture(prefix + ".ka", Property("Ka")(0.f), matProps) <<
					GetTexture(prefix + ".uroughness", Property("uroughness")(.1f), matProps) <<
					GetTexture(prefix + ".vroughness", Property("vroughness")(.1f), matProps) <<
					GetTexture(prefix + ".d", Property("d")(0.f), matProps) <<
					GetTexture(prefix + ".index", Property("index")(0.f), matProps) <<
					Property(prefix +".multibounce")(matProps.Get(Property("multibounce")(false)).Get<bool>());
		}
	} else if (type == "metal2") {
		const string fresnelTexName = GetLuxCoreValidName(matProps.Get(Property("fresnel")("")).Get<string>());
		if (fresnelTexName == "") {
			const string texPrefix = "scene.textures." + name;
			*sceneProps <<
					Property(texPrefix + "_LUXCORE_PARSERLXS_fresnelapproxn.type")("fresnelapproxn") <<
					GetTexture(texPrefix + "_LUXCORE_PARSERLXS_fresnelapproxn.texture", Property("Kr")(Spectrum(.5f)), matProps) <<
					Property(texPrefix + "_LUXCORE_PARSERLXS_fresnelapproxk.type")("fresnelapproxk") <<
					GetTexture(texPrefix + "_LUXCORE_PARSERLXS_fresnelapproxk.texture", Property("Kr")(Spectrum(.5f)), matProps);
					Property(prefix + ".type")("metal2") <<
					Property(prefix + ".n")(fresnelTexName + "_LUXCORE_PARSERLXS_fresnelapproxn") <<
					Property(prefix + ".k")(fresnelTexName + "_LUXCORE_PARSERLXS_fresnelapproxk");
		} else {
			*sceneProps <<
					Property(prefix + ".type")("metal2") <<
					Property(prefix + ".fresnel")(fresnelTexName);
		}

		*sceneProps <<
				GetTexture(prefix + ".uroughness", Property("uroughness")(.1f), matProps) <<
				GetTexture(prefix + ".vroughness", Property("vroughness")(.1f), matProps);
	} else if (type == "roughglass") {
		*sceneProps <<
				Property(prefix + ".type")("roughglass") <<
				GetTexture(prefix + ".kr", Property("Kr")(Spectrum(1.f)), matProps) <<
				GetTexture(prefix + ".kt", Property("Kt")(Spectrum(1.f)), matProps) <<
				Property(prefix +".ioroutside")(1.f) <<
				GetTexture(prefix + ".iorinside", Property("index")(1.5f), matProps) <<
				GetTexture(prefix + ".uroughness", Property("uroughness")(.1f), matProps) <<
				GetTexture(prefix + ".vroughness", Property("vroughness")(.1f), matProps);
	} else if (type == "velvet") {
		*sceneProps <<
				Property(prefix + ".type")("velvet") <<
				GetTexture(prefix + ".kd", Property("Kd")(Spectrum(1.f)), matProps) <<
				GetTexture(prefix + ".p1", Property("p1")(2.0f), matProps) <<
				GetTexture(prefix + ".p2", Property("p2")(20.0f), matProps) <<
				GetTexture(prefix + ".p3", Property("p3")(-2.0f), matProps);
				GetTexture(prefix + ".thickness", Property("thickness")(.1f), matProps);
	} else if (type == "cloth") {
		*sceneProps <<
				Property(prefix + ".type")("cloth") <<
				Property(prefix + ".preset")(matProps.Get("presetname").Get<string>()) <<
				GetTexture(prefix + ".weft_kd", Property("weft_kd")(Spectrum(.5f)), matProps) <<
				GetTexture(prefix + ".weft_ks", Property("weft_ks")(Spectrum(.5f)), matProps) <<
				GetTexture(prefix + ".warp_kd", Property("weft_kd")(Spectrum(.5f)), matProps) <<
				GetTexture(prefix + ".warp_ks", Property("weft_ks")(Spectrum(.5f)), matProps) <<
				Property(prefix + ".repeat_u")(matProps.Get(Property("repeat_u")(100.f)).Get<float>()) <<
				Property(prefix + ".repeat_v")(matProps.Get(Property("repeat_v")(100.f)).Get<float>());
	} else if (type == "carpaint") {
		*sceneProps <<
				Property(prefix + ".type")("carpaint") <<
				GetTexture(prefix + ".ka", Property("Ka")(Spectrum(0.f)), matProps) <<
				GetTexture(prefix + ".d", Property("d")(0.f), matProps);
		if (matProps.IsDefined("name"))
			*sceneProps << Property(prefix + ".preset")(matProps.Get("name").Get<string>());
		if (matProps.IsDefined("Kd"))
			*sceneProps << GetTexture(prefix + ".kd", Property("Kd")(Spectrum(0.f)), matProps);
		if (matProps.IsDefined("Ks1"))
			*sceneProps << GetTexture(prefix + ".ks1", Property("Ks1")(Spectrum(0.f)), matProps);
		if (matProps.IsDefined("Ks2"))
			*sceneProps << GetTexture(prefix + ".ks2", Property("Ks2")(Spectrum(0.f)), matProps);
		if (matProps.IsDefined("Ks3"))
			*sceneProps << GetTexture(prefix + ".ks3", Property("Ks3")(Spectrum(0.f)), matProps);
		if (matProps.IsDefined("R1"))
			*sceneProps << GetTexture(prefix + ".r1", Property("R1")(0.f), matProps);
		if (matProps.IsDefined("R2"))
			*sceneProps << GetTexture(prefix + ".r2", Property("R2")(0.f), matProps);
		if (matProps.IsDefined("R3"))
			*sceneProps << GetTexture(prefix + ".r3", Property("R3")(0.f), matProps);
		if (matProps.IsDefined("M1"))
			*sceneProps << GetTexture(prefix + ".m1", Property("M1")(0.f), matProps);
		if (matProps.IsDefined("M2"))
			*sceneProps << GetTexture(prefix + ".m2", Property("M2")(0.f), matProps);
		if (matProps.IsDefined("M3"))
			*sceneProps << GetTexture(prefix + ".m3", Property("M3")(0.f), matProps);
	} else if (type == "glossytranslucent") {
		*sceneProps <<
				Property(prefix + ".type")("glossytranslucent") <<
				GetTexture(prefix + ".kd", Property("Kd")(.5f), matProps) <<
				GetTexture(prefix + ".kt", Property("Kt")(.5f), matProps) <<
				GetTexture(prefix + ".ks", Property("Ks")(.5f), matProps) <<
				GetTexture(prefix + ".ka", Property("Ka")(0.f), matProps) <<
				GetTexture(prefix + ".uroughness", Property("uroughness")(.1f), matProps) <<
				GetTexture(prefix + ".vroughness", Property("vroughness")(.1f), matProps) <<
				GetTexture(prefix + ".d", Property("d")(0.f), matProps) <<
				GetTexture(prefix + ".index", Property("index")(0.f), matProps) <<
				Property(prefix +".multibounce")(matProps.Get(Property("multibounce")(false)).Get<bool>());
		if (matProps.Get(Property("onesided")(true)).Get<bool>()) {
			*sceneProps <<
				GetTexture(prefix + ".ks_bf", Property("Ks")(.5f), matProps) <<
				GetTexture(prefix + ".ka_bf", Property("Ka")(0.f), matProps) <<
				GetTexture(prefix + ".uroughness_bf", Property("uroughness")(.1f), matProps) <<
				GetTexture(prefix + ".vroughness_bf", Property("vroughness")(.1f), matProps) <<
				GetTexture(prefix + ".d_bf", Property("d")(0.f), matProps) <<
				GetTexture(prefix + ".index_bf", Property("index")(0.f), matProps) <<
				Property(prefix +".multibounce_bf")(matProps.Get(Property("multibounce")(false)).Get<bool>());
		} else {
			*sceneProps <<
				GetTexture(prefix + ".ks_bf", Property("backface_Ks")(.5f), matProps) <<
				GetTexture(prefix + ".ka_bf", Property("backface_Ka")(0.f), matProps) <<
				GetTexture(prefix + ".uroughness_bf", Property("backface_uroughness")(.1f), matProps) <<
				GetTexture(prefix + ".vroughness_bf", Property("backface_vroughness")(.1f), matProps) <<
				GetTexture(prefix + ".d_bf", Property("backface_d")(0.f), matProps) <<
				GetTexture(prefix + ".index_bf", Property("backface_index")(0.f), matProps) <<
				Property(prefix +".multibounce_bf")(matProps.Get(Property("backface_multibounce")(false)).Get<bool>());
		}
	} else if (type == "glossycoating") {
		*sceneProps <<
				Property(prefix + ".type")("glossycoating") <<
				Property(prefix + ".base")(GetLuxCoreValidName(matProps.Get(Property("basematerial")("")).Get<string>())) <<
				GetTexture(prefix + ".ks", Property("Ks")(.5f), matProps) <<
				GetTexture(prefix + ".ka", Property("Ka")(0.f), matProps) <<
				GetTexture(prefix + ".uroughness", Property("uroughness")(.1f), matProps) <<
				GetTexture(prefix + ".vroughness", Property("vroughness")(.1f), matProps) <<
				GetTexture(prefix + ".d", Property("d")(0.f), matProps) <<
				GetTexture(prefix + ".index", Property("index")(0.f), matProps) <<
				Property(prefix +".multibounce")(matProps.Get(Property("multibounce")(false)).Get<bool>());
	} else {
		LC_LOG("LuxCore::ParserLXS supports only Matte, Mirror, Glass, Metal, MatteTranslucent, Null, "
				"Mix, Glossy2, Metal2, RoughGlass, Velvet, Cloth, Carpaint, GlossyTranslucent "
				"and GlossyCoating materials (i.e. not " <<
				type << "). Replacing an unsupported material with matte.");

		*sceneProps <<
				Property(prefix + ".type")("matte") <<
				Property(prefix + ".kd")(Spectrum(.9f));
	}

	//--------------------------------------------------------------------------
	// Material bump mapping and normal mapping definition
	//--------------------------------------------------------------------------

	if (matProps.IsDefined("bumpmap")) {
		// TODO: check the kind of texture to understand if it is a bump map or a normal map
		*sceneProps << Property(prefix + ".bumptex")(GetLuxCoreValidName(matProps.Get("bumpmap").Get<string>()));
		//*sceneProps << Property(prefix + ".normaltex")(props.Get("bumpmap").Get<string>());
	}

	//--------------------------------------------------------------------------
	// Material emission definition
	//--------------------------------------------------------------------------

	if (lightProps.GetSize() > 0) {
		*sceneProps <<
				GetTexture(prefix + ".emission", Property("L")(Spectrum(1.f)), lightProps) << 
				Property(prefix + ".emission.gain")(Spectrum(lightProps.Get(Property("gain")(1.f)).Get<float>())) <<
				Property(prefix + ".emission.power")(lightProps.Get(Property("power")(100.f)).Get<float>()) <<
				Property(prefix + ".emission.efficency")(lightProps.Get(Property("efficency")(17.f)).Get<float>()) <<
				Property(prefix + ".emission.id")(currentGraphicsState.currentLightGroup);
				
				// Only define the .emission.iesfile and .emission.mapfile props if we already have values for them.
				if (lightProps.IsDefined("iesname")) {
					*sceneProps << 
						Property(prefix + ".emission.iesfile")(lightProps.Get("iesname").Get<string>()) <<
						Property(prefix + ".emission.flipz")(lightProps.Get(Property("flipz")(false)).Get<bool>());
				}
				if (lightProps.IsDefined("mapname")) {
					*sceneProps << Property(prefix + ".emission.mapfile")(lightProps.Get("mapname").Get<string>());
				}
	}

	//--------------------------------------------------------------------------
	// Material volumes definition
	//--------------------------------------------------------------------------

	if (interiorVolumeName != "") {
		*sceneProps <<
				Property(prefix + ".volume.interior")(interiorVolumeName);
	}
	if (exteriorVolumeName != "") {
		*sceneProps <<
				Property(prefix + ".volume.exterior")(exteriorVolumeName);
	}
}

static void DefineVolume(const string &name, const Properties &volProps) {
	const string prefix = "scene.volumes." + name;

	//--------------------------------------------------------------------------
	// Volume definition
	//--------------------------------------------------------------------------

	const string type = volProps.Get(Property("type")("homogenous")).Get<string>();
	if (type == "clear") {
		*sceneProps <<
				Property(prefix + ".type")("clear") <<
				GetTexture(prefix + ".absorption", Property("absorption")(0.f, 0.f, 0.f), volProps);
	} else if (type == "homogenous") {
		*sceneProps <<
				Property(prefix + ".type")("homogenous") <<
				GetTexture(prefix + ".absorption", Property("sigma_a")(0.f, 0.f, 0.f), volProps) <<
				GetTexture(prefix + ".scattering", Property("sigma_s")(0.f, 0.f, 0.f), volProps) <<
				GetTexture(prefix + ".asymmetry", Property("g")(0.f, 0.f, 0.f), volProps);
	} else if (type == "heterogeneous") {
		*sceneProps <<
				Property(prefix + ".type")("heterogeneous") <<
				GetTexture(prefix + ".absorption", Property("sigma_a")(0.f, 0.f, 0.f), volProps) <<
				GetTexture(prefix + ".scattering", Property("sigma_s")(0.f, 0.f, 0.f), volProps) <<
				GetTexture(prefix + ".asymmetry", Property("g")(0.f, 0.f, 0.f), volProps) <<
				GetTexture(prefix + ".steps.size", Property("stepsize")(1.f), volProps);
	} else {
		LC_LOG("LuxCore::ParserLXS supports clear, homogenous "
				"and heterogeneous volumes (i.e. not " <<
				type << "). Replacing an unsupported material with a clear volume.");

		*sceneProps <<
				Property(prefix + ".type")("clear");
	}
}

u_int lineNum = 0;
string currentFile;

class ParamListElem {
public:
	ParamListElem() : token(NULL), arg(NULL), size(0), textureHelper(false)
	{ }
	const char *token;
	void *arg;
	u_int size;
	bool textureHelper;
};
u_int curParamlistAllocated = 0;
u_int curParamlistSize = 0;
ParamListElem *curParamlists = NULL;

#define CPAL curParamlistAllocated
#define CPS curParamlistSize
#define CP curParamlists
#define CPT(__n) curParamlists[(__n)].token
#define CPA(__n) curParamlists[(__n)].arg
#define CPSZ(__n) curParamlists[(__n)].size
#define CPTH(__n) curParamlists[(__n)].textureHelper

class ParamArray {
public:
	ParamArray() : elementSize(0), allocated(0), nelems(0), array(NULL) { }
	u_int elementSize;
	u_int allocated;
	u_int nelems;
	void *array;
};

ParamArray *curArray = NULL;
bool arrayIsSingleString = false;

#define NA(r) ((float *) r->array)
#define SA(r) ((const char **) r->array)

void AddArrayElement(void *elem)
{
	if (curArray->nelems >= curArray->allocated) {
		curArray->allocated = 2 * curArray->allocated + 1;
		curArray->array = realloc(curArray->array,
			curArray->allocated * curArray->elementSize);
	}
	char *next = static_cast<char *>(curArray->array) +
		curArray->nelems * curArray->elementSize;
	memcpy(next, elem, curArray->elementSize);
	curArray->nelems++;
}

ParamArray *ArrayDup(ParamArray *ra)
{
	ParamArray *ret = new ParamArray;
	ret->elementSize = ra->elementSize;
	ret->allocated = ra->allocated;
	ret->nelems = ra->nelems;
	ret->array = malloc(ra->nelems * ra->elementSize);
	memcpy(ret->array, ra->array, ra->nelems * ra->elementSize);
	return ret;
}

void ArrayFree(ParamArray *ra)
{
	free(ra->array);
	delete ra;
}

void FreeArgs()
{
	for (u_int i = 0; i < CPS; ++i) {
		// NOTE - Ratow - freeing up strings inside string type args
		if (memcmp("string", CPT(i), 6) == 0 ||
			memcmp("texture", CPT(i), 7) == 0) {
			for (u_int j = 0; j < CPSZ(i); ++j)
				free(static_cast<char **>(CPA(i))[j]);
		}
		delete[] static_cast<char *>(CPA(i));
	}
}

static bool VerifyArrayLength(ParamArray *arr, u_int required,
	const char *command)
{
	if (arr->nelems != required) {
		LC_LOG(command << " requires a(n) "	<< required << " element array !");
		return false;
	}
	return true;
}

typedef enum {
	PARAM_TYPE_INT, PARAM_TYPE_BOOL, PARAM_TYPE_FLOAT,
	PARAM_TYPE_POINT, PARAM_TYPE_VECTOR, PARAM_TYPE_NORMAL,
	PARAM_TYPE_COLOR, PARAM_TYPE_STRING, PARAM_TYPE_TEXTURE
} ParamType;

static bool LookupType(const char *token, ParamType *type, string &name) {
	BOOST_ASSERT(token != NULL);
	*type = ParamType(0);
	const char *strp = token;
	while (*strp && isspace(*strp))
		++strp;
	if (!*strp) {
		LC_LOG("Parameter '" << token << "' doesn't have a type declaration ?!");
		name = string(token);
		return false;
	}
#define TRY_DECODING_TYPE(name, mask) \
	if (strncmp(name, strp, strlen(name)) == 0) { \
		*type = mask; strp += strlen(name); \
	}
	TRY_DECODING_TYPE("float", PARAM_TYPE_FLOAT)
	else TRY_DECODING_TYPE("integer", PARAM_TYPE_INT)
	else TRY_DECODING_TYPE("bool", PARAM_TYPE_BOOL)
	else TRY_DECODING_TYPE("point", PARAM_TYPE_POINT)
	else TRY_DECODING_TYPE("vector", PARAM_TYPE_VECTOR)
	else TRY_DECODING_TYPE("normal", PARAM_TYPE_NORMAL)
	else TRY_DECODING_TYPE("string", PARAM_TYPE_STRING)
	else TRY_DECODING_TYPE("texture", PARAM_TYPE_TEXTURE)
	else TRY_DECODING_TYPE("color", PARAM_TYPE_COLOR)
	else {
		LC_LOG("Unable to decode type for token '" << token << "'");
		name = string(token);
		return false;
	}
	while (*strp && isspace(*strp))
		++strp;
	name = string(strp);
	return true;
}

static void InitProperties(Properties &props, const u_int count, const ParamListElem *list) {
	for (u_int i = 0; i < count; ++i) {
		ParamType type;
		string name;
		if (!LookupType(list[i].token, &type, name)) {
			LC_LOG("Type of parameter '" << list[i].token << "' is unknown");
			continue;
		}
		if (list[i].textureHelper && type != PARAM_TYPE_TEXTURE &&
			type != PARAM_TYPE_STRING) {
			LC_LOG("Bad type for " << name << ". Changing it to a texture");
			type = PARAM_TYPE_TEXTURE;
		}

		Property prop(name);

		void *data = list[i].arg;
		u_int nItems = list[i].size;
		if (type == PARAM_TYPE_INT) {
			// parser doesn't handle ints, so convert from floats
			int *idata = new int[nItems];
			float *fdata = static_cast<float *>(data);
			for (u_int j = 0; j < nItems; ++j)
				idata[j] = static_cast<int>(fdata[j]);
			for (u_int j = 0; j < nItems; ++j)
				prop.Add(idata[j]);
			delete[] idata;
		} else if (type == PARAM_TYPE_BOOL) {
			// strings -> bools
			bool *bdata = new bool[nItems];
			for (u_int j = 0; j < nItems; ++j) {
				string s(*static_cast<const char **>(data));
				if (s == "true")
					bdata[j] = true;
				else if (s == "false")
					bdata[j] = false;
				else {
					LC_LOG("Value '" << s << "' unknown for boolean parameter '" << list[i].token << "'. Using 'false'");
					bdata[j] = false;
				}
			}
			for (u_int j = 0; j < nItems; ++j)
				prop.Add(bdata[j]);
			delete[] bdata;
		} else if (type == PARAM_TYPE_FLOAT) {
			const float *d = static_cast<float *>(data);
			for (u_int j = 0; j < nItems; ++j)
				prop.Add(d[j]);
		} else if (type == PARAM_TYPE_POINT) {
			const Point *d = static_cast<Point *>(data);
			for (u_int j = 0; j < nItems / 3; ++j)
				prop.Add(d[j]);
		} else if (type == PARAM_TYPE_VECTOR) {
			const Vector *d = static_cast<Vector *>(data);
			for (u_int j = 0; j < nItems / 3; ++j)
				prop.Add(d[j]);
		} else if (type == PARAM_TYPE_NORMAL) {
			const Normal *d = static_cast<Normal *>(data);
			for (u_int j = 0; j < nItems / 3; ++j)
				prop.Add(d[j]);
		} else if (type == PARAM_TYPE_COLOR) {
			const Spectrum *d = static_cast<Spectrum *>(data);
			for (u_int j = 0; j < nItems / 3; ++j)
				prop.Add(d[j]);
		} else if (type == PARAM_TYPE_STRING) {
			string *strings = new string[nItems];
			for (u_int j = 0; j < nItems; ++j)
				strings[j] = string(static_cast<const char **>(data)[j]);
			for (u_int j = 0; j < nItems; ++j)
				prop.Add(strings[j]);
			delete[] strings;
		} else if (type == PARAM_TYPE_TEXTURE) {
			if (nItems == 1) {
				string val(*static_cast<const char **>(data));
				prop.Add(val);
			} else {
				LC_LOG("Only one string allowed for 'texture' parameter " << name);
			}
		}

		props.Set(prop);
	}
}

} }

using namespace luxcore::parselxs;

//------------------------------------------------------------------------------

extern int yylex(void);

#define YYMAXDEPTH 100000000

void yyerror(const char *str)
{
	stringstream ss;
	ss << "Parsing error";
	if (currentFile != "")
		ss << " in file '" << currentFile << "'";
	if (lineNum > 0)
		ss << " at line " << lineNum;
	ss << ": " << str;
	LC_LOG(ss.str().c_str());
}

#define YYPRINT(file, type, value)  \
{ \
	if ((type) == ID || (type) == STRING) \
		fprintf((file), " %s", (value).string); \
	else if ((type) == NUM) \
		fprintf((file), " %f", (value).num); \
}


#line 818 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "luxparse.hpp"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_STRING = 3,                     /* STRING  */
  YYSYMBOL_ID = 4,                         /* ID  */
  YYSYMBOL_NUM = 5,                        /* NUM  */
  YYSYMBOL_LBRACK = 6,                     /* LBRACK  */
  YYSYMBOL_RBRACK = 7,                     /* RBRACK  */
  YYSYMBOL_ACCELERATOR = 8,                /* ACCELERATOR  */
  YYSYMBOL_AREALIGHTSOURCE = 9,            /* AREALIGHTSOURCE  */
  YYSYMBOL_ATTRIBUTEBEGIN = 10,            /* ATTRIBUTEBEGIN  */
  YYSYMBOL_ATTRIBUTEEND = 11,              /* ATTRIBUTEEND  */
  YYSYMBOL_CAMERA = 12,                    /* CAMERA  */
  YYSYMBOL_CONCATTRANSFORM = 13,           /* CONCATTRANSFORM  */
  YYSYMBOL_COORDINATESYSTEM = 14,          /* COORDINATESYSTEM  */
  YYSYMBOL_COORDSYSTRANSFORM = 15,         /* COORDSYSTRANSFORM  */
  YYSYMBOL_EXTERIOR = 16,                  /* EXTERIOR  */
  YYSYMBOL_FILM = 17,                      /* FILM  */
  YYSYMBOL_IDENTITY = 18,                  /* IDENTITY  */
  YYSYMBOL_INTERIOR = 19,                  /* INTERIOR  */
  YYSYMBOL_LIGHTSOURCE = 20,               /* LIGHTSOURCE  */
  YYSYMBOL_LOOKAT = 21,                    /* LOOKAT  */
  YYSYMBOL_MATERIAL = 22,                  /* MATERIAL  */
  YYSYMBOL_MAKENAMEDMATERIAL = 23,         /* MAKENAMEDMATERIAL  */
  YYSYMBOL_MAKENAMEDVOLUME = 24,           /* MAKENAMEDVOLUME  */
  YYSYMBOL_MOTIONBEGIN = 25,               /* MOTIONBEGIN  */
  YYSYMBOL_MOTIONEND = 26,                 /* MOTIONEND  */
  YYSYMBOL_NAMEDMATERIAL = 27,             /* NAMEDMATERIAL  */
  YYSYMBOL_OBJECTBEGIN = 28,               /* OBJECTBEGIN  */
  YYSYMBOL_OBJECTEND = 29,                 /* OBJECTEND  */
  YYSYMBOL_OBJECTINSTANCE = 30,            /* OBJECTINSTANCE  */
  YYSYMBOL_PORTALINSTANCE = 31,            /* PORTALINSTANCE  */
  YYSYMBOL_MOTIONINSTANCE = 32,            /* MOTIONINSTANCE  */
  YYSYMBOL_LIGHTGROUP = 33,                /* LIGHTGROUP  */
  YYSYMBOL_PIXELFILTER = 34,               /* PIXELFILTER  */
  YYSYMBOL_RENDERER = 35,                  /* RENDERER  */
  YYSYMBOL_REVERSEORIENTATION = 36,        /* REVERSEORIENTATION  */
  YYSYMBOL_ROTATE = 37,                    /* ROTATE  */
  YYSYMBOL_SAMPLER = 38,                   /* SAMPLER  */
  YYSYMBOL_SCALE = 39,                     /* SCALE  */
  YYSYMBOL_SEARCHPATH = 40,                /* SEARCHPATH  */
  YYSYMBOL_PORTALSHAPE = 41,               /* PORTALSHAPE  */
  YYSYMBOL_SHAPE = 42,                     /* SHAPE  */
  YYSYMBOL_SURFACEINTEGRATOR = 43,         /* SURFACEINTEGRATOR  */
  YYSYMBOL_TEXTURE = 44,                   /* TEXTURE  */
  YYSYMBOL_TRANSFORMBEGIN = 45,            /* TRANSFORMBEGIN  */
  YYSYMBOL_TRANSFORMEND = 46,              /* TRANSFORMEND  */
  YYSYMBOL_TRANSFORM = 47,                 /* TRANSFORM  */
  YYSYMBOL_TRANSLATE = 48,                 /* TRANSLATE  */
  YYSYMBOL_VOLUME = 49,                    /* VOLUME  */
  YYSYMBOL_VOLUMEINTEGRATOR = 50,          /* VOLUMEINTEGRATOR  */
  YYSYMBOL_WORLDBEGIN = 51,                /* WORLDBEGIN  */
  YYSYMBOL_WORLDEND = 52,                  /* WORLDEND  */
  YYSYMBOL_HIGH_PRECEDENCE = 53,           /* HIGH_PRECEDENCE  */
  YYSYMBOL_YYACCEPT = 54,                  /* $accept  */
  YYSYMBOL_start = 55,                     /* start  */
  YYSYMBOL_array_init = 56,                /* array_init  */
  YYSYMBOL_string_array_init = 57,         /* string_array_init  */
  YYSYMBOL_num_array_init = 58,            /* num_array_init  */
  YYSYMBOL_array = 59,                     /* array  */
  YYSYMBOL_string_array = 60,              /* string_array  */
  YYSYMBOL_real_string_array = 61,         /* real_string_array  */
  YYSYMBOL_single_element_string_array = 62, /* single_element_string_array  */
  YYSYMBOL_string_list = 63,               /* string_list  */
  YYSYMBOL_string_list_entry = 64,         /* string_list_entry  */
  YYSYMBOL_num_array = 65,                 /* num_array  */
  YYSYMBOL_real_num_array = 66,            /* real_num_array  */
  YYSYMBOL_single_element_num_array = 67,  /* single_element_num_array  */
  YYSYMBOL_num_list = 68,                  /* num_list  */
  YYSYMBOL_num_list_entry = 69,            /* num_list_entry  */
  YYSYMBOL_paramlist = 70,                 /* paramlist  */
  YYSYMBOL_paramlist_init = 71,            /* paramlist_init  */
  YYSYMBOL_paramlist_contents = 72,        /* paramlist_contents  */
  YYSYMBOL_paramlist_entry = 73,           /* paramlist_entry  */
  YYSYMBOL_ri_stmt_list = 74,              /* ri_stmt_list  */
  YYSYMBOL_ri_stmt = 75                    /* ri_stmt  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined LUXCORE_PARSERLXS_YYSTYPE_IS_TRIVIAL && LUXCORE_PARSERLXS_YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  88
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   144

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  54
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  22
/* YYNRULES -- Number of rules.  */
#define YYNRULES  73
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  156

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   308


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53
};

#if LUXCORE_PARSERLXS_YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   786,   786,   790,   798,   803,   808,   812,   817,   821,
     827,   832,   836,   839,   843,   849,   853,   858,   863,   867,
     870,   874,   880,   884,   889,   893,   896,   913,   916,   920,
     932,   939,   944,   955,   990,  1003,  1007,  1016,  1033,  1084,
    1088,  1097,  1110,  1276,  1283,  1290,  1303,  1320,  1324,  1327,
    1336,  1342,  1346,  1380,  1383,  1386,  1426,  1450,  1453,  1458,
    1484,  1489,  1492,  1618,  1622,  1648,  2029,  2033,  2042,  2056,
    2061,  2065,  2069,  2072
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if LUXCORE_PARSERLXS_YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "STRING", "ID", "NUM",
  "LBRACK", "RBRACK", "ACCELERATOR", "AREALIGHTSOURCE", "ATTRIBUTEBEGIN",
  "ATTRIBUTEEND", "CAMERA", "CONCATTRANSFORM", "COORDINATESYSTEM",
  "COORDSYSTRANSFORM", "EXTERIOR", "FILM", "IDENTITY", "INTERIOR",
  "LIGHTSOURCE", "LOOKAT", "MATERIAL", "MAKENAMEDMATERIAL",
  "MAKENAMEDVOLUME", "MOTIONBEGIN", "MOTIONEND", "NAMEDMATERIAL",
  "OBJECTBEGIN", "OBJECTEND", "OBJECTINSTANCE", "PORTALINSTANCE",
  "MOTIONINSTANCE", "LIGHTGROUP", "PIXELFILTER", "RENDERER",
  "REVERSEORIENTATION", "ROTATE", "SAMPLER", "SCALE", "SEARCHPATH",
  "PORTALSHAPE", "SHAPE", "SURFACEINTEGRATOR", "TEXTURE", "TRANSFORMBEGIN",
  "TRANSFORMEND", "TRANSFORM", "TRANSLATE", "VOLUME", "VOLUMEINTEGRATOR",
  "WORLDBEGIN", "WORLDEND", "HIGH_PRECEDENCE", "$accept", "start",
  "array_init", "string_array_init", "num_array_init", "array",
  "string_array", "real_string_array", "single_element_string_array",
  "string_list", "string_list_entry", "num_array", "real_num_array",
  "single_element_num_array", "num_list", "num_list_entry", "paramlist",
  "paramlist_init", "paramlist_contents", "paramlist_entry",
  "ri_stmt_list", "ri_stmt", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-140)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-6)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      92,     6,     8,  -140,  -140,    10,  -140,    13,    14,    15,
      16,  -140,    17,    18,    21,    19,    25,    26,  -140,  -140,
      31,    32,  -140,    33,    36,    37,    38,    39,    40,  -140,
      41,    42,    43,    44,    46,    47,    48,    49,  -140,  -140,
    -140,    50,    51,    54,  -140,  -140,    58,    92,  -140,  -140,
    -140,  -140,    53,  -140,  -140,  -140,  -140,  -140,  -140,  -140,
    -140,  -140,    55,  -140,  -140,    59,  -140,  -140,  -140,  -140,
    -140,    56,  -140,  -140,  -140,    60,  -140,    61,  -140,  -140,
    -140,  -140,    64,    53,  -140,    63,  -140,  -140,  -140,  -140,
    -140,    66,  -140,  -140,  -140,    65,  -140,  -140,  -140,    67,
    -140,  -140,  -140,    68,  -140,  -140,  -140,    69,  -140,    70,
    -140,  -140,  -140,    73,    72,  -140,  -140,  -140,  -140,    66,
      57,  -140,  -140,    76,  -140,    75,    77,  -140,  -140,  -140,
       0,  -140,  -140,  -140,  -140,  -140,  -140,  -140,  -140,    78,
    -140,  -140,  -140,    79,    82,  -140,    81,    80,  -140,  -140,
      83,  -140,  -140,    84,    85,  -140
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       0,     0,     0,    31,    32,     0,     3,     0,     0,     0,
       0,    39,     0,     0,     0,     0,     0,     0,     3,    48,
       0,     0,    51,     0,     0,     0,     0,     0,     0,    57,
       0,     0,     0,     0,     0,     0,     0,     0,    66,    67,
       3,     0,     0,     0,    72,    73,     0,     2,    28,    23,
      23,    23,     5,    34,    15,    16,    35,    36,    37,    23,
      40,    23,     0,    23,    23,     0,    47,    49,    50,    52,
      53,     0,    23,    23,    23,     0,    23,     0,    61,    23,
      23,    23,     0,     0,    68,     0,    23,    23,     1,    27,
      29,    25,    30,    33,     5,     0,    18,    38,    42,     0,
      44,    45,    23,     0,    41,    55,    56,     0,    59,     0,
      63,    62,    64,     0,     0,    71,    70,     3,    22,    25,
       5,    20,    21,     0,    46,     0,     0,    60,    23,    69,
       4,    26,     6,     8,     9,     7,    24,    17,    19,     0,
      54,    58,    65,     4,     0,    11,     0,     4,    13,    14,
       0,    10,    12,     0,     0,    43
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -140,  -140,   -37,  -140,  -140,  -140,  -140,  -140,  -140,  -140,
    -139,   -18,     4,  -140,  -140,   -87,   -49,  -140,   -56,  -140,
    -140,    24
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,    46,    52,   144,    95,   131,   132,   133,   134,   147,
     145,    53,    54,    55,   120,    96,    90,    91,   118,   119,
      47,    48
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      66,    92,    93,    83,   148,    -5,   143,   121,   152,    49,
      97,    50,    98,    51,   100,   101,    56,    57,    58,    59,
      60,    61,    63,   104,   105,   106,    62,   108,    64,    65,
     110,   111,   112,   138,    67,    68,    69,   115,   116,    70,
      71,    72,    73,    74,    84,    76,    75,    78,    77,    79,
      80,    81,    82,   124,    86,    85,   121,    87,    88,    94,
      99,   103,   102,   136,   137,   107,   109,   113,   114,   117,
     122,    89,   123,   125,   126,   127,   128,   129,   140,   142,
     130,   139,   141,   146,    -5,   149,   150,   151,   153,   154,
     155,     0,     0,     0,     0,     0,     0,     0,     0,   135,
       1,     2,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45
};

static const yytype_int16 yycheck[] =
{
      18,    50,    51,    40,   143,     5,     6,    94,   147,     3,
      59,     3,    61,     3,    63,    64,     3,     3,     3,     3,
       3,     3,     3,    72,    73,    74,     5,    76,     3,     3,
      79,    80,    81,   120,     3,     3,     3,    86,    87,     3,
       3,     3,     3,     3,    40,     3,     5,     3,     5,     3,
       3,     3,     3,   102,     3,     5,   143,     3,     0,     6,
       5,     5,     3,   119,     7,     5,     5,     3,     5,     3,
       5,    47,     5,     5,     5,     5,     3,     5,     3,   128,
     117,     5,     5,     5,     5,     3,     5,     7,     5,     5,
       5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   117,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    55,    74,    75,     3,
       3,     3,    56,    65,    66,    67,     3,     3,     3,     3,
       3,     3,     5,     3,     3,     3,    65,     3,     3,     3,
       3,     3,     3,     3,     3,     5,     3,     5,     3,     3,
       3,     3,     3,    56,    66,     5,     3,     3,     0,    75,
      70,    71,    70,    70,     6,    58,    69,    70,    70,     5,
      70,    70,     3,     5,    70,    70,    70,     5,    70,     5,
      70,    70,    70,     3,     5,    70,    70,     3,    72,    73,
      68,    69,     5,     5,    70,     5,     5,     5,     3,     5,
      56,    59,    60,    61,    62,    65,    72,     7,    69,     5,
       3,     5,    70,     6,    57,    64,     5,    63,    64,     3,
       5,     7,    64,     5,     5,     5
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    54,    55,    56,    57,    58,    59,    59,    60,    60,
      61,    62,    63,    63,    64,    65,    65,    66,    67,    68,
      68,    69,    70,    71,    72,    72,    73,    74,    74,    75,
      75,    75,    75,    75,    75,    75,    75,    75,    75,    75,
      75,    75,    75,    75,    75,    75,    75,    75,    75,    75,
      75,    75,    75,    75,    75,    75,    75,    75,    75,    75,
      75,    75,    75,    75,    75,    75,    75,    75,    75,    75,
      75,    75,    75,    75
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     0,     0,     0,     1,     1,     1,     1,
       4,     2,     2,     1,     2,     1,     1,     4,     2,     2,
       1,     2,     2,     0,     2,     0,     2,     2,     1,     3,
       3,     1,     1,     3,     2,     2,     2,     2,     3,     1,
       2,     3,     3,    10,     3,     3,     4,     2,     1,     2,
       2,     1,     2,     2,     5,     3,     3,     1,     5,     3,
       4,     2,     3,     3,     3,     5,     1,     1,     2,     4,
       3,     3,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = LUXCORE_PARSERLXS_YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == LUXCORE_PARSERLXS_YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use LUXCORE_PARSERLXS_YYerror or LUXCORE_PARSERLXS_YYUNDEF. */
#define YYERRCODE LUXCORE_PARSERLXS_YYUNDEF


/* Enable debugging if requested.  */
#if LUXCORE_PARSERLXS_YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !LUXCORE_PARSERLXS_YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !LUXCORE_PARSERLXS_YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = LUXCORE_PARSERLXS_YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == LUXCORE_PARSERLXS_YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= LUXCORE_PARSERLXS_YYEOF)
    {
      yychar = LUXCORE_PARSERLXS_YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == LUXCORE_PARSERLXS_YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = LUXCORE_PARSERLXS_YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = LUXCORE_PARSERLXS_YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* start: ri_stmt_list  */
#line 787 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
}
#line 1986 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 3: /* array_init: %empty  */
#line 791 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	if (curArray)
		ArrayFree(curArray);
	curArray = new ParamArray;
	arrayIsSingleString = false;
}
#line 1997 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 4: /* string_array_init: %empty  */
#line 799 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	curArray->elementSize = sizeof(const char *);
}
#line 2005 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 5: /* num_array_init: %empty  */
#line 804 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	curArray->elementSize = sizeof(float);
}
#line 2013 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 6: /* array: string_array  */
#line 809 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	(yyval.ribarray) = (yyvsp[0].ribarray);
}
#line 2021 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 7: /* array: num_array  */
#line 813 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	(yyval.ribarray) = (yyvsp[0].ribarray);
}
#line 2029 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 8: /* string_array: real_string_array  */
#line 818 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	(yyval.ribarray) = (yyvsp[0].ribarray);
}
#line 2037 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 9: /* string_array: single_element_string_array  */
#line 822 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	(yyval.ribarray) = ArrayDup(curArray);
	arrayIsSingleString = true;
}
#line 2046 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 10: /* real_string_array: array_init LBRACK string_list RBRACK  */
#line 828 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	(yyval.ribarray) = ArrayDup(curArray);
}
#line 2054 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 11: /* single_element_string_array: array_init string_list_entry  */
#line 833 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
}
#line 2061 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 12: /* string_list: string_list string_list_entry  */
#line 837 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
}
#line 2068 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 13: /* string_list: string_list_entry  */
#line 840 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
}
#line 2075 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 14: /* string_list_entry: string_array_init STRING  */
#line 844 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	char *toAdd = strdup((yyvsp[0].string));
	AddArrayElement(&toAdd);
}
#line 2084 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 15: /* num_array: real_num_array  */
#line 850 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	(yyval.ribarray) = (yyvsp[0].ribarray);
}
#line 2092 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 16: /* num_array: single_element_num_array  */
#line 854 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	(yyval.ribarray) = ArrayDup(curArray);
}
#line 2100 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 17: /* real_num_array: array_init LBRACK num_list RBRACK  */
#line 859 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	(yyval.ribarray) = ArrayDup(curArray);
}
#line 2108 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 18: /* single_element_num_array: array_init num_list_entry  */
#line 864 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
}
#line 2115 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 19: /* num_list: num_list num_list_entry  */
#line 868 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
}
#line 2122 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 20: /* num_list: num_list_entry  */
#line 871 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
}
#line 2129 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 21: /* num_list_entry: num_array_init NUM  */
#line 875 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	float toAdd = (yyvsp[0].num);
	AddArrayElement(&toAdd);
}
#line 2138 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 22: /* paramlist: paramlist_init paramlist_contents  */
#line 881 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
}
#line 2145 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 23: /* paramlist_init: %empty  */
#line 885 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	CPS = 0;
}
#line 2153 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 24: /* paramlist_contents: paramlist_entry paramlist_contents  */
#line 890 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
}
#line 2160 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 25: /* paramlist_contents: %empty  */
#line 893 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
}
#line 2167 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 26: /* paramlist_entry: STRING array  */
#line 897 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	void *arg = new char[(yyvsp[0].ribarray)->nelems * (yyvsp[0].ribarray)->elementSize];
	memcpy(arg, (yyvsp[0].ribarray)->array, (yyvsp[0].ribarray)->nelems * (yyvsp[0].ribarray)->elementSize);
	if (CPS >= CPAL) {
		CPAL = 2 * CPAL + 1;
		CP = static_cast<ParamListElem *>(realloc(CP,
			CPAL * sizeof(ParamListElem)));
	}
	CPT(CPS) = (yyvsp[-1].string);
	CPA(CPS) = arg;
	CPSZ(CPS) = (yyvsp[0].ribarray)->nelems;
	CPTH(CPS) = arrayIsSingleString;
	++CPS;
	ArrayFree((yyvsp[0].ribarray));
}
#line 2187 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 27: /* ri_stmt_list: ri_stmt_list ri_stmt  */
#line 914 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
}
#line 2194 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 28: /* ri_stmt_list: ri_stmt  */
#line 917 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
}
#line 2201 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 29: /* ri_stmt: ACCELERATOR STRING paramlist  */
#line 921 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	Properties props;
	InitProperties(props, CPS, CP);

	// Map kdtree and bvh to luxrays' bvh accel otherwise just use the default settings
	const string name((yyvsp[-1].string));
	if ((name =="kdtree") || (name =="bvh"))
		*renderConfigProps << Property("accelerator.type")("BVH");
		
	FreeArgs();
}
#line 2217 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 30: /* ri_stmt: AREALIGHTSOURCE STRING paramlist  */
#line 933 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	currentGraphicsState.areaLightName = (yyvsp[-1].string);
	InitProperties(currentGraphicsState.areaLightProps, CPS, CP);

	FreeArgs();
}
#line 2228 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 31: /* ri_stmt: ATTRIBUTEBEGIN  */
#line 940 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	graphicsStatesStack.push_back(currentGraphicsState);
	transformsStack.push_back(currentTransform);
}
#line 2237 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 32: /* ri_stmt: ATTRIBUTEEND  */
#line 945 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	if (!graphicsStatesStack.size()) {
		LC_LOG("Unmatched AttributeEnd encountered. Ignoring it.");
	} else {
		currentGraphicsState = graphicsStatesStack.back();
		graphicsStatesStack.pop_back();
		currentTransform = transformsStack.back();
		transformsStack.pop_back();
	}
}
#line 2252 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 33: /* ri_stmt: CAMERA STRING paramlist  */
#line 956 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	const string name((yyvsp[-1].string));
	if (name != "perspective")
		throw runtime_error("LuxCore supports only perspective camera");

	Properties props;
	InitProperties(props, CPS, CP);
	
	if (props.IsDefined("screenwindow")) {
		Property prop = props.Get("screenwindow");
		*sceneProps << Property("scene.camera.screenwindow")(
			prop.Get<float>(0), prop.Get<float>(1), prop.Get<float>(2), prop.Get<float>(3));
	}

	if (props.IsDefined("clippingplane")) {
		Property prop = props.Get("clippingplane");
		*sceneProps <<
				Property("scene.camera.clippingplane.enable")(1) <<
				Property("scene.camera.clippingplane.center")(prop.Get<float>(0), prop.Get<float>(1), prop.Get<float>(2)) <<
				Property("scene.camera.clippingplane.normal")(prop.Get<float>(3), prop.Get<float>(4), prop.Get<float>(5));
	}

	*sceneProps <<
			Property("scene.camera.fieldofview")(props.Get(Property("fov")(90.f)).Get<float>()) <<
			Property("scene.camera.lensradius")(props.Get(Property("lensradius")(0.f)).Get<float>()) <<
			Property("scene.camera.focaldistance")(props.Get(Property("focaldistance")(1e30f)).Get<float>()) <<
			Property("scene.camera.hither")(props.Get(Property("cliphither")(1e-3f)).Get<float>()) <<
			Property("scene.camera.yon")(props.Get(Property("clipyon")(1e30f)).Get<float>());

	worldToCamera = currentTransform;
	namedCoordinateSystems["camera"] = currentTransform;

	FreeArgs();
}
#line 2291 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 34: /* ri_stmt: CONCATTRANSFORM num_array  */
#line 991 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	if (VerifyArrayLength((yyvsp[0].ribarray), 16, "ConcatTransform")) {
		const float *tr = static_cast<float *>((yyvsp[0].ribarray)->array);
		Transform t(Matrix4x4(tr[0], tr[4], tr[8], tr[12],
				tr[1], tr[5], tr[9], tr[13],
				tr[2], tr[6], tr[10], tr[14],
				tr[3], tr[7], tr[11], tr[15]));

		currentTransform = currentTransform * t;
	}
	ArrayFree((yyvsp[0].ribarray));
}
#line 2308 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 35: /* ri_stmt: COORDINATESYSTEM STRING  */
#line 1004 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	namedCoordinateSystems[(yyvsp[0].string)] = currentTransform;
}
#line 2316 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 36: /* ri_stmt: COORDSYSTRANSFORM STRING  */
#line 1008 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	const string name((yyvsp[0].string));
	if (namedCoordinateSystems.count(name))
		currentTransform = namedCoordinateSystems[name];
	else {
		throw runtime_error("Coordinate system '" + name + "' unknown");
	}
}
#line 2329 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 37: /* ri_stmt: EXTERIOR STRING  */
#line 1017 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	const string name = GetLuxCoreValidName((yyvsp[0].string));
	if (!namedVolumes.count(name))
		throw runtime_error("Named volume '" + name + "' unknown");

	currentGraphicsState.exteriorVolumeName = name;
	currentGraphicsState.exteriorVolumeProps = namedVolumes[name];

	// If I'm not defining an object, set the world volume
	if (graphicsStatesStack.size() == 0) {
		*sceneProps <<
				Property("scene.camera.autovolume.enable")(false) <<
				Property("scene.camera.volume")(name);
				
	}
}
#line 2350 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 38: /* ri_stmt: FILM STRING paramlist  */
#line 1034 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	Properties props;
	InitProperties(props, CPS, CP);

	// Image size
	*renderConfigProps <<
			Property("film.width")(props.Get(Property("xresolution")(800)).Get<u_int>()) <<
			Property("film.height")(props.Get(Property("yresolution")(600)).Get<u_int>());

	// Define the image pipeline (classic LuxRender has a fixed image pipeline)
	u_int pluginNumber = 0;

	// Tone mapping
	string pluginPrefix = "film.imagepipeline." + ToString(pluginNumber++);
	const string toneMapType = props.Get(Property("tonemapkernel")("autolinear")).Get<string>();
	if (toneMapType == "autolinear") {
		*renderConfigProps <<
			Property(pluginPrefix + ".type")("TONEMAP_AUTOLINEAR");
	} else if (toneMapType == "linear") {
		*renderConfigProps <<
			Property(pluginPrefix + ".type")("TONEMAP_LUXLINEAR") <<
			Property(pluginPrefix + ".sensitivity")(props.Get(Property("linear_sensitivity")(100.f)).Get<float>()) <<
			Property(pluginPrefix + ".exposure")(props.Get(Property("linear_exposure")(1.f / 1000.f)).Get<float>()) <<
			Property(pluginPrefix + ".fstop")(props.Get(Property("linear_fstop")(2.8f)).Get<float>());
	} else {
		LC_LOG("LuxCore supports only linear tone mapping, ignoring tone mapping settings");
	}

	// Camera response
	const string cameraResponse = props.Get(Property("cameraresponse")("")).Get<string>();
	if (cameraResponse != "") {
		pluginPrefix = "film.imagepipeline." + ToString(pluginNumber++);
		*renderConfigProps <<
			Property(pluginPrefix + ".type")("CAMERA_RESPONSE_FUNC") <<
			Property(pluginPrefix + ".name")(cameraResponse);
	}

	// Gamma correction
	pluginPrefix = "film.imagepipeline." + ToString(pluginNumber++);
	*renderConfigProps <<
		Property(pluginPrefix + ".type")("GAMMA_CORRECTION") <<
		Property(pluginPrefix + ".value")(props.Get(Property("gamma")(2.2f)).Get<float>());

	// Halt conditions
	*renderConfigProps <<
			Property("batch.halttime")(props.Get(Property("halttime")(0)).Get<u_int>()) <<
			Property("batch.haltspp")(props.Get(Property("haltspp")(0)).Get<u_int>());
	
	FreeArgs();
}
#line 2405 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 39: /* ri_stmt: IDENTITY  */
#line 1085 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	currentTransform = Transform();
}
#line 2413 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 40: /* ri_stmt: INTERIOR STRING  */
#line 1089 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	const string name = GetLuxCoreValidName((yyvsp[0].string));
	if (!namedVolumes.count(name))
		throw runtime_error("Named volume '" + name + "' unknown");

	currentGraphicsState.interiorVolumeName = name;
	currentGraphicsState.interiorVolumeProps = namedVolumes[name];
}
#line 2426 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 41: /* ri_stmt: LIGHTGROUP STRING paramlist  */
#line 1098 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	const string name((yyvsp[-1].string));
	if (namedLightGroups.count(name))
		currentGraphicsState.currentLightGroup = namedLightGroups[name];
	else {
		// It is a new light group
		currentGraphicsState.currentLightGroup = freeLightGroupIndex;
		namedLightGroups[name] = freeLightGroupIndex++;
	}

	FreeArgs();
}
#line 2443 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 42: /* ri_stmt: LIGHTSOURCE STRING paramlist  */
#line 1111 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	Properties props;
	InitProperties(props, CPS, CP);

	// Define light name
	string lightName;
	if (props.IsDefined("name"))
		lightName = props.Get("name").Get<string>();
	else
		lightName = "LUXCORE_LIGHT";
	lightName += "_" + ToString(freeLightID++);
	const string prefix = "scene.lights." + lightName;

	const string name((yyvsp[-1].string));
	if (name == "sun") {
		*sceneProps <<
				Property(prefix + ".type")("sun") <<
				Property(prefix + ".dir")(props.Get(Property("sundir")(Vector(0.f, 0.f , 1.f))).Get<Vector>()) <<
				Property(prefix + ".turbidity")(props.Get(Property("turbidity")(2.f)).Get<float>()) <<
				Property(prefix + ".relsize")(props.Get(Property("relsize")(1.f)).Get<float>()) <<
				Property(prefix + ".gain")(Spectrum(props.Get(Property("gain")(1.f)).Get<float>())) <<
				Property(prefix + ".transformation")(currentTransform.m) <<
				Property(prefix + ".id")(currentGraphicsState.currentLightGroup);
	} else if (name == "sky") {
		*sceneProps <<
				Property(prefix + ".type")("sky") <<
				Property(prefix + ".dir")(props.Get(Property("sundir")(Vector(0.f, 0.f , 1.f))).Get<Vector>()) <<
				Property(prefix + ".turbidity")(props.Get(Property("turbidity")(2.f)).Get<float>()) <<
				Property(prefix + ".gain")(Spectrum(props.Get(Property("gain")(1.f)).Get<float>())) <<
				Property(prefix + ".transformation")(currentTransform.m) <<
				Property(prefix + ".id")(currentGraphicsState.currentLightGroup);
	} else if (name == "sky2") {
		*sceneProps <<
				Property(prefix + ".type")("sky2") <<
				Property(prefix + ".dir")(props.Get(Property("sundir")(Vector(0.f, 0.f , 1.f))).Get<Vector>()) <<
				Property(prefix + ".turbidity")(props.Get(Property("turbidity")(2.f)).Get<float>()) <<
				Property(prefix + ".gain")(Spectrum(props.Get(Property("gain")(1.f)).Get<float>())) <<
				Property(prefix + ".transformation")(currentTransform.m) <<
				Property(prefix + ".id")(currentGraphicsState.currentLightGroup);
	} else if (name == "sunsky") {
		*sceneProps <<
				Property(prefix + "_SUN.type")("sun") <<
				Property(prefix + "_SUN.dir")(props.Get(Property("sundir")(Vector(0.f, 0.f , 1.f))).Get<Vector>()) <<
				Property(prefix + "_SUN.turbidity")(props.Get(Property("turbidity")(2.f)).Get<float>()) <<
				Property(prefix + "_SUN.relsize")(props.Get(Property("relsize")(1.f)).Get<float>()) <<
				Property(prefix + "_SUN.gain")(Spectrum(props.Get(Property("gain")(1.f)).Get<float>())) <<
				Property(prefix + "_SUN.transformation")(currentTransform.m) <<
				Property(prefix + "_SUN.id")(currentGraphicsState.currentLightGroup);

		*sceneProps <<
				Property(prefix + "_SKY.type")("sky") <<
				Property(prefix + "_SKY.dir")(props.Get(Property("sundir")(Vector(0.f, 0.f , 1.f))).Get<Vector>()) <<
				Property(prefix + "_SKY.turbidity")(props.Get(Property("turbidity")(2.f)).Get<float>()) <<
				Property(prefix + "_SKY.gain")(Spectrum(props.Get(Property("gain")(1.f)).Get<float>())) <<
				Property(prefix + "_SKY.transformation")(currentTransform.m) <<
				Property(prefix + "_SKY.id")(currentGraphicsState.currentLightGroup);
	} else if (name == "sunsky2") {
		*sceneProps <<
				Property(prefix + "_SUN2.type")("sun") <<
				Property(prefix + "_SUN2.dir")(props.Get(Property("sundir")(Vector(0.f, 0.f , 1.f))).Get<Vector>()) <<
				Property(prefix + "_SUN2.turbidity")(props.Get(Property("turbidity")(2.f)).Get<float>()) <<
				Property(prefix + "_SUN2.relsize")(props.Get(Property("relsize")(1.f)).Get<float>()) <<
				Property(prefix + "_SUN2.gain")(Spectrum(props.Get(Property("gain")(1.f)).Get<float>())) <<
				Property(prefix + "_SUN2.transformation")(currentTransform.m) <<
				Property(prefix + "_SUN2.id")(currentGraphicsState.currentLightGroup);

		*sceneProps <<
				Property(prefix + "_SKY2.type")("sky2") <<
				Property(prefix + "_SKY2.dir")(props.Get(Property("sundir")(Vector(0.f, 0.f , 1.f))).Get<Vector>()) <<
				Property(prefix + "_SKY2.turbidity")(props.Get(Property("turbidity")(2.f)).Get<float>()) <<
				Property(prefix + "_SKY2.gain")(Spectrum(props.Get(Property("gain")(1.f)).Get<float>())) <<
				Property(prefix + "_SKY2.transformation")(currentTransform.m) <<
				Property(prefix + "_SKY2.id")(currentGraphicsState.currentLightGroup);
	} else if ((name == "infinite") || (name == "infinitesample")) {
		// Check if i have to use infiniete or constantinfinite
		if (props.Get(Property("mapname")("")).Get<string>() == "") {
			*sceneProps <<
					Property(prefix + ".type")("constantinfinite") <<
					Property(prefix + ".gain")(Spectrum(props.Get(Property("gain")(1.f)).Get<float>())) <<
					Property(prefix + ".color")(props.Get(Property("L")(Spectrum(1.f))).Get<Spectrum>()) <<
					Property(prefix + ".id")(currentGraphicsState.currentLightGroup);			
		} else {
			const float gain = props.Get(Property("gain")(1.f)).Get<float>();
			const Spectrum L = props.Get(Property("L")(Spectrum(1.f))).Get<Spectrum>();
			const Spectrum combinedGain = gain * L;
			*sceneProps <<
					Property(prefix + ".type")("infinite") <<
					Property(prefix + ".file")(props.Get(Property("mapname")("")).Get<string>()) <<
					Property(prefix + ".gamma")(props.Get(Property("gamma")(2.2f)).Get<float>()) <<
					Property(prefix + ".gain")(combinedGain) <<
					Property(prefix + ".transformation")(currentTransform.m) <<
					Property(prefix + ".id")(currentGraphicsState.currentLightGroup);
		}
	} else if (name == "point") {
		// Check if it is a point or mappoint light source
		if (props.IsDefined("mapname") || props.IsDefined("iesname")) {
			*sceneProps << Property(prefix + ".type")("mappoint");
			if (props.IsDefined("mapname"))
				*sceneProps << Property(prefix + ".mapfile")(props.Get(Property("mapname")("")).Get<string>());
			if (props.IsDefined("iesname")) {
				*sceneProps <<
						Property(prefix + ".iesfile")(props.Get(Property("iesname")("")).Get<string>()) <<
						Property(prefix + ".flipz")(props.Get(Property("flipz")(false)).Get<bool>());
			}
		} else
			*sceneProps << Property(prefix + ".type")("point");
		
		const Point from = props.Get(Property("from")(Point(0.f, 0.f, 0.f))).Get<Point>();

		*sceneProps <<
				Property(prefix + ".position")(Point(0.f, 0.f, 0.f)) <<
				Property(prefix + ".color")(props.Get(Property("L")(Spectrum(1.f))).Get<Spectrum>()) <<
				Property(prefix + ".gain")(Spectrum(props.Get(Property("gain")(1.f)).Get<float>())) <<
				Property(prefix + ".power")(props.Get(Property("power")(0.f)).Get<float>()) <<
				Property(prefix + ".efficency")(props.Get(Property("efficency")(0.f)).Get<float>()) <<
				Property(prefix + ".transformation")((Translate(Vector(from.x, from.y, from.z)) * currentTransform).m) <<
				Property(prefix + ".id")(currentGraphicsState.currentLightGroup);
	} else if (name == "spot") {
		*sceneProps <<
				Property(prefix + ".type")("spot") <<
				Property(prefix + ".coneangle")(props.Get(Property("coneangle")(30.f)).Get<float>()) <<
				Property(prefix + ".conedeltaangle")(props.Get(Property("conedeltaangle")(5.f)).Get<float>()) <<
				Property(prefix + ".position")(props.Get(Property("from")(Point(0.f, 0.f, 0.f))).Get<Point>()) <<
				Property(prefix + ".target")(props.Get(Property("to")(Point(0.f, 0.f, 1.f))).Get<Point>()) <<
				Property(prefix + ".color")(props.Get(Property("L")(Spectrum(1.f))).Get<Spectrum>()) <<
				Property(prefix + ".gain")(Spectrum(props.Get(Property("gain")(1.f)).Get<float>())) <<
				Property(prefix + ".power")(props.Get(Property("power")(0.f)).Get<float>()) <<
				Property(prefix + ".efficency")(props.Get(Property("efficency")(0.f)).Get<float>()) <<
				Property(prefix + ".transformation")(currentTransform.m) <<
				Property(prefix + ".id")(currentGraphicsState.currentLightGroup);
	} else if (name == "projection") {
		*sceneProps <<
				Property(prefix + ".type")("projection") <<
				Property(prefix + ".mapfile")(props.Get(Property("mapname")("")).Get<string>()) <<
				Property(prefix + ".fov")(props.Get(Property("fov")(45.f)).Get<float>()) <<
				Property(prefix + ".position")(props.Get(Property("from")(Point(0.f, 0.f, 0.f))).Get<Point>()) <<
				Property(prefix + ".target")(props.Get(Property("to")(Point(0.f, 0.f, 1.f))).Get<Point>()) <<
				Property(prefix + ".color")(props.Get(Property("L")(Spectrum(1.f))).Get<Spectrum>()) <<
				Property(prefix + ".gain")(Spectrum(props.Get(Property("gain")(1.f)).Get<float>())) <<
				Property(prefix + ".transformation")(currentTransform.m) <<
				Property(prefix + ".id")(currentGraphicsState.currentLightGroup);
	} else if (name == "distant") {
		const float theta = props.Get(Property("theta")(0.f)).Get<float>();
		if (theta == 0.f) {
			*sceneProps <<
					Property(prefix + ".type")("sharpdistant");
		} else {
			*sceneProps <<
					Property(prefix + ".type")("distant") <<
					Property(prefix + ".theta")(theta) ;
		}

		const Point from = props.Get(Property("from")(Point(0.f, 0.f, 0.f))).Get<Point>();
		const Point to = props.Get(Property("to")(Point(0.f, 0.f, 1.f))).Get<Point>();
		
		*sceneProps <<
				Property(prefix + ".direction")(Normalize(to - from)) <<
				Property(prefix + ".color")(props.Get(Property("L")(Spectrum(1.f))).Get<Spectrum>()) <<
				Property(prefix + ".gain")(Spectrum(props.Get(Property("gain")(1.f)).Get<float>())) <<
				Property(prefix + ".transformation")(currentTransform.m) <<
				Property(prefix + ".id")(currentGraphicsState.currentLightGroup);
	}

	FreeArgs();
}
#line 2613 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 43: /* ri_stmt: LOOKAT NUM NUM NUM NUM NUM NUM NUM NUM NUM  */
#line 1277 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	*sceneProps <<
			Property("scene.camera.lookat.orig")((yyvsp[-8].num), (yyvsp[-7].num), (yyvsp[-6].num)) <<
			Property("scene.camera.lookat.target")((yyvsp[-5].num), (yyvsp[-4].num), (yyvsp[-3].num)) <<
			Property("scene.camera.up")((yyvsp[-2].num), (yyvsp[-1].num), (yyvsp[0].num));
}
#line 2624 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 44: /* ri_stmt: MATERIAL STRING paramlist  */
#line 1284 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	currentGraphicsState.materialName = "";
	InitProperties(currentGraphicsState.materialProps, CPS, CP);

	FreeArgs();
}
#line 2635 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 45: /* ri_stmt: MAKENAMEDMATERIAL STRING paramlist  */
#line 1291 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	const string name = GetLuxCoreValidName((yyvsp[-1].string));
	if (namedMaterials.count(name))
		throw runtime_error("Named material '" + name + "' already defined");

	Properties props;
	InitProperties(props, CPS, CP);
	namedMaterials[name] = props;
	DefineMaterial(name, props, Properties(), "", "");

	FreeArgs();
}
#line 2652 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 46: /* ri_stmt: MAKENAMEDVOLUME STRING STRING paramlist  */
#line 1304 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	const string name = GetLuxCoreValidName((yyvsp[-2].string));
	if (namedVolumes.count(name))
		throw runtime_error("Named volume '" + name + "' already defined");

	Properties props;
	InitProperties(props, CPS, CP);
	// The volume type
	const string type = (yyvsp[-1].string);
	props << Property("type")(type);

	namedVolumes[name] = props;
	DefineVolume(name, props);

	FreeArgs();
}
#line 2673 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 47: /* ri_stmt: MOTIONBEGIN num_array  */
#line 1321 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	ArrayFree((yyvsp[0].ribarray));
}
#line 2681 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 48: /* ri_stmt: MOTIONEND  */
#line 1325 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
}
#line 2688 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 49: /* ri_stmt: NAMEDMATERIAL STRING  */
#line 1328 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	const string name = GetLuxCoreValidName((yyvsp[0].string));
	if (!namedMaterials.count(name))
		throw runtime_error("Named material '" + name + "' unknown");

	currentGraphicsState.materialName = name;
	currentGraphicsState.materialProps = namedMaterials[name];
}
#line 2701 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 50: /* ri_stmt: OBJECTBEGIN STRING  */
#line 1337 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	const string objName((yyvsp[0].string));

	currentObjectName = GetLuxCoreValidName(objName);
}
#line 2711 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 51: /* ri_stmt: OBJECTEND  */
#line 1343 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	currentObjectName = "";
}
#line 2719 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 52: /* ri_stmt: OBJECTINSTANCE STRING  */
#line 1347 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	const string namedObjNameStr((yyvsp[0].string));
	const string namedObjName = GetLuxCoreValidName(namedObjNameStr);

	const vector<string> &shapes = namedObjectShapes[namedObjName];
	const vector<string> &materials = namedObjectMaterials[namedObjName];
	const vector<Transform> &transforms = namedObjectTransforms[namedObjName];

	if (currentObjectName == "") {
		// I'm not inside a ObjectBegin/ObjectEnd

		const string objName = namedObjName + "_" + ToString(freeObjectID++);

		for (u_int i = 0; i < shapes.size(); ++i) {
			const string prefix = "scene.objects." + objName + "_" + ToString(i);

			*sceneProps <<
					Property(prefix + ".shape")(shapes[i]) <<
					Property(prefix + ".material")(materials[i]) <<
					Property(prefix + ".transformation")((currentTransform * transforms[i]).m);
		}
	} else {
		// I'm inside a ObjectBegin/ObjectEnd
		
		// I have to add all the shapes/materials/transforms of the referenced
		// named object to the current named object
		for (u_int i = 0; i < shapes.size(); ++i) {
			namedObjectShapes[currentObjectName].push_back(shapes[i]);
			namedObjectMaterials[currentObjectName].push_back(materials[i]);
			namedObjectTransforms[currentObjectName].push_back(currentTransform * transforms[i]);
		}
	}
}
#line 2757 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 53: /* ri_stmt: PORTALINSTANCE STRING  */
#line 1381 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
}
#line 2764 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 54: /* ri_stmt: MOTIONINSTANCE STRING NUM NUM STRING  */
#line 1384 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
}
#line 2771 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 55: /* ri_stmt: PIXELFILTER STRING paramlist  */
#line 1387 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	Properties props;
	InitProperties(props, CPS, CP);

	const string name((yyvsp[-1].string));
	if (name == "box") {
		*renderConfigProps <<
				Property("film.filter.type")("BOX") <<
				Property("film.filter.xwidth")(props.Get(Property("xwidth", .5f)).Get<float>() * .5f) <<
				Property("film.filter.ywidth")(props.Get(Property("ywidth", .5f)).Get<float>() * .5f);
	} else if (name == "gaussian") {
		*renderConfigProps <<
				Property("film.filter.type")("GAUSSIAN") <<
				Property("film.filter.xwidth")(props.Get(Property("xwidth", 2.f)).Get<float>() * .5f) <<
				Property("film.filter.ywidth")(props.Get(Property("ywidth", 2.f)).Get<float>() * .5f) <<
				Property("film.filter.gaussian.alpha")(props.Get(Property("alpha", 2.f)).Get<float>());
	} else if (name == "mitchell") {
		const bool supersample = props.Get(Property("supersample")(false)).Get<bool>();
		const string prefix = supersample ? "mitchell": "mitchellss";

		*renderConfigProps <<
				Property("film.filter.type")(supersample ? "MITCHELL_SS" : "MITCHELL") <<
				Property("film.filter.xwidth")(props.Get(Property("xwidth", 2.f)).Get<float>() * .5f) <<
				Property("film.filter.ywidth")(props.Get(Property("ywidth", 2.f)).Get<float>() * .5f) <<
				Property("film.filter." + prefix + ".B")(props.Get(Property("B", 1.f / 3.f)).Get<float>()) <<
				Property("film.filter." + prefix + ".C")(props.Get(Property("C", 1.f / 3.f)).Get<float>());
	} else if (name == "blackmanharris") {
		*renderConfigProps <<
				Property("film.filter.type")("BLACKMANHARRIS") <<
				Property("film.filter.xwidth")(props.Get(Property("xwidth", 4.f)).Get<float>() * .5f) <<
				Property("film.filter.ywidth")(props.Get(Property("ywidth", 4.f)).Get<float>() * .5f);
	} else {
		LC_LOG("LuxCore doesn't support the filter type " + name + ", using BLACKMANHARRIS filter instead");
		*renderConfigProps <<
				Property("film.filter.type")("BLACKMANHARRIS");
	}

	FreeArgs();
}
#line 2815 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 56: /* ri_stmt: RENDERER STRING paramlist  */
#line 1427 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	Properties props;
	InitProperties(props, CPS, CP);

	// Check the name of the renderer
	if ((strcmp((yyvsp[-1].string), "slg") == 0) || (strcmp((yyvsp[-1].string), "slg") == 0)) {
		// It is LuxCoreRenderer

		// Look for the config parameter
		if (props.IsDefined("config")) {
			const Property &prop = props.Get("config");
			for (u_int i = 0; i < prop.GetSize(); ++i)
				luxcore::parselxs::overwriteProps.SetFromString(prop.Get<string>(i));
		}

		// Look for the localconfigfile parameter
		if (props.IsDefined("localconfigfile")) {
			luxcore::parselxs::overwriteProps.SetFromFile(props.Get("localconfigfile").Get<string>());
		}
	}

	FreeArgs();
}
#line 2843 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 57: /* ri_stmt: REVERSEORIENTATION  */
#line 1451 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
}
#line 2850 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 58: /* ri_stmt: ROTATE NUM NUM NUM NUM  */
#line 1454 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	Transform t(Rotate((yyvsp[-3].num), Vector((yyvsp[-2].num), (yyvsp[-1].num), (yyvsp[0].num))));
	currentTransform = currentTransform * t;
}
#line 2859 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 59: /* ri_stmt: SAMPLER STRING paramlist  */
#line 1459 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	Properties props;
	InitProperties(props, CPS, CP);

	const string name((yyvsp[-1].string));
	if (name == "metropolis") {
		*renderConfigProps <<
				Property("sampler.type")("METROPOLIS") <<
				Property("sampler.metropolis.maxconsecutivereject")(Property("maxconsecrejects")(512).Get<u_int>()) <<
				Property("sampler.metropolis.largesteprate")(Property("largemutationprob")(.4f).Get<float>()) <<
				Property("sampler.metropolis.imagemutationrate")(Property("mutationrange")(.1f).Get<float>());
	} else if ((name == "sobol") || (name == "lowdiscrepancy")) {
		*renderConfigProps <<
				Property("sampler.type")("SOBOL");
	} else if (name == "random") {
		*renderConfigProps <<
				Property("sampler.type")("RANDOM");
	} else {
		LC_LOG("LuxCore doesn't support the sampler type " + name + ", falling back to random sampler");
		*renderConfigProps <<
				Property("sampler.type")("RANDOM");
	}

	FreeArgs();
}
#line 2889 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 60: /* ri_stmt: SCALE NUM NUM NUM  */
#line 1485 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	Transform t(Scale((yyvsp[-2].num), (yyvsp[-1].num), (yyvsp[0].num)));
	currentTransform = currentTransform * t;
}
#line 2898 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 61: /* ri_stmt: SEARCHPATH STRING  */
#line 1490 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
}
#line 2905 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 62: /* ri_stmt: SHAPE STRING paramlist  */
#line 1493 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	Properties props;
	InitProperties(props, CPS, CP);

	// Define object name
	string objName, prefix;
	if (currentObjectName == "") {
		if (props.IsDefined("name")) {
			// LuxRender object names are not unique
			objName = props.Get("name").Get<string>();
		} else
			objName = "LUXCORE_OBJECT";
		objName += "_" + ToString(freeObjectID++);
		objName = GetLuxCoreValidName(objName);
		prefix = "scene.objects." + objName;
	} else {
		objName = currentObjectName + "_" + ToString(freeObjectID++);
		prefix = "scene.shapes." + objName;
		
		namedObjectShapes[currentObjectName].push_back(objName);
		namedObjectTransforms[currentObjectName].push_back(Transform(Matrix4x4::MAT_IDENTITY));
	}

	// Define object material
	if ((currentGraphicsState.materialName == "") ||
		(currentGraphicsState.interiorVolumeName != "") ||
		(currentGraphicsState.exteriorVolumeName != "")) {
		const string materialName = "LUXCORE_MATERIAL_" + objName;

		// Define the used material on-the-fly
		DefineMaterial(materialName, currentGraphicsState.materialProps,
				currentGraphicsState.areaLightProps,
				currentGraphicsState.interiorVolumeName,
				currentGraphicsState.exteriorVolumeName);
		
		// Material assignment is not required for shapes		
		if (currentObjectName == "") {
			*sceneProps <<
				Property(prefix + ".material")(materialName);
		} else
			namedObjectMaterials[currentObjectName].push_back(materialName);
	} else {
		// It is a named material
		if ((currentGraphicsState.areaLightName == "") &&
				(currentGraphicsState.interiorVolumeName == "") &&
				(currentGraphicsState.exteriorVolumeName == "")) {
			// I can use the already defined material without emission and
			// without volumes

			// Material assignment is not required for shapes		
			if (currentObjectName == "") {
				*sceneProps <<
					Property(prefix + ".material")(currentGraphicsState.materialName);
			} else
				namedObjectMaterials[currentObjectName].push_back(currentGraphicsState.materialName);
		} else {
			const string materialName = "LUXCORE_MATERIAL_" + objName;

			// I have to define a new material with emission
			DefineMaterial(materialName, currentGraphicsState.materialProps,
				currentGraphicsState.areaLightProps,
				currentGraphicsState.interiorVolumeName,
				currentGraphicsState.exteriorVolumeName);

			// Material assignment is not required for shapes		
			if (currentObjectName == "") {
				*sceneProps <<
					Property(prefix + ".material")(materialName);
			} else
				namedObjectMaterials[currentObjectName].push_back(materialName);
		}
	}

	const string name((yyvsp[-1].string));
	if (name == "plymesh") {
		*sceneProps <<
			Property(prefix + ".ply")(props.Get(Property("filename")("none")).Get<string>()) <<
			Property(prefix + ".transformation")(currentTransform.m);
	} else 	if ((name == "trianglemesh") || (name == "mesh")) {
		if (!props.IsDefined("P"))
			throw runtime_error("Missing P parameter in trianglemesh/mesh: " + objName);
		Property pointsProp = props.Get("P");
		if ((pointsProp.GetSize() == 0) || (pointsProp.GetSize() % 3 != 0))
			throw runtime_error("Wrong trianglemesh/mesh point list length: " + objName);
		// Copy all vertices
		Property points = pointsProp.Renamed(prefix + ".vertices");

		const string indicesName = (name == "trianglemesh") ? "indices" : "triindices";
		if (!props.IsDefined(indicesName))
			throw runtime_error("Missing indices parameter in trianglemesh/mesh: " + objName);
		Property indicesProp = props.Get(indicesName);
		if ((indicesProp.GetSize() == 0) || (indicesProp.GetSize() % 3 != 0))
			throw runtime_error("Wrong trianglemesh/mesh indices list length: " + objName);
		// Copy all indices
		Property faces = indicesProp.Renamed(prefix + ".faces");

		*sceneProps <<
			points <<
			faces <<
			Property(prefix + ".transformation")(currentTransform.m);

		if (props.IsDefined("N")) {
			Property normalsProp = props.Get("N");
			if ((normalsProp.GetSize() == 0) ||	(normalsProp.GetSize() != pointsProp.GetSize()))
				throw runtime_error("Wrong trianglemesh/mesh normal list length: " + objName);
			// Copy all normals
			*sceneProps <<
					normalsProp.Renamed(prefix + ".normals");
		}

		if (props.IsDefined("uv")) {
			Property uvsProps = props.Get("uv");
			if ((uvsProps.GetSize() == 0) || (uvsProps.GetSize() % 2 != 0) ||
					(uvsProps.GetSize() / 2 != pointsProp.GetSize() / 3))
				throw runtime_error("Wrong trianglemesh/mesh uv list length: " + objName);
			// Copy all uvs
			*sceneProps <<
					uvsProps.Renamed(prefix + ".uvs");
		}
	} else {
		LC_LOG("LuxCore doesn't support the shape type " + name + ", ignoring the shape definition");
	}

	FreeArgs();
}
#line 3035 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 63: /* ri_stmt: PORTALSHAPE STRING paramlist  */
#line 1619 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	FreeArgs();
}
#line 3043 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 64: /* ri_stmt: SURFACEINTEGRATOR STRING paramlist  */
#line 1623 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	Properties props;
	InitProperties(props, CPS, CP);

	const string name((yyvsp[-1].string));
	if (name == "path") {
		// Path tracing
		*renderConfigProps <<
			Property("renderengine.type")("PATHOCL") <<
			Property("path.maxdepth")(props.Get(Property("maxdepth")(16u)).Get<u_int>());
	} else if (name == "bidirectional") {
		// Bidirectional path tracing
		*renderConfigProps <<
			Property("renderengine.type")("BIDIRCPU") <<
			Property("path.maxdepth")(props.Get(Property("eyedepth")(8u)).Get<u_int>()) <<
			Property("light.maxdepth")(props.Get(Property("lightdepth")(8u)).Get<u_int>());
	} else {
		// Unmapped surface integrator, just use path tracing
		LC_LOG("LuxCore doesn't support the SurfaceIntegrator, falling back to path tracing");
		*renderConfigProps <<
			Property("renderengine.type")("PATHOCL");
	}

	FreeArgs();
}
#line 3073 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 65: /* ri_stmt: TEXTURE STRING STRING STRING paramlist  */
#line 1649 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	Properties props;
	InitProperties(props, CPS, CP);

	string name = GetLuxCoreValidName((yyvsp[-3].string));
	if (namedTextures.count(name))
		LC_LOG("Texture '" << name << "' being redefined.");
	namedTextures.insert(name);

	const string texType((yyvsp[-1].string));
	const string prefix = "scene.textures." + name;

	if (texType == "constant") {
		const string channels((yyvsp[-2].string));

		if (channels == "float") {
			*sceneProps <<
				Property(prefix + ".type")("constfloat1") <<
				Property(prefix + ".value")(props.Get(Property("value")(1.f)).Get<float>());
		} else if ((channels == "color") || (channels == "spectrum")) {
			*sceneProps <<
				Property(prefix + ".type")("constfloat3") <<
				Property(prefix + ".value")(props.Get(Property("value")(Spectrum(1.f))).Get<Spectrum>());
		} else if (channels == "fresnel") {
			*sceneProps <<
				Property(prefix + ".type")("fresnelconst") <<
				Property(prefix + ".n")(props.Get(Property("value")(Spectrum(1.f))).Get<Spectrum>()) <<
				Property(prefix + ".k")(Spectrum(0.f));
		} else  {
			LC_LOG("LuxCore doesn't support the constant texture type: " << channels);

			*sceneProps <<
					Property(prefix + ".type")("constfloat1") <<
					Property(prefix + ".value")(.1f);
		}
	} else if (texType == "imagemap") {
		const float gamma = props.Get(Property("gamma")(2.2f)).Get<float>();
		const float gain = props.Get(Property("gain")(1.f)).Get<float>();
		*sceneProps <<
				Property(prefix + ".type")("imagemap") <<
				Property(prefix + ".file")(props.Get(Property("filename")("")).Get<string>()) <<
				Property(prefix + ".gamma")(gamma) <<
				// LuxRender applies gain before gamma correction
				Property(prefix + ".gain")(powf(gain, gamma)) <<
				Property(prefix + ".channel")(props.Get(Property("channel")("default")).Get<string>()) <<
				GetTextureMapping2D(prefix, props);
	} else if (texType == "add") {
		*sceneProps <<
				Property(prefix + ".type")("add") <<
				GetTexture(prefix + ".texture1", Property("tex1")(Spectrum(1.f)), props) <<
				GetTexture(prefix + ".texture2", Property("tex2")(Spectrum(1.f)), props);
	} else if (texType == "subtract") {
		*sceneProps <<
				Property(prefix + ".type")("subtract") <<
				GetTexture(prefix + ".texture1", Property("tex1")(Spectrum(1.f)), props) <<
				GetTexture(prefix + ".texture2", Property("tex2")(Spectrum(1.f)), props);
	} else if (texType == "scale") {
		*sceneProps <<
				Property(prefix + ".type")("scale") <<
				GetTexture(prefix + ".texture1", Property("tex1")(Spectrum(1.f)), props) <<
				GetTexture(prefix + ".texture2", Property("tex2")(Spectrum(1.f)), props);
	} else if (texType == "mix") {
		*sceneProps <<
				Property(prefix + ".type")("mix") <<
				GetTexture(prefix + ".amount", Property("amount")(.5f), props) <<
				GetTexture(prefix + ".texture1", Property("tex1")(Spectrum(0.f)), props) <<
				GetTexture(prefix + ".texture2", Property("tex2")(Spectrum(1.f)), props);
	} else if (texType == "colordepth") {
		*sceneProps <<
				Property(prefix + ".type")("colordepth") <<
				Property(prefix + ".depth")(props.Get(Property("depth")(1.f)).Get<float>()) <<
				GetTexture(prefix + ".kt", Property("Kt")(Spectrum(0.f)), props);
	} else if (texType == "blackbody") {
		*sceneProps <<
				Property(prefix + ".type")("blackbody") <<
				Property(prefix + ".temperature")(props.Get(Property("temperature")(6500.f)).Get<float>());
	} else if (texType == "irregulardata") {
		const Property &wl = props.Get(Property("wavelengths"));
		if (wl.GetSize() < 2)
			throw runtime_error("Insufficient wavelengths in an irregulardata texture");

		const Property &dt = props.Get(Property("data"));
		if (dt.GetSize() < 2)
			throw runtime_error("Insufficient data in an irregulardata texture");

		if (wl.GetSize() != dt.GetSize())
			throw runtime_error("Number of wavelengths doesn't match number of data values in irregulardata texture");

		Property(prefix + ".wavelengths");

		*sceneProps <<
				Property(prefix + ".type")("irregulardata") <<
				wl.Renamed(prefix + ".wavelengths") <<
				dt.Renamed(prefix + ".data");
	} else if (texType == "lampspectrum") {
		*sceneProps <<
				Property(prefix + ".type")("lampspectrum") <<
				Property(prefix + ".name")(props.Get(Property("name")("Incandescent2")).Get<string>());
	} else if (texType == "triplanar") {
		*sceneProps <<
				Property(prefix + ".type")("triplanar") <<
				GetTexture(prefix + ".texture1", Property("tex1")(Spectrum(1.f,0.f,0.f)), props) <<
				GetTexture(prefix + ".texture2", Property("tex2")(Spectrum(0.f,1.f,0.f)), props) <<
				GetTexture(prefix + ".texture3", Property("tex3")(Spectrum(0.f,0.f,1.f)), props) <<
				GetTextureMapping3D(prefix, currentTransform, props);
	} else
	//--------------------------------------------------------------------------
	// Procedural textures
	//--------------------------------------------------------------------------
	if (texType == "checkerboard") {
		const u_int dimension = props.Get(Property("dimension")(2)).Get<u_int>();

		*sceneProps <<
				Property(prefix + ".type")((dimension == 2) ? "checkerboard2d" : "checkerboard3d") <<
				GetTexture(prefix + ".texture1", Property("tex1")(Spectrum(1.f)), props) <<
				GetTexture(prefix + ".texture2", Property("tex2")(Spectrum(0.f)), props) <<
				((dimension == 2) ? GetTextureMapping2D(prefix, props) : GetTextureMapping3D(prefix, currentTransform, props));
	} else if (texType == "fbm") {
		*sceneProps <<
				Property(prefix + ".type")("fbm") <<
				GetTexture(prefix + ".octaves", Property("octaves")(8), props) <<
				GetTexture(prefix + ".roughness", Property("roughness")(.5f), props) <<
				GetTextureMapping3D(prefix, currentTransform, props);
	} else if (texType == "marble") {
		*sceneProps <<
				Property(prefix + ".type")("marble") <<
				GetTexture(prefix + ".octaves", Property("octaves")(8), props) <<
				GetTexture(prefix + ".roughness", Property("roughness")(.5f), props) <<
				GetTexture(prefix + ".scale", Property("scale")(1.f), props) <<
				GetTexture(prefix + ".variation", Property("variation")(.2f), props) <<
				GetTextureMapping3D(prefix, currentTransform, props);
	} else if (texType == "dots") {
		*sceneProps <<
				Property(prefix + ".type")("dots") <<
				GetTexture(prefix + ".inside", Property("inside")(1.f), props) <<
				GetTexture(prefix + ".outside", Property("outside")(0.f), props) <<
				GetTextureMapping3D(prefix, currentTransform, props);
	} else if (texType == "brick") {
		*sceneProps <<
				Property(prefix + ".type")("brick") <<
				GetTexture(prefix + ".bricktex", Property("bricktex")(Spectrum(1.f)), props) <<
				GetTexture(prefix + ".mortartex", Property("mortartex")(Spectrum(.2f)), props) <<
				GetTexture(prefix + ".brickmodtex", Property("brickmodtex")(Spectrum(1.f)), props) <<
				Property(prefix + ".brickwidth")(props.Get(Property("brickwidth")(.3f)).Get<float>()) <<
				Property(prefix + ".brickheight")(props.Get(Property("brickheight")(.1f)).Get<float>()) <<
				Property(prefix + ".brickdepth")(props.Get(Property("brickdepth")(.15f)).Get<float>()) <<
				Property(prefix + ".mortarsize")(props.Get(Property("mortarsize")(.01f)).Get<float>()) <<
				Property(prefix + ".brickbond")(props.Get(Property("brickbond")("running")).Get<string>()) <<
				Property(prefix + ".brickrun")(props.Get(Property("brickrun")(.75f)).Get<float>()) <<
				Property(prefix + ".brickbevel")(props.Get(Property("brickbevel")(0.f)).Get<float>()) <<
				GetTexture(prefix + ".brickwidth", Property("brickwidth")(.3f), props) <<
				GetTextureMapping3D(prefix, currentTransform, props);
	} else if (texType == "windy") {
		*sceneProps <<
				Property(prefix + ".type")("windy") <<
				GetTextureMapping3D(prefix, currentTransform, props);
	} else if (texType == "wrinkled") {
		*sceneProps <<
				Property(prefix + ".type")("wrinkled") <<
				GetTexture(prefix + ".octaves", Property("octaves")(8), props) <<
				GetTexture(prefix + ".roughness", Property("roughness")(.5f), props) <<
				GetTextureMapping3D(prefix, currentTransform, props);
	} else if (texType == "uv") {
		*sceneProps <<
				Property(prefix + ".type")("uv") <<
				GetTextureMapping2D(prefix, props);
	} else if (texType == "band") {
		*sceneProps <<
				Property(prefix + ".type")("band") <<
				GetTexture(prefix + ".amount", Property("amount")(0.f), props);

		const Property offsetsProp = props.Get(Property("offsets"));
		const u_int offsetsSize = offsetsProp.GetSize();
		for (u_int i = 0; i < offsetsSize; ++i) {
			*sceneProps <<
					Property(prefix + ".offset" + ToString(i))(offsetsProp.Get<float>(i));

			const Property valueProp = props.Get(Property("value" + ToString(i)));
			if (valueProp.GetSize() == 1) {
				*sceneProps <<
					Property(prefix + ".value" + ToString(i))(valueProp.Get<float>());
			} else if (valueProp.GetSize() == 3) {
				*sceneProps <<
					Property(prefix + ".value" + ToString(i))(Spectrum(valueProp.Get<float>(0),
						valueProp.Get<float>(1), valueProp.Get<float>(2)));
			} else {
				LC_LOG("LuxCore supports only Band texture with constant values");
				
				*sceneProps <<
					Property(prefix + ".value" + ToString(i))(.7f);
			}
		}
	} else if (texType == "bilerp") {
		*sceneProps <<
				Property(prefix + ".type")("bilerp") <<
				GetTexture(prefix + ".texture00", Property("v00")(0.f), props) <<
				GetTexture(prefix + ".texture01", Property("v01")(1.f), props) <<
				GetTexture(prefix + ".texture10", Property("v10")(0.f), props) <<
				GetTexture(prefix + ".texture11", Property("v11")(1.f), props);
	}
	//--------------------------------------------------------------------------
	// Blender procedural textures
	//--------------------------------------------------------------------------
	else if (texType == "blender_blend") {
		*sceneProps <<
				Property(prefix + ".type")("blender_blend") <<
				Property(prefix + ".progressiontype")(props.Get(Property("progressiontype")("linear")).Get<string>()) <<
				Property(prefix + ".bright")(props.Get(Property("bright")(1.f)).Get<float>()) <<
				Property(prefix + ".contrast")(props.Get(Property("contrast")(1.f)).Get<float>()) <<
				GetTextureMapping3D(prefix, currentTransform, props);
	} else if (texType == "blender_clouds") {
		*sceneProps <<
				Property(prefix + ".type")("blender_clouds") <<
				Property(prefix + ".noisetype")(props.Get(Property("noisetype")("soft_noise")).Get<string>()) <<
				Property(prefix + ".noisebasis")(props.Get(Property("noisebasis")("blender_original")).Get<string>()) <<
				Property(prefix + ".noisesize")(props.Get(Property("noisesize")(.25f)).Get<float>()) <<
				Property(prefix + ".noisedepth")(props.Get(Property("noisedepth")(2)).Get<int>()) <<
				Property(prefix + ".bright")(props.Get(Property("bright")(1.f)).Get<float>()) <<
				Property(prefix + ".contrast")(props.Get(Property("contrast")(1.f)).Get<float>()) <<
				GetTextureMapping3D(prefix, currentTransform, props);
	} else if (texType == "blender_distortednoise") {
		*sceneProps <<
				Property(prefix + ".type")("blender_distortednoise") <<
				Property(prefix + ".noise_distortion")(props.Get(Property("noise_distortion")("blender_original")).Get<string>()) <<
				Property(prefix + ".noisebasis")(props.Get(Property("noisebasis")("blender_original")).Get<string>()) <<
				Property(prefix + ".noisesize")(props.Get(Property("noisesize")(.25f)).Get<float>()) <<
				Property(prefix + ".distortion")(props.Get(Property("distortion")(1.f)).Get<float>()) <<
				Property(prefix + ".bright")(props.Get(Property("bright")(1.f)).Get<float>()) <<
				Property(prefix + ".contrast")(props.Get(Property("contrast")(1.f)).Get<float>()) <<
				GetTextureMapping3D(prefix, currentTransform, props);
	} else if (texType == "blender_magic") {
		*sceneProps <<
				Property(prefix + ".type")("blender_magic") <<
				Property(prefix + ".noisedepth")(props.Get(Property("noisedepth")(2)).Get<int>()) <<
				Property(prefix + ".turbulence")(props.Get(Property("turbulence")(5.f)).Get<float>()) <<
				Property(prefix + ".distortion")(props.Get(Property("distortion")(1.f)).Get<float>()) <<
				Property(prefix + ".bright")(props.Get(Property("bright")(1.f)).Get<float>()) <<
				Property(prefix + ".contrast")(props.Get(Property("contrast")(1.f)).Get<float>()) <<
				GetTextureMapping3D(prefix, currentTransform, props);
	} else if (texType == "blender_marble") {
		*sceneProps <<
				Property(prefix + ".type")("blender_marble") <<
				Property(prefix + ".marbletype")(props.Get(Property("marbletype")("soft")).Get<string>()) <<
				Property(prefix + ".noisebasis")(props.Get(Property("noisebasis")("blender_original")).Get<string>()) <<
				Property(prefix + ".noisebasis2")(props.Get(Property("noisebasis2")("sin")).Get<string>()) <<
				Property(prefix + ".noisedepth")(props.Get(Property("noisedepth")(2)).Get<int>()) <<
				Property(prefix + ".noisesize")(props.Get(Property("noisesize")(.25f)).Get<float>()) <<
				Property(prefix + ".noisetype")(props.Get(Property("noisetype")("soft_noise")).Get<string>()) <<
				Property(prefix + ".turbulence")(props.Get(Property("turbulence")(5.f)).Get<float>()) <<
				Property(prefix + ".bright")(props.Get(Property("bright")(1.f)).Get<float>()) <<
				Property(prefix + ".contrast")(props.Get(Property("contrast")(1.f)).Get<float>()) <<
				GetTextureMapping3D(prefix, currentTransform, props);
	} else if (texType == "blender_musgrave") {
		*sceneProps <<
				Property(prefix + ".type")("blender_musgrave") <<
				Property(prefix + ".musgravetype")(props.Get(Property("musgravetype")("multifractal")).Get<string>()) <<
				Property(prefix + ".noisebasis")(props.Get(Property("noisebasis")("blender_original")).Get<string>()) <<
				Property(prefix + ".dimension")(props.Get(Property("dimension")(1.f)).Get<float>()) <<
				Property(prefix + ".intensity")(props.Get(Property("intensity")(1.f)).Get<float>()) <<
				Property(prefix + ".lacunarity")(props.Get(Property("lacunarity")(1.f)).Get<float>()) <<
				Property(prefix + ".offset")(props.Get(Property("offset")(1.f)).Get<float>()) <<
				Property(prefix + ".gain")(props.Get(Property("gain")(1.f)).Get<float>()) <<
				Property(prefix + ".octaves")(props.Get(Property("octaves")(2.f)).Get<float>()) <<
				Property(prefix + ".noisesize")(props.Get(Property("noisesize")(.25f)).Get<float>()) <<
				Property(prefix + ".bright")(props.Get(Property("bright")(1.f)).Get<float>()) <<
				Property(prefix + ".contrast")(props.Get(Property("contrast")(1.f)).Get<float>()) <<
				GetTextureMapping3D(prefix, currentTransform, props);
	} else if (texType == "blender_noise") {
		*sceneProps <<
				Property(prefix + ".type")("blender_noise") <<
				Property(prefix + ".noisedepth")(props.Get(Property("noisedepth")(2)).Get<int>());
	} else if (texType == "blender_stucci") {
		*sceneProps <<
				Property(prefix + ".type")("blender_stucci") <<
				Property(prefix + ".stuccitype")(props.Get(Property("stuccitype")("plastic")).Get<string>()) <<
				Property(prefix + ".noisebasis")(props.Get(Property("noisebasis")("blender_original")).Get<string>()) <<
				Property(prefix + ".noisetype")(props.Get(Property("noisetype")("soft_noise")).Get<string>()) <<
				Property(prefix + ".noisesize")(props.Get(Property("noisesize")(.25f)).Get<float>()) <<
				Property(prefix + ".turbulence")(props.Get(Property("turbulence")(5.f)).Get<float>()) <<
				Property(prefix + ".bright")(props.Get(Property("bright")(1.f)).Get<float>()) <<
				Property(prefix + ".contrast")(props.Get(Property("contrast")(1.f)).Get<float>()) <<
				GetTextureMapping3D(prefix, currentTransform, props);
	} else if (texType == "blender_wood") {
		*sceneProps <<
				Property(prefix + ".type")("blender_wood") <<
				Property(prefix + ".woodtype")(props.Get(Property("woodtype")("bands")).Get<string>()) <<
				Property(prefix + ".noisebasis")(props.Get(Property("noisebasis")("blender_original")).Get<string>()) <<
				Property(prefix + ".noisebasis2")(props.Get(Property("noisebasis2")("sin")).Get<string>()) <<
				Property(prefix + ".noisetype")(props.Get(Property("noisetype")("soft_noise")).Get<string>()) <<
				Property(prefix + ".noisesize")(props.Get(Property("noisesize")(.25f)).Get<float>()) <<
				Property(prefix + ".turbulence")(props.Get(Property("turbulence")(5.f)).Get<float>()) <<
				Property(prefix + ".bright")(props.Get(Property("bright")(1.f)).Get<float>()) <<
				Property(prefix + ".contrast")(props.Get(Property("contrast")(1.f)).Get<float>()) <<
				GetTextureMapping3D(prefix, currentTransform, props);
	} else if (texType == "blender_voronoi") {
		*sceneProps <<
				Property(prefix + ".type")("blender_voronoi") <<
				Property(prefix + ".intensity")(props.Get(Property("intensity")(1.f)).Get<float>()) <<
				Property(prefix + ".exponent")(props.Get(Property("exponent")(2.f)).Get<float>()) <<
				Property(prefix + ".distmetric")(props.Get(Property("distmetric")("actual_distance")).Get<string>()) <<
				Property(prefix + ".w1")(props.Get(Property("w1")(1.f)).Get<float>()) <<
				Property(prefix + ".w2")(props.Get(Property("w2")(0.f)).Get<float>()) <<
				Property(prefix + ".w3")(props.Get(Property("w3")(0.f)).Get<float>()) <<
				Property(prefix + ".w4")(props.Get(Property("w4")(0.f)).Get<float>()) <<
				Property(prefix + ".noisesize")(props.Get(Property("noisesize")(.25f)).Get<float>()) <<
				Property(prefix + ".bright")(props.Get(Property("bright")(1.f)).Get<float>()) <<
				Property(prefix + ".contrast")(props.Get(Property("contrast")(1.f)).Get<float>()) <<
				GetTextureMapping3D(prefix, currentTransform, props);
	}
	//--------------------------------------------------------------------------
	else if (texType == "hitpointcolor") {
		*sceneProps <<
				Property(prefix + ".type")("hitpointcolor");
	} else if (texType == "hitpointalpha") {
		*sceneProps <<
				Property(prefix + ".type")("hitpointalpha");
	} else if (texType == "hitpointgrey") {
		const int channel = props.Get("channel").Get<int>();
		*sceneProps <<
				Property(prefix + ".type")("hitpointgrey") <<
				Property(prefix + ".channel")(((channel != 0) && (channel != 1) && (channel != 2)) ?
						-1 : channel);
	} else if (texType == "fresnelcolor") {
		Property krProp = props.Get(Property("Kr")(Spectrum(.5f)));
		if (krProp.GetSize() == 1) {
			// Kr is a texture
			//
			// Note: only constant textures are supported
			*sceneProps <<
					Property(prefix + ".type")("fresnelcolor") <<
					Property(prefix + ".kr")(GetLuxCoreValidName(props.Get(Property("Kr")("")).Get<string>()));
		} else if (krProp.GetSize() == 3) {
			// Kr is a Spectrum
			*sceneProps <<
					Property(prefix + ".type")("fresnelcolor") <<
					Property(prefix + ".kr")(props.Get(Property("Kr")(Spectrum(.5f))).Get<Spectrum>());
		} else
			throw runtime_error("Unknown Kr type of fresnelcolor: " + krProp.ToString());
	} else if (texType == "preset") {
		*sceneProps <<
				Property(prefix + ".type")("fresnelpreset") <<
				Property(prefix + ".name")(props.Get(Property("name")("aluminium")).Get<string>());
	} else if (texType == "sopra") {
		*sceneProps <<
				Property(prefix + ".type")("fresnelsopra") <<
				Property(prefix + ".file")(props.Get(Property("filename")("")).Get<string>());
	} else if (texType == "luxpop") {
		*sceneProps <<
				Property(prefix + ".type")("fresnelluxpop") <<
				Property(prefix + ".file")(props.Get(Property("filename")("")).Get<string>());
	} else if (texType == "cauchy") {
		const float index = props.Get(Property("index")(-1.f)).Get<float>();
		const float b = props.Get(Property("cauchyb")(0.f)).Get<float>();
		*sceneProps <<
				Property(prefix + ".type")("fresnelcauchy") <<
				Property(prefix + ".a")(props.Get(Property("cauchya")(index > 0.f ? (index - b * 1e6f / (720.f * 380.f)) : 1.5f)).Get<float>()) <<
				Property(prefix + ".b")(b);
	} else if (texType == "abbe") {
		const string mode = props.Get(Property("type")("d")).Get<string>();
		*sceneProps <<
				Property(prefix + ".type")("fresnelabbe") <<
				Property(prefix + ".mode")(props.Get(Property("type")("d")).Get<string>()) <<
				Property(prefix + ".v")(props.Get(Property("V")(64.17f)).Get<float>()) <<
				Property(prefix + ".n")(props.Get(Property("n")(1.5168f)).Get<float>());
		if (mode == "custom") {
			*sceneProps <<
				Property(prefix + ".d")(props.Get(Property("lambda_D")(587.5618f)).Get<float>()) <<
				Property(prefix + ".f")(props.Get(Property("lambda_F")(486.13f)).Get<float>()) <<
				Property(prefix + ".c")(props.Get(Property("lambda_C")(656.28f)).Get<float>());
		}
	} else {
		LC_LOG("LuxCore doesn't support the texture type: " << texType);

		*sceneProps <<
				Property(prefix + ".type")("constfloat1") <<
				Property(prefix + ".value")(.7f);
	}

	FreeArgs();
}
#line 3458 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 66: /* ri_stmt: TRANSFORMBEGIN  */
#line 2030 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	transformsStack.push_back(currentTransform);
}
#line 3466 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 67: /* ri_stmt: TRANSFORMEND  */
#line 2034 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	if (!(transformsStack.size() > graphicsStatesStack.size())) {
		LC_LOG("Unmatched TransformEnd encountered. Ignoring it.");
	} else {
		currentTransform = transformsStack.back();
		transformsStack.pop_back();
	}
}
#line 3479 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 68: /* ri_stmt: TRANSFORM real_num_array  */
#line 2043 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	if (VerifyArrayLength((yyvsp[0].ribarray), 16, "Transform")) {
		const float *tr = static_cast<float *>((yyvsp[0].ribarray)->array);
		Transform t(Matrix4x4(tr[0], tr[4], tr[8], tr[12],
				tr[1], tr[5], tr[9], tr[13],
				tr[2], tr[6], tr[10], tr[14],
				tr[3], tr[7], tr[11], tr[15]));

		currentTransform = t;
	}

	ArrayFree((yyvsp[0].ribarray));
}
#line 3497 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 69: /* ri_stmt: TRANSLATE NUM NUM NUM  */
#line 2057 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	Transform t(Translate(Vector((yyvsp[-2].num), (yyvsp[-1].num), (yyvsp[0].num))));
	currentTransform = currentTransform * t;
}
#line 3506 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 70: /* ri_stmt: VOLUMEINTEGRATOR STRING paramlist  */
#line 2062 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	FreeArgs();
}
#line 3514 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 71: /* ri_stmt: VOLUME STRING paramlist  */
#line 2066 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
	FreeArgs();
}
#line 3522 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 72: /* ri_stmt: WORLDBEGIN  */
#line 2070 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
}
#line 3529 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;

  case 73: /* ri_stmt: WORLDEND  */
#line 2073 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"
{
}
#line 3536 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"
    break;


#line 3540 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/redhat-linux-build/generated/luxparser/luxparse.cpp"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == LUXCORE_PARSERLXS_YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= LUXCORE_PARSERLXS_YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == LUXCORE_PARSERLXS_YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = LUXCORE_PARSERLXS_YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != LUXCORE_PARSERLXS_YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 2075 "/builddir/build/BUILD/LuxCore-luxcorerender_v2.7beta1/src/luxcore/luxparser/luxparse.y"

