
#include <string>

namespace luxrays { namespace ocl {
std::string KernelSource_cudadevice_oclemul_funcs =
"#line 2 \"cudadevice_oclemul_funcs.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"//------------------------------------------------------------------------------\n"
"//------------------------------------------------------------------------------\n"
"//------------------------------------------------------------------------------\n"
"// OpenCL functions\n"
"//------------------------------------------------------------------------------\n"
"//------------------------------------------------------------------------------\n"
"//------------------------------------------------------------------------------\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// get_global_id()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__forceinline__ size_t get_global_id(const uint dimIndex) {\n"
"	switch (dimIndex) {\n"
"		case 0:\n"
"			return blockIdx.x * blockDim.x + threadIdx.x;\n"
"		case 1:\n"
"			return blockIdx.y * blockDim.y + threadIdx.y;\n"
"		case 2:\n"
"			return blockIdx.z * blockDim.z + threadIdx.z;\n"
"		default:\n"
"			return 0;\n"
"	}\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// get_local_id()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__forceinline__ size_t get_local_id(const uint dimIndex) {\n"
"	switch (dimIndex) {\n"
"		case 0:\n"
"			return threadIdx.x;\n"
"		case 1:\n"
"			return threadIdx.y;\n"
"		case 2:\n"
"			return threadIdx.z;\n"
"		default:\n"
"			return 0;\n"
"	}\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// get_local_size()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__forceinline__ size_t get_local_size(const uint dimIndex) {\n"
"	switch (dimIndex) {\n"
"		case 0:\n"
"			return blockDim.x;\n"
"		case 1:\n"
"			return blockDim.y;\n"
"		case 2:\n"
"			return blockDim.z;\n"
"		default:\n"
"			return 0;\n"
"	}\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// get_group_id()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__forceinline__ size_t get_group_id(const uint dimIndex) {\n"
"	switch (dimIndex) {\n"
"		case 0:\n"
"			return blockIdx.x;\n"
"		case 1:\n"
"			return blockIdx.y;\n"
"		case 2:\n"
"			return blockIdx.z;\n"
"		default:\n"
"			return 0;\n"
"	}\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// barrier()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"#define CLK_LOCAL_MEM_FENCE 0\n"
"//#define CLK_GLOBAL_MEM_FENCE 1\n"
"\n"
"__forceinline__ void barrier(const uint flag) {\n"
"	// This works for CLK_LOCAL_MEM_FENCE\n"
"	__syncthreads();\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"//------------------------------------------------------------------------------\n"
"//------------------------------------------------------------------------------\n"
"// Math functions\n"
"//------------------------------------------------------------------------------\n"
"//------------------------------------------------------------------------------\n"
"//------------------------------------------------------------------------------\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// MAKE_FLOATn()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"#define MAKE_FLOAT2(x, y) make_float2(x, y)\n"
"#define MAKE_FLOAT3(x, y, z) make_float3(x, y, z)\n"
"#define MAKE_FLOAT4(x, y, z, w) make_float4(x, y, z, w)\n"
"\n"
"__forceinline__ float2 TO_FLOAT2(const float x) {\n"
"	return make_float2(x, x);\n"
"}\n"
"\n"
"__forceinline__ float3 TO_FLOAT3(const float x) {\n"
"	return make_float3(x, x, x);\n"
"}\n"
"\n"
"__forceinline__ float4 TO_FLOAT4(const float x) {\n"
"	return make_float4(x, x, x, x);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// vload_half()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"typedef unsigned short half;\n"
"\n"
"__forceinline__ float __half2float(const half a) {\n"
"	float val;\n"
"\n"
"    asm(\"{  cvt.f32.f16 %0, %1;}\\n\" : \"=f\"(val) : \"h\"(*(reinterpret_cast<const unsigned short *>(&a))));\n"
"\n"
"    return val;\n"
"}\n"
"\n"
"__forceinline__ float vload_half(const size_t offset, const half *p) {\n"
"	return __half2float(p[offset]);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// vloadn()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__forceinline__ float2 vload2(const size_t offset, const float *p) {\n"
"	return make_float2(p[offset], p[offset + 1]);\n"
"}\n"
"\n"
"__forceinline__ float3 vload3(const size_t offset, const float *p) {\n"
"	return make_float3(p[offset], p[offset + 1], p[offset + 2]);\n"
"}\n"
"\n"
"__forceinline__ float4 vload4(const size_t offset, const float *p) {\n"
"	return make_float4(p[offset], p[offset + 1], p[offset + 2], p[offset + 3]);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// vstoren()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__forceinline__ void vstore2(const float2 data, const size_t offset, float *p) {\n"
"	p[offset] = data.x;\n"
"	p[offset + 1] = data.y;\n"
"}\n"
"\n"
"__forceinline__ void vstore3(const float3 data, const size_t offset, float *p) {\n"
"	p[offset] = data.x;\n"
"	p[offset + 1] = data.y;\n"
"	p[offset + 2] = data.z;\n"
"}\n"
"\n"
"__forceinline__ void vstore4(const float4 data, const size_t offset, float *p) {\n"
"	p[offset] = data.x;\n"
"	p[offset + 1] = data.y;\n"
"	p[offset + 2] = data.z;\n"
"	p[offset + 2] = data.w;\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// mix()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__forceinline__ float mix(const float x, const float y, const float a) {\n"
"	return x + (y - x) * a;\n"
"}\n"
"\n"
"__forceinline__ float2 mix(const float2 x, const float2 y, const float a) {\n"
"	return x + (y - x) * a;\n"
"}\n"
"__forceinline__ float2 mix(const float2 x, const float2 y, const float2 a) {\n"
"	return x + (y - x) * a;\n"
"}\n"
"\n"
"__forceinline__ float3 mix(const float3 x, const float3 y, const float a) {\n"
"	return x + (y - x) * a;\n"
"}\n"
"__forceinline__ float3 mix(const float3 x, const float3 y, const float3 a) {\n"
"	return x + (y - x) * a;\n"
"}\n"
"\n"
"__forceinline__ float4 mix(const float4 x, const float4 y, const float a) {\n"
"	return x + (y - x) * a;\n"
"}\n"
"__forceinline__ float4 mix(const float4 x, const float4 y, const float4 a) {\n"
"	return x + (y - x) * a;\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// isequal()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__forceinline__ int isequal(const float x, const float y) {\n"
"	return x == y;\n"
"}\n"
"\n"
"__forceinline__ int2 isequal(const float2 x, const float2 y) {\n"
"	return make_int2(x.x == y.x ? -1 : 0, x.y == y.y ? -1 : 0);\n"
"}\n"
"\n"
"__forceinline__ int3 isequal(const float3 x, const float3 y) {\n"
"	return make_int3(x.x == y.x ? -1 : 0, x.y == y.y ? -1 : 0, x.z == y.z ? -1 : 0);\n"
"}\n"
"\n"
"__forceinline__ int4 isequal(const float4 x, const float4 y) {\n"
"	return make_int4(x.x == y.x ? -1 : 0, x.y == y.y ? -1 : 0, x.z == y.z ? -1 : 0, x.w == y.w ? -1 : 0);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// all()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__forceinline__ int all(const int x) {\n"
"	return x & -1;\n"
"}\n"
"\n"
"__forceinline__ int all(const int2 x) {\n"
"	return all(x.x) && all(x.y);\n"
"}\n"
"\n"
"__forceinline__ int all(const int3 x) {\n"
"	return all(x.x) && all(x.y) && all(x.z);\n"
"}\n"
"\n"
"__forceinline__ int all(const int4 x) {\n"
"	return all(x.x) && all(x.y) && all(x.z) && all(x.w);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// any()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__forceinline__ int any(const int x) {\n"
"	return x & -1;\n"
"}\n"
"\n"
"__forceinline__ int any(const int2 x) {\n"
"	return any(x.x) || any(x.y);\n"
"}\n"
"\n"
"__forceinline__ int any(const int3 x) {\n"
"	return any(x.x) || any(x.y) || any(x.z);\n"
"}\n"
"\n"
"__forceinline__ int any(const int4 x) {\n"
"	return any(x.x) || any(x.y) || any(x.z) || any(x.w);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// isnan()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__forceinline__ int2 isnan(const float2 x) {\n"
"	return make_int2(isnan(x.x), isnan(x.y));\n"
"}\n"
"\n"
"__forceinline__ int3 isnan(const float3 x) {\n"
"	return make_int3(isnan(x.x), isnan(x.y), isnan(x.z));\n"
"}\n"
"\n"
"__forceinline__ int4 isnan(const float4 x) {\n"
"	return make_int4(isnan(x.x), isnan(x.y), isnan(x.z), isnan(x.w));\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// isinf()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__forceinline__ int2 isinf(const float2 x) {\n"
"	return make_int2(isinf(x.x), isinf(x.y));\n"
"}\n"
"\n"
"__forceinline__ int3 isinf(const float3 x) {\n"
"	return make_int3(isinf(x.x), isinf(x.y), isinf(x.z));\n"
"}\n"
"\n"
"__forceinline__ int4 isinf(const float4 x) {\n"
"	return make_int4(isinf(x.x), isinf(x.y), isinf(x.z), isinf(x.w));\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// sqrt()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__forceinline__ float sqrt(const float x) {\n"
"	return sqrtf(x);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// pow()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__forceinline__ float pow(const float x, const float y) {\n"
"	return powf(x, y);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// native_powr()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__forceinline__ float native_powr(const float x, const float y) {\n"
"	return powf(x, y);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// exp()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__forceinline__ float exp(const float x) {\n"
"	return expf(x);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// native_exp()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__forceinline__ float native_exp(const float x) {\n"
"	return expf(x);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// log()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__forceinline__ float log(const float x) {\n"
"	return logf(x);\n"
"}\n"
"\n"
"__forceinline__ float3 log(const float3 x) {\n"
"	return MAKE_FLOAT3(logf(x.x), logf(x.y), logf(x.z));\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// native_log()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__forceinline__ float native_log(const float x) {\n"
"	return logf(x);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// sin()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__forceinline__ float sin(const float x) {\n"
"	return sinf(x);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// cos()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__forceinline__ float cos(const float x) {\n"
"	return cosf(x);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// atan()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__forceinline__ float atan(const float x) {\n"
"	return atanf(x);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// atan2()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__forceinline__ float atan2(const float x, const float y) {\n"
"	return atan2f(x, y);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// atanh()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__forceinline__ float atanh(const float x) {\n"
"	return atanhf(x);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// fabs()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__forceinline__ float fabs(const float x) {\n"
"	return fabsf(x);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// fmax()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__forceinline__ float fmax(const float x, const float y) {\n"
"	return fmaxf(x, y);\n"
"}\n"
"\n"
"\n"
"__forceinline__ float3 fmax(const float3 x, const float3 y) {\n"
"	return MAKE_FLOAT3(fmaxf(x.x, y.x), fmaxf(x.y, y.y), fmaxf(x.z, y.z));\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// fmin()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__forceinline__ float fmin(const float x, const float y) {\n"
"	return fminf(x, y);\n"
"}\n"
"\n"
"__forceinline__ float3 fmin(const float3 x, const float3 y) {\n"
"	return MAKE_FLOAT3(fminf(x.x, y.x), fminf(x.y, y.y), fminf(x.z, y.z));\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// as_*()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"template<typename T>\n"
"__forceinline__ int as_int(const T v) {\n"
"	union {\n"
"		T src;\n"
"		int dst;\n"
"	} val;\n"
"	\n"
"	val.src = v;\n"
"\n"
"	return val.dst;\n"
"}\n"
"\n"
"template<typename T>\n"
"__forceinline__ uint as_uint(const T v) {\n"
"	union {\n"
"		T src;\n"
"		uint dst;\n"
"	} val;\n"
"	\n"
"	val.src = v;\n"
"\n"
"	return val.dst;\n"
"}\n"
"\n"
"template<typename T>\n"
"__forceinline__ float as_float(const T v) {\n"
"	union {\n"
"		T src;\n"
"		float dst;\n"
"	} val;\n"
"	\n"
"	val.src = v;\n"
"\n"
"	return val.dst;\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// atomic_*()\n"
"//------------------------------------------------------------------------------\n"
"\n"
"uint atomic_cmpxchg(uint *p, uint cmp, uint val) {\n"
"	return atomicCAS(p, cmp, val);\n"
"}\n"
"\n"
"uint atomic_inc(uint *p) {\n"
"	return atomicAdd(p, 1u);\n"
"}\n"
"\n"
"int atomic_inc(int *p) {\n"
"	return atomicAdd(p, 1);\n"
"}\n"
"\n"
"uint atomic_dec(uint *p) {\n"
"	return atomicSub(p, 1u);\n"
"}\n"
"\n"
"int atomic_dec(int *p) {\n"
"	return atomicSub(p, 1);\n"
"}\n";
} }
