
#include <string>

namespace luxrays { namespace ocl {
std::string KernelSource_exttrianglemesh_types =
"#line 2 \"exttrianglemesh_types.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"#define EXTMESH_MAX_DATA_COUNT 8u\n"
"\n"
"typedef struct {\n"
"	Transform appliedTrans;\n"
"	int appliedTransSwapsHandedness;\n"
"} TriangleMeshParam;\n"
"\n"
"typedef struct {\n"
"	Transform trans;\n"
"	int transSwapsHandedness;\n"
"} TriangleInstanceMeshParam;\n"
"\n"
"typedef struct {\n"
"	MotionSystem motionSystem;\n"
"} TriangleMotionMeshParam;\n"
"\n"
"typedef struct {\n"
"	MeshType type;\n"
"\n"
"	// Vertex information\n"
"	unsigned int vertsOffset;\n"
"	unsigned int normalsOffset;\n"
"	unsigned int triNormalsOffset;\n"
"	unsigned int uvsOffset[EXTMESH_MAX_DATA_COUNT];\n"
"	unsigned int colsOffset[EXTMESH_MAX_DATA_COUNT];\n"
"	unsigned int alphasOffset[EXTMESH_MAX_DATA_COUNT];\n"
"\n"
"	 // Vertex and Triangle AOV\n"
"	unsigned int vertexAOVOffset[EXTMESH_MAX_DATA_COUNT];\n"
"	unsigned int triAOVOffset[EXTMESH_MAX_DATA_COUNT];\n"
"\n"
"	// Triangle information\n"
"	unsigned int trisOffset;\n"
"\n"
"	// Object space transformation\n"
"	union {\n"
"		TriangleMeshParam triangle;\n"
"		TriangleInstanceMeshParam instance;\n"
"		TriangleMotionMeshParam motion;\n"
"	};\n"
"} ExtMesh;\n"
"\n"
"#if defined(SLG_OPENCL_KERNEL)\n"
"\n"
"#define EXTMESH_PARAM_DECL , \\\n"
"		__global const ExtMesh* restrict meshDescs, \\\n"
"		__global const Point* restrict vertices, \\\n"
"		__global const Normal* restrict vertNormals, \\\n"
"		__global const Normal* restrict triNormals, \\\n"
"		__global const UV* restrict vertUVs, \\\n"
"		__global const Spectrum* restrict vertCols, \\\n"
"		__global const float* restrict vertAlphas, \\\n"
"		__global const float* restrict vertexAOVs, \\\n"
"		__global const float* restrict triAOVs, \\\n"
"		__global const Triangle* restrict triangles, \\\n"
"		__global const InterpolatedTransform* restrict interpolatedTransforms\n"
"#define EXTMESH_PARAM , \\\n"
"		meshDescs, \\\n"
"		vertices, \\\n"
"		vertNormals, \\\n"
"		triNormals, \\\n"
"		vertUVs, \\\n"
"		vertCols, \\\n"
"		vertAlphas, \\\n"
"		vertexAOVs, \\\n"
"		triAOVs, \\\n"
"		triangles, \\\n"
"		interpolatedTransforms\n"
"\n"
"#endif\n";
} }
