
#include <string>

namespace luxrays { namespace ocl {
std::string KernelSource_luxrays_types =
"#line 2 \"luxrays_types.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"#define NULL_INDEX (0xffffffffu)\n"
"\n"
"#if defined(LUXRAYS_OPENCL_KERNEL)\n"
"\n"
"// Used when the sources are not compiled by SLG library\n"
"#if !defined(OPENCL_FORCE_NOT_INLINE)\n"
"#define OPENCL_FORCE_NOT_INLINE\n"
"#endif\n"
"\n"
"#if !defined(OPENCL_FORCE_INLINE)\n"
"#define OPENCL_FORCE_INLINE\n"
"#endif\n"
"\n"
"#define NULL 0\n"
"\n"
"OPENCL_FORCE_INLINE float2 VLOAD2F(const __global float *p) {\n"
"	return vload2(0, p);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void VSTORE2F(const float2 v, __global float *p) {\n"
"	vstore2(v, 0, p);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 VLOAD3F(const __global float *p) {\n"
"	return vload3(0, p);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 VLOAD3F_Private(const float *p) {\n"
"	return vload3(0, p);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void VSTORE3F(const float3 v, __global float *p) {\n"
"	vstore3(v, 0, p);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float4 VLOAD4F(const __global float *p) {\n"
"	return vload4(0, p);\n"
"}\n"
"\n"
"// Input address must be aligned to 16B\n"
"// This performs better than vload4()\n"
"OPENCL_FORCE_INLINE float4 VLOAD4F_Align(const __global float *p) {\n"
"	return *((const __global float4 *)p);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float4 VLOAD4F_Private(const float *p) {\n"
"	return vload4(0, p);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void VSTORE4F(const float4 v, __global float *p) {\n"
"	vstore4(v, 0, p);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void VADD3F(__global float *p, const float3 v) {\n"
"	VSTORE3F(VLOAD3F(p) + v, p);\n"
"}\n"
"\n"
"#endif\n";
} }
