
#include <string>

namespace luxrays { namespace ocl {
std::string KernelSource_optixaccel =
"#line 2 \"optixaccel.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"//------------------------------------------------------------------------------\n"
"\n"
"typedef unsigned long long CUdeviceptr;\n"
"\n"
"typedef unsigned long long OptixTraversableHandle;\n"
"typedef unsigned int OptixVisibilityMask;\n"
"\n"
"//------------------------------------------------------------------------------\n"
"\n"
"static __forceinline__ __device__ uint3 optixGetLaunchIndex()\n"
"{\n"
"    unsigned int u0, u1, u2;\n"
"    asm( \"call (%0), _optix_get_launch_index_x, ();\" : \"=r\"( u0 ) : );\n"
"    asm( \"call (%0), _optix_get_launch_index_y, ();\" : \"=r\"( u1 ) : );\n"
"    asm( \"call (%0), _optix_get_launch_index_z, ();\" : \"=r\"( u2 ) : );\n"
"    return make_uint3( u0, u1, u2 );\n"
"}\n"
"\n"
"static __forceinline__ __device__ void optixTrace( OptixTraversableHandle handle,\n"
"                                                   float3                 rayOrigin,\n"
"                                                   float3                 rayDirection,\n"
"                                                   float                  tmin,\n"
"                                                   float                  tmax,\n"
"                                                   float                  rayTime,\n"
"                                                   OptixVisibilityMask    visibilityMask,\n"
"                                                   unsigned int           rayFlags,\n"
"                                                   unsigned int           SBToffset,\n"
"                                                   unsigned int           SBTstride,\n"
"                                                   unsigned int           missSBTIndex )\n"
"{\n"
"    float ox = rayOrigin.x, oy = rayOrigin.y, oz = rayOrigin.z;\n"
"    float dx = rayDirection.x, dy = rayDirection.y, dz = rayDirection.z;\n"
"    asm volatile(\n"
"        \"call _optix_trace_0\"\n"
"        \", (%0, %1, %2, %3, %4, %5, %6, %7, %8, %9, %10, %11, %12, %13, %14\"\n"
"        \");\"\n"
"        :\n"
"        /* no return value */\n"
"        : \"l\"( handle ), \"f\"( ox ), \"f\"( oy ), \"f\"( oz ), \"f\"( dx ), \"f\"( dy ), \"f\"( dz ), \"f\"( tmin ), \"f\"( tmax ),\n"
"          \"f\"( rayTime ), \"r\"( visibilityMask ), \"r\"( rayFlags ), \"r\"( SBToffset ), \"r\"( SBTstride ), \"r\"( missSBTIndex )\n"
"        : );\n"
"}\n"
"\n"
"static __forceinline__ __device__ float optixGetRayTmax()\n"
"{\n"
"    float f0;\n"
"    asm( \"call (%0), _optix_get_ray_tmax, ();\" : \"=f\"( f0 ) : );\n"
"    return f0;\n"
"}\n"
"\n"
"static __forceinline__ __device__ float2 optixGetTriangleBarycentrics()\n"
"{\n"
"    float f0, f1;\n"
"    asm( \"call (%0, %1), _optix_get_triangle_barycentrics, ();\" : \"=f\"( f0 ), \"=f\"( f1 ) : );\n"
"    return make_float2( f0, f1 );\n"
"}\n"
"\n"
"static __forceinline__ __device__ unsigned int optixGetPrimitiveIndex()\n"
"{\n"
"    unsigned int u0;\n"
"    asm( \"call (%0), _optix_read_primitive_idx, ();\" : \"=r\"( u0 ) : );\n"
"    return u0;\n"
"}\n"
"\n"
"static __forceinline__ __device__ CUdeviceptr optixGetSbtDataPointer()\n"
"{\n"
"    unsigned long long ptr;\n"
"    asm( \"call (%0), _optix_get_sbt_data_ptr_64, ();\" : \"=l\"( ptr ) : );\n"
"    return (CUdeviceptr)ptr;\n"
"}\n"
"\n"
"static __forceinline__ __device__ unsigned int optixGetInstanceId()\n"
"{\n"
"    unsigned int u0;\n"
"    asm( \"call (%0), _optix_read_instance_id, ();\" : \"=r\"( u0 ) : );\n"
"    return u0;\n"
"}\n"
"\n"
"static __forceinline__ __device__ unsigned int optixGetInstanceIndex()\n"
"{\n"
"    unsigned int u0;\n"
"    asm( \"call (%0), _optix_read_instance_idx, ();\" : \"=r\"( u0 ) : );\n"
"    return u0;\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// This must match the definition in optixaccel.cpp\n"
"\n"
"typedef struct Params {\n"
"	OptixTraversableHandle optixHandle;\n"
"	CUdeviceptr rayBuff;\n"
"	CUdeviceptr rayHitBuff;\n"
"} OptixAccelParams;\n"
"\n"
"//------------------------------------------------------------------------------\n"
"\n"
"extern \"C\" {\n"
"__constant__ OptixAccelParams optixAccelParams;\n"
"}\n"
"\n"
"extern \"C\" __global__ void __raygen__OptixAccel() {\n"
"	const uint3 launchIndex = optixGetLaunchIndex();\n"
"\n"
"	Ray *rayBuff = (Ray *)optixAccelParams.rayBuff;\n"
"	Ray *ray = &rayBuff[launchIndex.x];\n"
"\n"
"	if (ray->flags & RAY_FLAGS_MASKED)\n"
"		return;\n"
"\n"
"	optixTrace(\n"
"            optixAccelParams.optixHandle,\n"
"            make_float3(ray->o.x, ray->o.y, ray->o.z),\n"
"            make_float3(ray->d.x, ray->d.y, ray->d.z),\n"
"            ray->mint,\n"
"            ray->maxt,\n"
"            ray->time,\n"
"            OptixVisibilityMask(1),\n"
"            0,\n"
"            0, 1, 0);\n"
"}\n"
"\n"
"extern \"C\" __global__ void __closesthit__OptixAccel() {\n"
"	const uint3 launchIndex = optixGetLaunchIndex();\n"
"\n"
"	RayHit *rayHitBuff = (RayHit *)optixAccelParams.rayHitBuff;\n"
"	RayHit *rayHit = &rayHitBuff[launchIndex.x];\n"
"\n"
"	const uint triangleIndex = optixGetPrimitiveIndex();\n"
"\n"
"	if (triangleIndex == NULL_INDEX) {\n"
"		rayHit->meshIndex = NULL_INDEX;\n"
"		rayHit->triangleIndex = NULL_INDEX;\n"
"	} else {\n"
"		rayHit->t = optixGetRayTmax();\n"
"\n"
"		const float2 barycentrics = optixGetTriangleBarycentrics();\n"
"		rayHit->b1 = barycentrics.x;\n"
"		rayHit->b2 = barycentrics.y;\n"
"\n"
"		rayHit->meshIndex = optixGetInstanceId();\n"
"		rayHit->triangleIndex = triangleIndex;\n"
"	}\n"
"}\n"
"\n"
"extern \"C\" __global__ void __miss__OptixAccel() {\n"
"	const uint3 launchIndex = optixGetLaunchIndex();\n"
"\n"
"	RayHit *rayHitBuff = (RayHit *)optixAccelParams.rayHitBuff;\n"
"	RayHit *rayHit = &rayHitBuff[launchIndex.x];\n"
"	\n"
"	rayHit->meshIndex = NULL_INDEX;\n"
"	rayHit->triangleIndex = NULL_INDEX;\n"
"}\n";
} }
