
#include <string>

namespace luxrays { namespace ocl {
std::string KernelSource_randomgen_funcs =
"#line 2 \"randomgen_funcs.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Random number generator\n"
"// maximally equidistributed combined Tausworthe generator\n"
"//------------------------------------------------------------------------------\n"
"\n"
"#define FLOATMASK 0x00ffffffu\n"
"\n"
"OPENCL_FORCE_INLINE uint TAUSWORTHE(const uint s, const uint a,\n"
"	const uint b, const uint c,\n"
"	const uint d) {\n"
"	return ((s & c) << d) ^ (((s << a) ^ s) >> b);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE uint LCG(const uint x) { return x * 69069; }\n"
"\n"
"OPENCL_FORCE_INLINE uint ValidSeed(const uint x, const uint m) {\n"
"	return (x < m) ? (x + m) : x;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void Rnd_Init(uint seed, Seed *s) {\n"
"	s->s1 = ValidSeed(LCG(seed), 1);\n"
"	s->s2 = ValidSeed(LCG(s->s1), 7);\n"
"	s->s3 = ValidSeed(LCG(s->s2), 15);\n"
"}\n"
"\n"
"// This constructor is used to build a sequence of pseudo-random numbers\n"
"// starting form a floating point seed (usually another pseudo-random\n"
"// number)\n"
"OPENCL_FORCE_INLINE void Rnd_InitFloat(const float floatSeed, Seed *s) {\n"
"	union {\n"
"		float f;\n"
"		uint i;\n"
"	} bits;\n"
"\n"
"	bits.f = floatSeed;\n"
"\n"
"	Rnd_Init(bits.i, s);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE unsigned long Rnd_UintValue(Seed *s) {\n"
"	s->s1 = TAUSWORTHE(s->s1, 13, 19, 4294967294UL, 12);\n"
"	s->s2 = TAUSWORTHE(s->s2, 2, 25, 4294967288UL, 4);\n"
"	s->s3 = TAUSWORTHE(s->s3, 3, 11, 4294967280UL, 17);\n"
"\n"
"	return ((s->s1) ^ (s->s2) ^ (s->s3));\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float Rnd_FloatValue(Seed *s) {\n"
"	return (Rnd_UintValue(s) & FLOATMASK) * (1.f / (FLOATMASK + 1UL));\n"
"}\n";
} }
