
#include <string>

namespace luxrays { namespace ocl {
std::string KernelSource_utils_funcs =
"#line 2 \"utils_funcs.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"OPENCL_FORCE_INLINE int Mod(int a, int b) {\n"
"	if (b == 0)\n"
"		b = 1;\n"
"\n"
"	a %= b;\n"
"	if (a < 0)\n"
"		a += b;\n"
"\n"
"	return a;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float Radians(float deg) {\n"
"	return (M_PI_F / 180.f) * deg;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float Degrees(float rad) {\n"
"	return (180.f / M_PI_F) * rad;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float Sgn(float a) {\n"
"	return a < 0.f ? -1.f : 1.f;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE int Ceil2Int(float val) {\n"
"	return (int)ceil(val);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE uint Ceil2UInt(float val) {\n"
"	return (uint)ceil(val);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE int Floor2Int(const float val) {\n"
"	return (int)floor(val);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE unsigned int Floor2UInt(const float val) {\n"
"	return (val > 0.f) ? ((unsigned int)floor(val)) : 0;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float Lerp(const float t, const float v1, const float v2) {\n"
"	// Linear interpolation\n"
"	return mix(v1, v2, t);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float LerpWithStep(const float t, const float v1, const float v2, const float step) {\n"
"	const float lerp = mix(v1, v2, t);\n"
"\n"
"	if (step <= 0.f)\n"
"		return lerp;\n"
"\n"
"	// Linear interpolation with steps\n"
"	return floor(lerp / step) * step;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 Lerp3(const float t, const float3 v1, const float3 v2) {\n"
"	// Linear interpolation\n"
"	return mix(v1, v2, t);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float Cerp(float t, float v0, float v1, float v2, float v3) {\n"
"	// Cubic interpolation\n"
"	return v1 + .5f *\n"
"			t * (v2 - v0 +\n"
"				t * (2.f * v0 - 5.f * v1 + 4.f * v2 - v3 +\n"
"					t * (3.f * (v1 - v2) + v3 - v0)));\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 Cerp3(float t, float3 v0, float3 v1, float3 v2, float3 v3) {\n"
"	// Cubic interpolation\n"
"	return v1 + .5f *\n"
"			t * (v2 - v0 +\n"
"				t * (2.f * v0 - 5.f * v1 + 4.f * v2 - v3 +\n"
"					t * (3.f * (v1 - v2) + v3 - v0)));\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float SmoothStep(const float min, const float max, const float value) {\n"
"	const float v = clamp((value - min) / (max - min), 0.f, 1.f);\n"
"	return v * v * (-2.f * v  + 3.f);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float CosTheta(const float3 v) {\n"
"	return v.z;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float SinTheta2(const float3 w) {\n"
"	return fmax(0.f, 1.f - CosTheta(w) * CosTheta(w));\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float SinTheta(const float3 w) {\n"
"	return sqrt(SinTheta2(w));\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float CosPhi(const float3 w) {\n"
"	const float sinTheta = SinTheta(w);\n"
"	return sinTheta > 0.f ? clamp(w.x / sinTheta, -1.f, 1.f) : 1.f;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float SinPhi(const float3 w) {\n"
"	const float sinTheta = SinTheta(w);\n"
"	return sinTheta > 0.f ? clamp(w.y / sinTheta, -1.f, 1.f) : 0.f;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 SphericalDirection(float sintheta, float costheta, float phi) {\n"
"	return MAKE_FLOAT3(sintheta * cos(phi), sintheta * sin(phi), costheta);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 SphericalDirectionWithFrame(float sintheta, float costheta, float phi,\n"
"	const float3 x, const float3 y, const float3 z) {\n"
"	return sintheta * cos(phi) * x + sintheta * sin(phi) * y +\n"
"		costheta * z;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float DistanceSquared(const float3 a, const float3 b) {\n"
"	const float3 v = a - b;\n"
"	return dot(v, v);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float Sqr(const float a) {\n"
"	return a * a;\n"
"}\n";
} }
