
#include <string>

namespace slg { namespace ocl {
std::string KernelSource_bsdfutils_funcs =
"#line 2 \"bsdfutils_funcs.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"OPENCL_FORCE_INLINE BSDFEvent BSDF_GetEventTypes(__global const BSDF *bsdf\n"
"		MATERIALS_PARAM_DECL) {\n"
"	return Material_GetEventTypes(bsdf->materialIndex\n"
"			MATERIALS_PARAM);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE bool BSDF_IsDelta(__global const BSDF *bsdf\n"
"		MATERIALS_PARAM_DECL) {\n"
"	return Material_IsDelta(bsdf->materialIndex\n"
"			MATERIALS_PARAM);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE uint BSDF_GetObjectID(__global const BSDF *bsdf, __global const SceneObject* restrict sceneObjs) {\n"
"	const uint sceneObjectIndex = bsdf->sceneObjectIndex;\n"
"\n"
"	return (sceneObjectIndex != NULL_INDEX) ? sceneObjs[sceneObjectIndex].objectID : NULL_INDEX;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE uint BSDF_GetMaterialID(__global const BSDF *bsdf\n"
"		MATERIALS_PARAM_DECL) {\n"
"	return mats[bsdf->materialIndex].matID;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE uint BSDF_GetLightID(__global const BSDF *bsdf\n"
"		MATERIALS_PARAM_DECL) {\n"
"	return mats[bsdf->materialIndex].lightID;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE uint BSDF_GetMaterialInteriorVolume(__global const BSDF *bsdf\n"
"		MATERIALS_PARAM_DECL) {\n"
"	return Material_GetInteriorVolume(bsdf->materialIndex, &bsdf->hitPoint,\n"
"			bsdf->hitPoint.passThroughEvent\n"
"			MATERIALS_PARAM);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE uint BSDF_GetMaterialExteriorVolume(__global const BSDF *bsdf\n"
"		MATERIALS_PARAM_DECL) {\n"
"	return Material_GetExteriorVolume(bsdf->materialIndex, &bsdf->hitPoint,\n"
"			bsdf->hitPoint.passThroughEvent\n"
"			MATERIALS_PARAM);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float BSDF_GetGlossiness(__global const BSDF *bsdf\n"
"		MATERIALS_PARAM_DECL) {\n"
"	return Material_GetGlossiness(bsdf->materialIndex\n"
"			MATERIALS_PARAM);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 BSDF_GetPassThroughShadowTransparency(__global const BSDF *bsdf\n"
"		MATERIALS_PARAM_DECL) {\n"
"	return VLOAD3F(&mats[bsdf->materialIndex].passThroughShadowTransparency.c[0]);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 BSDF_GetLandingGeometryN(__global const BSDF *bsdf) {\n"
"	return HitPoint_GetGeometryN(&bsdf->hitPoint);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 BSDF_GetLandingInterpolatedN(__global const BSDF *bsdf) {\n"
"	return HitPoint_GetInterpolatedN(&bsdf->hitPoint);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 BSDF_GetLandingShadeN(__global const BSDF *bsdf) {\n"
"	return HitPoint_GetShadeN(&bsdf->hitPoint);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 BSDF_GetRayOrigin(__global const BSDF *bsdf, const float3 sampleDir) {\n"
"	const float3 p = VLOAD3F(&bsdf->hitPoint.p.x);\n"
"\n"
"	if (bsdf->isVolume)\n"
"		return p;\n"
"	else {\n"
"		// Rise the ray origin along the geometry normal to avoid self intersection\n"
"		const float3 geometryN = VLOAD3F(&bsdf->hitPoint.geometryN.x);\n"
"		const float riseDirection = (dot(sampleDir, geometryN) > 0.f) ? 1.f : -1.f;\n"
"		\n"
"		return p + riseDirection * (geometryN * MachineEpsilon_E_Float3(p));\n"
"	}\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE bool BSDF_IsAlbedoEndPoint(__global const BSDF *bsdf,\n"
"		const AlbedoSpecularSetting albedoSpecularSetting,\n"
"		const float albedoSpecularGlossinessThreshold\n"
"		MATERIALS_PARAM_DECL) {\n"
"	const BSDFEvent eventTypes = BSDF_GetEventTypes(bsdf MATERIALS_PARAM);\n"
"	if (!BSDF_IsDelta(bsdf MATERIALS_PARAM) &&\n"
"			!((eventTypes & GLOSSY) && (BSDF_GetGlossiness(bsdf MATERIALS_PARAM) < albedoSpecularGlossinessThreshold)))\n"
"		return true;\n"
"\n"
"	switch (albedoSpecularSetting) {\n"
"		case NO_REFLECT_TRANSMIT:\n"
"			return true;\n"
"		case ONLY_REFLECT:\n"
"			return !((eventTypes & REFLECT) && !(eventTypes & TRANSMIT));\n"
"		case ONLY_TRANSMIT:\n"
"			return !(!(eventTypes & REFLECT) && (eventTypes & TRANSMIT));\n"
"		case REFLECT_TRANSMIT:\n"
"			return !((eventTypes & REFLECT) || (eventTypes & TRANSMIT));\n"
"		default:\n"
"			return true;\n"
"	}\n"
"}\n";
} }
