
#include <string>

namespace slg { namespace ocl {
std::string KernelSource_dlsc_funcs =
"#line 2 \"dlsc_funcs.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"OPENCL_FORCE_INLINE __global const DLSCacheEntry* restrict DirectLightSamplingCache_GetNearestEntry(\n"
"		__global const DLSCacheEntry* restrict dlscAllEntries,\n"
"		__global const float* restrict dlscDistributions,\n"
"		__global const IndexBVHArrayNode* restrict dlscBVHNodes,\n"
"		const float dlscRadius2, const float dlscNormalCosAngle,\n"
"		const float3 p, const float3 n, const bool isVolume\n"
"		) {\n"
"	__global const DLSCacheEntry* restrict nearestEntry = NULL;\n"
"	float nearestDistance2 = dlscRadius2;\n"
"\n"
"	uint currentNode = 0; // Root Node\n"
"	const uint stopNode = IndexBVHNodeData_GetSkipIndex(dlscBVHNodes[0].nodeData); // Non-existent\n"
"\n"
"	while (currentNode < stopNode) {\n"
"		__global const IndexBVHArrayNode* restrict node = &dlscBVHNodes[currentNode];\n"
"\n"
"		const uint nodeData = node->nodeData;\n"
"		if (IndexBVHNodeData_IsLeaf(nodeData)) {\n"
"			// It is a leaf, check the entry\n"
"			__global const DLSCacheEntry* restrict entry = &dlscAllEntries[node->entryLeaf.entryIndex];\n"
"\n"
"			const float distance2 = DistanceSquared(p, VLOAD3F(&entry->p.x));\n"
"			if ((distance2 < nearestDistance2) &&\n"
"					(isVolume == entry->isVolume) && \n"
"					(isVolume ||\n"
"					(dot(n, VLOAD3F(&entry->n.x)) > dlscNormalCosAngle)\n"
"					)\n"
"				) {\n"
"				// I have found a valid nearer entry\n"
"				nearestEntry = entry;\n"
"				nearestDistance2 = distance2;\n"
"			}\n"
"\n"
"			++currentNode;\n"
"		} else {\n"
"			// It is a node, check the bounding box\n"
"			if (p.x >= node->bvhNode.bboxMin[0] && p.x <= node->bvhNode.bboxMax[0] &&\n"
"					p.y >= node->bvhNode.bboxMin[1] && p.y <= node->bvhNode.bboxMax[1] &&\n"
"					p.z >= node->bvhNode.bboxMin[2] && p.z <= node->bvhNode.bboxMax[2])\n"
"				++currentNode;\n"
"			else {\n"
"				// I don't need to use IndexBVHNodeData_GetSkipIndex() here because\n"
"				// I already know the leaf flag is 0\n"
"				currentNode = nodeData;\n"
"			}\n"
"		}\n"
"	}\n"
"\n"
"	return nearestEntry;\n"
"}\n"
"\n"
"uint DirectLightSamplingCache_GetLightDistribution(\n"
"		__global const DLSCacheEntry* restrict dlscAllEntries,\n"
"		__global const float* restrict dlscDistributions,\n"
"		__global const IndexBVHArrayNode* restrict dlscBVHNodes,\n"
"		const float dlscRadius2, const float dlscNormalCosAngle,\n"
"		const float3 p, const float3 n, const bool isVolume\n"
"		) {\n"
"	__global const DLSCacheEntry* restrict entry = DirectLightSamplingCache_GetNearestEntry(\n"
"			dlscAllEntries,\n"
"			dlscDistributions, dlscBVHNodes,\n"
"			dlscRadius2, dlscNormalCosAngle,\n"
"			p, n, isVolume\n"
"	);\n"
"		\n"
"	if (entry)\n"
"		return entry->lightsDistributionOffset;\n"
"	\n"
"	return NULL_INDEX;\n"
"}\n";
} }
