
#include <string>

namespace slg { namespace ocl {
std::string KernelSource_film_funcs =
"#line 2 \"film_funcs.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"OPENCL_FORCE_INLINE void Film_SetPixel2(__global float *dst, __global  float *val) {\n"
"	dst[0] = val[0];\n"
"	dst[1] = val[1];\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void Film_SetPixel3(__global float *dst, __global  float *val) {\n"
"	dst[0] = val[0];\n"
"	dst[1] = val[1];\n"
"	dst[2] = val[2];\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE bool Film_MinPixel(const bool usePixelAtomics, __global float *dst, const float val) {\n"
"	if (usePixelAtomics)\n"
"		return AtomicMin(&dst[0], val);\n"
"	else {\n"
"		if (val < dst[0]) {\n"
"			dst[0] = val;\n"
"			return true;\n"
"		} else\n"
"			return false;\n"
"	}\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void Film_IncPixelUInt(const bool usePixelAtomics, __global uint *dst) {\n"
"	if (usePixelAtomics)\n"
"		atomic_inc(dst);\n"
"	else\n"
"		*dst += 1;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void Film_AddPixelVal(const bool usePixelAtomics, __global float *dst, const float val) {\n"
"	if (usePixelAtomics)\n"
"		AtomicAdd(&dst[0], val);\n"
"	else\n"
"		dst[0] += val;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void Film_AddWeightedPixel2Val(const bool usePixelAtomics, __global float *dst, const float val, const float weight) {\n"
"	const float v = val;\n"
"\n"
"	if (!isnan(v) && !isinf(v) &&\n"
"		!isnan(weight) && !isinf(weight)) {\n"
"		if (usePixelAtomics) {\n"
"			AtomicAdd(&dst[0], v * weight);\n"
"			AtomicAdd(&dst[1], weight);\n"
"		} else {\n"
"			dst[0] += v * weight;\n"
"			dst[1] += weight;\n"
"		}\n"
"	}\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void Film_AddWeightedPixel2(const bool usePixelAtomics, __global float *dst, __global float *val, const float weight) {\n"
"	const float v = *val;\n"
"\n"
"	if (!isnan(v) && !isinf(v) &&\n"
"		!isnan(weight) && !isinf(weight)) {\n"
"		if (usePixelAtomics) {\n"
"			AtomicAdd(&dst[0], v * weight);\n"
"			AtomicAdd(&dst[1], weight);\n"
"		} else {\n"
"			dst[0] += v * weight;\n"
"			dst[1] += weight;\n"
"		}\n"
"	}\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void Film_AddIfValidWeightedPixel4Val(const bool usePixelAtomics, __global float *dst, float3 val, const float weight) {\n"
"	const float r = val.x;\n"
"	const float g = val.y;\n"
"	const float b = val.z;\n"
"\n"
"	if (!isnan(r) && !isinf(r) &&\n"
"			!isnan(g) && !isinf(g) &&\n"
"			!isnan(b) && !isinf(b) &&\n"
"			!isnan(weight) && !isinf(weight)) {\n"
"		if (usePixelAtomics) {\n"
"			AtomicAdd(&dst[0], r * weight);\n"
"			AtomicAdd(&dst[1], g * weight);\n"
"			AtomicAdd(&dst[2], b * weight);\n"
"			AtomicAdd(&dst[3], weight);\n"
"		} else {\n"
"			// The following code doesn't work with CUDA\n"
"			/*float4 p = VLOAD4F(dst);\n"
"			const float4 s = MAKE_FLOAT4(r * weight, g * weight, b * weight, weight);\n"
"			p += s;\n"
"			VSTORE4F(p, dst);*/\n"
"\n"
"			dst[0] += r * weight;\n"
"			dst[1] += g * weight;\n"
"			dst[2] += b * weight;\n"
"			dst[3] += weight;\n"
"		}\n"
"	} /*else {\n"
"		printf(\"NaN/Inf. error: (%f, %f, %f) [%f]\\n\", r, g, b, weight);\n"
"	}*/\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void Film_AddIfValidWeightedPixel4(const bool usePixelAtomics, __global float *dst, __global float *val, const float weight) {\n"
"	const float r = val[0];\n"
"	const float g = val[1];\n"
"	const float b = val[2];\n"
"\n"
"	if (!isnan(r) && !isinf(r) &&\n"
"			!isnan(g) && !isinf(g) &&\n"
"			!isnan(b) && !isinf(b) &&\n"
"			!isnan(weight) && !isinf(weight)) {\n"
"		if (usePixelAtomics) {\n"
"			AtomicAdd(&dst[0], r * weight);\n"
"			AtomicAdd(&dst[1], g * weight);\n"
"			AtomicAdd(&dst[2], b * weight);\n"
"			AtomicAdd(&dst[3], weight);\n"
"		} else {\n"
"			// The following code doesn't work with CUDA\n"
"			/*float4 p = VLOAD4F(dst);\n"
"			const float4 s = MAKE_FLOAT4(r * weight, g * weight, b * weight, weight);\n"
"			p += s;\n"
"			VSTORE4F(p, dst);*/\n"
"\n"
"			dst[0] += r * weight;\n"
"			dst[1] += g * weight;\n"
"			dst[2] += b * weight;\n"
"			dst[3] += weight;\n"
"		}\n"
"	} /*else {\n"
"		printf(\"NaN/Inf. error: (%f, %f, %f) [%f]\\n\", r, g, b, weight);\n"
"	}*/\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void Film_AddSampleResultColor(const uint x, const uint y,\n"
"		__global SampleResult *sampleResult, const float weight\n"
"		FILM_PARAM_DECL) {\n"
"	const bool usePixelAtomics = film->usePixelAtomics;\n"
"\n"
"	const uint index1 = x + y * filmWidth;\n"
"	const uint index2 = index1 * 2;\n"
"	const uint index4 = index1 * 4;\n"
"\n"
"	for (uint i = 0; i < FILM_MAX_RADIANCE_GROUP_COUNT; ++i) {\n"
"		if (filmRadianceGroup[i])\n"
"			Film_AddIfValidWeightedPixel4(usePixelAtomics, &((filmRadianceGroup[i])[index4]), sampleResult->radiancePerPixelNormalized[i].c, weight);\n"
"	}\n"
"\n"
"	if (film->hasChannelAlpha)\n"
"		Film_AddWeightedPixel2(usePixelAtomics, &filmAlpha[index2], &sampleResult->alpha, weight);\n"
"		\n"
"	if (film->hasChannelDirectDiffuse) {\n"
"		const float3 c = VLOAD3F(sampleResult->directDiffuseReflect.c) + VLOAD3F(sampleResult->directDiffuseTransmit.c);\n"
"		Film_AddIfValidWeightedPixel4Val(usePixelAtomics, &filmDirectDiffuse[index4], c, weight);\n"
"	}\n"
"	if (film->hasChannelDirectDiffuseReflect)\n"
"		Film_AddIfValidWeightedPixel4(usePixelAtomics, &filmDirectDiffuseReflect[index4], sampleResult->directDiffuseReflect.c, weight);\n"
"	if (film->hasChannelDirectDiffuseTransmit)\n"
"		Film_AddIfValidWeightedPixel4(usePixelAtomics, &filmDirectDiffuseTransmit[index4], sampleResult->directDiffuseTransmit.c, weight);\n"
"\n"
"	if (film->hasChannelDirectGlossy) {\n"
"		const float3 c = VLOAD3F(sampleResult->directGlossyReflect.c) + VLOAD3F(sampleResult->directGlossyTransmit.c);\n"
"		Film_AddIfValidWeightedPixel4Val(usePixelAtomics, &filmDirectGlossy[index4], c, weight);\n"
"	}\n"
"	if (film->hasChannelDirectGlossyReflect)\n"
"		Film_AddIfValidWeightedPixel4(usePixelAtomics, &filmDirectGlossyReflect[index4], sampleResult->directGlossyReflect.c, weight);\n"
"	if (film->hasChannelDirectGlossyTransmit)\n"
"		Film_AddIfValidWeightedPixel4(usePixelAtomics, &filmDirectGlossyTransmit[index4], sampleResult->directGlossyTransmit.c, weight);\n"
"\n"
"	if (film->hasChannelEmission)\n"
"		Film_AddIfValidWeightedPixel4(usePixelAtomics, &filmEmission[index4], sampleResult->emission.c, weight);\n"
"\n"
"	if (film->hasChannelIndirectDiffuse) {\n"
"		const float3 c = VLOAD3F(sampleResult->indirectDiffuseReflect.c) + VLOAD3F(sampleResult->indirectDiffuseTransmit.c);\n"
"		Film_AddIfValidWeightedPixel4Val(usePixelAtomics, &filmIndirectDiffuse[index4], c, weight);\n"
"	}\n"
"	if (film->hasChannelIndirectDiffuseReflect)\n"
"		Film_AddIfValidWeightedPixel4(usePixelAtomics, &filmIndirectDiffuseReflect[index4], sampleResult->indirectDiffuseReflect.c, weight);\n"
"	if (film->hasChannelIndirectDiffuseTransmit)\n"
"		Film_AddIfValidWeightedPixel4(usePixelAtomics, &filmIndirectDiffuseTransmit[index4], sampleResult->indirectDiffuseTransmit.c, weight);\n"
"\n"
"	if (film->hasChannelIndirectGlossy) {\n"
"		const float3 c = VLOAD3F(sampleResult->indirectGlossyReflect.c) + VLOAD3F(sampleResult->indirectGlossyTransmit.c);\n"
"		Film_AddIfValidWeightedPixel4Val(usePixelAtomics, &filmIndirectGlossy[index4], c, weight);\n"
"	}\n"
"	if (film->hasChannelIndirectGlossyReflect)\n"
"		Film_AddIfValidWeightedPixel4(usePixelAtomics, &filmIndirectGlossyReflect[index4], sampleResult->indirectGlossyReflect.c, weight);\n"
"	if (film->hasChannelIndirectGlossyTransmit)\n"
"		Film_AddIfValidWeightedPixel4(usePixelAtomics, &filmIndirectGlossyTransmit[index4], sampleResult->indirectGlossyTransmit.c, weight);\n"
"\n"
"	if (film->hasChannelIndirectSpecular) {\n"
"		const float3 c = VLOAD3F(sampleResult->indirectSpecularReflect.c) + VLOAD3F(sampleResult->indirectSpecularTransmit.c);\n"
"		Film_AddIfValidWeightedPixel4Val(usePixelAtomics, &filmIndirectSpecular[index4], c, weight);\n"
"	}\n"
"	if (film->hasChannelIndirectSpecularReflect)\n"
"		Film_AddIfValidWeightedPixel4(usePixelAtomics, &filmIndirectSpecularReflect[index4], sampleResult->indirectSpecularReflect.c, weight);\n"
"	if (film->hasChannelIndirectSpecularTransmit)\n"
"		Film_AddIfValidWeightedPixel4(usePixelAtomics, &filmIndirectSpecularTransmit[index4], sampleResult->indirectSpecularTransmit.c, weight);\n"
"\n"
"	if (film->hasChannelMaterialIDMask) {\n"
"		const float materialIDMask = (sampleResult->materialID == film->channelMaterialIDMask) ? 1.f : 0.f;\n"
"		Film_AddWeightedPixel2Val(usePixelAtomics, &filmMaterialIDMask[index2], materialIDMask, weight);\n"
"	}\n"
"	if (film->hasChannelDirectShadowMask)\n"
"		Film_AddWeightedPixel2(usePixelAtomics, &filmDirectShadowMask[index2], &sampleResult->directShadowMask, weight);\n"
"	if (film->hasChannelIndirectShadowMask)\n"
"		Film_AddWeightedPixel2(usePixelAtomics, &filmIndirectShadowMask[index2], &sampleResult->indirectShadowMask, weight);\n"
"	if (film->hasChannelByMaterialID) {\n"
"		float3 byMaterialIDColor = BLACK;\n"
"\n"
"		if (sampleResult->materialID == film->channelByMaterialID) {\n"
"			for (uint i = 0; i < FILM_MAX_RADIANCE_GROUP_COUNT; ++i) {\n"
"				if (filmRadianceGroup[i])\n"
"					byMaterialIDColor += VLOAD3F(sampleResult->radiancePerPixelNormalized[i].c);\n"
"			}\n"
"		}\n"
"		Film_AddIfValidWeightedPixel4Val(usePixelAtomics, &filmByMaterialID[index4], byMaterialIDColor, weight);\n"
"	}\n"
"	if (film->hasChannelIrradiance)\n"
"		Film_AddIfValidWeightedPixel4(usePixelAtomics, &filmIrradiance[index4], sampleResult->irradiance.c, weight);\n"
"	if (film->hasChannelObjectIDMask) {\n"
"		const float objectIDMask = (sampleResult->objectID == film->channelObjectIDMask) ? 1.f : 0.f;\n"
"		Film_AddWeightedPixel2Val(usePixelAtomics, &filmObjectIDMask[index2], objectIDMask, weight);\n"
"	}\n"
"	if (film->hasChannelByObjectID) {\n"
"		float3 byObjectIDColor = BLACK;\n"
"\n"
"		if (sampleResult->objectID == film->channelByObjectID) {\n"
"			for (uint i = 0; i < FILM_MAX_RADIANCE_GROUP_COUNT; ++i) {\n"
"				if (filmRadianceGroup[i])\n"
"					byObjectIDColor += VLOAD3F(sampleResult->radiancePerPixelNormalized[i].c);\n"
"			}\n"
"		}\n"
"		Film_AddIfValidWeightedPixel4Val(usePixelAtomics, &filmByObjectID[index4], byObjectIDColor, weight);\n"
"	}\n"
"	if (film->hasChannelMaterialIDColor) {\n"
"		const uint matID = sampleResult->materialID;\n"
"\n"
"		float3 matIDCol;\n"
"		matIDCol.x = (matID & 0x0000ffu) * (1.f / 255.f);\n"
"		matIDCol.y = ((matID & 0x00ff00u) >> 8) * (1.f / 255.f);\n"
"		matIDCol.z = ((matID & 0xff0000u) >> 16) * (1.f / 255.f);\n"
"\n"
"		Film_AddIfValidWeightedPixel4Val(usePixelAtomics, &filmMaterialIDColor[index4], matIDCol, weight);\n"
"	}\n"
"	if (film->hasChannelAlbedo)\n"
"		Film_AddIfValidWeightedPixel4(usePixelAtomics, &filmAlbedo[index4], sampleResult->albedo.c, weight);\n"
"	if (film->hasChannelAvgShadingNormal)\n"
"		Film_AddIfValidWeightedPixel4(usePixelAtomics, &filmAvgShadingNormal[index4], &sampleResult->shadingNormal.x, weight);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void Film_AddSampleResultData(const uint x, const uint y,\n"
"		__global SampleResult *sampleResult\n"
"		FILM_PARAM_DECL) {\n"
"	const bool usePixelAtomics = film->usePixelAtomics;\n"
"\n"
"	const uint index1 = x + y * filmWidth;\n"
"	const uint index2 = index1 * 2;\n"
"	const uint index3 = index1 * 3;\n"
"\n"
"	bool depthWrite = true;\n"
"	if (film->hasChannelDepth)\n"
"		depthWrite = Film_MinPixel(usePixelAtomics, &filmDepth[index1], sampleResult->depth);\n"
"\n"
"	if (depthWrite) {\n"
"		if (film->hasChannelPosition)\n"
"			Film_SetPixel3(&filmPosition[index3], &sampleResult->position.x);\n"
"		if (film->hasChannelGeometryNormal)\n"
"			Film_SetPixel3(&filmGeometryNormal[index3], &sampleResult->geometryNormal.x);\n"
"		if (film->hasChannelShadingNormal)\n"
"			Film_SetPixel3(&filmShadingNormal[index3], &sampleResult->shadingNormal.x);\n"
"		if (film->hasChannelMaterialID)\n"
"			filmMaterialID[index1] = sampleResult->materialID;\n"
"		if (film->hasChannelUV)\n"
"			Film_SetPixel2(&filmUV[index2], &sampleResult->uv.u);\n"
"		if (film->hasChannelObjectID) {\n"
"			const uint objectID = sampleResult->objectID;\n"
"			if (objectID != NULL_INDEX)\n"
"				filmObjectID[index1] = sampleResult->objectID;\n"
"		}\n"
"	}\n"
"\n"
"	if (film->hasChannelRayCount)\n"
"		Film_AddPixelVal(usePixelAtomics, &filmRayCount[index1], sampleResult->rayCount);\n"
"\n"
"	if (film->hasChannelSampleCount)\n"
"		Film_IncPixelUInt(usePixelAtomics, &filmSampleCount[index1]);\n"
"}\n"
"\n"
"// CUDA want to inline this function due to the large number of arguments\n"
"#if defined (LUXRAYS_CUDA_DEVICE)\n"
"OPENCL_FORCE_INLINE\n"
"#else\n"
"OPENCL_FORCE_NOT_INLINE\n"
"#endif\n"
"void Film_AddSample(\n"
"		const uint x, const uint y,\n"
"		__global SampleResult *sampleResult, const float weight\n"
"		FILM_PARAM_DECL) {\n"
"	if (film->bcdDenoiserEnable) {\n"
"		// Add the sample to film denoiser sample accumulator\n"
"		FilmDenoiser_AddSample(film,\n"
"				x, y, sampleResult, weight,\n"
"				filmWidth, filmHeight\n"
"				FILM_DENOISER_PARAM);\n"
"	}\n"
"\n"
"	Film_AddSampleResultColor(x, y, sampleResult, weight\n"
"			FILM_PARAM);\n"
"	Film_AddSampleResultData(x, y, sampleResult\n"
"			FILM_PARAM);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Film kernel parameters\n"
"//------------------------------------------------------------------------------\n"
"\n"
"#define KERNEL_ARGS_FILM_RADIANCE_GROUP_SCALE_0 \\\n"
"		, float filmRadianceGroupScale0_R \\\n"
"		, float filmRadianceGroupScale0_G \\\n"
"		, float filmRadianceGroupScale0_B\n"
"#define KERNEL_ARGS_FILM_RADIANCE_GROUP_SCALE_1 \\\n"
"		, float filmRadianceGroupScale1_R \\\n"
"		, float filmRadianceGroupScale1_G \\\n"
"		, float filmRadianceGroupScale1_B\n"
"#define KERNEL_ARGS_FILM_RADIANCE_GROUP_SCALE_2 \\\n"
"		, float filmRadianceGroupScale2_R \\\n"
"		, float filmRadianceGroupScale2_G \\\n"
"		, float filmRadianceGroupScale2_B\n"
"#define KERNEL_ARGS_FILM_RADIANCE_GROUP_SCALE_3 \\\n"
"		, float filmRadianceGroupScale3_R \\\n"
"		, float filmRadianceGroupScale3_G \\\n"
"		, float filmRadianceGroupScale3_B\n"
"#define KERNEL_ARGS_FILM_RADIANCE_GROUP_SCALE_4 \\\n"
"		, float filmRadianceGroupScale4_R \\\n"
"		, float filmRadianceGroupScale4_G \\\n"
"		, float filmRadianceGroupScale4_B\n"
"#define KERNEL_ARGS_FILM_RADIANCE_GROUP_SCALE_5 \\\n"
"		, float filmRadianceGroupScale5_R \\\n"
"		, float filmRadianceGroupScale5_G \\\n"
"		, float filmRadianceGroupScale5_B\n"
"#define KERNEL_ARGS_FILM_RADIANCE_GROUP_SCALE_6 \\\n"
"		, float filmRadianceGroupScale6_R \\\n"
"		, float filmRadianceGroupScale6_G \\\n"
"		, float filmRadianceGroupScale6_B\n"
"#define KERNEL_ARGS_FILM_RADIANCE_GROUP_SCALE_7 \\\n"
"		, float filmRadianceGroupScale7_R \\\n"
"		, float filmRadianceGroupScale7_G \\\n"
"		, float filmRadianceGroupScale7_B\n"
"\n"
"#define KERNEL_ARGS_FILM_DENOISER \\\n"
"	, const int filmDenoiserWarmUpDone \\\n"
"	, const float filmDenoiserGamma \\\n"
"	, const float filmDenoiserMaxValue \\\n"
"	, const float filmDenoiserSampleScale \\\n"
"	, const uint filmDenoiserNbOfBins \\\n"
"	, __global float *filmDenoiserNbOfSamplesImage \\\n"
"	, __global float *filmDenoiserSquaredWeightSumsImage \\\n"
"	, __global float *filmDenoiserMeanImage \\\n"
"	, __global float *filmDenoiserCovarImage \\\n"
"	, __global float *filmDenoiserHistoImage \\\n"
"	KERNEL_ARGS_FILM_RADIANCE_GROUP_SCALE_0 \\\n"
"	KERNEL_ARGS_FILM_RADIANCE_GROUP_SCALE_1 \\\n"
"	KERNEL_ARGS_FILM_RADIANCE_GROUP_SCALE_2 \\\n"
"	KERNEL_ARGS_FILM_RADIANCE_GROUP_SCALE_3 \\\n"
"	KERNEL_ARGS_FILM_RADIANCE_GROUP_SCALE_4 \\\n"
"	KERNEL_ARGS_FILM_RADIANCE_GROUP_SCALE_5 \\\n"
"	KERNEL_ARGS_FILM_RADIANCE_GROUP_SCALE_6 \\\n"
"	KERNEL_ARGS_FILM_RADIANCE_GROUP_SCALE_7\n"
"\n"
"//------------------------------------------------------------------------------\n"
"\n"
"#define KERNEL_ARGS_FILM \\\n"
"		, const uint filmWidth, const uint filmHeight \\\n"
"		, const uint filmSubRegion0, const uint filmSubRegion1 \\\n"
"		, const uint filmSubRegion2, const uint filmSubRegion3 \\\n"
"		, __global float *filmRadianceGroup0 \\\n"
"		, __global float *filmRadianceGroup1 \\\n"
"		, __global float *filmRadianceGroup2 \\\n"
"		, __global float *filmRadianceGroup3 \\\n"
"		, __global float *filmRadianceGroup4 \\\n"
"		, __global float *filmRadianceGroup5 \\\n"
"		, __global float *filmRadianceGroup6 \\\n"
"		, __global float *filmRadianceGroup7 \\\n"
"		, __global float *filmAlpha \\\n"
"		, __global float *filmDepth \\\n"
"		, __global float *filmPosition \\\n"
"		, __global float *filmGeometryNormal \\\n"
"		, __global float *filmShadingNormal \\\n"
"		, __global uint *filmMaterialID \\\n"
"		, __global float *filmDirectDiffuse \\\n"
"		, __global float *filmDirectDiffuseReflect \\\n"
"		, __global float *filmDirectDiffuseTransmit \\\n"
"		, __global float *filmDirectGlossy \\\n"
"		, __global float *filmDirectGlossyReflect \\\n"
"		, __global float *filmDirectGlossyTransmit \\\n"
"		, __global float *filmEmission \\\n"
"		, __global float *filmIndirectDiffuse \\\n"
"		, __global float *filmIndirectDiffuseReflect \\\n"
"		, __global float *filmIndirectDiffuseTransmit \\\n"
"		, __global float *filmIndirectGlossy \\\n"
"		, __global float *filmIndirectGlossyReflect \\\n"
"		, __global float *filmIndirectGlossyTransmit \\\n"
"		, __global float *filmIndirectSpecular \\\n"
"		, __global float *filmIndirectSpecularReflect \\\n"
"		, __global float *filmIndirectSpecularTransmit \\\n"
"		, __global float *filmMaterialIDMask \\\n"
"		, __global float *filmDirectShadowMask \\\n"
"		, __global float *filmIndirectShadowMask \\\n"
"		, __global float *filmUV \\\n"
"		, __global float *filmRayCount \\\n"
"		, __global float *filmByMaterialID \\\n"
"		, __global float *filmIrradiance \\\n"
"		, __global uint *filmObjectID \\\n"
"		, __global float *filmObjectIDMask \\\n"
"		, __global float *filmByObjectID \\\n"
"		, __global uint *filmSampleCount \\\n"
"		, __global float *filmConvergence \\\n"
"		, __global float *filmMaterialIDColor \\\n"
"		, __global float *filmAlbedo \\\n"
"		, __global float *filmAvgShadingNormal \\\n"
"		, __global float *filmNoise \\\n"
"		, __global float *filmUserImportance \\\n"
"		KERNEL_ARGS_FILM_DENOISER\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Film_Clear Kernel\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__kernel void Film_Clear(\n"
"	const int dummy // This dummy variable is required by KERNEL_ARGS_FILM macro\n"
"	KERNEL_ARGS_FILM) {\n"
"	const size_t gid = get_global_id(0);\n"
"	if (gid >= filmWidth * filmHeight)\n"
"		return;\n"
"\n"
"	__global float *filmRadianceGroup[FILM_MAX_RADIANCE_GROUP_COUNT];\n"
"	filmRadianceGroup[0] = filmRadianceGroup0;\n"
"	filmRadianceGroup[1] = filmRadianceGroup1;\n"
"	filmRadianceGroup[2] = filmRadianceGroup2;\n"
"	filmRadianceGroup[3] = filmRadianceGroup3;\n"
"	filmRadianceGroup[4] = filmRadianceGroup4;\n"
"	filmRadianceGroup[5] = filmRadianceGroup5;\n"
"	filmRadianceGroup[6] = filmRadianceGroup6;\n"
"	filmRadianceGroup[7] = filmRadianceGroup7;\n"
"	\n"
"	for (uint i = 0; i < FILM_MAX_RADIANCE_GROUP_COUNT; ++i) {\n"
"		if (filmRadianceGroup[i]) {\n"
"			filmRadianceGroup[i][gid * 4] = 0.f;\n"
"			filmRadianceGroup[i][gid * 4 + 1] = 0.f;\n"
"			filmRadianceGroup[i][gid * 4 + 2] = 0.f;\n"
"			filmRadianceGroup[i][gid * 4 + 3] = 0.f;\n"
"		}\n"
"	}\n"
"\n"
"	if (filmAlpha) {\n"
"		filmAlpha[gid * 2] = 0.f;\n"
"		filmAlpha[gid * 2 + 1] = 0.f;	\n"
"	}\n"
"\n"
"	if (filmDepth)\n"
"		filmDepth[gid] = INFINITY;\n"
"\n"
"	if (filmPosition) {\n"
"		filmPosition[gid * 3] = INFINITY;\n"
"		filmPosition[gid * 3 + 1] = INFINITY;\n"
"		filmPosition[gid * 3 + 2] = INFINITY;\n"
"	}\n"
"\n"
"	if (filmGeometryNormal) {\n"
"		filmGeometryNormal[gid * 3] = 0.f;\n"
"		filmGeometryNormal[gid * 3 + 1] = 0.f;\n"
"		filmGeometryNormal[gid * 3 + 2] = 0.f;\n"
"	}\n"
"\n"
"	if (filmShadingNormal) {\n"
"		filmShadingNormal[gid * 3] = 0.f;\n"
"		filmShadingNormal[gid * 3 + 1] = 0.f;\n"
"		filmShadingNormal[gid * 3 + 2] = 0.f;\n"
"	}\n"
"\n"
"	if (filmMaterialID)\n"
"		filmMaterialID[gid] = NULL_INDEX;\n"
"\n"
"\n"
"	if (filmDirectDiffuse) {\n"
"		filmDirectDiffuse[gid * 4] = 0.f;\n"
"		filmDirectDiffuse[gid * 4 + 1] = 0.f;\n"
"		filmDirectDiffuse[gid * 4 + 2] = 0.f;\n"
"		filmDirectDiffuse[gid * 4 + 3] = 0.f;\n"
"	}\n"
"	\n"
"	if (filmDirectGlossy) {\n"
"		filmDirectGlossy[gid * 4] = 0.f;\n"
"		filmDirectGlossy[gid * 4 + 1] = 0.f;\n"
"		filmDirectGlossy[gid * 4 + 2] = 0.f;\n"
"		filmDirectGlossy[gid * 4 + 3] = 0.f;\n"
"	}\n"
"	\n"
"	if (filmEmission) {\n"
"		filmEmission[gid * 4] = 0.f;\n"
"		filmEmission[gid * 4 + 1] = 0.f;\n"
"		filmEmission[gid * 4 + 2] = 0.f;\n"
"		filmEmission[gid * 4 + 3] = 0.f;\n"
"	}\n"
"	\n"
"	if (filmIndirectDiffuse) {\n"
"		filmIndirectDiffuse[gid * 4] = 0.f;\n"
"		filmIndirectDiffuse[gid * 4 + 1] = 0.f;\n"
"		filmIndirectDiffuse[gid * 4 + 2] = 0.f;\n"
"		filmIndirectDiffuse[gid * 4 + 3] = 0.f;\n"
"	}\n"
"\n"
"	if (filmIndirectGlossy) {\n"
"		filmIndirectGlossy[gid * 4] = 0.f;\n"
"		filmIndirectGlossy[gid * 4 + 1] = 0.f;\n"
"		filmIndirectGlossy[gid * 4 + 2] = 0.f;\n"
"		filmIndirectGlossy[gid * 4 + 3] = 0.f;\n"
"	}\n"
"\n"
"	if (filmIndirectSpecular) {\n"
"		filmIndirectSpecular[gid * 4] = 0.f;\n"
"		filmIndirectSpecular[gid * 4 + 1] = 0.f;\n"
"		filmIndirectSpecular[gid * 4 + 2] = 0.f;\n"
"		filmIndirectSpecular[gid * 4 + 3] = 0.f;\n"
"	}\n"
"\n"
"	if (filmMaterialIDMask) {\n"
"		filmMaterialIDMask[gid * 2] = 0.f;\n"
"		filmMaterialIDMask[gid * 2 + 1] = 0.f;\n"
"	}\n"
"\n"
"	if (filmDirectShadowMask) {\n"
"		filmDirectShadowMask[gid * 2] = 0.f;\n"
"		filmDirectShadowMask[gid * 2 + 1] = 0.f;\n"
"	}\n"
"\n"
"	if (filmIndirectShadowMask) {\n"
"		filmIndirectShadowMask[gid * 2] = 0.f;\n"
"		filmIndirectShadowMask[gid * 2 + 1] = 0.f;\n"
"	}\n"
"\n"
"	if (filmUV) {\n"
"		filmUV[gid * 2] = INFINITY;\n"
"		filmUV[gid * 2 + 1] = INFINITY;\n"
"	}\n"
"\n"
"	if (filmRayCount)\n"
"		filmRayCount[gid] = 0;\n"
"\n"
"	if (filmByMaterialID) {\n"
"		filmByMaterialID[gid * 4] = 0.f;\n"
"		filmByMaterialID[gid * 4 + 1] = 0.f;\n"
"		filmByMaterialID[gid * 4 + 2] = 0.f;\n"
"		filmByMaterialID[gid * 4 + 3] = 0.f;\n"
"	}\n"
"	\n"
"	if (filmIrradiance) {\n"
"		filmIrradiance[gid * 4] = 0.f;\n"
"		filmIrradiance[gid * 4 + 1] = 0.f;\n"
"		filmIrradiance[gid * 4 + 2] = 0.f;\n"
"		filmIrradiance[gid * 4 + 3] = 0.f;\n"
"	}\n"
"	\n"
"	if (filmObjectID)\n"
"		filmObjectID[gid] = NULL_INDEX;\n"
"\n"
"	if (filmObjectIDMask) {\n"
"		filmObjectIDMask[gid * 2] = 0.f;\n"
"		filmObjectIDMask[gid * 2 + 1] = 0.f;\n"
"	}\n"
"\n"
"	if (filmByObjectID) {\n"
"		filmByObjectID[gid * 4] = 0.f;\n"
"		filmByObjectID[gid * 4 + 1] = 0.f;\n"
"		filmByObjectID[gid * 4 + 2] = 0.f;\n"
"		filmByObjectID[gid * 4 + 3] = 0.f;\n"
"	}\n"
"	\n"
"	if (filmSampleCount)\n"
"		filmSampleCount[gid] = 0;\n"
"\n"
"	if (filmConvergence)\n"
"		filmConvergence[gid] = INFINITY;\n"
"\n"
"	if (filmMaterialIDColor) {\n"
"		filmMaterialIDColor[gid * 4] = 0.f;\n"
"		filmMaterialIDColor[gid * 4 + 1] = 0.f;\n"
"		filmMaterialIDColor[gid * 4 + 2] = 0.f;\n"
"		filmMaterialIDColor[gid * 4 + 3] = 0.f;\n"
"	}\n"
"	\n"
"	if (filmAlbedo) {\n"
"		filmAlbedo[gid * 4] = 0.f;\n"
"		filmAlbedo[gid * 4 + 1] = 0.f;\n"
"		filmAlbedo[gid * 4 + 2] = 0.f;\n"
"		filmAlbedo[gid * 4 + 3] = 0.f;\n"
"	}\n"
"\n"
"	if (filmAvgShadingNormal) {\n"
"		filmAvgShadingNormal[gid * 4] = 0.f;\n"
"		filmAvgShadingNormal[gid * 4 + 1] = 0.f;\n"
"		filmAvgShadingNormal[gid * 4 + 2] = 0.f;\n"
"		filmAvgShadingNormal[gid * 4 + 3] = 0.f;\n"
"	}\n"
"\n"
"	if (filmNoise)\n"
"		filmNoise[gid] = INFINITY;\n"
"\n"
"	if (filmUserImportance)\n"
"		filmUserImportance[gid] = 1.f;\n"
"\n"
"	//--------------------------------------------------------------------------\n"
"	// Film denoiser buffers\n"
"	//--------------------------------------------------------------------------\n"
"\n"
"	if (filmDenoiserNbOfSamplesImage)\n"
"		filmDenoiserNbOfSamplesImage[gid] = 0.f;\n"
"	if (filmDenoiserSquaredWeightSumsImage)\n"
"		filmDenoiserSquaredWeightSumsImage[gid] = 0.f;\n"
"\n"
"	if (filmDenoiserMeanImage) {\n"
"		filmDenoiserMeanImage[gid * 3 + 0] = 0.f;\n"
"		filmDenoiserMeanImage[gid * 3 + 1] = 0.f;\n"
"		filmDenoiserMeanImage[gid * 3 + 2] = 0.f;\n"
"	}\n"
"\n"
"	if (filmDenoiserCovarImage) {\n"
"		filmDenoiserCovarImage[gid * 6 + 0] = 0.f;\n"
"		filmDenoiserCovarImage[gid * 6 + 1] = 0.f;\n"
"		filmDenoiserCovarImage[gid * 6 + 2] = 0.f;\n"
"		filmDenoiserCovarImage[gid * 6 + 3] = 0.f;\n"
"		filmDenoiserCovarImage[gid * 6 + 4] = 0.f;\n"
"		filmDenoiserCovarImage[gid * 6 + 5] = 0.f;\n"
"	}\n"
"\n"
"	if (filmDenoiserHistoImage) {\n"
"		for (uint channelIndex = 0; channelIndex < 3; ++channelIndex)\n"
"			for (uint i = 0; i < filmDenoiserNbOfBins; ++i)\n"
"				filmDenoiserHistoImage[gid * filmDenoiserNbOfBins * 3 + channelIndex * filmDenoiserNbOfBins + i] = 0.f;\n"
"	}\n"
"}\n";
} }
