
#include <string>

namespace slg { namespace ocl {
std::string KernelSource_film_types =
"#line 2 \"film_types.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Film\n"
"//------------------------------------------------------------------------------\n"
"\n"
"typedef struct {\n"
"	unsigned int radianceGroupCount;\n"
"	int bcdDenoiserEnable, usePixelAtomics;\n"
"	\n"
"	// Film channels (AOVs)\n"
"	int hasChannelAlpha;\n"
"	int hasChannelDepth;\n"
"	int hasChannelPosition;\n"
"	int hasChannelGeometryNormal;\n"
"	int hasChannelShadingNormal;\n"
"	int hasChannelMaterialID;\n"
"	int hasChannelDirectDiffuse;\n"
"	int hasChannelDirectDiffuseReflect;\n"
"	int hasChannelDirectDiffuseTransmit;\n"
"	int hasChannelDirectGlossy;\n"
"	int hasChannelDirectGlossyReflect;\n"
"	int hasChannelDirectGlossyTransmit;\n"
"	int hasChannelEmission;\n"
"	int hasChannelIndirectDiffuse;\n"
"	int hasChannelIndirectDiffuseReflect;\n"
"	int hasChannelIndirectDiffuseTransmit;\n"
"	int hasChannelIndirectGlossy;\n"
"	int hasChannelIndirectGlossyReflect;\n"
"	int hasChannelIndirectGlossyTransmit;\n"
"	int hasChannelIndirectSpecular;\n"
"	int hasChannelIndirectSpecularReflect;\n"
"	int hasChannelIndirectSpecularTransmit;\n"
"	int hasChannelMaterialIDMask;\n"
"	unsigned int channelMaterialIDMask;\n"
"	int hasChannelDirectShadowMask;\n"
"	int hasChannelIndirectShadowMask;\n"
"	int hasChannelUV;\n"
"	int hasChannelRayCount;\n"
"	int hasChannelByMaterialID;\n"
"	unsigned int channelByMaterialID;\n"
"	int hasChannelIrradiance;\n"
"	int hasChannelObjectID;\n"
"	int hasChannelObjectIDMask;\n"
"	int channelObjectIDMask;\n"
"	int hasChannelByObjectID;\n"
"	unsigned int channelByObjectID;\n"
"	int hasChannelSampleCount;\n"
"	int hasChannelConvergence;\n"
"	int hasChannelMaterialIDColor;\n"
"	int hasChannelAlbedo;\n"
"	int hasChannelAvgShadingNormal;\n"
"	int hasChannelNoise;\n"
"	int hasChannelUserImportance;\n"
"} Film;\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Some macro trick in order to have more readable code\n"
"//------------------------------------------------------------------------------\n"
"\n"
"#if defined(SLG_OPENCL_KERNEL)\n"
"\n"
"#define FILM_DENOISER_PARAM_DECL \\\n"
"		, const int filmDenoiserWarmUpDone \\\n"
"		, const float filmDenoiserGamma \\\n"
"		, const float filmDenoiserMaxValue \\\n"
"		, const float filmDenoiserSampleScale \\\n"
"		, const uint filmDenoiserNbOfBins \\\n"
"		, __global float *filmDenoiserNbOfSamplesImage \\\n"
"		, __global float *filmDenoiserSquaredWeightSumsImage \\\n"
"		, __global float *filmDenoiserMeanImage \\\n"
"		, __global float *filmDenoiserCovarImage \\\n"
"		, __global float *filmDenoiserHistoImage \\\n"
"		, float3 filmRadianceGroupScale[FILM_MAX_RADIANCE_GROUP_COUNT]\n"
"#define FILM_DENOISER_PARAM \\\n"
"		, filmDenoiserWarmUpDone \\\n"
"		, filmDenoiserGamma \\\n"
"		, filmDenoiserMaxValue \\\n"
"		, filmDenoiserSampleScale \\\n"
"		, filmDenoiserNbOfBins \\\n"
"		, filmDenoiserNbOfSamplesImage \\\n"
"		, filmDenoiserSquaredWeightSumsImage \\\n"
"		, filmDenoiserMeanImage \\\n"
"		, filmDenoiserCovarImage \\\n"
"		, filmDenoiserHistoImage \\\n"
"		, filmRadianceGroupScale\n"
"\n"
"#define FILM_PARAM_DECL \\\n"
"	, __constant const Film* restrict film \\\n"
"	, const uint filmWidth, const uint filmHeight \\\n"
"	, const uint filmSubRegion0, const uint filmSubRegion1, const uint filmSubRegion2, const uint filmSubRegion3 \\\n"
"	, __global float **filmRadianceGroup \\\n"
"	, __global float *filmAlpha \\\n"
"	, __global float *filmDepth \\\n"
"	, __global float *filmPosition \\\n"
"	, __global float *filmGeometryNormal \\\n"
"	, __global float *filmShadingNormal \\\n"
"	, __global uint *filmMaterialID \\\n"
"	, __global float *filmDirectDiffuse \\\n"
"	, __global float *filmDirectDiffuseReflect \\\n"
"	, __global float *filmDirectDiffuseTransmit \\\n"
"	, __global float *filmDirectGlossy \\\n"
"	, __global float *filmDirectGlossyReflect \\\n"
"	, __global float *filmDirectGlossyTransmit \\\n"
"	, __global float *filmEmission \\\n"
"	, __global float *filmIndirectDiffuse \\\n"
"	, __global float *filmIndirectDiffuseReflect \\\n"
"	, __global float *filmIndirectDiffuseTransmit \\\n"
"	, __global float *filmIndirectGlossy \\\n"
"	, __global float *filmIndirectGlossyReflect \\\n"
"	, __global float *filmIndirectGlossyTransmit \\\n"
"	, __global float *filmIndirectSpecular \\\n"
"	, __global float *filmIndirectSpecularReflect \\\n"
"	, __global float *filmIndirectSpecularTransmit \\\n"
"	, __global float *filmMaterialIDMask \\\n"
"	, __global float *filmDirectShadowMask \\\n"
"	, __global float *filmIndirectShadowMask \\\n"
"	, __global float *filmUV \\\n"
"	, __global float *filmRayCount \\\n"
"	, __global float *filmByMaterialID \\\n"
"	, __global float *filmIrradiance \\\n"
"	, __global uint *filmObjectID \\\n"
"	, __global float *filmObjectIDMask \\\n"
"	, __global float *filmByObjectID \\\n"
"	, __global uint *filmSampleCount \\\n"
"	, __global float *filmConvergence \\\n"
"	, __global float *filmMaterialIDColor \\\n"
"	, __global float *filmAlbedo \\\n"
"	, __global float *filmAvgShadingNormal \\\n"
"	, __global float *filmNoise \\\n"
"	, __global float *filmUserImportance \\\n"
"	FILM_DENOISER_PARAM_DECL\n"
"\n"
"#define FILM_PARAM \\\n"
"	, film \\\n"
"	, filmWidth, filmHeight \\\n"
"	, filmSubRegion0, filmSubRegion1, filmSubRegion2, filmSubRegion3 \\\n"
"	, filmRadianceGroup \\\n"
"	, filmAlpha \\\n"
"	, filmDepth \\\n"
"	, filmPosition \\\n"
"	, filmGeometryNormal \\\n"
"	, filmShadingNormal \\\n"
"	, filmMaterialID \\\n"
"	, filmDirectDiffuse \\\n"
"	, filmDirectDiffuseReflect \\\n"
"	, filmDirectDiffuseTransmit \\\n"
"	, filmDirectGlossy \\\n"
"	, filmDirectGlossyReflect \\\n"
"	, filmDirectGlossyTransmit \\\n"
"	, filmEmission \\\n"
"	, filmIndirectDiffuse \\\n"
"	, filmIndirectDiffuseReflect \\\n"
"	, filmIndirectDiffuseTransmit \\\n"
"	, filmIndirectGlossy \\\n"
"	, filmIndirectGlossyReflect \\\n"
"	, filmIndirectGlossyTransmit \\\n"
"	, filmIndirectSpecular \\\n"
"	, filmIndirectSpecularReflect \\\n"
"	, filmIndirectSpecularTransmit \\\n"
"	, filmMaterialIDMask \\\n"
"	, filmDirectShadowMask \\\n"
"	, filmIndirectShadowMask \\\n"
"	, filmUV \\\n"
"	, filmRayCount \\\n"
"	, filmByMaterialID \\\n"
"	, filmIrradiance \\\n"
"	, filmObjectID \\\n"
"	, filmObjectIDMask \\\n"
"	, filmByObjectID \\\n"
"	, filmSampleCount \\\n"
"	, filmConvergence \\\n"
"	, filmMaterialIDColor \\\n"
"	, filmAlbedo \\\n"
"	, filmAvgShadingNormal \\\n"
"	, filmNoise \\\n"
"	, filmUserImportance \\\n"
"	FILM_DENOISER_PARAM\n"
"\n"
"#endif\n";
} }
