
#include <string>

namespace slg { namespace ocl {
std::string KernelSource_filmdenoiser_funcs =
"#line 2 \"filmdenoiser_funcs.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"OPENCL_FORCE_INLINE void SamplesAccumulator_AtomicAdd(__global float *buff,\n"
"		const uint buffWidth, const uint buffHeight, const uint buffDepth,\n"
"		const uint line, const uint column, const uint index,\n"
"		const float value) {\n"
"	AtomicAdd(&buff[(line * buffWidth + column) * buffDepth + index], value);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void SamplesAccumulator_AddSampleAtomic(\n"
"		const uint line, const uint column,\n"
"		const float3 sample, const float weight,\n"
"		const uint filmWidth, const uint filmHeight\n"
"		FILM_DENOISER_PARAM_DECL) {\n"
"	const float satureLevelGamma = 2.f; // used for determining the weight to give to the sample in the highest two bins, when the sample is saturated\n"
"\n"
"	// Sample count\n"
"	SamplesAccumulator_AtomicAdd(filmDenoiserNbOfSamplesImage,\n"
"			filmWidth, filmHeight, 1,\n"
"			line, column, 0,\n"
"			weight);\n"
"	// Sample squared count\n"
"	SamplesAccumulator_AtomicAdd(filmDenoiserSquaredWeightSumsImage,\n"
"			filmWidth, filmHeight, 1,\n"
"			line, column, 0,\n"
"			weight * weight);\n"
"\n"
"	// Samples mean\n"
"	SamplesAccumulator_AtomicAdd(filmDenoiserMeanImage,\n"
"			filmWidth, filmHeight, 3,\n"
"			line, column, 0,\n"
"			weight * sample.x);\n"
"	SamplesAccumulator_AtomicAdd(filmDenoiserMeanImage,\n"
"			filmWidth, filmHeight, 3,\n"
"			line, column, 1,\n"
"			weight * sample.y);\n"
"	SamplesAccumulator_AtomicAdd(filmDenoiserMeanImage,\n"
"			filmWidth, filmHeight, 3,\n"
"			line, column, 2,\n"
"			weight * sample.z);\n"
"\n"
"	// Covariance\n"
"	SamplesAccumulator_AtomicAdd(filmDenoiserCovarImage,\n"
"			filmWidth, filmHeight, 6,\n"
"			line, column, 0,\n"
"			weight * sample.x * sample.x);\n"
"	SamplesAccumulator_AtomicAdd(filmDenoiserCovarImage,\n"
"			filmWidth, filmHeight, 6,\n"
"			line, column, 1,\n"
"			weight * sample.y * sample.y);\n"
"	SamplesAccumulator_AtomicAdd(filmDenoiserCovarImage,\n"
"			filmWidth, filmHeight, 6,\n"
"			line, column, 2,\n"
"			weight * sample.z * sample.z);\n"
"	SamplesAccumulator_AtomicAdd(filmDenoiserCovarImage,\n"
"			filmWidth, filmHeight, 6,\n"
"			line, column, 3,\n"
"			weight * sample.y * sample.z);\n"
"	SamplesAccumulator_AtomicAdd(filmDenoiserCovarImage,\n"
"			filmWidth, filmHeight, 6,\n"
"			line, column, 4,\n"
"			weight * sample.x * sample.z);\n"
"	SamplesAccumulator_AtomicAdd(filmDenoiserCovarImage,\n"
"			filmWidth, filmHeight, 6,\n"
"			line, column, 5,\n"
"			weight * sample.x * sample.y);\n"
"\n"
"	int floorBinIndex;\n"
"	int ceilBinIndex;\n"
"	float binFloatIndex;\n"
"	float floorBinWeight;\n"
"	float ceilBinWeight;\n"
"\n"
"	for (int channelIndex = 0; channelIndex < 3; ++channelIndex) { // fill histogram; code refactored from Ray Histogram Fusion PBRT code\n"
"		float value = (channelIndex == 0) ? sample.x : ((channelIndex == 1) ? sample.y : sample.z);\n"
"		value = (value > 0 ? value : 0);\n"
"		if (filmDenoiserGamma > 1)\n"
"			value = pow(value, 1.f / filmDenoiserGamma); // exponential scaling\n"
"		if (filmDenoiserMaxValue > 0)\n"
"			value = (value / filmDenoiserMaxValue); // normalize to the maximum value\n"
"		value = value > satureLevelGamma ? satureLevelGamma : value;\n"
"\n"
"		binFloatIndex = value * (filmDenoiserNbOfBins - 2);\n"
"		floorBinIndex = (int)binFloatIndex;\n"
"\n"
"		if (floorBinIndex < filmDenoiserNbOfBins - 2) // in bounds\n"
"		{\n"
"			ceilBinIndex = floorBinIndex + 1;\n"
"			ceilBinWeight = binFloatIndex - floorBinIndex;\n"
"			floorBinWeight = 1.0f - ceilBinWeight;\n"
"		} else { //out of bounds... v >= 1\n"
"			floorBinIndex = filmDenoiserNbOfBins - 2;\n"
"			ceilBinIndex = floorBinIndex + 1;\n"
"			ceilBinWeight = (value - 1.0f) / (satureLevelGamma - 1.f);\n"
"			floorBinWeight = 1.0f - ceilBinWeight;\n"
"		}\n"
"\n"
"		SamplesAccumulator_AtomicAdd(filmDenoiserHistoImage,\n"
"			filmWidth, filmHeight, filmDenoiserNbOfBins * 3,\n"
"			line, column, channelIndex * filmDenoiserNbOfBins + floorBinIndex,\n"
"			weight * floorBinWeight);\n"
"		SamplesAccumulator_AtomicAdd(filmDenoiserHistoImage,\n"
"			filmWidth, filmHeight, filmDenoiserNbOfBins * 3,\n"
"			line, column, channelIndex * filmDenoiserNbOfBins + ceilBinIndex,\n"
"			weight * ceilBinWeight);\n"
"	}\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void FilmDenoiser_AddSample(\n"
"		__constant const Film* restrict film,\n"
"		const uint x, const uint y,\n"
"		__global SampleResult *sampleResult,\n"
"		const float weight,\n"
"		const uint filmWidth, const uint filmHeight\n"
"		FILM_DENOISER_PARAM_DECL) {\n"
"	if (!filmDenoiserWarmUpDone)\n"
"		return;\n"
"\n"
"	const float3 sample = clamp(SampleResult_GetSpectrum(film,sampleResult, filmRadianceGroupScale) * filmDenoiserSampleScale,\n"
"			0.f, filmDenoiserMaxValue);\n"
"	\n"
"	if (!Spectrum_IsNanOrInf(sample)) {\n"
"			const int line = filmHeight - y - 1;\n"
"			const int column = x;\n"
"\n"
"			SamplesAccumulator_AddSampleAtomic(line, column, sample, weight,\n"
"					filmWidth, filmHeight\n"
"					FILM_DENOISER_PARAM);\n"
"	}\n"
"}\n";
} }
