
#include <string>

namespace slg { namespace ocl {
std::string KernelSource_filter_funcs =
"#line 2 \"filter_funcs.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// FilterDistribution\n"
"//------------------------------------------------------------------------------\n"
"\n"
"void FilterDistribution_SampleContinuous(__constant const Filter *pixelFitler,\n"
"		__global float *pixelFilterDistribution,\n"
"		const float u0, const float u1, float *su0, float *su1) {\n"
"	// Sample according the pixel filter distribution\n"
"	float2 uv;\n"
"	float distPdf;\n"
"	Distribution2D_SampleContinuous(pixelFilterDistribution, u0, u1, &uv, &distPdf);\n"
"\n"
"	*su0 = (uv.x - .5f) * (2.f * pixelFitler->widthX);\n"
"	*su1 = (uv.y - .5f) * (2.f * pixelFitler->widthY);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Pixel related functions\n"
"//------------------------------------------------------------------------------\n"
"\n"
"void PixelIndex2XY(const uint filmWidth, const uint index, uint *x, uint *y) {\n"
"	*y = index / filmWidth;\n"
"	*x = index - (*y) * filmWidth;\n"
"}\n"
"\n"
"uint XY2PixelIndex(const uint filmWidth, const uint x, const uint y) {\n"
"	return x + y * filmWidth;\n"
"}\n";
} }
