
#include <string>

namespace slg { namespace ocl {
std::string KernelSource_imagemap_types =
"#line 2 \"imagemap_types.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"typedef enum {\n"
"	BYTE, HALF, FLOAT\n"
"} ImageMapStorageType;\n"
"\n"
"typedef enum {\n"
"	WRAP_REPEAT,\n"
"	WRAP_BLACK,\n"
"	WRAP_WHITE,\n"
"	WRAP_CLAMP\n"
"} ImageWrapType;\n"
"\n"
"typedef enum {\n"
"	FILTER_NEAREST,\n"
"	FILTER_LINEAR\n"
"} ImageFilterType;\n"
"\n"
"typedef struct {\n"
"	ImageMapStorageType storageType;\n"
"	ImageWrapType wrapType;\n"
"	ImageFilterType filterType;\n"
"	unsigned int channelCount, width, height;\n"
"	unsigned int pageIndex;\n"
"	// The following field must be 64bit aligned (for OpenCL)\n"
"#if defined(SLG_OPENCL_KERNEL)\n"
"	// CUDA unsigned long has a 32bit size so we need different definitions\n"
"	// between CUDA and OpenCL\n"
"#if defined(LUXRAYS_CUDA_DEVICE)\n"
"	unsigned long long pixelsIndex;\n"
"#elif defined(LUXRAYS_OPENCL_DEVICE)\n"
"	unsigned long pixelsIndex;\n"
"#else\n"
"#error \"Unsupported device in ImageMap struct\"\n"
"#endif\n"
"#else\n"
"#if defined(LUXRAYS_ENABLE_OPENCL)\n"
"	cl_ulong pixelsIndex;\n"
"#else\n"
"	// In this, case cl_ulong is not defined. The type, in this case, doesn't\n"
"	// really matter because this structure is not used at all.\n"
"	unsigned long long pixelsIndex;\n"
"#endif\n"
"#endif\n"
"} ImageMap;\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Some macro trick in order to have more readable code\n"
"//------------------------------------------------------------------------------\n"
"\n"
"#if defined(SLG_OPENCL_KERNEL)\n"
"\n"
"#define IMAGEMAPS_PARAM_DECL , __global const ImageMap* restrict imageMapDescs, __global const float* restrict* restrict imageMapBuff\n"
"#define IMAGEMAPS_PARAM , imageMapDescs, imageMapBuff\n"
"\n"
"#endif\n";
} }
