
#include <string>

namespace slg { namespace ocl {
std::string KernelSource_lightstrategy_funcs =
"#line 2 \"lightstrategy_funcs.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"OPENCL_FORCE_INLINE uint LightStrategy_SampleLights(\n"
"		__global const float* restrict lightsDistribution1D,\n"
"		__global const DLSCacheEntry* restrict dlscAllEntries,\n"
"		__global const float* restrict dlscDistributions,\n"
"		__global const IndexBVHArrayNode* restrict dlscBVHNodes,\n"
"		const float dlscRadius2, const float dlscNormalCosAngle,\n"
"		const float3 p, const float3 n,\n"
"		const bool isVolume,\n"
"		const float u, float *pdf) {\n"
"#if !defined(RENDER_ENGINE_RTPATHOCL)\n"
"	if (dlscAllEntries) {\n"
"		// DLSC strategy\n"
"\n"
"		// Check if a cache entry is available for this point\n"
"		const uint lightsDistributionOffset = DirectLightSamplingCache_GetLightDistribution(\n"
"				dlscAllEntries,\n"
"				dlscDistributions, dlscBVHNodes,\n"
"				dlscRadius2, dlscNormalCosAngle,\n"
"				p, n, isVolume\n"
"		);\n"
"\n"
"		if (lightsDistributionOffset != NULL_INDEX) {\n"
"			const uint lightIndex = Distribution1D_SampleDiscrete(\n"
"					&dlscDistributions[lightsDistributionOffset], u, pdf);\n"
"\n"
"			if (*pdf > 0.f)\n"
"				return lightIndex;\n"
"			else\n"
"				return NULL_INDEX;\n"
"		} else\n"
"			return Distribution1D_SampleDiscrete(lightsDistribution1D, u, pdf);\n"
"	} else\n"
"#endif\n"
"	{\n"
"		// All other strategies\n"
"		if (lightsDistribution1D)\n"
"			return Distribution1D_SampleDiscrete(lightsDistribution1D, u, pdf);\n"
"		else\n"
"			return NULL_INDEX;\n"
"	}\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float LightStrategy_SampleLightPdf(\n"
"		__global const float* restrict lightsDistribution1D,\n"
"		__global const DLSCacheEntry* restrict dlscAllEntries,\n"
"		__global const float* restrict dlscDistributions,\n"
"		__global const IndexBVHArrayNode* restrict dlscBVHNodes,\n"
"		const float dlscRadius2, const float dlscNormalCosAngle,\n"
"		const float3 p, const float3 n,\n"
"		const bool isVolume,\n"
"		const uint lightIndex) {\n"
"#if !defined(RENDER_ENGINE_RTPATHOCL)\n"
"	if (dlscAllEntries) {\n"
"		// DLSC strategy\n"
"		\n"
"		// Check if a cache entry is available for this point\n"
"		const uint lightsDistributionOffset = DirectLightSamplingCache_GetLightDistribution(\n"
"				dlscAllEntries,\n"
"				dlscDistributions, dlscBVHNodes,\n"
"				dlscRadius2, dlscNormalCosAngle,\n"
"				p, n, isVolume\n"
"		);\n"
"\n"
"		if (lightsDistributionOffset != NULL_INDEX)\n"
"			return Distribution1D_PdfDiscrete(&dlscDistributions[lightsDistributionOffset], lightIndex);\n"
"		else\n"
"			return Distribution1D_PdfDiscrete(lightsDistribution1D, lightIndex);\n"
"	} else\n"
"#endif\n"
"	{\n"
"		// All other strategies\n"
"		if (lightsDistribution1D)\n"
"			return Distribution1D_PdfDiscrete(lightsDistribution1D, lightIndex);\n"
"		else\n"
"			return NULL_INDEX;\n"
"	}\n"
"}\n";
} }
