
#include <string>

namespace slg { namespace ocl {
std::string KernelSource_mapping_types =
"#line 2 \"mapping_types.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// TextureMapping2D\n"
"//------------------------------------------------------------------------------\n"
"\n"
"typedef enum {\n"
"	UVMAPPING2D, UVRANDOMMAPPING2D\n"
"} TextureMapping2DType;\n"
"\n"
"typedef struct {\n"
"    float sinTheta, cosTheta, uScale, vScale, uDelta, vDelta;\n"
"} UVMapping2DParam;\n"
"\n"
"typedef enum {\n"
"	OBJECT_ID, TRIANGLE_AOV, OBJECT_ID_OFFSET\n"
"} RandomMappingSeedType;\n"
"\n"
"typedef struct {\n"
"    RandomMappingSeedType seedType;\n"
"	union {\n"
"		unsigned int triAOVIndex;\n"
"		unsigned int objectIDOffset;\n"
"	};\n"
"	float uvRotationMin, uvRotationMax, uvRotationStep;\n"
"	float uScaleMin, uScaleMax;\n"
"	float vScaleMin, vScaleMax;\n"
"	float uDeltaMin, uDeltaMax;\n"
"	float vDeltaMin, vDeltaMax;\n"
"	\n"
"	int uniformScale;\n"
"} UVRandomMapping2DParam;\n"
"\n"
"typedef struct {\n"
"	TextureMapping2DType type;\n"
"	unsigned int dataIndex;\n"
"	union {\n"
"		UVMapping2DParam uvMapping2D;\n"
"		UVRandomMapping2DParam uvRandomMapping2D;\n"
"	};\n"
"} TextureMapping2D;\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// TextureMapping3D\n"
"//------------------------------------------------------------------------------\n"
"\n"
"typedef enum {\n"
"	UVMAPPING3D, GLOBALMAPPING3D, LOCALMAPPING3D, LOCALRANDOMMAPPING3D\n"
"} TextureMapping3DType;\n"
"\n"
"typedef struct {\n"
"    unsigned int dataIndex;\n"
"} UVMapping3DParam;\n"
"\n"
"typedef struct {\n"
"	RandomMappingSeedType seedType;\n"
"	union {\n"
"		unsigned int triAOVIndex;\n"
"		unsigned int objectIDOffset;\n"
"	};\n"
"	float xRotationMin, xRotationMax, xRotationStep;\n"
"	float yRotationMin, yRotationMax, yRotationStep;\n"
"	float zRotationMin, zRotationMax, zRotationStep;\n"
"	float xScaleMin, xScaleMax;\n"
"	float yScaleMin, yScaleMax;\n"
"	float zScaleMin, zScaleMax;\n"
"	float xTranslateMin, xTranslateMax;\n"
"	float yTranslateMin, yTranslateMax;\n"
"	float zTranslateMin, zTranslateMax;\n"
"\n"
"	int uniformScale;\n"
"} LocalRandomMapping3DParam;\n"
"\n"
"typedef struct {\n"
"	TextureMapping3DType type;\n"
"	Transform worldToLocal;\n"
"	union {\n"
"		UVMapping3DParam uvMapping3D;\n"
"		// GlobalMapping3D has no additional parameters\n"
"		// LocalMapping3D has no additional parameters\n"
"		LocalRandomMapping3DParam localRandomMapping;\n"
"	};\n"
"} TextureMapping3D;\n";
} }
