
#include <string>

namespace slg { namespace ocl {
std::string KernelSource_materialdefs_funcs_archglass =
"#line 2 \"materialdefs_funcs_archglass.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"OPENCL_FORCE_INLINE float ExtractExteriorIors(__global const HitPoint *hitPoint, const uint exteriorIorTexIndex\n"
"		TEXTURES_PARAM_DECL) {\n"
"	uint extIndex = NULL_INDEX;\n"
"	if (exteriorIorTexIndex != NULL_INDEX)\n"
"		extIndex = exteriorIorTexIndex;\n"
"	else {\n"
"		const uint hitPointExteriorIorTexIndex = hitPoint->exteriorIorTexIndex;\n"
"		if (hitPointExteriorIorTexIndex != NULL_INDEX)\n"
"			extIndex = hitPointExteriorIorTexIndex;\n"
"	}\n"
"	return (extIndex == NULL_INDEX) ? 1.f : Texture_GetFloatValue(extIndex, hitPoint\n"
"			TEXTURES_PARAM);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float ExtractInteriorIors(__global const HitPoint *hitPoint, const uint interiorIorTexIndex\n"
"		TEXTURES_PARAM_DECL) {\n"
"	uint intIndex = NULL_INDEX;\n"
"	if (interiorIorTexIndex != NULL_INDEX)\n"
"		intIndex = interiorIorTexIndex;\n"
"	else {\n"
"		const uint hitPointInteriorIorTexIndex = hitPoint->interiorIorTexIndex;\n"
"		if (hitPointInteriorIorTexIndex != NULL_INDEX)\n"
"			intIndex = hitPointInteriorIorTexIndex;\n"
"	}\n"
"	return (intIndex == NULL_INDEX) ? 1.f : Texture_GetFloatValue(intIndex, hitPoint\n"
"			TEXTURES_PARAM);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// ArchGlass material\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float3 ArchGlassMaterial_EvalSpecularReflection(__global const HitPoint *hitPoint,\n"
"		const float3 localFixedDir, const float3 kr,\n"
"		const float nc, const float nt,\n"
"		float3 *sampledDir, const float localFilmThickness, const float localFilmIor) {\n"
"	if (Spectrum_IsBlack(kr))\n"
"		return BLACK;\n"
"\n"
"	const float costheta = CosTheta(localFixedDir);\n"
"	if (costheta <= 0.f)\n"
"		return BLACK;\n"
"\n"
"	*sampledDir = MAKE_FLOAT3(-localFixedDir.x, -localFixedDir.y, localFixedDir.z);\n"
"\n"
"	const float ntc = nt / nc;\n"
"	const float3 result = kr * FresnelCauchy_Evaluate(ntc, costheta);\n"
"	\n"
"	if (localFilmThickness > 0.f) {\n"
"		const float3 filmColor = CalcFilmColor(localFixedDir, localFilmThickness, localFilmIor);\n"
"		return result * filmColor;\n"
"	}\n"
"	return result;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 ArchGlassMaterial_EvalSpecularTransmission(__global const HitPoint *hitPoint,\n"
"		const float3 localFixedDir, const float3 kt,\n"
"		const float nc, const float nt, float3 *sampledDir) {\n"
"	if (Spectrum_IsBlack(kt))\n"
"		return BLACK;\n"
"\n"
"	// Note: there can not be total internal reflection for \n"
"	\n"
"	*sampledDir = -localFixedDir;\n"
"\n"
"	const float ntc = nt / nc;\n"
"	const float costheta = CosTheta(localFixedDir);\n"
"	const bool entering = (costheta > 0.f);\n"
"	float ce;\n"
"//	if (!hitPoint.fromLight) {\n"
"		if (entering)\n"
"			ce = 0.f;\n"
"		else\n"
"			ce = FresnelCauchy_Evaluate(ntc, -costheta);\n"
"//	} else {\n"
"//		if (entering)\n"
"//			ce = FresnelTexture::CauchyEvaluate(ntc, costheta);\n"
"//		else\n"
"//			ce = 0.f;\n"
"//	}\n"
"	const float factor = 1.f - ce;\n"
"	const float result = (1.f + factor * factor) * ce;\n"
"\n"
"	return (1.f - result) * kt;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void ArchGlassMaterial_Albedo(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"    const float3 albedo = WHITE;\n"
"\n"
"	EvalStack_PushFloat3(albedo);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void ArchGlassMaterial_GetInteriorVolume(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	DefaultMaterial_GetInteriorVolume(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void ArchGlassMaterial_GetExteriorVolume(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	DefaultMaterial_GetExteriorVolume(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void ArchGlassMaterial_GetPassThroughTransparency(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	bool backTracing;\n"
"	EvalStack_PopUInt(backTracing);\n"
"	float passThroughEvent;\n"
"	EvalStack_PopFloat(passThroughEvent);\n"
"	float3 localFixedDir;\n"
"	EvalStack_PopFloat3(localFixedDir);\n"
"\n"
"	const float3 kt = Spectrum_Clamp(Texture_GetSpectrumValue(material->archglass.ktTexIndex, hitPoint\n"
"		TEXTURES_PARAM));\n"
"	const float3 kr = Spectrum_Clamp(Texture_GetSpectrumValue(material->archglass.krTexIndex, hitPoint\n"
"		TEXTURES_PARAM));\n"
"\n"
"	const float nc = Spectrum_Filter(TO_FLOAT3(ExtractExteriorIors(hitPoint,\n"
"			material->archglass.exteriorIorTexIndex\n"
"			TEXTURES_PARAM)));\n"
"	const float nt = Spectrum_Filter(TO_FLOAT3(ExtractInteriorIors(hitPoint,\n"
"			material->archglass.interiorIorTexIndex\n"
"			TEXTURES_PARAM)));\n"
"\n"
"	float3 transLocalSampledDir; \n"
"	const float3 trans = ArchGlassMaterial_EvalSpecularTransmission(hitPoint, localFixedDir,\n"
"			kt, nc, nt, &transLocalSampledDir);\n"
"			\n"
"	const float localFilmThickness = (material->archglass.filmThicknessTexIndex != NULL_INDEX) \n"
"									 ? Texture_GetFloatValue(material->archglass.filmThicknessTexIndex, hitPoint TEXTURES_PARAM) : 0.f;\n"
"	const float localFilmIor = (localFilmThickness > 0.f && material->archglass.filmIorTexIndex != NULL_INDEX) \n"
"							   ? Texture_GetFloatValue(material->archglass.filmIorTexIndex, hitPoint TEXTURES_PARAM) : 1.f;\n"
"	\n"
"	float3 reflLocalSampledDir;\n"
"	const float3 refl = ArchGlassMaterial_EvalSpecularReflection(hitPoint, localFixedDir,\n"
"			kr, nc, nt, &reflLocalSampledDir, localFilmThickness, localFilmIor);\n"
"\n"
"	// Decide to transmit or reflect\n"
"	float3 transp;\n"
"	if (!Spectrum_IsBlack(refl)) {\n"
"		if (!Spectrum_IsBlack(trans)) {\n"
"			// Importance sampling\n"
"			const float reflFilter = Spectrum_Filter(refl);\n"
"			const float transFilter = Spectrum_Filter(trans);\n"
"			float threshold = transFilter / (reflFilter + transFilter);\n"
"\n"
"			// A place an upper and lower limit to not under sample\n"
"			// reflection or transmission\n"
"			threshold = clamp(threshold, .25f, .75f);\n"
"\n"
"			if (passThroughEvent < threshold) {\n"
"				// Transmit\n"
"				transp = trans / threshold;\n"
"			} else {\n"
"				// Reflect\n"
"				transp = BLACK;\n"
"			}\n"
"		} else\n"
"			transp = BLACK;\n"
"	} else {\n"
"		if (!Spectrum_IsBlack(trans)) {\n"
"			// Transmit\n"
"\n"
"			// threshold = 1 so I avoid the / threshold\n"
"			transp = trans;\n"
"		} else\n"
"			transp = BLACK;\n"
"	}\n"
"\n"
"	EvalStack_PushFloat3(transp);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void ArchGlassMaterial_GetEmittedRadiance(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	DefaultMaterial_GetEmittedRadiance(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void ArchGlassMaterial_Evaluate(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	float3 lightDir, eyeDir;\n"
"	EvalStack_PopFloat3(eyeDir);\n"
"	EvalStack_PopFloat3(lightDir);\n"
"\n"
"	MATERIAL_EVALUATE_RETURN_BLACK;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void ArchGlassMaterial_Sample(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	float u0, u1, passThroughEvent;\n"
"	EvalStack_PopFloat(passThroughEvent);\n"
"	EvalStack_PopFloat(u1);\n"
"	EvalStack_PopFloat(u0);\n"
"	float3 fixedDir;\n"
"	EvalStack_PopFloat3(fixedDir);\n"
"\n"
"	const float3 ktTexVal = Texture_GetSpectrumValue(material->archglass.ktTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float3 krTexVal = Texture_GetSpectrumValue(material->archglass.krTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float3 kt = Spectrum_Clamp(ktTexVal);\n"
"	const float3 kr = Spectrum_Clamp(krTexVal);\n"
"\n"
"	const float nc = ExtractExteriorIors(hitPoint, material->archglass.exteriorIorTexIndex TEXTURES_PARAM);\n"
"	const float nt = ExtractInteriorIors(hitPoint, material->archglass.interiorIorTexIndex TEXTURES_PARAM);\n"
"\n"
"	float3 transLocalSampledDir; \n"
"	const float3 trans = ArchGlassMaterial_EvalSpecularTransmission(hitPoint, fixedDir,\n"
"			kt, nc, nt, &transLocalSampledDir);\n"
"	\n"
"	const float localFilmThickness = (material->archglass.filmThicknessTexIndex != NULL_INDEX) \n"
"									 ? Texture_GetFloatValue(material->archglass.filmThicknessTexIndex, hitPoint TEXTURES_PARAM) : 0.f;\n"
"	const float localFilmIor = (localFilmThickness > 0.f && material->archglass.filmIorTexIndex != NULL_INDEX) \n"
"							   ? Texture_GetFloatValue(material->archglass.filmIorTexIndex, hitPoint TEXTURES_PARAM) : 1.f;\n"
"	float3 reflLocalSampledDir;\n"
"	const float3 refl = ArchGlassMaterial_EvalSpecularReflection(hitPoint, fixedDir,\n"
"			kr, nc, nt, &reflLocalSampledDir, localFilmThickness, localFilmIor);\n"
"\n"
"	// Decide to transmit or reflect\n"
"	float threshold;\n"
"	if (!Spectrum_IsBlack(refl)) {\n"
"		if (!Spectrum_IsBlack(trans)) {\n"
"			// Importance sampling\n"
"			const float reflFilter = Spectrum_Filter(refl);\n"
"			const float transFilter = Spectrum_Filter(trans);\n"
"			threshold = transFilter / (reflFilter + transFilter);\n"
"\n"
"			// A place an upper and lower limit to not under sample\n"
"			// reflection or transmission\n"
"			threshold = clamp(threshold, .25f, .75f);\n"
"		} else\n"
"			threshold = 0.f;\n"
"	} else {\n"
"		// ArchGlassMaterial::Sample() can be called only if ArchGlassMaterial::GetPassThroughTransparency()\n"
"		// has detected a reflection or a mixed reflection/transmission.\n"
"		// Here, there was no reflection at all so I return black.\n"
"		MATERIAL_SAMPLE_RETURN_BLACK;\n"
"	}\n"
"\n"
"	float3 sampledDir;\n"
"	BSDFEvent event;\n"
"	float pdfW;\n"
"	float3 result;\n"
"	if (passThroughEvent < threshold) {\n"
"		// Transmit\n"
"\n"
"		sampledDir = transLocalSampledDir;\n"
"\n"
"		event = SPECULAR | TRANSMIT;\n"
"		pdfW = threshold;\n"
"		\n"
"		result = trans;\n"
"	} else {\n"
"		// Reflect\n"
"		sampledDir = reflLocalSampledDir;\n"
"\n"
"		event = SPECULAR | REFLECT;\n"
"		pdfW = 1.f - threshold;\n"
"\n"
"		result = refl;\n"
"	}\n"
"	result /= pdfW;\n"
"\n"
"	EvalStack_PushFloat3(result);\n"
"	EvalStack_PushFloat3(sampledDir);\n"
"	EvalStack_PushFloat(pdfW);\n"
"	EvalStack_PushBSDFEvent(event);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Material specific EvalOp\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_NOT_INLINE void ArchGlassMaterial_EvalOp(\n"
"		__global const Material* restrict material,\n"
"		const MaterialEvalOpType evalType,\n"
"		__global float *evalStack,\n"
"		uint *evalStackOffset,\n"
"		__global const HitPoint *hitPoint\n"
"		MATERIALS_PARAM_DECL) {\n"
"	switch (evalType) {\n"
"		case EVAL_ALBEDO:\n"
"			ArchGlassMaterial_Albedo(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_GET_INTERIOR_VOLUME:\n"
"			ArchGlassMaterial_GetInteriorVolume(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_GET_EXTERIOR_VOLUME:\n"
"			ArchGlassMaterial_GetExteriorVolume(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_GET_EMITTED_RADIANCE:\n"
"			ArchGlassMaterial_GetEmittedRadiance(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_GET_PASS_TROUGH_TRANSPARENCY:\n"
"			ArchGlassMaterial_GetPassThroughTransparency(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_EVALUATE:\n"
"			ArchGlassMaterial_Evaluate(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_SAMPLE:\n"
"			ArchGlassMaterial_Sample(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		default:\n"
"			// Something wrong here\n"
"			break;\n"
"	}\n"
"}\n";
} }
