
#include <string>

namespace slg { namespace ocl {
std::string KernelSource_materialdefs_funcs_default =
"#line 2 \"material_funcs_default.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Default material functions\n"
"//------------------------------------------------------------------------------\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// DefaultMaterial_GetInteriorVolume\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE void DefaultMaterial_GetInteriorVolume(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	float passThroughEvent;\n"
"	EvalStack_PopFloat(passThroughEvent);\n"
"\n"
"	const uint volIndex = material->interiorVolumeIndex;\n"
"\n"
"	EvalStack_PushUInt(volIndex);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// DefaultMaterial_GetExteriorVolume\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE void DefaultMaterial_GetExteriorVolume(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	float passThroughEvent;\n"
"	EvalStack_PopFloat(passThroughEvent);\n"
"\n"
"	const uint volIndex = material->exteriorVolumeIndex;\n"
"\n"
"	EvalStack_PushUInt(volIndex);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// DefaultMaterial_GetPassThroughTransparency\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE void DefaultMaterial_GetPassThroughTransparency(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	bool backTracing;\n"
"	EvalStack_PopUInt(backTracing);\n"
"	float passThroughEvent;\n"
"	EvalStack_PopFloat(passThroughEvent);\n"
"	float3 localFixedDir;\n"
"	EvalStack_PopFloat3(localFixedDir);\n"
"\n"
"	const uint transpTexIndex = (hitPoint->intoObject != backTracing) ?\n"
"		material->frontTranspTexIndex : material->backTranspTexIndex;\n"
"\n"
"	float3 transp;\n"
"	if (transpTexIndex != NULL_INDEX) {\n"
"		const float weight = clamp(\n"
"				Texture_GetFloatValue(transpTexIndex, hitPoint TEXTURES_PARAM),\n"
"				0.f, 1.f);\n"
"\n"
"		transp = (passThroughEvent > weight) ? WHITE : BLACK;\n"
"	} else\n"
"		transp = BLACK;\n"
"	\n"
"	EvalStack_PushFloat3(transp);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// DefaultMaterial_GetEmittedRadiance\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE void DefaultMaterial_GetEmittedRadiance(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	float oneOverPrimitiveArea;\n"
"	EvalStack_PopFloat(oneOverPrimitiveArea);\n"
"\n"
"	const uint emitTexIndex = material->emitTexIndex;\n"
"	const float3 emittedRadiance = (emitTexIndex == NULL_INDEX) ?\n"
"		BLACK :\n"
"		(VLOAD3F(material->emittedFactor.c) *\n"
"		(material->usePrimitiveArea ? oneOverPrimitiveArea : 1.f) *\n"
"		clamp(Texture_GetSpectrumValue(emitTexIndex, hitPoint\n"
"				TEXTURES_PARAM), BLACK, MAKE_FLOAT3(INFINITY, INFINITY, INFINITY)));\n"
"\n"
"	EvalStack_PushFloat3(emittedRadiance);\n"
"}\n";
} }
