
#include <string>

namespace slg { namespace ocl {
std::string KernelSource_materialdefs_funcs_disney =
"#line 2 \"materialdefs_funcs_disney.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Disney BRDF material\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE void DisneyMaterial_Albedo(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"    const float3 albedo = Spectrum_Clamp(Texture_GetSpectrumValue(material->disney.baseColorTexIndex, hitPoint TEXTURES_PARAM));\n"
"\n"
"	EvalStack_PushFloat3(albedo);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void DisneyMaterial_GetInteriorVolume(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	DefaultMaterial_GetInteriorVolume(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void DisneyMaterial_GetExteriorVolume(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	DefaultMaterial_GetExteriorVolume(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void DisneyMaterial_GetPassThroughTransparency(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	DefaultMaterial_GetPassThroughTransparency(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void DisneyMaterial_GetEmittedRadiance(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	DefaultMaterial_GetEmittedRadiance(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float3 DisneyMaterial_CalculateTint(const float3 color) {\n"
"	float luminance = color.x * 0.3f + color.y * 0.6f + color.z * 1.0f;\n"
"	return (luminance > 0.0f) ? color * (1.0f / luminance) : WHITE;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float DisneyMaterial_GTR1(float NdotH, float a) {\n"
"	if (a >= 1.0f)\n"
"		return M_1_PI_F;\n"
"\n"
"	float a2 = a * a;\n"
"	float t = 1.0f + (a2 - 1.0f) * (NdotH * NdotH);\n"
"\n"
"	return (a2 - 1.0f) / (M_PI_F * log(a2) * t);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float DisneyMaterial_GTR2_Aniso(float NdotH, float HdotX, float HdotY,\n"
"		float ax, float ay) {\n"
"	return 1.0f / (M_PI_F * ax * ay * Sqr(Sqr(HdotX / ax) + Sqr(HdotY / ay) + NdotH * NdotH));\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float DisneyMaterial_SmithG_GGX_Aniso(float NdotV, float VdotX, float VdotY,\n"
"		float ax, float ay) {\n"
"	return 1.0f / (NdotV + sqrt(Sqr(VdotX * ax) + Sqr(VdotY * ay) + Sqr(NdotV)));\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float DisneyMaterial_SmithG_GGX(float NdotV, float alphaG) {\n"
"	const float a = alphaG * alphaG;\n"
"	const float b = NdotV * NdotV;\n"
"\n"
"	return 1.0f / (fabs(NdotV) + max(sqrt(a + b - a * b), 0.0001f));\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float DisneyMaterial_Schlick_Weight(const float cosi) {\n"
"	return pow(1.f - cosi, 5.f);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void DisneyMaterial_Anisotropic_Params(const float anisotropic,\n"
"		const float roughness, float *ax, float *ay) {\n"
"	const float aspect = sqrt(1.0f - 0.9f * anisotropic);\n"
"	*ax = fmax(0.001f, Sqr(roughness) / aspect);\n"
"	*ay = fmax(0.001f, Sqr(roughness) * aspect);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void DisneyMaterial_ComputeRatio(const float metallic, const float clearcoat,\n"
"		float *ratioGlossy, float *ratioDiffuse, float *ratioClearcoat) {\n"
"	const float metallicBRDF = metallic;\n"
"	const float dielectricBRDF = (1.0f - metallic);\n"
"\n"
"	const float specularWeight = metallicBRDF + dielectricBRDF;\n"
"	const float diffuseWeight = dielectricBRDF;\n"
"	const float clearcoatWeight = clearcoat;\n"
"\n"
"	const float norm = 1.0f / (specularWeight + diffuseWeight + clearcoatWeight);\n"
"\n"
"	*ratioGlossy = specularWeight * norm;\n"
"	*ratioDiffuse = diffuseWeight * norm;\n"
"	*ratioClearcoat = clearcoatWeight * norm;\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float DisneyMaterial_DiffusePdf(const float3 wi, const float3 wo) {\n"
"	return fabs(CosTheta(wi)) * M_1_PI_F;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float DisneyMaterial_MetallicPdf(const float anisotropic,\n"
"		const float roughness, const float3 wi, const float3 wo) {\n"
"	const float3 wh = normalize(wo + wi);\n"
"\n"
"	float ax, ay;\n"
"	DisneyMaterial_Anisotropic_Params(anisotropic, roughness, &ax, &ay);\n"
"\n"
"	const float ax2 = ax * ax;\n"
"	const float ay2 = ay * ay;\n"
"\n"
"	const float HdotX = wh.x;\n"
"	const float HdotY = wh.y;\n"
"	const float NdotH = fabs(CosTheta(wh));\n"
"\n"
"	const float denom = HdotX * HdotX / ax2 + HdotY * HdotY / ay2 + NdotH * NdotH;\n"
"	if (denom == 0.0f)\n"
"		return 0.0f;\n"
"\n"
"	const float pdfDistribution = NdotH / (M_PI_F * ax * ay * denom * denom);\n"
"\n"
"	return pdfDistribution / (4.0f * dot(wo, wh));\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float DisneyMaterial_ClearcoatPdf(const float clearcoatGloss,\n"
"		const float3 wi, const float3 wo) {\n"
"	const float3 wh = normalize(wo + wi);\n"
"\n"
"	const float NdotH = fabs(CosTheta(wh));\n"
"	const float Dr = DisneyMaterial_GTR1(NdotH, Lerp(clearcoatGloss, 0.1f, 0.001f));\n"
"\n"
"	return Dr * NdotH / (4.0f * dot(wo, wh));\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float DisneyMaterial_DisneyPdf(const float roughness, const float metallic,\n"
"		const float clearcoat, const float clearcoatGloss, const float anisotropic,\n"
"		const float3 localLightDir, const float3 localEyeDir) {\n"
"	if (CosTheta(localLightDir) * CosTheta(localEyeDir) <= 0.0f)\n"
"		return 0.0f;\n"
"\n"
"	const float3 wi = localLightDir;\n"
"	const float3 wo = localEyeDir;\n"
"\n"
"	float ratioGlossy, ratioDiffuse, ratioClearcoat;\n"
"	DisneyMaterial_ComputeRatio(metallic, clearcoat,\n"
"			&ratioGlossy, &ratioDiffuse, &ratioClearcoat);\n"
"\n"
"	const float pdfDiffuse = ratioDiffuse * DisneyMaterial_DiffusePdf(wi, wo);\n"
"	const float pdfMicrofacet = ratioGlossy * DisneyMaterial_MetallicPdf(anisotropic, roughness, wi, wo);\n"
"	const float pdfClearcoat = ratioClearcoat * DisneyMaterial_ClearcoatPdf(clearcoatGloss, wi, wo);\n"
"\n"
"	return pdfDiffuse + pdfMicrofacet + pdfClearcoat;\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float3 DisneyMaterial_DisneyDiffuse(const float3 color,\n"
"		const float roughness,\n"
"		float NdotL, float NdotV, float LdotH) {\n"
"	const float FL = DisneyMaterial_Schlick_Weight(NdotL);\n"
"	const float FV = DisneyMaterial_Schlick_Weight(NdotV);\n"
"\n"
"	const float Fd90 = 0.5f + 2.0f * (LdotH * LdotH) * (roughness * roughness);\n"
"	const float Fd = Lerp(FL, 1.0f, Fd90) * Lerp(FV, 1.0f, Fd90);\n"
"\n"
"	return M_1_PI_F * Fd * color;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 DisneyMaterial_DisneySubsurface(const float3 color,\n"
"		const float roughness,\n"
"		float NdotL, float NdotV, float LdotH) {\n"
"\n"
"	const float FL = DisneyMaterial_Schlick_Weight(NdotL);\n"
"	const float FV = DisneyMaterial_Schlick_Weight(NdotV);\n"
"\n"
"	const float Fss90 = LdotH * LdotH * roughness;\n"
"	const float Fss = Lerp(FL, 1.0f, Fss90) * Lerp(FV, 1.0f, Fss90);\n"
"	const float ss = 1.25f * (Fss * (1.0f / (NdotL + NdotV) - 0.5f) + 0.5f);\n"
"\n"
"	return M_1_PI_F * ss * color;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 DisneyMaterial_DisneyMetallic(const float3 color,\n"
"		const float specular, const float specularTint, const float metallic,\n"
"		const float anisotropic, const float roughness,\n"
"		const float NdotL, const float NdotV, const float NdotH,\n"
"		const float LdotH, const float VdotH,\n"
"		const float3 wi, const float3 wo, const float3 H) {\n"
"	const float3 Ctint = DisneyMaterial_CalculateTint(color);\n"
"\n"
"	const float3 CSpecTint = specular * 0.08f * Lerp3(specularTint, WHITE, Ctint);\n"
"	const float3 Cspec0 = Lerp3(metallic, CSpecTint, color);\n"
"\n"
"	float ax, ay;\n"
"	DisneyMaterial_Anisotropic_Params(anisotropic, roughness, &ax, &ay);\n"
"\n"
"	const float Ds = DisneyMaterial_GTR2_Aniso(NdotH, H.x, H.y, ax, ay);\n"
"\n"
"	const float FH = DisneyMaterial_Schlick_Weight(LdotH);\n"
"\n"
"	const float3 Fs = Lerp3(FH, Cspec0, WHITE);\n"
"\n"
"	const float Gl = DisneyMaterial_SmithG_GGX_Aniso(NdotL, wi.x, wi.y, ax, ay);\n"
"	const float Gv = DisneyMaterial_SmithG_GGX_Aniso(NdotV, wo.x, wo.y, ax, ay);\n"
"\n"
"	const float Gs = Gl * Gv;\n"
"\n"
"	return Gs * Fs * Ds;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float DisneyMaterial_DisneyClearCoat(const float clearcoat,\n"
"		const float clearcoatGloss,	float NdotL, float NdotV, float NdotH, float LdotH) {\n"
"	const float gloss = Lerp(clearcoatGloss, 0.1f, 0.001f);\n"
"\n"
"	const float Dr = DisneyMaterial_GTR1(fabs(NdotH), gloss);\n"
"	const float FH = DisneyMaterial_Schlick_Weight(LdotH);\n"
"	const float Fr = Lerp(FH, 0.04f, 1.0f);\n"
"	const float Gr = DisneyMaterial_SmithG_GGX(NdotL, 0.25f) * DisneyMaterial_SmithG_GGX(NdotV, 0.25f);\n"
"\n"
"	return clearcoat * Fr * Gr * Dr;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 DisneyMaterial_DisneySheen(const float3 color,\n"
"		const float sheen, const float sheenTint,\n"
"		float LdotH) {\n"
"	const float FH = DisneyMaterial_Schlick_Weight(LdotH);\n"
"\n"
"	const float3 Ctint = DisneyMaterial_CalculateTint(color);\n"
"	const float3 Csheen = Lerp3(sheenTint, WHITE, Ctint);\n"
"\n"
"	return clamp(FH * sheen * Csheen, 0.f, 1.f);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 DisneyMaterial_EvaluateImpl(\n"
"		__global const HitPoint *hitPoint, const float3 lightDir, const float3 eyeDir,\n"
"		BSDFEvent *event, float *directPdfW,\n"
"		const float3 colorVal, const float subsurfaceVal, const float roughnessVal,\n"
"		const float metallicVal, const float specularVal, const float specularTintVal,\n"
"		const float clearcoatVal, const float clearcoatGlossVal, const float anisotropicGlossVal,\n"
"		const float sheenVal, const float sheenTintVal, \n"
"		const float localFilmAmount, const float localFilmThickness, const float localFilmIor) {\n"
"	const float3 wo = eyeDir; \n"
"	const float3 wi = lightDir;\n"
"\n"
"	const float NdotL = fabs(CosTheta(wi));\n"
"	const float NdotV = fabs(CosTheta(wo));\n"
"	\n"
"	if (NdotL < DEFAULT_COS_EPSILON_STATIC || NdotV < DEFAULT_COS_EPSILON_STATIC)\n"
"		return BLACK;\n"
"\n"
"	const float3 color = Spectrum_Clamp(colorVal);\n"
"	const float subsurface = clamp(subsurfaceVal, 0.0f, 1.0f);\n"
"	const float roughness = clamp(roughnessVal, 0.0f, 1.0f);\n"
"	const float metallic = clamp(metallicVal, 0.0f, 1.0f);\n"
"	const float specular = clamp(specularVal, 0.0f, 1.0f);\n"
"	const float specularTint = clamp(specularTintVal, 0.0f, 1.0f);\n"
"	const float clearcoat = clamp(clearcoatVal, 0.0f, 1.0f);\n"
"	const float clearcoatGloss = clamp(clearcoatGlossVal, 0.0f, 1.0f);\n"
"	const float anisotropicGloss = clamp(anisotropicGlossVal, 0.0f, 1.0f);\n"
"	// I allow sheen values > 1.0 to accentuate the effect. The result is still\n"
"	// clamped between 0.0 and 1.0 to not break the energy conservation law.\n"
"	const float sheen = sheenVal;\n"
"	const float sheenTint = clamp(sheenTintVal, 0.0f, 1.0f);\n"
"\n"
"	const float3 H = normalize(wo + wi);\n"
"\n"
"	const float NdotH = fabs(CosTheta(H));\n"
"	const float LdotH = dot(wi, H);\n"
"	const float VdotH = dot(wo, H);\n"
"\n"
"	const float3 diffuseEval = DisneyMaterial_DisneyDiffuse(color, roughness, NdotL, NdotV, LdotH);\n"
"\n"
"	const float3 subsurfaceEval = DisneyMaterial_DisneySubsurface(color, roughness, NdotL, NdotV, LdotH);\n"
"\n"
"	float3 metallicEval = DisneyMaterial_DisneyMetallic(color, specular, specularTint, metallic, anisotropicGloss, roughness,\n"
"														NdotL, NdotV, NdotH, LdotH, VdotH, wi, wo, H);\n"
"	if (localFilmThickness > 0.f) {\n"
"		const float3 metallicWithFilmColor = metallicEval * CalcFilmColor(wo, localFilmThickness, localFilmIor);\n"
"		metallicEval = Lerp3(localFilmAmount, metallicEval, metallicWithFilmColor);\n"
"	}\n"
"	\n"
"	const float clearCoatEval = DisneyMaterial_DisneyClearCoat(clearcoat, clearcoatGloss,\n"
"																NdotL, NdotV, NdotH, LdotH);\n"
"	const float3 glossyEval = metallicEval + clearCoatEval;\n"
"\n"
"	const float3 sheenEval = DisneyMaterial_DisneySheen(color, sheen, sheenTint, LdotH);\n"
"\n"
"	if (directPdfW) {\n"
"		*directPdfW = DisneyMaterial_DisneyPdf(roughness, metallic, clearcoat, clearcoatGloss, anisotropicGloss, lightDir, eyeDir);\n"
"\n"
"		if (*directPdfW < 0.0001f)\n"
"			return BLACK;\n"
"	}\n"
"\n"
"	*event = GLOSSY | REFLECT;\n"
"\n"
"	const float3 f = (Lerp3(subsurface, diffuseEval, subsurfaceEval) + sheenEval) * (1.0f - metallic) + glossyEval;\n"
"	\n"
"	return f * fabs(NdotL);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void DisneyMaterial_Evaluate(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	float3 lightDir, eyeDir;\n"
"	EvalStack_PopFloat3(eyeDir);\n"
"	EvalStack_PopFloat3(lightDir);\n"
"	\n"
"	const float localFilmAmount = (material->disney.filmAmountTexIndex != NULL_INDEX) \n"
"								  ? clamp(Texture_GetFloatValue(material->disney.filmAmountTexIndex, hitPoint TEXTURES_PARAM), 0.f, 1.f) : 1.f;\n"
"	const float localFilmThickness = (material->disney.filmThicknessTexIndex != NULL_INDEX) \n"
"									 ? Texture_GetFloatValue(material->disney.filmThicknessTexIndex, hitPoint TEXTURES_PARAM) : 0.f;\n"
"	const float localFilmIor = (localFilmThickness > 0.f && material->disney.filmIorTexIndex != NULL_INDEX) \n"
"							   ? Texture_GetFloatValue(material->disney.filmIorTexIndex, hitPoint TEXTURES_PARAM) : 1.f;\n"
"\n"
"	BSDFEvent event;\n"
"	float directPdfW;\n"
"	const float3 result = DisneyMaterial_EvaluateImpl(hitPoint, lightDir, eyeDir,\n"
"		&event, &directPdfW,\n"
"		Texture_GetSpectrumValue(material->disney.baseColorTexIndex, hitPoint TEXTURES_PARAM),\n"
"		Texture_GetFloatValue(material->disney.subsurfaceTexIndex, hitPoint TEXTURES_PARAM),\n"
"		Texture_GetFloatValue(material->disney.roughnessTexIndex, hitPoint TEXTURES_PARAM),\n"
"		Texture_GetFloatValue(material->disney.metallicTexIndex, hitPoint TEXTURES_PARAM),\n"
"		Texture_GetFloatValue(material->disney.specularTexIndex, hitPoint TEXTURES_PARAM),\n"
"		Texture_GetFloatValue(material->disney.specularTintTexIndex, hitPoint TEXTURES_PARAM),\n"
"		Texture_GetFloatValue(material->disney.clearcoatTexIndex, hitPoint TEXTURES_PARAM),\n"
"		Texture_GetFloatValue(material->disney.clearcoatGlossTexIndex, hitPoint TEXTURES_PARAM),\n"
"		Texture_GetFloatValue(material->disney.anisotropicTexIndex, hitPoint TEXTURES_PARAM),\n"
"		Texture_GetFloatValue(material->disney.sheenTexIndex, hitPoint TEXTURES_PARAM),\n"
"		Texture_GetFloatValue(material->disney.sheenTintTexIndex, hitPoint TEXTURES_PARAM),\n"
"		localFilmAmount, localFilmThickness, localFilmIor)\n"
"		// Evaluate() follows LuxRender habit to return the result multiplied by cosThetaToLight\n"
"		* fabs(CosTheta(lightDir));\n"
"\n"
"	if (Spectrum_IsBlack(result)) {\n"
"		MATERIAL_EVALUATE_RETURN_BLACK;\n"
"	}\n"
"\n"
"	EvalStack_PushFloat3(result);\n"
"	EvalStack_PushBSDFEvent(event);\n"
"	EvalStack_PushFloat(directPdfW);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float3 DisneyMaterial_DisneyDiffuseSample(const float3 wo,\n"
"		const float u0, const float u1) {\n"
"	return Sgn(CosTheta(wo)) * CosineSampleHemisphere(u0, u1);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 DisneyMaterial_DisneyMetallicSample(const float anisotropic,\n"
"		const float roughness, const float3 wo,\n"
"		const float u0, const float u1) {\n"
"	float ax, ay;\n"
"	DisneyMaterial_Anisotropic_Params(anisotropic, roughness, &ax, &ay);\n"
"\n"
"	float phi = atan(ay / ax * tan(2.0f * M_PI_F * u1 + 0.5f * M_PI_F));\n"
"	if (u1 > 0.5f)\n"
"		phi += M_PI_F;\n"
"\n"
"	const float sinPhi = sin(phi), cosPhi = cos(phi);\n"
"	const float ax2 = ax * ax, ay2 = ay * ay;\n"
"	const float alpha2 = 1.0f / (cosPhi * cosPhi / ax2 + sinPhi * sinPhi / ay2);\n"
"	const float tanTheta2 = alpha2 * u0 / (1.0f - u0);\n"
"	const float cosTheta = 1.0f / sqrt(1.0f + tanTheta2);\n"
"\n"
"	const float sinTheta = sqrt(fmax(0.0f, 1.0f - cosTheta * cosTheta));\n"
"	float3 wh = MAKE_FLOAT3(sinTheta * cosPhi, sinTheta * sinPhi, cosTheta);\n"
"\n"
"	if (CosTheta(wo) * CosTheta(wh) <= 0.0f)\n"
"		wh *= MAKE_FLOAT3(-1.f, -1.f, -1.f);\n"
"\n"
"	return normalize(2.0f * dot(wh, wo) * wh - wo);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 DisneyMaterial_DisneyClearcoatSample(const float clearcoatGloss,\n"
"		const float3 wo, float u0, float u1) {\n"
"	const float gloss = Lerp(clearcoatGloss, 0.1f, 0.001f);\n"
"	const float alpha2 = gloss * gloss;\n"
"	const float cosTheta = sqrt(fmax(0.0001f, (1.0f - pow(alpha2, 1.0f - u0)) / (1.0f - alpha2)));\n"
"	const float sinTheta = sqrt(fmax(0.0001f, 1.0f - cosTheta * cosTheta));\n"
"	const float phi = 2.0f * M_PI_F * u1;\n"
"\n"
"	float3 wh = MAKE_FLOAT3(sinTheta * cos(phi), sinTheta * sin(phi), cosTheta);\n"
"\n"
"	if (CosTheta(wo) * CosTheta(wh) <= 0.0f)\n"
"		wh *= MAKE_FLOAT3(-1.f, -1.f, -1.f);\n"
"\n"
"	return normalize(2.0f * dot(wh, wo) * wh - wo);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void DisneyMaterial_Sample(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	float u0, u1, passThroughEvent;\n"
"	EvalStack_PopFloat(passThroughEvent);\n"
"	EvalStack_PopFloat(u1);\n"
"	EvalStack_PopFloat(u0);\n"
"	float3 fixedDir;\n"
"	EvalStack_PopFloat3(fixedDir);\n"
"\n"
"	const float3 colorVal = Texture_GetSpectrumValue(material->disney.baseColorTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float subsurfaceVal = Texture_GetFloatValue(material->disney.subsurfaceTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float roughnessVal = Texture_GetFloatValue(material->disney.roughnessTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float metallicVal = Texture_GetFloatValue(material->disney.metallicTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float specularVal = Texture_GetFloatValue(material->disney.specularTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float specularTintVal = Texture_GetFloatValue(material->disney.specularTintTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float clearcoatVal = Texture_GetFloatValue(material->disney.clearcoatTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float clearcoatGlossVal = Texture_GetFloatValue(material->disney.clearcoatGlossTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float anisotropicGlossVal = Texture_GetFloatValue(material->disney.anisotropicTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float sheenVal = Texture_GetFloatValue(material->disney.sheenTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float sheenTintVal = Texture_GetFloatValue(material->disney.sheenTintTexIndex, hitPoint TEXTURES_PARAM);\n"
"\n"
"	const float roughness = clamp(roughnessVal, 0.0f, 1.0f);\n"
"	const float metallic = clamp(metallicVal, 0.0f, 1.0f);\n"
"	const float clearcoat = clamp(clearcoatVal, 0.0f, 1.0f);\n"
"	const float clearcoatGloss = clamp(clearcoatGlossVal, 0.0f, 1.0f);\n"
"	const float anisotropicGloss = clamp(anisotropicGlossVal, 0.0f, 1.0f);\n"
"\n"
"	const float3 wo = fixedDir;\n"
"\n"
"	float ratioGlossy, ratioDiffuse, ratioClearcoat;\n"
"	DisneyMaterial_ComputeRatio(metallic, clearcoat,\n"
"			&ratioGlossy, &ratioDiffuse, &ratioClearcoat);\n"
"\n"
"	float3 sampledDir;\n"
"	if (passThroughEvent <= ratioGlossy)\n"
"		sampledDir = DisneyMaterial_DisneyMetallicSample(anisotropicGloss, roughness, wo, u0, u1);\n"
"	else if (passThroughEvent > ratioGlossy &&  passThroughEvent <= ratioGlossy + ratioClearcoat)\n"
"		sampledDir = DisneyMaterial_DisneyClearcoatSample(clearcoatGloss, wo, u0, u1);\n"
"	else if (passThroughEvent > ratioGlossy + ratioClearcoat && passThroughEvent <= ratioGlossy + ratioClearcoat + ratioDiffuse)\n"
"		sampledDir = DisneyMaterial_DisneyDiffuseSample(wo, u0, u1);\n"
"	else {\n"
"		MATERIAL_SAMPLE_RETURN_BLACK;\n"
"	}\n"
"	\n"
"	const float3 localLightDir = sampledDir;\n"
"	const float3 localEyeDir = fixedDir;\n"
"\n"
"	const float NdotL = fabs(CosTheta(localLightDir));\n"
"	const float NdotV = fabs(CosTheta(localEyeDir));\n"
"	if (NdotL < DEFAULT_COS_EPSILON_STATIC || NdotV < DEFAULT_COS_EPSILON_STATIC) {\n"
"		MATERIAL_SAMPLE_RETURN_BLACK;\n"
"	}\n"
"\n"
"	const float pdfW = DisneyMaterial_DisneyPdf(roughnessVal, metallicVal, clearcoatVal, clearcoatGlossVal, anisotropicGlossVal,\n"
"			localLightDir, localEyeDir);\n"
"	if (pdfW < 0.0001f) {\n"
"		MATERIAL_SAMPLE_RETURN_BLACK;\n"
"	}\n"
"	\n"
"	const float localFilmAmount = (material->disney.filmAmountTexIndex != NULL_INDEX) \n"
"								  ? clamp(Texture_GetFloatValue(material->disney.filmAmountTexIndex, hitPoint TEXTURES_PARAM), 0.f, 1.f) : 1.f;\n"
"	const float localFilmThickness = (material->disney.filmThicknessTexIndex != NULL_INDEX) \n"
"									 ? Texture_GetFloatValue(material->disney.filmThicknessTexIndex, hitPoint TEXTURES_PARAM) : 0.f;\n"
"	const float localFilmIor = (localFilmThickness > 0.f && material->disney.filmIorTexIndex != NULL_INDEX) \n"
"							   ? Texture_GetFloatValue(material->disney.filmIorTexIndex, hitPoint TEXTURES_PARAM) : 1.f;\n"
"\n"
"	BSDFEvent event;\n"
"	const float3 f = DisneyMaterial_EvaluateImpl(hitPoint, localLightDir, localEyeDir, &event, NULL,\n"
"			colorVal, subsurfaceVal, roughnessVal, metallicVal, specularVal, specularTintVal,\n"
"			clearcoatVal, clearcoatGlossVal, anisotropicGlossVal, sheenVal, sheenTintVal,\n"
"			localFilmAmount, localFilmThickness, localFilmIor);\n"
"\n"
"	const float3 result = f / pdfW;\n"
"\n"
"	EvalStack_PushFloat3(result);\n"
"	EvalStack_PushFloat3(sampledDir);\n"
"	EvalStack_PushFloat(pdfW);\n"
"	EvalStack_PushBSDFEvent(event);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Material specific EvalOp\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_NOT_INLINE void DisneyMaterial_EvalOp(\n"
"		__global const Material* restrict material,\n"
"		const MaterialEvalOpType evalType,\n"
"		__global float *evalStack,\n"
"		uint *evalStackOffset,\n"
"		__global const HitPoint *hitPoint\n"
"		MATERIALS_PARAM_DECL) {\n"
"	switch (evalType) {\n"
"		case EVAL_ALBEDO:\n"
"			DisneyMaterial_Albedo(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_GET_INTERIOR_VOLUME:\n"
"			DisneyMaterial_GetInteriorVolume(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_GET_EXTERIOR_VOLUME:\n"
"			DisneyMaterial_GetExteriorVolume(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_GET_EMITTED_RADIANCE:\n"
"			DisneyMaterial_GetEmittedRadiance(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_GET_PASS_TROUGH_TRANSPARENCY:\n"
"			DisneyMaterial_GetPassThroughTransparency(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_EVALUATE:\n"
"			DisneyMaterial_Evaluate(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_SAMPLE:\n"
"			DisneyMaterial_Sample(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		default:\n"
"			// Something wrong here\n"
"			break;\n"
"	}\n"
"}\n";
} }
