
#include <string>

namespace slg { namespace ocl {
std::string KernelSource_materialdefs_funcs_glass =
"#line 2 \"materialdefs_funcs_glass.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Glass material\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE void GlassMaterial_Albedo(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"    const float3 albedo = WHITE;\n"
"\n"
"	EvalStack_PushFloat3(albedo);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void GlassMaterial_GetInteriorVolume(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	DefaultMaterial_GetInteriorVolume(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void GlassMaterial_GetExteriorVolume(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	DefaultMaterial_GetExteriorVolume(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void GlassMaterial_GetPassThroughTransparency(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	DefaultMaterial_GetPassThroughTransparency(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void GlassMaterial_GetEmittedRadiance(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	DefaultMaterial_GetEmittedRadiance(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 GlassMaterial_WaveLength2RGB(const float waveLength) {\n"
"	float r, g, b;\n"
"	if ((waveLength >= 380.f) && (waveLength < 440.f)) {\n"
"		r = -(waveLength - 440.f) / (440 - 380.f);\n"
"		g = 0.f;\n"
"		b = 1.f;\n"
"	} else if ((waveLength >= 440.f) && (waveLength < 490.f)) {\n"
"		r = 0.f;\n"
"		g = (waveLength - 440.f) / (490.f - 440.f);\n"
"		b = 1.f;\n"
"	} else if ((waveLength >= 490.f) && (waveLength < 510.f)) {\n"
"		r = 0.f;\n"
"		g = 1.f;\n"
"		b = -(waveLength - 510.f) / (510.f - 490.f);\n"
"	} else if ((waveLength >= 510.f) && (waveLength < 580.f)) {\n"
"		r = (waveLength - 510.f) / (580.f - 510.f);\n"
"		g = 1.f;\n"
"		b = 0.f;\n"
"	} else if ((waveLength >= 580.f) && (waveLength < 645.f)) {\n"
"		r = 1.f;\n"
"		g = -(waveLength - 645.f) / (645 - 580.f);\n"
"		b = 0.f;\n"
"	} else if ((waveLength >= 645.f) && (waveLength < 780.f)) {\n"
"		r = 1.f;\n"
"		g = 0.f;\n"
"		b = 0.f;\n"
"	} else\n"
"		return BLACK;\n"
"\n"
"	// The intensity fall off near the upper and lower limits\n"
"	float factor;\n"
"	if ((waveLength >= 380.f) && (waveLength < 420.f))\n"
"		factor = .3f + .7f * (waveLength - 380.f) / (420.f - 380.f);\n"
"	else if ((waveLength >= 420) && (waveLength < 700))\n"
"		factor = 1.f;\n"
"	else\n"
"		factor = .3f + .7f * (780.f - waveLength) / (780.f - 700.f);\n"
"\n"
"	const float3 result = MAKE_FLOAT3(r, g, b) * factor;\n"
"\n"
"	// To normalize the output\n"
"	const float3 normFactor = MAKE_FLOAT3(1.f / .5652729f, 1.f / .36875f, 1.f / .265375f);\n"
"	\n"
"	return result * normFactor;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float GlassMaterial_WaveLength2IOR(const float waveLength, const float IOR, const float B) {\n"
"	// Cauchy's equation for relationship between the refractive index and wavelength\n"
"	// note: Cauchy's lambda is expressed in micrometers while waveLength is in nanometers\n"
"\n"
"	// This is the formula suggested by Neo here, with a changed naming convention from B->A and C-> B:\n"
"	// https://github.com/LuxCoreRender/BlendLuxCore/commit/d3fed046ab62e18226e410b42a16ca1bccefb530#commitcomment-26617643\n"
"	\n"
"	// Compute Cauchy-A assuming the user input IOR at 587.56 nm \n"
"	// (Fraunhofer d-line, Helium, used in one definition of the Abbe number)\n"
"	//const float A = IOR - B / Sqr(587.56f / 1000.f);\n"
"\n"
"	// Use the user input IOR directly as Cauchy-A. Equivalent to the B used by old LuxRender.\n"
"	const float A = IOR;\n"
"\n"
"	// Cauchy's equation\n"
"	const float cauchyEq = A + B / Sqr(waveLength / 1000.f);\n"
"\n"
"	return cauchyEq;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 GlassMaterial_EvalSpecularReflection(__global const HitPoint *hitPoint,\n"
"		const float3 localFixedDir, const float3 kr,\n"
"		const float nc, const float nt,\n"
"		float3 *sampledDir, const float localFilmThickness, const float localFilmIor) {\n"
"	if (Spectrum_IsBlack(kr))\n"
"		return BLACK;\n"
"\n"
"	const float costheta = CosTheta(localFixedDir);\n"
"	*sampledDir = MAKE_FLOAT3(-localFixedDir.x, -localFixedDir.y, localFixedDir.z);\n"
"\n"
"	const float ntc = nt / nc;\n"
"	const float3 result = kr * FresnelCauchy_Evaluate(ntc, costheta);\n"
"	\n"
"	if (localFilmThickness > 0.f) {\n"
"		const float3 filmColor = CalcFilmColor(localFixedDir, localFilmThickness, localFilmIor);\n"
"		return result * filmColor;\n"
"	}\n"
"	return result;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 GlassMaterial_EvalSpecularTransmission(__global const HitPoint *hitPoint,\n"
"		const float3 localFixedDir, const float u0,\n"
"		const float3 kt, const float nc, const float nt, const float cauchyB,\n"
"		float3 *sampledDir) {\n"
"	if (Spectrum_IsBlack(kt))\n"
"		return BLACK;\n"
"\n"
"	// Compute transmitted ray direction\n"
"	float3 lkt;\n"
"	float lnt;\n"
"	if (cauchyB > 0.f) {\n"
"		// Select the wavelength to sample\n"
"		const float waveLength = mix(380.f, 780.f, u0);\n"
"\n"
"		lnt = GlassMaterial_WaveLength2IOR(waveLength, nt, cauchyB);\n"
"\n"
"		lkt = kt * GlassMaterial_WaveLength2RGB(waveLength);\n"
"	} else {\n"
"		lnt = nt;\n"
"		lkt = kt;\n"
"	}\n"
"\n"
"	const float ntc = lnt / nc;\n"
"	const float costheta = CosTheta(localFixedDir);\n"
"	const bool entering = (costheta > 0.f);\n"
"	const float eta = entering ? (nc / lnt) : ntc;\n"
"	const float eta2 = eta * eta;\n"
"	const float sini2 = SinTheta2(localFixedDir);\n"
"	const float sint2 = eta2 * sini2;\n"
"\n"
"	// Handle total internal reflection for transmission\n"
"	if (sint2 >= 1.f)\n"
"		return BLACK;\n"
"\n"
"	const float cost = sqrt(fmax(0.f, 1.f - sint2)) * (entering ? -1.f : 1.f);\n"
"	*sampledDir = MAKE_FLOAT3(-eta * localFixedDir.x, -eta * localFixedDir.y, cost);\n"
"\n"
"	float ce;\n"
"//	if (!hitPoint.fromLight)\n"
"		ce = (1.f - FresnelCauchy_Evaluate(ntc, cost)) * eta2;\n"
"//	else {\n"
"//		const float absCosSampledDir = fabsf(CosTheta(*sampledDir));\n"
"//		ce = (1.f - FresnelTexture::CauchyEvaluate(ntc, costheta)) * fabsf(localFixedDir.z / absCosSampledDir);\n"
"//	}\n"
"\n"
"	return lkt * ce;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void GlassMaterial_Evaluate(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	float3 lightDir, eyeDir;\n"
"	EvalStack_PopFloat3(eyeDir);\n"
"	EvalStack_PopFloat3(lightDir);\n"
"\n"
"	MATERIAL_EVALUATE_RETURN_BLACK;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void GlassMaterial_Sample(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	float u0, u1, passThroughEvent;\n"
"	EvalStack_PopFloat(passThroughEvent);\n"
"	EvalStack_PopFloat(u1);\n"
"	EvalStack_PopFloat(u0);\n"
"	float3 fixedDir;\n"
"	EvalStack_PopFloat3(fixedDir);\n"
"\n"
"	const float3 ktTexVal = Texture_GetSpectrumValue(material->glass.ktTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float3 krTexVal = Texture_GetSpectrumValue(material->glass.krTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float3 kt = Spectrum_Clamp(ktTexVal);\n"
"	const float3 kr = Spectrum_Clamp(krTexVal);\n"
"\n"
"	const float nc = ExtractExteriorIors(hitPoint, material->glass.exteriorIorTexIndex TEXTURES_PARAM);\n"
"	const float nt = ExtractInteriorIors(hitPoint, material->glass.interiorIorTexIndex TEXTURES_PARAM);\n"
"\n"
"	const float cauchyB = (material->glass.cauchyBTex != NULL_INDEX) ? Texture_GetFloatValue(material->glass.cauchyBTex, hitPoint TEXTURES_PARAM) : -1.f;\n"
"\n"
"	float3 transLocalSampledDir; \n"
"	const float3 trans = GlassMaterial_EvalSpecularTransmission(hitPoint, fixedDir, u0,\n"
"			kt, nc, nt, cauchyB, &transLocalSampledDir);\n"
"	\n"
"	const float localFilmThickness = (material->glass.filmThicknessTexIndex != NULL_INDEX) \n"
"									 ? Texture_GetFloatValue(material->glass.filmThicknessTexIndex, hitPoint TEXTURES_PARAM) : 0.f;\n"
"	const float localFilmIor = (localFilmThickness > 0.f && material->glass.filmIorTexIndex != NULL_INDEX) \n"
"							   ? Texture_GetFloatValue(material->glass.filmIorTexIndex, hitPoint TEXTURES_PARAM) : 1.f;\n"
"	\n"
"	float3 reflLocalSampledDir;\n"
"	const float3 refl = GlassMaterial_EvalSpecularReflection(hitPoint, fixedDir,\n"
"			kr, nc, nt, &reflLocalSampledDir, localFilmThickness, localFilmIor);\n"
"\n"
"	// Decide to transmit or reflect\n"
"	float threshold;\n"
"	if (!Spectrum_IsBlack(refl)) {\n"
"		if (!Spectrum_IsBlack(trans)) {\n"
"			// Importance sampling\n"
"			const float reflFilter = Spectrum_Filter(refl);\n"
"			const float transFilter = Spectrum_Filter(trans);\n"
"			threshold = transFilter / (reflFilter + transFilter);\n"
"\n"
"			// A place an upper and lower limit to not under sample\n"
"			// reflection or transmission\n"
"			threshold = clamp(threshold, .25f, .75f);\n"
"		} else\n"
"			threshold = 0.f;\n"
"	} else {\n"
"		if (!Spectrum_IsBlack(trans))\n"
"			threshold = 1.f;\n"
"		else {\n"
"			MATERIAL_SAMPLE_RETURN_BLACK;\n"
"		}\n"
"	}\n"
"\n"
"	float3 sampledDir;\n"
"	BSDFEvent event;\n"
"	float pdfW;\n"
"	float3 result;\n"
"	if (passThroughEvent < threshold) {\n"
"		// Transmit\n"
"\n"
"		sampledDir = transLocalSampledDir;\n"
"\n"
"		event = SPECULAR | TRANSMIT;\n"
"		pdfW = threshold;\n"
"	\n"
"		result = trans;\n"
"	} else {\n"
"		// Reflect\n"
"\n"
"		sampledDir = reflLocalSampledDir;\n"
"\n"
"		event = SPECULAR | REFLECT;\n"
"		pdfW = 1.f - threshold;\n"
"		\n"
"		result = refl;\n"
"	}\n"
"\n"
"	result /= pdfW;\n"
"\n"
"	EvalStack_PushFloat3(result);\n"
"	EvalStack_PushFloat3(sampledDir);\n"
"	EvalStack_PushFloat(pdfW);\n"
"	EvalStack_PushBSDFEvent(event);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Material specific EvalOp\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_NOT_INLINE void GlassMaterial_EvalOp(\n"
"		__global const Material* restrict material,\n"
"		const MaterialEvalOpType evalType,\n"
"		__global float *evalStack,\n"
"		uint *evalStackOffset,\n"
"		__global const HitPoint *hitPoint\n"
"		MATERIALS_PARAM_DECL) {\n"
"	switch (evalType) {\n"
"		case EVAL_ALBEDO:\n"
"			GlassMaterial_Albedo(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_GET_INTERIOR_VOLUME:\n"
"			GlassMaterial_GetInteriorVolume(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_GET_EXTERIOR_VOLUME:\n"
"			GlassMaterial_GetExteriorVolume(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_GET_EMITTED_RADIANCE:\n"
"			GlassMaterial_GetEmittedRadiance(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_GET_PASS_TROUGH_TRANSPARENCY:\n"
"			GlassMaterial_GetPassThroughTransparency(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_EVALUATE:\n"
"			GlassMaterial_Evaluate(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_SAMPLE:\n"
"			GlassMaterial_Sample(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		default:\n"
"			// Something wrong here\n"
"			break;\n"
"	}\n"
"}\n";
} }
