
#include <string>

namespace slg { namespace ocl {
std::string KernelSource_materialdefs_funcs_glossytranslucent =
"#line 2 \"materialdefs_funcs_glossytranslucent.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// GlossyTranslucent material\n"
"//\n"
"// LuxRender GlossyTranslucent material porting.\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE void GlossyTranslucentMaterial_Albedo(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"    const float3 albedo = Spectrum_Clamp(Texture_GetSpectrumValue(material->glossytranslucent.kdTexIndex, hitPoint TEXTURES_PARAM));\n"
"\n"
"	EvalStack_PushFloat3(albedo);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void GlossyTranslucentMaterial_GetInteriorVolume(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	DefaultMaterial_GetInteriorVolume(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void GlossyTranslucentMaterial_GetExteriorVolume(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	DefaultMaterial_GetExteriorVolume(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void GlossyTranslucentMaterial_GetPassThroughTransparency(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	DefaultMaterial_GetPassThroughTransparency(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void GlossyTranslucentMaterial_GetEmittedRadiance(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	DefaultMaterial_GetEmittedRadiance(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void GlossyTranslucentMaterial_Evaluate(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	float3 lightDir, eyeDir;\n"
"	EvalStack_PopFloat3(eyeDir);\n"
"	EvalStack_PopFloat3(lightDir);\n"
"\n"
"	const float3 fixedDir = eyeDir;\n"
"	const float3 sampledDir = lightDir;\n"
"\n"
"	const float cosi = fabs(lightDir.z);\n"
"	const float coso = fabs(eyeDir.z);\n"
"\n"
"	const float i = Texture_GetFloatValue(material->glossytranslucent.indexTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float i_bf = Texture_GetFloatValue(material->glossytranslucent.indexbfTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float3 kaVal = Texture_GetSpectrumValue(material->glossytranslucent.kaTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float3 kaVal_bf = Texture_GetSpectrumValue(material->glossytranslucent.kabfTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float d = Texture_GetFloatValue(material->glossytranslucent.depthTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float d_bf = Texture_GetFloatValue(material->glossytranslucent.depthbfTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float3 kdVal = Texture_GetSpectrumValue(material->glossytranslucent.kdTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float3 ksVal = Texture_GetSpectrumValue(material->glossytranslucent.ksTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float3 ksVal_bf = Texture_GetSpectrumValue(material->glossytranslucent.ksbfTexIndex, hitPoint TEXTURES_PARAM);\n"
"\n"
"	// Note: this is the same side test used by matte translucent material and\n"
"	// it is different from the CPU test because HitPoint::dpdu and HitPoint::dpdv\n"
"	// are not available here without bump mapping.\n"
"	const float sideTest = CosTheta(lightDir) * CosTheta(eyeDir);\n"
"\n"
"	float directPdfW;\n"
"	BSDFEvent event;\n"
"	float3 result;\n"
"	if (sideTest < -DEFAULT_COS_EPSILON_STATIC) {\n"
"		// Transmission\n"
"		event = DIFFUSE | TRANSMIT;\n"
"\n"
"		directPdfW = fabs(sampledDir.z) * (M_1_PI_F * .5f);\n"
"\n"
"		const float3 H = normalize(MAKE_FLOAT3(lightDir.x + eyeDir.x, lightDir.y + eyeDir.y,\n"
"			lightDir.z - eyeDir.z));\n"
"		const float u = fabs(dot(lightDir, H));\n"
"		float3 ks = ksVal;\n"
"\n"
"		if (i > 0.f) {\n"
"			const float ti = (i - 1.f) / (i + 1.f);\n"
"			ks *= ti * ti;\n"
"		}\n"
"\n"
"		ks = Spectrum_Clamp(ks);\n"
"		const float3 S1 = FresnelSchlick_Evaluate(ks, u);\n"
"\n"
"		ks = ksVal_bf;\n"
"\n"
"		if (i_bf > 0.f) {\n"
"			const float ti = (i_bf - 1.f) / (i_bf + 1.f);\n"
"			ks *= ti * ti;\n"
"		}\n"
"\n"
"		ks = Spectrum_Clamp(ks);\n"
"		const float3 S2 = FresnelSchlick_Evaluate(ks, u);\n"
"		float3 S = Spectrum_Sqrt((WHITE - S1) * (WHITE - S2));\n"
"\n"
"		if (lightDir.z > 0.f) {\n"
"			S *= Spectrum_Exp(Spectrum_Clamp(kaVal) * -(d / cosi) +\n"
"				Spectrum_Clamp(kaVal_bf) * -(d_bf / coso));\n"
"		} else {\n"
"			S *= Spectrum_Exp(Spectrum_Clamp(kaVal) * -(d / coso) +\n"
"				Spectrum_Clamp(kaVal_bf) * -(d_bf / cosi));\n"
"		}\n"
"\n"
"		const float3 ktVal = Texture_GetSpectrumValue(material->glossytranslucent.ktTexIndex, hitPoint TEXTURES_PARAM);\n"
"		result = (M_1_PI_F * cosi) * S * Spectrum_Clamp(ktVal) *\n"
"			(WHITE - Spectrum_Clamp(kdVal));\n"
"	} else if (sideTest > DEFAULT_COS_EPSILON_STATIC) {\n"
"		// Reflection\n"
"		event = GLOSSY | REFLECT;\n"
"\n"
"		const float3 baseF = Spectrum_Clamp(kdVal) * M_1_PI_F * cosi;\n"
"		float3 ks;\n"
"		float index;\n"
"		float u;\n"
"		float v;\n"
"		float3 alpha;\n"
"		float depth;\n"
"		int mbounce;\n"
"\n"
"		if (eyeDir.z >= 0.f) {\n"
"			ks = ksVal;\n"
"			index = i;\n"
"			const float nuVal = Texture_GetFloatValue(material->glossytranslucent.nuTexIndex, hitPoint TEXTURES_PARAM);\n"
"			const float nvVal = Texture_GetFloatValue(material->glossytranslucent.nvTexIndex, hitPoint TEXTURES_PARAM);\n"
"			u = clamp(nuVal, 1e-9f, 1.f);\n"
"			v = clamp(nvVal, 1e-9f, 1.f);\n"
"			alpha = Spectrum_Clamp(kaVal);\n"
"			depth = d;\n"
"			mbounce = material->glossytranslucent.multibounce;\n"
"		} else {\n"
"			ks = ksVal_bf;\n"
"			index = i_bf;\n"
"			const float nuVal_bf = Texture_GetFloatValue(material->glossytranslucent.nubfTexIndex, hitPoint TEXTURES_PARAM);\n"
"			const float nvVal_bf = Texture_GetFloatValue(material->glossytranslucent.nvbfTexIndex, hitPoint TEXTURES_PARAM);\n"
"			u = clamp(nuVal_bf, 1e-9f, 1.f);\n"
"			v = clamp(nvVal_bf, 1e-9f, 1.f);\n"
"			alpha = Spectrum_Clamp(kaVal_bf);\n"
"			depth = d_bf;\n"
"			mbounce = material->glossytranslucent.multibouncebf;\n"
"		}\n"
"\n"
"		if (index > 0.f) {\n"
"			const float ti = (index - 1.f) / (index + 1.f);\n"
"			ks *= ti * ti;\n"
"		}\n"
"		ks = Spectrum_Clamp(ks);\n"
"\n"
"		const float u2 = u * u;\n"
"		const float v2 = v * v;\n"
"		const float anisotropy = (u2 < v2) ? (1.f - u2 / v2) : u2 > 0.f ? (v2 / u2 - 1.f) : 0.f;\n"
"		const float roughness = u * v;\n"
"\n"
"		const float wCoating = SchlickBSDF_CoatingWeight(ks, fixedDir);\n"
"		const float wBase = 1.f - wCoating;\n"
"\n"
"		directPdfW = .5f * (wBase * fabs(sampledDir.z * M_1_PI_F) +\n"
"			wCoating * SchlickBSDF_CoatingPdf(roughness, anisotropy, fixedDir, sampledDir));\n"
"\n"
"		// Absorption\n"
"		const float3 absorption = CoatingAbsorption(cosi, coso, alpha, depth);\n"
"\n"
"		// Coating fresnel factor\n"
"		const float3 H = normalize(fixedDir + sampledDir);\n"
"		const float3 S = FresnelSchlick_Evaluate(ks, fabs(dot(sampledDir, H)));\n"
"\n"
"		const float3 coatingF = SchlickBSDF_CoatingF(ks, roughness, anisotropy, mbounce, fixedDir, sampledDir);\n"
"\n"
"		// Blend in base layer Schlick style\n"
"		// assumes coating bxdf takes fresnel factor S into account\n"
"\n"
"		result = coatingF + absorption * (WHITE - S) * baseF;\n"
"	} else {\n"
"		MATERIAL_EVALUATE_RETURN_BLACK;\n"
"	}\n"
"\n"
"	EvalStack_PushFloat3(result);\n"
"	EvalStack_PushBSDFEvent(event);\n"
"	EvalStack_PushFloat(directPdfW);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void GlossyTranslucentMaterial_Sample(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	float u0, u1, passThroughEvent;\n"
"	EvalStack_PopFloat(passThroughEvent);\n"
"	EvalStack_PopFloat(u1);\n"
"	EvalStack_PopFloat(u0);\n"
"	float3 fixedDir;\n"
"	EvalStack_PopFloat3(fixedDir);\n"
"\n"
"	if (fabs(fixedDir.z) < DEFAULT_COS_EPSILON_STATIC) {\n"
"		MATERIAL_SAMPLE_RETURN_BLACK;\n"
"	}\n"
"\n"
"	const float i = Texture_GetFloatValue(material->glossytranslucent.indexTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float i_bf = Texture_GetFloatValue(material->glossytranslucent.indexbfTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float3 kaVal = Texture_GetSpectrumValue(material->glossytranslucent.kaTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float3 kaVal_bf = Texture_GetSpectrumValue(material->glossytranslucent.kabfTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float d = Texture_GetFloatValue(material->glossytranslucent.depthTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float d_bf = Texture_GetFloatValue(material->glossytranslucent.depthbfTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float3 kdVal = Texture_GetSpectrumValue(material->glossytranslucent.kdTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float3 ksVal = Texture_GetSpectrumValue(material->glossytranslucent.ksTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float3 ksVal_bf = Texture_GetSpectrumValue(material->glossytranslucent.ksbfTexIndex, hitPoint TEXTURES_PARAM);\n"
"\n"
"	BSDFEvent event;\n"
"	float pdfW;\n"
"	float3 sampledDir;\n"
"	float3 result;\n"
"	if (passThroughEvent < .5f) {\n"
"		// Reflection\n"
"		float3 ks;\n"
"		float index;\n"
"		float u;\n"
"		float v;\n"
"		float3 alpha;\n"
"		float depth;\n"
"		int mbounce;\n"
"\n"
"		if (fixedDir.z >= 0.f) {\n"
"			ks = ksVal;\n"
"			index = i;\n"
"			const float nuVal = Texture_GetFloatValue(material->glossytranslucent.nuTexIndex, hitPoint TEXTURES_PARAM);\n"
"			const float nvVal = Texture_GetFloatValue(material->glossytranslucent.nvTexIndex, hitPoint TEXTURES_PARAM);\n"
"			u = clamp(nuVal, 1e-9f, 1.f);\n"
"			v = clamp(nvVal, 1e-9f, 1.f);\n"
"			alpha = Spectrum_Clamp(kaVal);\n"
"			depth = d;\n"
"			mbounce = material->glossytranslucent.multibounce;\n"
"		} else {\n"
"			ks = ksVal_bf;\n"
"			index = i_bf;\n"
"			const float nuVal_bf = Texture_GetFloatValue(material->glossytranslucent.nubfTexIndex, hitPoint TEXTURES_PARAM);\n"
"			const float nvVal_bf = Texture_GetFloatValue(material->glossytranslucent.nvbfTexIndex, hitPoint TEXTURES_PARAM);\n"
"			u = clamp(nuVal_bf, 1e-9f, 1.f);\n"
"			v = clamp(nvVal_bf, 1e-9f, 1.f);\n"
"			alpha = Spectrum_Clamp(kaVal_bf);\n"
"			depth = d_bf;\n"
"			mbounce = material->glossytranslucent.multibouncebf;\n"
"		}\n"
"\n"
"		if (index > 0.f) {\n"
"			const float ti = (index - 1.f) / (index + 1.f);\n"
"			ks *= ti * ti;\n"
"		}\n"
"		ks = Spectrum_Clamp(ks);\n"
"\n"
"		const float u2 = u * u;\n"
"		const float v2 = v * v;\n"
"		const float anisotropy = (u2 < v2) ? (1.f - u2 / v2) : u2 > 0.f ? (v2 / u2 - 1.f) : 0.f;\n"
"		const float roughness = u * v;\n"
"\n"
"		const float wCoating = SchlickBSDF_CoatingWeight(ks, fixedDir);\n"
"		const float wBase = 1.f - wCoating;\n"
"\n"
"		float basePdf, coatingPdf;\n"
"		float3 baseF, coatingF;\n"
"\n"
"		if (2.f * passThroughEvent < wBase) {\n"
"			// Sample base BSDF (Matte BSDF)\n"
"			sampledDir = CosineSampleHemisphereWithPdf(u0, u1, &basePdf);\n"
"			sampledDir *= signbit(fixedDir.z) ? -1.f : 1.f;\n"
"\n"
"			const float absCosSampledDir = fabs(CosTheta(sampledDir));\n"
"			if (absCosSampledDir < DEFAULT_COS_EPSILON_STATIC) {\n"
"				MATERIAL_SAMPLE_RETURN_BLACK;\n"
"			}\n"
"\n"
"			baseF = Spectrum_Clamp(kdVal) * M_1_PI_F * absCosSampledDir;\n"
"\n"
"			// Evaluate coating BSDF (Schlick BSDF)\n"
"			coatingF = SchlickBSDF_CoatingF(ks, roughness, anisotropy, mbounce,\n"
"				fixedDir, sampledDir);\n"
"			coatingPdf = SchlickBSDF_CoatingPdf(roughness, anisotropy, fixedDir, sampledDir);\n"
"\n"
"		} else {\n"
"			// Sample coating BSDF (Schlick BSDF)\n"
"			coatingF = SchlickBSDF_CoatingSampleF(ks, roughness, anisotropy, mbounce,\n"
"				fixedDir, &sampledDir, u0, u1, &coatingPdf);\n"
"			if (Spectrum_IsBlack(coatingF)) {\n"
"				MATERIAL_SAMPLE_RETURN_BLACK;\n"
"			}\n"
"\n"
"			const float absCosSampledDir = fabs(CosTheta(sampledDir));\n"
"			if (absCosSampledDir < DEFAULT_COS_EPSILON_STATIC) {\n"
"				MATERIAL_SAMPLE_RETURN_BLACK;\n"
"			}\n"
"\n"
"			coatingF *= coatingPdf;\n"
"\n"
"			// Evaluate base BSDF (Matte BSDF)\n"
"			basePdf = absCosSampledDir * M_1_PI_F;\n"
"			baseF = Spectrum_Clamp(kdVal) * M_1_PI_F * absCosSampledDir;\n"
"		}\n"
"		event = GLOSSY | REFLECT;\n"
"\n"
"		// Note: this is the same side test used by matte translucent material and\n"
"		// it is different from the CPU test because HitPoint::dpdu and HitPoint::dpdv\n"
"		// are not available here without bump mapping.\n"
"		const float sideTest = CosTheta(fixedDir) * CosTheta(sampledDir);\n"
"		if (!(sideTest > DEFAULT_COS_EPSILON_STATIC)) {\n"
"			MATERIAL_SAMPLE_RETURN_BLACK;\n"
"		}\n"
"\n"
"		pdfW = .5f * (coatingPdf * wCoating + basePdf * wBase);\n"
"\n"
"		// Absorption\n"
"		const float cosi = fabs(sampledDir.z);\n"
"		const float coso = fabs(fixedDir.z);\n"
"		const float3 absorption = CoatingAbsorption(cosi, coso, alpha, d);\n"
"\n"
"		// Coating fresnel factor\n"
"		const float3 H = normalize(fixedDir + sampledDir);\n"
"		const float3 S = FresnelSchlick_Evaluate(ks, fabs(dot(sampledDir, H)));\n"
"\n"
"		// Blend in base layer Schlick style\n"
"		// coatingF already takes fresnel factor S into account\n"
"\n"
"		result = (coatingF + absorption * (WHITE - S) * baseF) / pdfW;\n"
"	} else {\n"
"		// Transmission\n"
"		sampledDir = CosineSampleHemisphereWithPdf(u0, u1, &pdfW);\n"
"		sampledDir *= signbit(fixedDir.z) ? 1.f : -1.f;\n"
"\n"
"		// Note: this is the same side test used by matte translucent material and\n"
"		// it is different from the CPU test because HitPoint::dpdu and HitPoint::dpdv\n"
"		// are not available here without bump mapping.\n"
"		const float sideTest = CosTheta(fixedDir) * CosTheta(sampledDir);\n"
"		if (!(sideTest < -DEFAULT_COS_EPSILON_STATIC)) {\n"
"			MATERIAL_SAMPLE_RETURN_BLACK;\n"
"		}\n"
"\n"
"		pdfW *= .5f;\n"
"\n"
"		const float absCosSampledDir = fabs(CosTheta(sampledDir));\n"
"		if (absCosSampledDir < DEFAULT_COS_EPSILON_STATIC) {\n"
"			MATERIAL_SAMPLE_RETURN_BLACK;\n"
"		}\n"
"\n"
"		event = DIFFUSE | TRANSMIT;\n"
"\n"
"		// This is an inline expansion of Evaluate(hitPoint, *localSampledDir,\n"
"		// localFixedDir, event, pdfW, NULL) / pdfW\n"
"		//\n"
"		// Note: pdfW and the pdf computed inside Evaluate() are exactly the same\n"
"		\n"
"		const float cosi = fabs(sampledDir.z);\n"
"		const float coso = fabs(fixedDir.z);\n"
"\n"
"		const float3 H = normalize(MAKE_FLOAT3(sampledDir.x + fixedDir.x, sampledDir.y + fixedDir.y,\n"
"			sampledDir.z - fixedDir.z));\n"
"		const float u = fabs(dot(sampledDir, H));\n"
"		float3 ks = ksVal;\n"
"\n"
"		if (i > 0.f) {\n"
"			const float ti = (i - 1.f) / (i + 1.f);\n"
"			ks *= ti * ti;\n"
"		}\n"
"\n"
"		ks = Spectrum_Clamp(ks);\n"
"		const float3 S1 = FresnelSchlick_Evaluate(ks, u);\n"
"\n"
"		ks = ksVal_bf;\n"
"\n"
"		if (i_bf > 0.f) {\n"
"			const float ti = (i_bf - 1.f) / (i_bf + 1.f);\n"
"			ks *= ti * ti;\n"
"		}\n"
"\n"
"		ks = Spectrum_Clamp(ks);\n"
"		const float3 S2 = FresnelSchlick_Evaluate(ks, u);\n"
"		float3 S = Spectrum_Sqrt((WHITE - S1) * (WHITE - S2));\n"
"\n"
"		if (sampledDir.z > 0.f) {\n"
"			S *= Spectrum_Exp(Spectrum_Clamp(kaVal) * -(d / cosi) +\n"
"				Spectrum_Clamp(kaVal_bf) * -(d_bf / coso));\n"
"		} else {\n"
"			S *= Spectrum_Exp(Spectrum_Clamp(kaVal) * -(d / coso) +\n"
"				Spectrum_Clamp(kaVal_bf) * -(d_bf / cosi));\n"
"		}\n"
"\n"
"		const float3 ktVal = Texture_GetSpectrumValue(material->glossytranslucent.ktTexIndex, hitPoint TEXTURES_PARAM);\n"
"		result = (M_1_PI_F * cosi / pdfW) * S * Spectrum_Clamp(ktVal) *\n"
"			(WHITE - Spectrum_Clamp(kdVal));\n"
"	}\n"
"\n"
"	EvalStack_PushFloat3(result);\n"
"	EvalStack_PushFloat3(sampledDir);\n"
"	EvalStack_PushFloat(pdfW);\n"
"	EvalStack_PushBSDFEvent(event);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Material specific EvalOp\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_NOT_INLINE void GlossyTranslucentMaterial_EvalOp(\n"
"		__global const Material* restrict material,\n"
"		const MaterialEvalOpType evalType,\n"
"		__global float *evalStack,\n"
"		uint *evalStackOffset,\n"
"		__global const HitPoint *hitPoint\n"
"		MATERIALS_PARAM_DECL) {\n"
"	switch (evalType) {\n"
"		case EVAL_ALBEDO:\n"
"			GlossyTranslucentMaterial_Albedo(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_GET_INTERIOR_VOLUME:\n"
"			GlossyTranslucentMaterial_GetInteriorVolume(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_GET_EXTERIOR_VOLUME:\n"
"			GlossyTranslucentMaterial_GetExteriorVolume(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_GET_EMITTED_RADIANCE:\n"
"			GlossyTranslucentMaterial_GetEmittedRadiance(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_GET_PASS_TROUGH_TRANSPARENCY:\n"
"			GlossyTranslucentMaterial_GetPassThroughTransparency(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_EVALUATE:\n"
"			GlossyTranslucentMaterial_Evaluate(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_SAMPLE:\n"
"			GlossyTranslucentMaterial_Sample(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		default:\n"
"			// Something wrong here\n"
"			break;\n"
"	}\n"
"}\n";
} }
