
#include <string>

namespace slg { namespace ocl {
std::string KernelSource_materialdefs_funcs_mix =
"#line 2 \"materialdefs_funcs_mix.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"OPENCL_FORCE_INLINE void MixMaterial_Albedo(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	float3 albedo1, albedo2;\n"
"	EvalStack_PopFloat3(albedo2);\n"
"	EvalStack_PopFloat3(albedo1);\n"
"\n"
"	const float factor = Texture_GetFloatValue(material->mix.mixFactorTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float weight2 = clamp(factor, 0.f, 1.f);\n"
"	const float weight1 = 1.f - weight2;\n"
"\n"
"	const float3 albedo =  weight1 * albedo1 + weight2 * albedo2;\n"
"\n"
"	EvalStack_PushFloat3(albedo);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void MixMaterial_GetVolumeSetUp1(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	float passThroughEvent;\n"
"	EvalStack_PopFloat(passThroughEvent);\n"
"\n"
"	const float factor = Texture_GetFloatValue(material->mix.mixFactorTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float weight2 = clamp(factor, 0.f, 1.f);\n"
"	const float weight1 = 1.f - weight2;\n"
"\n"
"	const float passThroughEvent1 = passThroughEvent / weight1;\n"
"\n"
"	EvalStack_PushFloat(passThroughEvent);\n"
"	EvalStack_PushFloat(factor);\n"
"	EvalStack_PushFloat(passThroughEvent1);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void MixMaterial_GetVolumeSetUp2(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	uint volIndex1;\n"
"	EvalStack_PopUInt(volIndex1);\n"
"\n"
"	float factor;\n"
"	EvalStack_PopFloat(factor);\n"
"	const float weight2 = clamp(factor, 0.f, 1.f);\n"
"	const float weight1 = 1.f - weight2;\n"
"\n"
"	float passThroughEvent;\n"
"	EvalStack_PopFloat(passThroughEvent);\n"
"\n"
"	const float passThroughEvent2 = (passThroughEvent - weight1) / weight2;\n"
"\n"
"	EvalStack_PushFloat(passThroughEvent);\n"
"	EvalStack_PushFloat(factor);\n"
"	EvalStack_PushUInt(volIndex1);\n"
"	EvalStack_PushFloat(passThroughEvent2);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void MixMaterial_GetInteriorVolume(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	const uint volIndex = material->interiorVolumeIndex;\n"
"	if (volIndex != NULL_INDEX) {\n"
"		float passThroughEvent;\n"
"		EvalStack_PopFloat(passThroughEvent);\n"
"\n"
"		EvalStack_PushUInt(volIndex);\n"
"	} else {\n"
"		uint volIndex1, volIndex2;\n"
"		EvalStack_PopUInt(volIndex2);\n"
"		EvalStack_PopUInt(volIndex1);\n"
"\n"
"		float factor;\n"
"		EvalStack_PopFloat(factor);\n"
"		const float weight2 = clamp(factor, 0.f, 1.f);\n"
"		const float weight1 = 1.f - weight2;\n"
"\n"
"		float passThroughEvent;\n"
"		EvalStack_PopFloat(passThroughEvent);\n"
"\n"
"		const uint volIndex = (passThroughEvent < weight1) ? volIndex1 : volIndex2;\n"
"		EvalStack_PushUInt(volIndex);\n"
"	}\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void MixMaterial_GetExteriorVolume(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	const uint volIndex = material->exteriorVolumeIndex;\n"
"	if (volIndex != NULL_INDEX) {\n"
"		float passThroughEvent;\n"
"		EvalStack_PopFloat(passThroughEvent);\n"
"\n"
"		EvalStack_PushUInt(volIndex);\n"
"	} else {\n"
"		uint volIndex1, volIndex2;\n"
"		EvalStack_PopUInt(volIndex2);\n"
"		EvalStack_PopUInt(volIndex1);\n"
"\n"
"		float factor;\n"
"		EvalStack_PopFloat(factor);\n"
"		const float weight2 = clamp(factor, 0.f, 1.f);\n"
"		const float weight1 = 1.f - weight2;\n"
"\n"
"		float passThroughEvent;\n"
"		EvalStack_PopFloat(passThroughEvent);\n"
"\n"
"		const uint volIndex = (passThroughEvent < weight1) ? volIndex1 : volIndex2;\n"
"		EvalStack_PushUInt(volIndex);\n"
"	}\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void MixMaterial_GetPassThroughTransparencySetUp1(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	bool backTracing;\n"
"	EvalStack_PopUInt(backTracing);\n"
"	float passThroughEvent;\n"
"	EvalStack_PopFloat(passThroughEvent);\n"
"	float3 localFixedDir;\n"
"	EvalStack_PopFloat3(localFixedDir);\n"
"\n"
"	// Save the parameters\n"
"	EvalStack_PushFloat3(localFixedDir);\n"
"	EvalStack_PushFloat(passThroughEvent);\n"
"	EvalStack_PushUInt(backTracing);\n"
"\n"
"	const float factor = Texture_GetFloatValue(material->mix.mixFactorTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float weight2 = clamp(factor, 0.f, 1.f);\n"
"	const float weight1 = 1.f - weight2;\n"
"\n"
"	const float passThroughEvent1 = passThroughEvent / weight1;\n"
"\n"
"	EvalStack_PushFloat(factor);\n"
"\n"
"	// To setup the following EVAL_GET_PASS_TROUGH_TRANSPARENCY evaluation of first sub-nodes\n"
"	EvalStack_PushFloat3(localFixedDir);\n"
"	EvalStack_PushFloat(passThroughEvent1);\n"
"	EvalStack_PushUInt(backTracing);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void MixMaterial_GetPassThroughTransparencySetUp2(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	float3 transp1;\n"
"	EvalStack_PopFloat3(transp1);\n"
"\n"
"	float factor;\n"
"	EvalStack_PopFloat(factor);\n"
"\n"
"	bool backTracing;\n"
"	EvalStack_PopUInt(backTracing);\n"
"	float passThroughEvent;\n"
"	EvalStack_PopFloat(passThroughEvent);\n"
"	float3 localFixedDir;\n"
"	EvalStack_PopFloat3(localFixedDir);\n"
"\n"
"	const float weight2 = clamp(factor, 0.f, 1.f);\n"
"	const float weight1 = 1.f - weight2;\n"
"\n"
"	const float passThroughEvent2 = (passThroughEvent - weight1) / weight2;\n"
"\n"
"	// Save the parameters\n"
"	EvalStack_PushFloat3(localFixedDir);\n"
"	EvalStack_PushFloat(passThroughEvent);\n"
"	EvalStack_PushUInt(backTracing);\n"
"\n"
"	EvalStack_PushFloat(factor);\n"
"\n"
"	EvalStack_PushFloat3(transp1);\n"
"\n"
"	// To setup the following EVAL_GET_PASS_TROUGH_TRANSPARENCY evaluation of second sub-nodes\n"
"	EvalStack_PushFloat3(localFixedDir);\n"
"	EvalStack_PushFloat(passThroughEvent2);\n"
"	EvalStack_PushUInt(backTracing);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void MixMaterial_GetPassThroughTransparency(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	float3 transp1, transp2;\n"
"	EvalStack_PopFloat3(transp2);\n"
"	EvalStack_PopFloat3(transp1);\n"
"\n"
"	float factor;\n"
"	EvalStack_PopFloat(factor);\n"
"\n"
"	bool backTracing;\n"
"	EvalStack_PopUInt(backTracing);\n"
"	float passThroughEvent;\n"
"	EvalStack_PopFloat(passThroughEvent);\n"
"	float3 localFixedDir;\n"
"	EvalStack_PopFloat3(localFixedDir);\n"
"\n"
"	const uint transpTexIndex = (hitPoint->intoObject != backTracing) ?\n"
"		material->frontTranspTexIndex : material->backTranspTexIndex;\n"
"\n"
"	float3 transp;\n"
"	if (transpTexIndex != NULL_INDEX) {\n"
"		const float weight = clamp(\n"
"				Texture_GetFloatValue(transpTexIndex, hitPoint TEXTURES_PARAM),\n"
"				0.f, 1.f);\n"
"\n"
"		transp = (passThroughEvent > weight) ? WHITE : BLACK;\n"
"	} else {\n"
"		const float weight2 = clamp(factor, 0.f, 1.f);\n"
"		const float weight1 = 1.f - weight2;\n"
"\n"
"		transp = (passThroughEvent < weight1) ? transp1 : transp2;\n"
"	}\n"
"\n"
"	EvalStack_PushFloat3(transp);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void MixMaterial_GetEmittedRadianceSetUp1(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	float oneOverPrimitiveArea;\n"
"	EvalStack_PopFloat(oneOverPrimitiveArea);\n"
"\n"
"	EvalStack_PushFloat(oneOverPrimitiveArea);\n"
"	// To setup the following EVAL_GET_EMITTED_RADIANCE evaluation of first sub-nodes\n"
"	EvalStack_PushFloat(oneOverPrimitiveArea);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void MixMaterial_GetEmittedRadianceSetUp2(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	float3 emit1;\n"
"	EvalStack_PopFloat3(emit1);\n"
"\n"
"	float oneOverPrimitiveArea;\n"
"	EvalStack_PopFloat(oneOverPrimitiveArea);\n"
"\n"
"	EvalStack_PushFloat(oneOverPrimitiveArea);\n"
"	EvalStack_PushFloat3(emit1);\n"
"	// To setup the following EVAL_GET_EMITTED_RADIANCE evaluation of second sub-nodes\n"
"	EvalStack_PushFloat(oneOverPrimitiveArea);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void MixMaterial_GetEmittedRadiance(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	float3 emittedRadiance;\n"
"	if (material->emitTexIndex != NULL_INDEX)\n"
"		 DefaultMaterial_GetEmittedRadiance(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"	else {\n"
"		float3 emit1, emit2;\n"
"		EvalStack_PopFloat3(emit2);\n"
"		EvalStack_PopFloat3(emit1);\n"
"\n"
"		float oneOverPrimitiveArea;\n"
"		EvalStack_PopFloat(oneOverPrimitiveArea);\n"
"\n"
"		const float factor = Texture_GetFloatValue(material->mix.mixFactorTexIndex, hitPoint TEXTURES_PARAM);\n"
"		const float weight2 = clamp(factor, 0.f, 1.f);\n"
"		const float weight1 = 1.f - weight2;\n"
"\n"
"		emittedRadiance = BLACK;\n"
"		if (weight1 > 0.f)\n"
"			emittedRadiance += weight1 * emit1;\n"
"		 if (weight2 > 0.f)\n"
"			emittedRadiance += weight2 * emit2;\n"
"\n"
"		EvalStack_PushFloat3(emittedRadiance);\n"
"	}\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Material evaluate\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE void MixMaterial_EvaluateSetUp1(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	float3 lightDir, eyeDir;\n"
"	EvalStack_PopFloat3(eyeDir);\n"
"	EvalStack_PopFloat3(lightDir);\n"
"\n"
"	// Save current shading normal/dpdu/dpdv and setup the hitPoint with A material bump mapping\n"
"	const float3 originalShadeN = VLOAD3F(&hitPoint->shadeN.x);\n"
"	const float3 originalDpdu = VLOAD3F(&hitPoint->dpdu.x);\n"
"	const float3 originalDpdv = VLOAD3F(&hitPoint->dpdv.x);\n"
"	EvalStack_PushFloat3(originalShadeN);\n"
"	EvalStack_PushFloat3(originalDpdu);\n"
"	EvalStack_PushFloat3(originalDpdv);\n"
"\n"
"	__global HitPoint *hitPointTmp = (__global HitPoint *)hitPoint;\n"
"	Material_Bump(material->mix.matAIndex, hitPointTmp\n"
"		MATERIALS_PARAM);\n"
"	// Re-read the shadeN modified by Material_Bump()\n"
"	const float3 matAShadeN = VLOAD3F(&hitPointTmp->shadeN.x);\n"
"	const float3 matADpdu = VLOAD3F(&hitPointTmp->dpdu.x);\n"
"	const float3 matADpdv = VLOAD3F(&hitPointTmp->dpdv.x);\n"
"\n"
"	// Save the parameters\n"
"	EvalStack_PushFloat3(lightDir);\n"
"	EvalStack_PushFloat3(eyeDir);\n"
"	\n"
"	// Transform lightDir and eyeDir to A material new reference system\n"
"	Frame frameA;\n"
"	Frame_Set_Private(&frameA, matADpdu, matADpdv, matAShadeN);\n"
"	Frame frameOriginal;\n"
"	Frame_Set_Private(&frameOriginal, originalDpdu, originalDpdv, originalShadeN);\n"
"\n"
"	const float3 matALightDir = Frame_ToLocal_Private(&frameA, Frame_ToWorld_Private(&frameOriginal, lightDir));\n"
"	const float3 matAEyeDir = Frame_ToLocal_Private(&frameA, Frame_ToWorld_Private(&frameOriginal, eyeDir));\n"
"\n"
"	// To setup the following EVAL_EVALUATE evaluation of first sub-nodes\n"
"	EvalStack_PushFloat3(matALightDir);\n"
"	EvalStack_PushFloat3(matAEyeDir);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void MixMaterial_EvaluateSetUp2(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	// Pop the result of the first evaluation\n"
"	float directPdfWMatA;\n"
"	BSDFEvent eventMatA;\n"
"	float3 resultMatA;\n"
"	EvalStack_PopFloat(directPdfWMatA);\n"
"	EvalStack_PopBSDFEvent(eventMatA);\n"
"	EvalStack_PopFloat3(resultMatA);\n"
"\n"
"	// Pop the saved parameters\n"
"	float3 lightDir, eyeDir;\n"
"	EvalStack_PopFloat3(eyeDir);\n"
"	EvalStack_PopFloat3(lightDir);\n"
"\n"
"	// Pop saved original shading normal/dpdu/dpdv\n"
"	float3 originalShadeN, originalDpdu, originalDpdv;\n"
"	EvalStack_PopFloat3(originalDpdv);\n"
"	EvalStack_PopFloat3(originalDpdu);\n"
"	EvalStack_PopFloat3(originalShadeN);\n"
"	// Restore original hitPoint\n"
"	__global HitPoint *hitPointTmp = (__global HitPoint *)hitPoint;\n"
"	VSTORE3F(originalShadeN, &hitPointTmp->shadeN.x);\n"
"	VSTORE3F(originalDpdu, &hitPointTmp->dpdu.x);\n"
"	VSTORE3F(originalDpdv, &hitPointTmp->dpdv.x);\n"
"\n"
"	// Save current shading normal/dpdu/dpdv and setup the hitPoint with A material bump mapping\n"
"	EvalStack_PushFloat3(originalShadeN);\n"
"	EvalStack_PushFloat3(originalDpdu);\n"
"	EvalStack_PushFloat3(originalDpdv);\n"
"\n"
"	Material_Bump(material->mix.matBIndex, hitPointTmp\n"
"		MATERIALS_PARAM);\n"
"	// Re-read the shadeN modified by Material_Bump()\n"
"	const float3 matBShadeN = VLOAD3F(&hitPointTmp->shadeN.x);\n"
"	const float3 matBDpdu = VLOAD3F(&hitPointTmp->dpdu.x);\n"
"	const float3 matBDpdv = VLOAD3F(&hitPointTmp->dpdv.x);\n"
"\n"
"	// Save the parameters\n"
"	EvalStack_PushFloat3(eyeDir);\n"
"	EvalStack_PushFloat3(lightDir);\n"
"\n"
"	// Save the result of the first evaluation\n"
"	EvalStack_PushFloat3(resultMatA);\n"
"	EvalStack_PushBSDFEvent(eventMatA);\n"
"	EvalStack_PushFloat(directPdfWMatA);\n"
"	\n"
"	// Transform lightDir and eyeDir to A material new reference system\n"
"	Frame frameB;\n"
"	Frame_Set_Private(&frameB, matBDpdu, matBDpdv, matBShadeN);\n"
"	Frame frameOriginal;\n"
"	Frame_Set_Private(&frameOriginal, originalDpdu, originalDpdv, originalShadeN);\n"
"\n"
"	const float3 matBLightDir = Frame_ToLocal_Private(&frameB, Frame_ToWorld_Private(&frameOriginal, lightDir));\n"
"	const float3 matBEyeDir = Frame_ToLocal_Private(&frameB, Frame_ToWorld_Private(&frameOriginal, eyeDir));\n"
"\n"
"	// To setup the following EVAL_EVALUATE evaluation of second sub-nodes\n"
"	EvalStack_PushFloat3(matBLightDir);\n"
"	EvalStack_PushFloat3(matBEyeDir);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void MixMaterial_Evaluate(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	// Pop the result of the second evaluation\n"
"	float directPdfWMatB;\n"
"	BSDFEvent eventMatB;\n"
"	float3 resultMatB;\n"
"	EvalStack_PopFloat(directPdfWMatB);\n"
"	EvalStack_PopBSDFEvent(eventMatB);\n"
"	EvalStack_PopFloat3(resultMatB);\n"
"\n"
"	// Pop the result of the first evaluation\n"
"	float directPdfWMatA;\n"
"	BSDFEvent eventMatA;\n"
"	float3 resultMatA;\n"
"	EvalStack_PopFloat(directPdfWMatA);\n"
"	EvalStack_PopBSDFEvent(eventMatA);\n"
"	EvalStack_PopFloat3(resultMatA);\n"
"\n"
"	// Pop the saved parameters\n"
"	float3 lightDir, eyeDir;\n"
"	EvalStack_PopFloat3(eyeDir);\n"
"	EvalStack_PopFloat3(lightDir);\n"
"\n"
"	// Pop saved original shading normal/dpdu/dpdv\n"
"	float3 originalShadeN, originalDpdu, originalDpdv;\n"
"	EvalStack_PopFloat3(originalDpdv);\n"
"	EvalStack_PopFloat3(originalDpdu);\n"
"	EvalStack_PopFloat3(originalShadeN);\n"
"	// Restore original hitPoint\n"
"	__global HitPoint *hitPointTmp = (__global HitPoint *)hitPoint;\n"
"	VSTORE3F(originalShadeN, &hitPointTmp->shadeN.x);\n"
"	VSTORE3F(originalDpdu, &hitPointTmp->dpdu.x);\n"
"	VSTORE3F(originalDpdv, &hitPointTmp->dpdv.x);\n"
"\n"
"	float3 result = BLACK;\n"
"	float directPdfW = 0.f;\n"
"	\n"
"	// This test is usually done by BSDF_Evaluate() and must be repeated in\n"
"	// material referencing other materials\n"
"	const float isTransmitEval = (signbit(lightDir.z) != signbit(eyeDir.z));\n"
"\n"
"	const float factor = Texture_GetFloatValue(material->mix.mixFactorTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float weight2 = clamp(factor, 0.f, 1.f);\n"
"	const float weight1 = 1.f - weight2;\n"
"\n"
"	BSDFEvent event = NONE;\n"
"\n"
"	//--------------------------------------------------------------------------\n"
"	// Evaluate material A\n"
"	//--------------------------------------------------------------------------\n"
"\n"
"	const BSDFEvent eventTypesMatA = mats[material->mix.matAIndex].eventTypes;\n"
"	if ((weight1 > 0.f) &&\n"
"			((!isTransmitEval && (eventTypesMatA & REFLECT)) ||\n"
"			(isTransmitEval && (eventTypesMatA & TRANSMIT))) &&\n"
"			!Spectrum_IsBlack(resultMatA)) {\n"
"		result += weight1 * resultMatA;\n"
"		directPdfW += weight1 * directPdfWMatA;\n"
"		\n"
"		event |= eventMatA;\n"
"	}\n"
"\n"
"	//--------------------------------------------------------------------------\n"
"	// Evaluate material B\n"
"	//--------------------------------------------------------------------------\n"
"\n"
"	const BSDFEvent eventTypesMatB = mats[material->mix.matBIndex].eventTypes;\n"
"	if ((weight2 > 0.f) &&\n"
"			((!isTransmitEval && (eventTypesMatB & REFLECT)) ||\n"
"			(isTransmitEval && (eventTypesMatB & TRANSMIT))) &&\n"
"			!Spectrum_IsBlack(resultMatB)) {\n"
"		result += weight2 * resultMatB;\n"
"		directPdfW += weight2 * directPdfWMatB;\n"
"\n"
"		event |= eventMatB;\n"
"	}\n"
"\n"
"	EvalStack_PushFloat3(result);\n"
"	EvalStack_PushBSDFEvent(event);\n"
"	EvalStack_PushFloat(directPdfW);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Material sample\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE void MixMaterial_SampleSetUp1(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	float u0, u1, passThroughEvent;\n"
"	EvalStack_PopFloat(passThroughEvent);\n"
"	EvalStack_PopFloat(u1);\n"
"	EvalStack_PopFloat(u0);\n"
"	float3 fixedDir;\n"
"	EvalStack_PopFloat3(fixedDir);\n"
"\n"
"	const float factor = Texture_GetFloatValue(material->mix.mixFactorTexIndex, hitPoint TEXTURES_PARAM);\n"
"	const float weight2 = clamp(factor, 0.f, 1.f);\n"
"	const float weight1 = 1.f - weight2;\n"
"\n"
"	const bool sampleMatA = (passThroughEvent < weight1);\n"
"	const float passThroughEventFirst = sampleMatA ? (passThroughEvent / weight1) : (passThroughEvent - weight1) / weight2;\n"
"	const uint matIndexFirst = sampleMatA ? material->mix.matAIndex : material->mix.matBIndex;\n"
"\n"
"	// Save current shading normal/dpdu/dpdv and setup the hitPoint with first material bump mapping\n"
"	const float3 originalShadeN = VLOAD3F(&hitPoint->shadeN.x);\n"
"	const float3 originalDpdu = VLOAD3F(&hitPoint->dpdu.x);\n"
"	const float3 originalDpdv = VLOAD3F(&hitPoint->dpdv.x);\n"
"	EvalStack_PushFloat3(originalShadeN);\n"
"	EvalStack_PushFloat3(originalDpdu);\n"
"	EvalStack_PushFloat3(originalDpdv);\n"
"\n"
"	__global HitPoint *hitPointTmp = (__global HitPoint *)hitPoint;\n"
"	Material_Bump(matIndexFirst, hitPointTmp\n"
"		MATERIALS_PARAM);\n"
"	// Re-read the shadeN modified by Material_Bump()\n"
"	const float3 matFirstShadeN = VLOAD3F(&hitPointTmp->shadeN.x);\n"
"	const float3 matFirstDpdu = VLOAD3F(&hitPointTmp->dpdu.x);\n"
"	const float3 matFirstDpdv = VLOAD3F(&hitPointTmp->dpdv.x);\n"
"\n"
"	// Save the parameters\n"
"	EvalStack_PushFloat3(fixedDir);\n"
"	EvalStack_PushFloat(u0);\n"
"	EvalStack_PushFloat(u1);\n"
"	EvalStack_PushFloat(passThroughEvent);\n"
"\n"
"	// Save factor\n"
"	EvalStack_PushFloat(factor);\n"
"	// Save sampleMatA\n"
"	EvalStack_PushInt(sampleMatA);\n"
"\n"
"	// Transform fixedDir to first material new reference system\n"
"	Frame frameFirst;\n"
"	Frame_Set_Private(&frameFirst, matFirstDpdu, matFirstDpdv, matFirstShadeN);\n"
"	Frame frameOriginal;\n"
"	Frame_Set_Private(&frameOriginal, originalDpdu, originalDpdv, originalShadeN);\n"
"\n"
"	const float3 matFirstFixedDir = Frame_ToLocal_Private(&frameFirst, Frame_ToWorld_Private(&frameOriginal, fixedDir));\n"
"\n"
"	// To setup the following EVAL_SAMPLE evaluation of first sub-nodes\n"
"	EvalStack_PushFloat3(matFirstFixedDir);\n"
"	EvalStack_PushFloat(u0);\n"
"	EvalStack_PushFloat(u1);\n"
"	EvalStack_PushFloat(passThroughEventFirst);\n"
"\n"
"	// To setup the following EVAL_CONDITIONAL_GOTO evaluation\n"
"	EvalStack_PushInt(!sampleMatA);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void MixMaterial_SampleSetUp2(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	// Pop the result of the first evaluation\n"
"	float3 resultFirst, sampledDirFirst;\n"
"	float pdfWFirst;\n"
"	BSDFEvent eventFirst;\n"
"	EvalStack_PopBSDFEvent(eventFirst);\n"
"	EvalStack_PopFloat(pdfWFirst);\n"
"	EvalStack_PopFloat3(sampledDirFirst);\n"
"	EvalStack_PopFloat3(resultFirst);\n"
"\n"
"	// Pop sampleMatA\n"
"	bool sampleMatA;\n"
"	EvalStack_PopInt(sampleMatA);\n"
"	// Pop factor\n"
"	float factor;\n"
"	EvalStack_PopFloat(factor);\n"
"\n"
"	const uint matIndexSecond = sampleMatA ? material->mix.matBIndex : material->mix.matAIndex;\n"
"\n"
"	// Pop parameters\n"
"	float u0, u1, passThroughEvent;\n"
"	EvalStack_PopFloat(passThroughEvent);\n"
"	EvalStack_PopFloat(u1);\n"
"	EvalStack_PopFloat(u0);\n"
"	float3 fixedDir;\n"
"	EvalStack_PopFloat3(fixedDir);\n"
"\n"
"	// Pop saved original shading normal/dpdu/dpdv\n"
"	float3 originalShadeN, originalDpdu, originalDpdv;\n"
"	EvalStack_PopFloat3(originalDpdv);\n"
"	EvalStack_PopFloat3(originalDpdu);\n"
"	EvalStack_PopFloat3(originalShadeN);\n"
"\n"
"	// Set the first frame reference system\n"
"	const float3 matFirstShadeN = VLOAD3F(&hitPoint->shadeN.x);\n"
"	const float3 matFirstDpdu = VLOAD3F(&hitPoint->dpdu.x);\n"
"	const float3 matFirstDpdv = VLOAD3F(&hitPoint->dpdv.x);\n"
"	Frame frameFirst;\n"
"	Frame_Set_Private(&frameFirst, matFirstDpdu, matFirstDpdv, matFirstShadeN);\n"
"\n"
"	// Restore original hitPoint\n"
"	__global HitPoint *hitPointTmp = (__global HitPoint *)hitPoint;\n"
"	VSTORE3F(originalShadeN, &hitPointTmp->shadeN.x);\n"
"	VSTORE3F(originalDpdu, &hitPointTmp->dpdu.x);\n"
"	VSTORE3F(originalDpdv, &hitPointTmp->dpdv.x);\n"
"\n"
"	// Transform sampledDirFirst from first frame reference to original Mix material reference\n"
"	Frame frameOriginal;\n"
"	Frame_Set_Private(&frameOriginal, originalDpdu, originalDpdv, originalShadeN);\n"
"	sampledDirFirst = Frame_ToLocal_Private(&frameOriginal, Frame_ToWorld_Private(&frameFirst, sampledDirFirst));\n"
"\n"
"	// Save current shading normal/dpdu/dpdv and setup the hitPoint with first material bump mapping\n"
"	EvalStack_PushFloat3(originalShadeN);\n"
"	EvalStack_PushFloat3(originalDpdu);\n"
"	EvalStack_PushFloat3(originalDpdv);\n"
"\n"
"	Material_Bump(matIndexSecond, hitPointTmp\n"
"		MATERIALS_PARAM);\n"
"	// Re-read the shadeN modified by Material_Bump()\n"
"	const float3 matSecondShadeN = VLOAD3F(&hitPointTmp->shadeN.x);\n"
"	const float3 matSecondDpdu = VLOAD3F(&hitPointTmp->dpdu.x);\n"
"	const float3 matSecondDpdv = VLOAD3F(&hitPointTmp->dpdv.x);\n"
"\n"
"	// Save the parameters\n"
"	EvalStack_PushFloat3(fixedDir);\n"
"	EvalStack_PushFloat(u0);\n"
"	EvalStack_PushFloat(u1);\n"
"	EvalStack_PushFloat(passThroughEvent);\n"
"\n"
"	// Save factor\n"
"	EvalStack_PushFloat(factor);\n"
"	// Save sampleMatA\n"
"	EvalStack_PushInt(sampleMatA);\n"
"\n"
"	// Save the result of the first evaluation\n"
"	EvalStack_PushFloat3(resultFirst);\n"
"	EvalStack_PushFloat3(sampledDirFirst);\n"
"	EvalStack_PushFloat(pdfWFirst);\n"
"	EvalStack_PushBSDFEvent(eventFirst);\n"
"\n"
"	// To setup the following EVAL_EVALUATE evaluation of second sub-nodes\n"
"	if (Spectrum_IsBlack(resultFirst)) {\n"
"		// In this case, sampledDirFirst is not initialized so I have to put\n"
"		// there some meaningful value\n"
"		sampledDirFirst = fixedDir;\n"
"	}\n"
"	\n"
"	// Transform sampledDirFirst and fixedDir to second material new reference system\n"
"	Frame frameSecond;\n"
"	Frame_Set_Private(&frameSecond, matSecondDpdu, matSecondDpdv, matSecondShadeN);\n"
"\n"
"	const float3 matSecondSampledDir = Frame_ToLocal_Private(&frameSecond, Frame_ToWorld_Private(&frameOriginal, sampledDirFirst));\n"
"	const float3 matSecondFixedDir = Frame_ToLocal_Private(&frameSecond, Frame_ToWorld_Private(&frameOriginal, fixedDir));\n"
"\n"
"	EvalStack_PushFloat3(matSecondSampledDir);\n"
"	EvalStack_PushFloat3(matSecondFixedDir);\n"
"\n"
"	// To setup the first EVAL_CONDITIONAL_GOTO evaluation\n"
"	EvalStack_PushInt(sampleMatA);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void MixMaterial_Sample(__global const Material* restrict material,\n"
"		__global const HitPoint *hitPoint,\n"
"		__global float *evalStack, uint *evalStackOffset\n"
"		MATERIALS_PARAM_DECL) {\n"
"	// Pop the result of the second evaluation\n"
"	float3 resultSecond;\n"
"	BSDFEvent eventSecond;\n"
"	float directPdfWSecond;\n"
"	EvalStack_PopFloat(directPdfWSecond);\n"
"	EvalStack_PopBSDFEvent(eventSecond);\n"
"	EvalStack_PopFloat3(resultSecond);\n"
"\n"
"	// Pop the result of the first evaluation\n"
"	float3 resultFirst, sampledDirFirst;\n"
"	float pdfWFirst;\n"
"	BSDFEvent eventFirst;\n"
"	EvalStack_PopBSDFEvent(eventFirst);\n"
"	EvalStack_PopFloat(pdfWFirst);\n"
"	EvalStack_PopFloat3(sampledDirFirst);\n"
"	EvalStack_PopFloat3(resultFirst);\n"
"	\n"
"	// Pop sampleMatA\n"
"	bool sampleMatA;\n"
"	EvalStack_PopInt(sampleMatA);\n"
"	// Pop factor\n"
"	float factor;\n"
"	EvalStack_PopFloat(factor);\n"
"\n"
"	// Pop parameters\n"
"	float u0, u1, passThroughEvent;\n"
"	EvalStack_PopFloat(passThroughEvent);\n"
"	EvalStack_PopFloat(u1);\n"
"	EvalStack_PopFloat(u0);\n"
"	float3 fixedDir;\n"
"	EvalStack_PopFloat3(fixedDir);\n"
"	\n"
"	// Pop saved original shading normal/dpdu/dpdv\n"
"	float3 originalShadeN, originalDpdu, originalDpdv;\n"
"	EvalStack_PopFloat3(originalDpdv);\n"
"	EvalStack_PopFloat3(originalDpdu);\n"
"	EvalStack_PopFloat3(originalShadeN);\n"
"	// Restore original hitPoint\n"
"	__global HitPoint *hitPointTmp = (__global HitPoint *)hitPoint;\n"
"	VSTORE3F(originalShadeN, &hitPointTmp->shadeN.x);\n"
"	VSTORE3F(originalDpdu, &hitPointTmp->dpdu.x);\n"
"	VSTORE3F(originalDpdv, &hitPointTmp->dpdv.x);\n"
"\n"
"	//--------------------------------------------------------------------------\n"
"	\n"
"	float3 result = resultFirst;\n"
"	if (Spectrum_IsBlack(result)) {\n"
"		MATERIAL_SAMPLE_RETURN_BLACK;\n"
"	}\n"
"\n"
"	const float3 sampledDir = sampledDirFirst;\n"
"	\n"
"	const float weight2 = clamp(factor, 0.f, 1.f);\n"
"	const float weight1 = 1.f - weight2;\n"
"	const float weightFirst = sampleMatA ? weight1 : weight2;\n"
"	const float weightSecond = sampleMatA ? weight2 : weight1;\n"
"\n"
"	float pdfW = weightFirst * pdfWFirst;\n"
"\n"
"	BSDFEvent event = eventFirst;\n"
"\n"
"	if (eventFirst & SPECULAR) {\n"
"		EvalStack_PushFloat3(result);\n"
"		EvalStack_PushFloat3(sampledDir);\n"
"		EvalStack_PushFloat(pdfW);\n"
"		EvalStack_PushBSDFEvent(event);\n"
"\n"
"		return;\n"
"	}\n"
"	\n"
"	result *= pdfW;\n"
"\n"
"	const float3 fixedDirSecond = fixedDir;\n"
"	const float3 sampledDirSecond = sampledDir;\n"
"\n"
"	// This test is usually done by BSDF_Evaluate() and must be repeated in\n"
"	// material referencing other materials\n"
"	const float isTransmitEval = (signbit(fixedDirSecond.z) != signbit(sampledDirSecond.z));\n"
"\n"
"	const BSDFEvent eventTypesSecond = mats[sampleMatA ? material->mix.matBIndex : material->mix.matAIndex].eventTypes;\n"
"	if (((!isTransmitEval && (eventTypesSecond & REFLECT)) ||\n"
"			(isTransmitEval && (eventTypesSecond & TRANSMIT))) &&\n"
"			!Spectrum_IsBlack(resultSecond)) {\n"
"		result += weightSecond * resultSecond;\n"
"		pdfW += weightSecond * directPdfWSecond;\n"
"	}\n"
"\n"
"	result /= pdfW;\n"
"\n"
"	//--------------------------------------------------------------------------\n"
"\n"
"	EvalStack_PushFloat3(result);\n"
"	EvalStack_PushFloat3(sampledDir);\n"
"	EvalStack_PushFloat(pdfW);\n"
"	EvalStack_PushBSDFEvent(event);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Material specific EvalOp\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_NOT_INLINE void MixMaterial_EvalOp(\n"
"		__global const Material* restrict material,\n"
"		const MaterialEvalOpType evalType,\n"
"		__global float *evalStack,\n"
"		uint *evalStackOffset,\n"
"		__global const HitPoint *hitPoint\n"
"		MATERIALS_PARAM_DECL) {\n"
"	switch (evalType) {\n"
"		case EVAL_ALBEDO:\n"
"			MixMaterial_Albedo(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_GET_VOLUME_MIX_SETUP1:\n"
"			MixMaterial_GetVolumeSetUp1(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_GET_VOLUME_MIX_SETUP2:\n"
"			MixMaterial_GetVolumeSetUp2(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_GET_INTERIOR_VOLUME:\n"
"			MixMaterial_GetInteriorVolume(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_GET_EXTERIOR_VOLUME:\n"
"			MixMaterial_GetExteriorVolume(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_GET_EMITTED_RADIANCE_MIX_SETUP1:\n"
"			MixMaterial_GetEmittedRadianceSetUp1(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_GET_EMITTED_RADIANCE_MIX_SETUP2:\n"
"			MixMaterial_GetEmittedRadianceSetUp2(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_GET_EMITTED_RADIANCE:\n"
"			MixMaterial_GetEmittedRadiance(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_GET_PASS_TROUGH_TRANSPARENCY_MIX_SETUP1:\n"
"			MixMaterial_GetPassThroughTransparencySetUp1(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_GET_PASS_TROUGH_TRANSPARENCY_MIX_SETUP2:\n"
"			MixMaterial_GetPassThroughTransparencySetUp2(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_GET_PASS_TROUGH_TRANSPARENCY:\n"
"			MixMaterial_GetPassThroughTransparency(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_EVALUATE_MIX_SETUP1:\n"
"			MixMaterial_EvaluateSetUp1(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_EVALUATE_MIX_SETUP2:\n"
"			MixMaterial_EvaluateSetUp2(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_EVALUATE:\n"
"			MixMaterial_Evaluate(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_SAMPLE_MIX_SETUP1:\n"
"			MixMaterial_SampleSetUp1(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_SAMPLE_MIX_SETUP2:\n"
"			MixMaterial_SampleSetUp2(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		case EVAL_SAMPLE:\n"
"			MixMaterial_Sample(material, hitPoint, evalStack, evalStackOffset MATERIALS_PARAM);\n"
"			break;\n"
"		default:\n"
"			// Something wrong here\n"
"			break;\n"
"	}\n"
"}\n";
} }
