
#include <string>

namespace slg { namespace ocl {
std::string KernelSource_pathoclbase_funcs =
"#line 2 \"pathoclbase_funcs.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"// List of symbols defined at compile time:\n"
"//  PARAM_RAY_EPSILON_MIN\n"
"//  PARAM_RAY_EPSILON_MAX\n"
"\n"
"/*void MangleMemory(__global unsigned char *ptr, const size_t size) {\n"
"	Seed seed;\n"
"	Rnd_Init(7 + get_global_id(0), &seed);\n"
"\n"
"	for (uint i = 0; i < size; ++i)\n"
"		*ptr++ = (unsigned char)(Rnd_UintValue(&seed) & 0xff);\n"
"}*/\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Init functions\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE void InitSampleResult(\n"
"		__constant const GPUTaskConfiguration* restrict taskConfig,\n"
"		const uint filmWidth, const uint filmHeight,\n"
"		const uint filmSubRegion0, const uint filmSubRegion1,\n"
"		const uint filmSubRegion2, const uint filmSubRegion3,\n"
"		__global float *pixelFilterDistribution\n"
"		SAMPLER_PARAM_DECL) {\n"
"	const size_t gid = get_global_id(0);\n"
"	__global SampleResult *sampleResult = &sampleResultsBuff[gid];\n"
"\n"
"	SampleResult_Init(&taskConfig->film, sampleResult);\n"
"\n"
"	float filmX = Sampler_GetSample(taskConfig, IDX_SCREEN_X SAMPLER_PARAM);\n"
"	float filmY = Sampler_GetSample(taskConfig, IDX_SCREEN_Y SAMPLER_PARAM);\n"
"\n"
"	// Metropolis return IDX_SCREEN_X and IDX_SCREEN_Y between [0.0, 1.0] instead\n"
"	// that in film pixels like RANDOM and SOBOL samplers\n"
"	if (taskConfig->sampler.type == METROPOLIS) {\n"
"		filmX = filmSubRegion0 + filmX * (filmSubRegion1 - filmSubRegion0 + 1);\n"
"		filmY = filmSubRegion2 + filmY * (filmSubRegion3 - filmSubRegion2 + 1);\n"
"	}\n"
"\n"
"	const uint pixelX = min(Floor2UInt(filmX), filmSubRegion1);\n"
"	const uint pixelY = min(Floor2UInt(filmY), filmSubRegion3);\n"
"	const float uSubPixelX = filmX - pixelX;\n"
"	const float uSubPixelY = filmY - pixelY;\n"
"\n"
"	sampleResult->pixelX = pixelX;\n"
"	sampleResult->pixelY = pixelY;\n"
"\n"
"	// Sample according the pixel filter distribution\n"
"	float distX, distY;\n"
"	FilterDistribution_SampleContinuous(&taskConfig->pixelFilter, pixelFilterDistribution,\n"
"			uSubPixelX, uSubPixelY, &distX, &distY);\n"
"\n"
"	sampleResult->filmX = pixelX + .5f + distX;\n"
"	sampleResult->filmY = pixelY + .5f + distY;\n"
"\n"
"	sampleResult->directShadowMask = 1.f;\n"
"	sampleResult->indirectShadowMask = 1.f;\n"
"\n"
"	sampleResult->lastPathVertex = (taskConfig->pathTracer.maxPathDepth.depth == 1);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void GenerateEyePath(\n"
"		__constant const GPUTaskConfiguration* restrict taskConfig,\n"
"		__global GPUTaskDirectLight *taskDirectLight,\n"
"		__global GPUTaskState *taskState,\n"
"		__global const Camera* restrict camera,\n"
"		__global const float* restrict cameraBokehDistribution,\n"
"		const uint filmWidth, const uint filmHeight,\n"
"		const uint filmSubRegion0, const uint filmSubRegion1,\n"
"		const uint filmSubRegion2, const uint filmSubRegion3,\n"
"		__global float *pixelFilterDistribution,\n"
"		__global Ray *ray,\n"
"		__global EyePathInfo *pathInfo\n"
"#if defined(RENDER_ENGINE_TILEPATHOCL) || defined(RENDER_ENGINE_RTPATHOCL)\n"
"		// cameraFilmWidth/cameraFilmHeight and filmWidth/filmHeight are usually\n"
"		// the same. They are different when doing tile rendering\n"
"		, const uint cameraFilmWidth, const uint cameraFilmHeight,\n"
"		const uint tileStartX, const uint tileStartY\n"
"#endif\n"
"		SAMPLER_PARAM_DECL) {\n"
"	const size_t gid = get_global_id(0);\n"
"	__global SampleResult *sampleResult = &sampleResultsBuff[gid];\n"
"\n"
"	EyePathInfo_Init(pathInfo);\n"
"\n"
"	InitSampleResult(taskConfig,\n"
"			filmWidth, filmHeight,\n"
"			filmSubRegion0, filmSubRegion1,\n"
"			filmSubRegion2, filmSubRegion3,\n"
"			pixelFilterDistribution\n"
"			SAMPLER_PARAM);\n"
"\n"
"	// Generate the came ray\n"
"	const float timeSample = Sampler_GetSample(taskConfig, IDX_EYE_TIME SAMPLER_PARAM);\n"
"\n"
"	const float dofSampleX = Sampler_GetSample(taskConfig, IDX_DOF_X SAMPLER_PARAM);\n"
"	const float dofSampleY = Sampler_GetSample(taskConfig, IDX_DOF_Y SAMPLER_PARAM);\n"
"\n"
"#if defined(RENDER_ENGINE_TILEPATHOCL) || defined(RENDER_ENGINE_RTPATHOCL)\n"
"	Camera_GenerateRay(camera, cameraBokehDistribution, cameraFilmWidth, cameraFilmHeight,\n"
"			ray,\n"
"			&pathInfo->volume,\n"
"			sampleResult->filmX + tileStartX, sampleResult->filmY + tileStartY,\n"
"			timeSample,\n"
"			dofSampleX, dofSampleY);\n"
"#else\n"
"	Camera_GenerateRay(camera, cameraBokehDistribution, filmWidth, filmHeight,\n"
"			ray,\n"
"			&pathInfo->volume,\n"
"			sampleResult->filmX, sampleResult->filmY,\n"
"			timeSample,\n"
"			dofSampleX, dofSampleY);\n"
"#endif\n"
"\n"
"	// Initialize the path state\n"
"	taskState->state = MK_RT_NEXT_VERTEX;\n"
"	VSTORE3F(WHITE, taskState->throughput.c);\n"
"	taskState->albedoToDo = true;\n"
"	VSTORE3F(BLACK, sampleResult->albedo.c);  // Just in case albedoToDo is never true\n"
"	VSTORE3F(BLACK, &sampleResult->shadingNormal.x);\n"
"	taskState->photonGICacheEnabledOnLastHit = false;\n"
"	taskState->photonGICausticCacheUsed = false;\n"
"	taskState->photonGIShowIndirectPathMixUsed = false;\n"
"	// Initialize the trough a shadow transparency flag used by Scene_Intersect()\n"
"	taskState->throughShadowTransparency = false;\n"
"\n"
"	// Initialize the pass-through event seed\n"
"	//\n"
"	// Note: using the IDX_PASSTHROUGH of path depth 0\n"
"	const float passThroughEvent = Sampler_GetSample(taskConfig, IDX_BSDF_OFFSET + IDX_PASSTHROUGH SAMPLER_PARAM);\n"
"	Seed seedPassThroughEvent;\n"
"	Rnd_InitFloat(passThroughEvent, &seedPassThroughEvent);\n"
"	taskState->seedPassThroughEvent = seedPassThroughEvent;\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Utility functions\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE bool CheckDirectHitVisibilityFlags(__global const LightSource* restrict lightSource,\n"
"		__global PathDepthInfo *depthInfo,\n"
"		const BSDFEvent lastBSDFEvent) {\n"
"	if (depthInfo->depth == 0)\n"
"		return true;\n"
"\n"
"	if ((lastBSDFEvent & DIFFUSE) && (lightSource->visibility & DIFFUSE))\n"
"		return true;\n"
"	if ((lastBSDFEvent & GLOSSY) && (lightSource->visibility & GLOSSY))\n"
"		return true;\n"
"	if ((lastBSDFEvent & SPECULAR) && (lightSource->visibility & SPECULAR))\n"
"		return true;\n"
"\n"
"	return false;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void DirectHitInfiniteLight(__constant const Film* restrict film,\n"
"		__global EyePathInfo *pathInfo, __global const Spectrum* restrict pathThroughput,\n"
"		const __global Ray *ray, __global const BSDF *bsdf, __global SampleResult *sampleResult\n"
"		LIGHTS_PARAM_DECL) {\n"
"	// If the material is shadow transparent, Direct Light sampling\n"
"	// will take care of transporting all emitted light\n"
"	if (bsdf && bsdf->hitPoint.throughShadowTransparency)\n"
"		return;\n"
"\n"
"	const float3 throughput = VLOAD3F(pathThroughput->c);\n"
"\n"
"	for (uint i = 0; i < envLightCount; ++i) {\n"
"		__global const LightSource* restrict light = &lights[envLightIndices[i]];\n"
"\n"
"		// Check if the light source is visible according the settings\n"
"		if (!CheckDirectHitVisibilityFlags(light, &pathInfo->depth, pathInfo->lastBSDFEvent))\n"
"			continue;\n"
"\n"
"		float directPdfW;\n"
"		const float3 envRadiance = EnvLight_GetRadiance(light, bsdf,\n"
"				-VLOAD3F(&ray->d.x), &directPdfW\n"
"				LIGHTS_PARAM);\n"
"\n"
"		if (!Spectrum_IsBlack(envRadiance)) {\n"
"			float weight;\n"
"			if (!(pathInfo->lastBSDFEvent & SPECULAR)) {\n"
"				const float lightPickProb = LightStrategy_SampleLightPdf(lightsDistribution,\n"
"						dlscAllEntries,\n"
"						dlscDistributions, dlscBVHNodes,\n"
"						dlscRadius2, dlscNormalCosAngle,\n"
"						VLOAD3F(&ray->o.x), VLOAD3F(&pathInfo->lastShadeN.x),\n"
"						pathInfo->lastFromVolume,\n"
"						light->lightSceneIndex);\n"
"\n"
"				// MIS between BSDF sampling and direct light sampling\n"
"				weight = PowerHeuristic(pathInfo->lastBSDFPdfW, directPdfW * lightPickProb);\n"
"			} else\n"
"				weight = 1.f;\n"
"			\n"
"			SampleResult_AddEmission(film, sampleResult, light->lightID, throughput, weight * envRadiance);\n"
"		}\n"
"	}\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void DirectHitFiniteLight(__constant const Film* restrict film,\n"
"		__global EyePathInfo *pathInfo,\n"
"		__global const Spectrum* restrict pathThroughput, const __global Ray *ray,\n"
"		const float distance, __global const BSDF *bsdf,\n"
"		__global SampleResult *sampleResult\n"
"		LIGHTS_PARAM_DECL) {\n"
"	__global const LightSource* restrict light = &lights[bsdf->triangleLightSourceIndex];\n"
"\n"
"	// Check if the light source is visible according the settings\n"
"	if (!CheckDirectHitVisibilityFlags(light, &pathInfo->depth, pathInfo->lastBSDFEvent) ||\n"
"			// If the material is shadow transparent, Direct Light sampling\n"
"			// will take care of transporting all emitted light\n"
"			bsdf->hitPoint.throughShadowTransparency)\n"
"		return;\n"
"	\n"
"	float directPdfA;\n"
"	const float3 emittedRadiance = BSDF_GetEmittedRadiance(bsdf, &directPdfA\n"
"			LIGHTS_PARAM);\n"
"\n"
"	if (!Spectrum_IsBlack(emittedRadiance)) {\n"
"		// Add emitted radiance\n"
"		float weight = 1.f;\n"
"		if (!(pathInfo->lastBSDFEvent & SPECULAR)) {\n"
"			const float lightPickProb = LightStrategy_SampleLightPdf(lightsDistribution,\n"
"					dlscAllEntries,\n"
"					dlscDistributions, dlscBVHNodes,\n"
"					dlscRadius2, dlscNormalCosAngle,\n"
"					VLOAD3F(&ray->o.x), VLOAD3F(&pathInfo->lastShadeN.x),\n"
"					pathInfo->lastFromVolume,\n"
"					light->lightSceneIndex);\n"
"\n"
"#if !defined(RENDER_ENGINE_RTPATHOCL)\n"
"			// This is a specific check to avoid fireflies with DLSC\n"
"			if ((lightPickProb == 0.f) && light->isDirectLightSamplingEnabled && dlscAllEntries)\n"
"				return;\n"
"#endif\n"
"			\n"
"			const float directPdfW = PdfAtoW(directPdfA, distance,\n"
"					fabs(dot(VLOAD3F(&bsdf->hitPoint.fixedDir.x), VLOAD3F(&bsdf->hitPoint.shadeN.x))));\n"
"\n"
"			// MIS between BSDF sampling and direct light sampling\n"
"			//\n"
"			// Note: mats[bsdf->materialIndex].avgPassThroughTransparency = lightSource->GetAvgPassThroughTransparency()\n"
"			weight = PowerHeuristic(pathInfo->lastBSDFPdfW * Light_GetAvgPassThroughTransparency(light LIGHTS_PARAM), directPdfW * lightPickProb);\n"
"		}\n"
"\n"
"		SampleResult_AddEmission(film, sampleResult, BSDF_GetLightID(bsdf\n"
"				MATERIALS_PARAM), VLOAD3F(pathThroughput->c), weight * emittedRadiance);\n"
"	}\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float RussianRouletteProb(const float importanceCap, const float3 color) {\n"
"	return clamp(Spectrum_Filter(color), importanceCap, 1.f);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE bool DirectLight_Illuminate(\n"
"		__global const BSDF *bsdf,\n"
"		__global Ray *shadowRay,\n"
"		const float worldCenterX,\n"
"		const float worldCenterY,\n"
"		const float worldCenterZ,\n"
"		const float worldRadius,\n"
"		__global HitPoint *tmpHitPoint,\n"
"		const float time, const float u0, const float u1, const float u2,\n"
"		const float lightPassThroughEvent,\n"
"		__global DirectLightIlluminateInfo *info\n"
"		LIGHTS_PARAM_DECL) {\n"
"	// Select the light strategy to use\n"
"	__global const float* restrict lightDist = BSDF_IsShadowCatcherOnlyInfiniteLights(bsdf MATERIALS_PARAM) ?\n"
"		infiniteLightSourcesDistribution : lightsDistribution;\n"
"\n"
"	// Pick a light source to sample\n"
"	float lightPickPdf;\n"
"	const uint lightIndex = LightStrategy_SampleLights(lightDist,\n"
"			dlscAllEntries,\n"
"			dlscDistributions, dlscBVHNodes,\n"
"			dlscRadius2, dlscNormalCosAngle,\n"
"			VLOAD3F(&bsdf->hitPoint.p.x), BSDF_GetLandingGeometryN(bsdf), \n"
"			bsdf->isVolume,\n"
"			u0, &lightPickPdf);\n"
"	if ((lightIndex == NULL_INDEX) || (lightPickPdf <= 0.f))\n"
"		return false;\n"
"\n"
"	__global const LightSource* restrict light = &lights[lightIndex];\n"
"\n"
"	info->lightIndex = lightIndex;\n"
"	info->lightID = light->lightID;\n"
"	info->pickPdf = lightPickPdf;\n"
"\n"
"	// Illuminate the point\n"
"	float directPdfW;\n"
"	const float3 lightRadiance = Light_Illuminate(\n"
"			&lights[lightIndex],\n"
"			bsdf,\n"
"			time, u1, u2,\n"
"			lightPassThroughEvent,\n"
"			worldCenterX, worldCenterY, worldCenterZ, worldRadius,\n"
"			tmpHitPoint,		\n"
"			shadowRay, &directPdfW\n"
"			LIGHTS_PARAM);\n"
"	\n"
"	if (Spectrum_IsBlack(lightRadiance))\n"
"		return false;\n"
"	else {\n"
"		info->directPdfW = directPdfW;\n"
"		VSTORE3F(lightRadiance, info->lightRadiance.c);\n"
"		VSTORE3F(lightRadiance, info->lightIrradiance.c);\n"
"		return true;\n"
"	}\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE bool DirectLight_BSDFSampling(\n"
"		__constant const GPUTaskConfiguration* restrict taskConfig,\n"
"		__global DirectLightIlluminateInfo *info,\n"
"		const float time,\n"
"		const bool lastPathVertex,\n"
"		__global EyePathInfo *pathInfo,\n"
"		__global PathDepthInfo *tmpDepthInfo,\n"
"		__global const BSDF *bsdf,\n"
"		const float3 shadowRayDir\n"
"		LIGHTS_PARAM_DECL) {\n"
"	// Sample the BSDF\n"
"	BSDFEvent event;\n"
"	float bsdfPdfW;\n"
"	const float3 bsdfEval = BSDF_Evaluate(bsdf,\n"
"			shadowRayDir, &event, &bsdfPdfW\n"
"			MATERIALS_PARAM);\n"
"\n"
"	if (Spectrum_IsBlack(bsdfEval) ||\n"
"			(taskConfig->pathTracer.hybridBackForward.enabled &&\n"
"			EyePathInfo_IsCausticPathWithEvent(pathInfo, event,\n"
"				BSDF_GetGlossiness(bsdf MATERIALS_PARAM),\n"
"				taskConfig->pathTracer.hybridBackForward.glossinessThreshold))\n"
"			)\n"
"		return false;\n"
"\n"
"	// Create a new DepthInfo for the path to the light source\n"
"	//\n"
"	// Note: I was using a local variable before to save, use and than restore\n"
"	// the depthInfo variable but it was triggering a AMD OpenCL compiler bug.\n"
"	*tmpDepthInfo = pathInfo->depth;\n"
"	PathDepthInfo_IncDepths(tmpDepthInfo, event);\n"
"\n"
"	const float directLightSamplingPdfW = info->directPdfW * info->pickPdf;\n"
"	const float factor = 1.f / directLightSamplingPdfW;\n"
"\n"
"	// Russian Roulette\n"
"	bsdfPdfW *= (PathDepthInfo_GetRRDepth(tmpDepthInfo) >= taskConfig->pathTracer.rrDepth) ?\n"
"		RussianRouletteProb(taskConfig->pathTracer.rrImportanceCap, bsdfEval) :\n"
"		1.f;\n"
"\n"
"	// Account for material transparency\n"
"	__global const LightSource* restrict light = &lights[info->lightIndex];\n"
"	bsdfPdfW *= Light_GetAvgPassThroughTransparency(light\n"
"			LIGHTS_PARAM);\n"
"	\n"
"	// MIS between direct light sampling and BSDF sampling\n"
"	//\n"
"	// Note: I have to avoiding MIS on the last path vertex\n"
"\n"
"	const bool misEnabled = !lastPathVertex &&\n"
"			Light_IsEnvOrIntersectable(light) &&\n"
"			CheckDirectHitVisibilityFlags(light, tmpDepthInfo, event) &&\n"
"			!bsdf->hitPoint.throughShadowTransparency;\n"
"\n"
"	const float weight = misEnabled ? PowerHeuristic(directLightSamplingPdfW, bsdfPdfW) : 1.f;\n"
"\n"
"	const float3 lightRadiance = VLOAD3F(info->lightRadiance.c);\n"
"	VSTORE3F(bsdfEval * (weight * factor) * lightRadiance, info->lightRadiance.c);\n"
"	VSTORE3F(factor * lightRadiance, info->lightIrradiance.c);\n"
"\n"
"	return true;\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Kernel parameters\n"
"//------------------------------------------------------------------------------\n"
"\n"
"#define KERNEL_ARGS_VOLUMES \\\n"
"		, __global PathVolumeInfo *directLightVolInfos\n"
"\n"
"#define KERNEL_ARGS_INFINITELIGHTS \\\n"
"		, const float worldCenterX \\\n"
"		, const float worldCenterY \\\n"
"		, const float worldCenterZ \\\n"
"		, const float worldRadius\n"
"\n"
"#define KERNEL_ARGS_NORMALS_BUFFER \\\n"
"		, __global const Normal* restrict vertNormals\n"
"#define KERNEL_ARGS_TRINORMALS_BUFFER \\\n"
"		, __global const Normal* restrict triNormals\n"
"#define KERNEL_ARGS_UVS_BUFFER \\\n"
"		, __global const UV* restrict vertUVs\n"
"#define KERNEL_ARGS_COLS_BUFFER \\\n"
"		, __global const Spectrum* restrict vertCols\n"
"#define KERNEL_ARGS_ALPHAS_BUFFER \\\n"
"		, __global const float* restrict vertAlphas\n"
"#define KERNEL_ARGS_VERTEXAOVS_BUFFER \\\n"
"		, __global const float* restrict vertexAOVs\n"
"#define KERNEL_ARGS_TRIAOVS_BUFFER \\\n"
"		, __global const float* restrict triAOVs\n"
"\n"
"#define KERNEL_ARGS_ENVLIGHTS \\\n"
"		, __global const uint* restrict envLightIndices \\\n"
"		, const uint envLightCount\n"
"\n"
"#define KERNEL_ARGS_INFINITELIGHT \\\n"
"		, __global const float* restrict envLightDistribution\n"
"\n"
"#define KERNEL_ARGS_IMAGEMAPS_PAGES \\\n"
"		, __global const ImageMap* restrict imageMapDescs \\\n"
"		, __global const float* restrict imageMapBuff0 \\\n"
"		, __global const float* restrict imageMapBuff1 \\\n"
"		, __global const float* restrict imageMapBuff2 \\\n"
"		, __global const float* restrict imageMapBuff3 \\\n"
"		, __global const float* restrict imageMapBuff4 \\\n"
"		, __global const float* restrict imageMapBuff5 \\\n"
"		, __global const float* restrict imageMapBuff6 \\\n"
"		, __global const float* restrict imageMapBuff7\n"
"\n"
"#define KERNEL_ARGS_FAST_PIXEL_FILTER \\\n"
"		, __global float *pixelFilterDistribution\n"
"\n"
"#define KERNEL_ARGS_PHOTONGI \\\n"
"		, __global const RadiancePhoton* restrict pgicRadiancePhotons \\\n"
"		, uint pgicLightGroupCounts \\\n"
"		, __global const Spectrum* restrict pgicRadiancePhotonsValues \\\n"
"		, __global const IndexBVHArrayNode* restrict pgicRadiancePhotonsBVHNodes \\\n"
"		, __global const Photon* restrict pgicCausticPhotons \\\n"
"		, __global const IndexBVHArrayNode* restrict pgicCausticPhotonsBVHNodes\n"
"\n"
"#define KERNEL_ARGS \\\n"
"		__constant const GPUTaskConfiguration* restrict taskConfig \\\n"
"		, __global GPUTask *tasks \\\n"
"		, __global GPUTaskDirectLight *tasksDirectLight \\\n"
"		, __global GPUTaskState *tasksState \\\n"
"		, __global GPUTaskStats *taskStats \\\n"
"		KERNEL_ARGS_FAST_PIXEL_FILTER \\\n"
"		, __global void *samplerSharedDataBuff \\\n"
"		, __global void *samplesBuff \\\n"
"		, __global float *samplesDataBuff \\\n"
"		, __global SampleResult *sampleResultsBuff \\\n"
"		, __global EyePathInfo *eyePathInfos \\\n"
"		KERNEL_ARGS_VOLUMES \\\n"
"		, __global Ray *rays \\\n"
"		, __global RayHit *rayHits \\\n"
"		/* Film parameters */ \\\n"
"		KERNEL_ARGS_FILM \\\n"
"		/* Scene parameters */ \\\n"
"		KERNEL_ARGS_INFINITELIGHTS \\\n"
"		, __global const Material* restrict mats \\\n"
"		, __global const MaterialEvalOp* restrict matEvalOps \\\n"
"		, __global float *matEvalStacks \\\n"
"		, const uint maxMaterialEvalStackSize \\\n"
"		, __global const Texture* restrict texs \\\n"
"		, __global const TextureEvalOp* restrict texEvalOps \\\n"
"		, __global float *texEvalStacks \\\n"
"		, const uint maxTextureEvalStackSize \\\n"
"		, __global const SceneObject* restrict sceneObjs \\\n"
"		, __global const ExtMesh* restrict meshDescs \\\n"
"		, __global const Point* restrict vertices \\\n"
"		KERNEL_ARGS_NORMALS_BUFFER \\\n"
"		KERNEL_ARGS_TRINORMALS_BUFFER \\\n"
"		KERNEL_ARGS_UVS_BUFFER \\\n"
"		KERNEL_ARGS_COLS_BUFFER \\\n"
"		KERNEL_ARGS_ALPHAS_BUFFER \\\n"
"		KERNEL_ARGS_VERTEXAOVS_BUFFER \\\n"
"		KERNEL_ARGS_TRIAOVS_BUFFER \\\n"
"		, __global const Triangle* restrict triangles \\\n"
"		, __global const InterpolatedTransform* restrict interpolatedTransforms \\\n"
"		, __global const Camera* restrict camera \\\n"
"		, __global const float* restrict cameraBokehDistribution \\\n"
"		/* Lights */ \\\n"
"		, __global const LightSource* restrict lights \\\n"
"		KERNEL_ARGS_ENVLIGHTS \\\n"
"		, __global const uint* restrict lightIndexOffsetByMeshIndex \\\n"
"		, __global const uint* restrict lightIndexByTriIndex \\\n"
"		KERNEL_ARGS_INFINITELIGHT \\\n"
"		, __global const float* restrict lightsDistribution \\\n"
"		, __global const float* restrict infiniteLightSourcesDistribution \\\n"
"		, __global const DLSCacheEntry* restrict dlscAllEntries \\\n"
"		, __global const float* restrict dlscDistributions \\\n"
"		, __global const IndexBVHArrayNode* restrict dlscBVHNodes \\\n"
"		, const float dlscRadius2 \\\n"
"		, const float dlscNormalCosAngle \\\n"
"		, __global const ELVCacheEntry* restrict elvcAllEntries \\\n"
"		, __global const float* restrict elvcDistributions \\\n"
"		, __global const uint* restrict elvcTileDistributionOffsets \\\n"
"		, __global const IndexBVHArrayNode* restrict elvcBVHNodes \\\n"
"		, const float elvcRadius2 \\\n"
"		, const float elvcNormalCosAngle \\\n"
"		, const uint elvcTilesXCount \\\n"
"		, const uint elvcTilesYCount \\\n"
"		/* Images */ \\\n"
"		KERNEL_ARGS_IMAGEMAPS_PAGES \\\n"
"		KERNEL_ARGS_PHOTONGI\n"
"\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// To initialize image maps page pointer table\n"
"//------------------------------------------------------------------------------\n"
"\n"
"#define INIT_IMAGEMAPS_PAGES \\\n"
"	__global const float* restrict imageMapBuff[8]; \\\n"
"	imageMapBuff[0] = imageMapBuff0; \\\n"
"	imageMapBuff[1] = imageMapBuff1; \\\n"
"	imageMapBuff[2] = imageMapBuff2; \\\n"
"	imageMapBuff[3] = imageMapBuff3; \\\n"
"	imageMapBuff[4] = imageMapBuff4; \\\n"
"	imageMapBuff[5] = imageMapBuff5; \\\n"
"	imageMapBuff[6] = imageMapBuff6; \\\n"
"	imageMapBuff[7] = imageMapBuff7;\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Init Kernels\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__kernel void InitSeed(__global GPUTask *tasks,\n"
"		const uint seedBase) {\n"
"	const size_t gid = get_global_id(0);\n"
"\n"
"	// Initialize random number generator\n"
"\n"
"	Seed seed;\n"
"	Rnd_Init(seedBase + gid, &seed);\n"
"\n"
"	// Save the seed\n"
"	__global GPUTask *task = &tasks[gid];\n"
"	task->seed = seed;\n"
"}\n"
"\n"
"__kernel void Init(\n"
"		__constant const GPUTaskConfiguration* restrict taskConfig,\n"
"		__global GPUTask *tasks,\n"
"		__global GPUTaskDirectLight *tasksDirectLight,\n"
"		__global GPUTaskState *tasksState,\n"
"		__global GPUTaskStats *taskStats,\n"
"		__global void *samplerSharedDataBuff,\n"
"		__global void *samplesBuff,\n"
"		__global float *samplesDataBuff,\n"
"		__global SampleResult *sampleResultsBuff,\n"
"		__global EyePathInfo *eyePathInfos,\n"
"		__global float *pixelFilterDistribution,\n"
"		__global Ray *rays,\n"
"		__global Camera *camera,\n"
"		__global const float* restrict cameraBokehDistribution\n"
"		KERNEL_ARGS_FILM\n"
"		) {\n"
"	const size_t gid = get_global_id(0);\n"
"\n"
"	__global GPUTaskState *taskState = &tasksState[gid];\n"
"\n"
"#if defined(RENDER_ENGINE_TILEPATHOCL) || defined(RENDER_ENGINE_RTPATHOCL)\n"
"	__global TilePathSamplerSharedData *samplerSharedData = (__global TilePathSamplerSharedData *)samplerSharedDataBuff;\n"
"\n"
"	if (gid >= filmWidth * filmHeight * Sqr(samplerSharedData->aaSamples)) {\n"
"		taskState->state = MK_DONE;\n"
"		// Mark the ray like like one to NOT trace\n"
"		rays[gid].flags = RAY_FLAGS_MASKED;\n"
"\n"
"		return;\n"
"	}\n"
"#endif\n"
"\n"
"	// Initialize the task\n"
"	__global GPUTask *task = &tasks[gid];\n"
"	__global GPUTaskDirectLight *taskDirectLight = &tasksDirectLight[gid];\n"
"\n"
"	// Read the seed\n"
"	Seed seedValue = task->seed;\n"
"	// This trick is required by Sampler_GetSample() macro\n"
"	Seed *seed = &seedValue;\n"
"\n"
"	// Initialize the sample and path\n"
"	const bool validSample = Sampler_Init(taskConfig,\n"
"			filmNoise,\n"
"			filmUserImportance,\n"
"			filmWidth, filmHeight,\n"
"			filmSubRegion0, filmSubRegion1, filmSubRegion2, filmSubRegion3\n"
"			SAMPLER_PARAM);\n"
"\n"
"	if (validSample) {\n"
"#if defined(RENDER_ENGINE_TILEPATHOCL) || defined(RENDER_ENGINE_RTPATHOCL)\n"
"		__global TilePathSamplerSharedData *samplerSharedData = (__global TilePathSamplerSharedData *)samplerSharedDataBuff;\n"
"		const uint cameraFilmWidth = samplerSharedData->cameraFilmWidth;\n"
"		const uint cameraFilmHeight = samplerSharedData->cameraFilmHeight;\n"
"		const uint tileStartX = samplerSharedData->tileStartX;\n"
"		const uint tileStartY =  samplerSharedData->tileStartY;\n"
"#endif\n"
"\n"
"		// Generate the eye path\n"
"		GenerateEyePath(taskConfig,\n"
"				taskDirectLight, taskState,\n"
"				camera,\n"
"				cameraBokehDistribution,\n"
"				filmWidth, filmHeight,\n"
"				filmSubRegion0, filmSubRegion1, filmSubRegion2, filmSubRegion3,\n"
"				pixelFilterDistribution,\n"
"				&rays[gid],\n"
"				&eyePathInfos[gid]\n"
"#if defined(RENDER_ENGINE_TILEPATHOCL) || defined(RENDER_ENGINE_RTPATHOCL)\n"
"				, cameraFilmWidth, cameraFilmHeight,\n"
"				tileStartX, tileStartY\n"
"#endif\n"
"				SAMPLER_PARAM);\n"
"	} else {\n"
"#if defined(RENDER_ENGINE_TILEPATHOCL) || defined(RENDER_ENGINE_RTPATHOCL)\n"
"		taskState->state = MK_DONE;\n"
"#else\n"
"		taskState->state = MK_GENERATE_CAMERA_RAY;\n"
"#endif\n"
"		// Mark the ray like like one to NOT trace\n"
"		rays[gid].flags = RAY_FLAGS_MASKED;\n"
"	}\n"
"\n"
"	// Save the seed\n"
"	task->seed = seedValue;\n"
"\n"
"	__global GPUTaskStats *taskStat = &taskStats[gid];\n"
"	taskStat->sampleCount = 0;\n"
"}\n";
} }
