
#include <string>

namespace slg { namespace ocl {
std::string KernelSource_pgic_funcs =
"#line 2 \"pgic_funcs.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"OPENCL_FORCE_INLINE bool PhotonGICache_IsPhotonGIEnabled(__global const BSDF *bsdf,\n"
"		const float glossinessUsageThreshold\n"
"		MATERIALS_PARAM_DECL) {\n"
"	const uint matIndex = bsdf->materialIndex;\n"
"\n"
"	if (matIndex == NULL_INDEX)\n"
"		return false;\n"
"	else {\n"
"		const BSDFEvent eventTypes = BSDF_GetEventTypes(bsdf\n"
"				MATERIALS_PARAM);\n"
"\n"
"		if ((eventTypes & TRANSMIT) || (eventTypes & SPECULAR) ||\n"
"				((eventTypes & GLOSSY) && (BSDF_GetGlossiness(bsdf MATERIALS_PARAM) < glossinessUsageThreshold)))\n"
"			return false;\n"
"		else\n"
"			return BSDF_IsPhotonGIEnabled(bsdf MATERIALS_PARAM);\n"
"	}\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE bool PhotonGICache_IsDirectLightHitVisible(\n"
"		__constant const GPUTaskConfiguration* restrict taskConfig,\n"
"		__global const EyePathInfo *pathInfo,\n"
"		const bool photonGICausticCacheUsed) {\n"
"	// This is a specific check to cut fireflies created by some glossy or\n"
"	// specular bounce\n"
"	if (!(pathInfo->lastBSDFEvent & DIFFUSE) && (pathInfo->depth.diffuseDepth > 0))\n"
"		return false;\n"
"	else if (!taskConfig->pathTracer.pgic.causticEnabled || !photonGICausticCacheUsed)\n"
"		return true;\n"
"	else if (!pathInfo->isNearlyCaustic && (taskConfig->pathTracer.pgic.debugType == PGIC_DEBUG_NONE))\n"
"		return true;\n"
"	else\n"
"		return false;\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Indirect cache related functions\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float PhotonGICache_GetIndirectUsageThreshold(\n"
"		const BSDFEvent lastBSDFEvent, const float lastGlossiness,\n"
"		const float u0,\n"
"		const float pgicGlossinessUsageThreshold,\n"
"		const float pgicIndirectUsageThresholdScale,\n"
"		const float pgicIndirectLookUpRadius) {\n"
"	// Decide if the glossy surface is \"nearly specular\"\n"
"\n"
"	if ((lastBSDFEvent & GLOSSY) && (lastGlossiness < pgicGlossinessUsageThreshold)) {\n"
"		// Disable the cache, the surface is \"nearly specular\"\n"
"		return INFINITY;\n"
"	} else {\n"
"		// Use a larger blend zone for glossy surface\n"
"		const float scale = (lastBSDFEvent & GLOSSY) ? 2.f : 1.f;\n"
"\n"
"		// Enable the cache for diffuse or glossy \"nearly diffuse\" but only after\n"
"		// the threshold (before I brute force and cache between 0x and 1x the threshold)\n"
"		return scale * u0 * pgicIndirectUsageThresholdScale * pgicIndirectLookUpRadius;\n"
"	}\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE __global const RadiancePhoton* restrict RadiancePhotonsBVH_GetNearestEntry(\n"
"		__global const RadiancePhoton* restrict pgicRadiancePhotons,\n"
"		__global const IndexBVHArrayNode* restrict pgicRadiancePhotonsBVHNodes,\n"
"		const float pgicIndirectLookUpRadius2, const float pgicIndirectLookUpNormalCosAngle,\n"
"		const float3 p, const float3 n, const bool isVolume\n"
"		) {\n"
"	__global const RadiancePhoton* restrict nearestEntry = NULL;\n"
"\n"
"	float nearestDistance2 = pgicIndirectLookUpRadius2;\n"
"\n"
"	uint currentNode = 0; // Root Node\n"
"	const uint stopNode = IndexBVHNodeData_GetSkipIndex(pgicRadiancePhotonsBVHNodes[0].nodeData); // Non-existent\n"
"\n"
"	while (currentNode < stopNode) {\n"
"		__global const IndexBVHArrayNode* restrict node = &pgicRadiancePhotonsBVHNodes[currentNode];\n"
"\n"
"		const uint nodeData = node->nodeData;\n"
"		if (IndexBVHNodeData_IsLeaf(nodeData)) {\n"
"			// It is a leaf, check the entry\n"
"			__global const RadiancePhoton* restrict entry = &pgicRadiancePhotons[node->entryLeaf.entryIndex];\n"
"\n"
"			const float distance2 = DistanceSquared(p, VLOAD3F(&entry->p.x));\n"
"			if ((distance2 < nearestDistance2) && \n"
"					(entry->isVolume == isVolume) &&\n"
"						(isVolume ||\n"
"						(dot(n, VLOAD3F(&entry->n.x)) > pgicIndirectLookUpNormalCosAngle)\n"
"						)\n"
"				) {\n"
"				// I have found a valid nearer entry\n"
"				nearestEntry = entry;\n"
"				nearestDistance2 = distance2;\n"
"			}\n"
"\n"
"			++currentNode;\n"
"		} else {\n"
"			// It is a node, check the bounding box\n"
"			if (p.x >= node->bvhNode.bboxMin[0] && p.x <= node->bvhNode.bboxMax[0] &&\n"
"					p.y >= node->bvhNode.bboxMin[1] && p.y <= node->bvhNode.bboxMax[1] &&\n"
"					p.z >= node->bvhNode.bboxMin[2] && p.z <= node->bvhNode.bboxMax[2])\n"
"				++currentNode;\n"
"			else {\n"
"				// I don't need to use IndexBVHNodeData_GetSkipIndex() here because\n"
"				// I already know the leaf flag is 0\n"
"				currentNode = nodeData;\n"
"			}\n"
"		}\n"
"	}\n"
"\n"
"	return nearestEntry;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE __global const Spectrum* restrict PhotonGICache_GetIndirectRadiance(__global const BSDF *bsdf,\n"
"		__global const RadiancePhoton* restrict pgicRadiancePhotons,\n"
"		const uint pgicLightGroupCounts, __global const Spectrum* restrict pgicRadiancePhotonsValues,\n"
"		__global const IndexBVHArrayNode* restrict pgicRadiancePhotonsBVHNodes,\n"
"		const float pgicIndirectLookUpRadius2, const float pgicIndirectLookUpNormalCosAngle) {\n"
"	if (!pgicRadiancePhotons)\n"
"		return NULL;\n"
"\n"
"	const float3 p = VLOAD3F(&bsdf->hitPoint.p.x);\n"
"	const float3 n = (bsdf->hitPoint.intoObject ? 1.f: -1.f) * VLOAD3F(&bsdf->hitPoint.geometryN.x);\n"
"\n"
"	__global const RadiancePhoton* restrict radiancePhoton = RadiancePhotonsBVH_GetNearestEntry(\n"
"			pgicRadiancePhotons, pgicRadiancePhotonsBVHNodes,\n"
"			pgicIndirectLookUpRadius2, pgicIndirectLookUpNormalCosAngle,\n"
"			p, n, bsdf->isVolume\n"
"			);\n"
"\n"
"	if (radiancePhoton)\n"
"		return &pgicRadiancePhotonsValues[radiancePhoton->outgoingRadianceIndex];\n"
"	else\n"
"		return NULL;\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Caustic cache related functions\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float3 PGICPhotonBvh_ConnectCacheEntry(__global const Photon* restrict photon,\n"
"		__global const BSDF *bsdf\n"
"		MATERIALS_PARAM_DECL) {\n"
"	BSDFEvent event;\n"
"	const float3 photonDir = VLOAD3F(&photon->d.x);\n"
"	float directPdfW;\n"
"	float3 bsdfEval = BSDF_Evaluate(bsdf, -photonDir, &event, &directPdfW MATERIALS_PARAM);\n"
"	// bsdf.Evaluate() multiplies the result by AbsDot(bsdf.hitPoint.shadeN, -photon->d)\n"
"	// so I have to cancel that factor. It is already included in photon density\n"
"	// estimation.\n"
"	if (!bsdf->isVolume)\n"
"		bsdfEval /= fabs(dot(VLOAD3F(&bsdf->hitPoint.shadeN.x), -photonDir));\n"
"	else\n"
"		bsdfEval /= directPdfW;\n"
"\n"
"	return VLOAD3F(photon->alpha.c) * bsdfEval;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE bool PGICPhotonBvh_ConnectAllNearEntries(__global const BSDF *bsdf,\n"
"		__global const Photon* restrict pgicCausticPhotons,\n"
"		__global const IndexBVHArrayNode* restrict pgicCausticPhotonsBVHNodes,\n"
"		const uint pgicCausticPhotonTracedCount,\n"
"		const float pgicCausticLookUpRadius, const float pgicCausticLookUpNormalCosAngle,\n"
"		const float3 scale,\n"
"		__global Spectrum *radiance\n"
"		MATERIALS_PARAM_DECL) {\n"
"	const float3 p = VLOAD3F(&bsdf->hitPoint.p.x);\n"
"	// Flip the normal if required\n"
"	const float3 n = (bsdf->hitPoint.intoObject ? 1.f: -1.f) * VLOAD3F(&bsdf->hitPoint.geometryN.x);\n"
"	const bool isVolume = bsdf->isVolume;\n"
"\n"
"	uint currentNode = 0; // Root Node\n"
"	const uint stopNode = IndexBVHNodeData_GetSkipIndex(pgicCausticPhotonsBVHNodes[0].nodeData); // Non-existent\n"
"\n"
"	const float pgicCausticLookUpRadius2 = pgicCausticLookUpRadius * pgicCausticLookUpRadius;\n"
"	const float factor = isVolume ?\n"
"		1.f / (pgicCausticPhotonTracedCount * (4.f / 3.f * M_PI_F * pgicCausticLookUpRadius2 * pgicCausticLookUpRadius)) :\n"
"		1.f / (pgicCausticPhotonTracedCount * (M_PI_F * pgicCausticLookUpRadius2));\n"
"\n"
"	bool isEmpty = true;\n"
"	while (currentNode < stopNode) {\n"
"		__global const IndexBVHArrayNode* restrict node = &pgicCausticPhotonsBVHNodes[currentNode];\n"
"\n"
"		const uint nodeData = node->nodeData;\n"
"		if (IndexBVHNodeData_IsLeaf(nodeData)) {\n"
"			// It is a leaf, check the entry\n"
"			const uint entryIndex = node->entryLeaf.entryIndex;\n"
"			__global const Photon* restrict entry = &pgicCausticPhotons[entryIndex];\n"
"\n"
"			const float distance2 = DistanceSquared(p, VLOAD3F(&entry->p.x));\n"
"			if ((distance2 < pgicCausticLookUpRadius2) &&\n"
"					(entry->isVolume == isVolume) &&\n"
"						(isVolume ||\n"
"						((dot(n, -VLOAD3F(&entry->d.x)) > DEFAULT_COS_EPSILON_STATIC) &&\n"
"						(dot(n, VLOAD3F(&entry->landingSurfaceNormal.x)) > pgicCausticLookUpNormalCosAngle))\n"
"						)\n"
"				) {\n"
"				const float3 alpha = PGICPhotonBvh_ConnectCacheEntry(entry, bsdf MATERIALS_PARAM) * factor;\n"
"				VADD3F(radiance[entry->lightID].c, alpha * scale);\n"
"				isEmpty = false;\n"
"			}\n"
"\n"
"			++currentNode;\n"
"		} else {\n"
"			// It is a node, check the bounding box\n"
"			if (p.x >= node->bvhNode.bboxMin[0] && p.x <= node->bvhNode.bboxMax[0] &&\n"
"					p.y >= node->bvhNode.bboxMin[1] && p.y <= node->bvhNode.bboxMax[1] &&\n"
"					p.z >= node->bvhNode.bboxMin[2] && p.z <= node->bvhNode.bboxMax[2])\n"
"				++currentNode;\n"
"			else {\n"
"				// I don't need to use IndexBVHNodeData_GetSkipIndex() here because\n"
"				// I already know the leaf flag is 0\n"
"				currentNode = nodeData;\n"
"			}\n"
"		}\n"
"	}\n"
"\n"
"	return isEmpty;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE bool PhotonGICache_ConnectWithCausticPaths(__global const BSDF *bsdf,\n"
"		__global const Photon* restrict pgicCausticPhotons,\n"
"		__global const IndexBVHArrayNode* restrict pgicCausticPhotonsBVHNodes,\n"
"		const uint pgicCausticPhotonTracedCount,\n"
"		const float pgicCausticLookUpRadius, const float pgicCausticLookUpNormalCosAngle,\n"
"		const float3 scale,\n"
"		__global Spectrum *radiance\n"
"		MATERIALS_PARAM_DECL) {\n"
"\n"
"	return pgicCausticPhotons ?\n"
"		PGICPhotonBvh_ConnectAllNearEntries(bsdf, pgicCausticPhotons, pgicCausticPhotonsBVHNodes,\n"
"			pgicCausticPhotonTracedCount, pgicCausticLookUpRadius, pgicCausticLookUpNormalCosAngle,\n"
"			scale, radiance\n"
"			MATERIALS_PARAM) :\n"
"		true;\n"
"}\n";
} }
