
#include <string>

namespace slg { namespace ocl {
std::string KernelSource_plugin_gammacorrection_funcs =
"#line 2 \"plugin_gammacorrection_funcs.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// GammaCorrectionPlugin_Apply\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float Radiance2PixelFloat(__global float *gammaTable, const uint tableSize,\n"
"		const float x) {\n"
"	const int index = clamp(Floor2UInt(tableSize * clamp(x, 0.f, 1.f)), 0u, tableSize - 1u);\n"
"	return gammaTable[index];\n"
"}\n"
"\n"
"__kernel void GammaCorrectionPlugin_Apply(\n"
"		const uint filmWidth, const uint filmHeight,\n"
"		__global float *channel_IMAGEPIPELINE,\n"
"		__global float *gammaTable,\n"
"		const uint tableSize) {\n"
"	const size_t gid = get_global_id(0);\n"
"	if (gid >= filmWidth * filmHeight)\n"
"		return;\n"
"\n"
"	// Check if the pixel has received any sample\n"
"	if (!isinf(channel_IMAGEPIPELINE[gid * 3])) {\n"
"		__global float *pixel = &channel_IMAGEPIPELINE[gid * 3];\n"
"\n"
"		pixel[0] = Radiance2PixelFloat(gammaTable, tableSize, pixel[0]);\n"
"		pixel[1] = Radiance2PixelFloat(gammaTable, tableSize, pixel[1]);\n"
"		pixel[2] = Radiance2PixelFloat(gammaTable, tableSize, pixel[2]);\n"
"	}\n"
"}\n";
} }
