
#include <string>

namespace slg { namespace ocl {
std::string KernelSource_plugin_optixdenoiser_funcs =
"#line 2 \"plugin_optixdenoiser_funcs.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// OptixDenoiserPlugin_BufferSetUp\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__kernel void OptixDenoiserPlugin_BufferSetUp(\n"
"		const uint filmWidth, const uint filmHeight,\n"
"		__global float *src,\n"
"		__global float *dst) {\n"
"	const size_t gid = get_global_id(0);\n"
"	if (gid >= filmWidth * filmHeight)\n"
"		return;\n"
"\n"
"	const uint index4 = gid * 4;\n"
"	const float x = src[index4];\n"
"	const float y = src[index4 + 1];\n"
"	const float z = src[index4 + 2];\n"
"	const float w = 1.f / src[index4 + 3];\n"
"\n"
"	const uint index3 = gid * 3;\n"
"	dst[index3] = x * w;\n"
"	dst[index3 + 1] = y * w;\n"
"	dst[index3 + 2] = z * w;\n"
"}\n";
} }
