
#include <string>

namespace slg { namespace ocl {
std::string KernelSource_plugin_vignetting_funcs =
"#line 2 \"plugin_vignetting_funcs.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// VignettingPlugin_Apply\n"
"//------------------------------------------------------------------------------\n"
"\n"
"__kernel void VignettingPlugin_Apply(\n"
"		const uint filmWidth, const uint filmHeight,\n"
"		__global float *channel_IMAGEPIPELINE,\n"
"		const float scale) {\n"
"	const size_t gid = get_global_id(0);\n"
"	if (gid >= filmWidth * filmHeight)\n"
"		return;\n"
"\n"
"	// Check if the pixel has received any sample\n"
"	if (!isinf(channel_IMAGEPIPELINE[gid * 3])) {\n"
"		const uint x = gid % filmWidth;\n"
"		const uint y = gid / filmWidth;\n"
"		const float nx = x / (float)filmWidth;\n"
"		const float ny = y / (float)filmHeight;\n"
"		const float xOffset = (nx - .5f) * 2.f;\n"
"		const float yOffset = (ny - .5f) * 2.f;\n"
"		const float tOffset = sqrt(xOffset * xOffset + yOffset * yOffset);\n"
"\n"
"		// Normalize to range [0.f - 1.f]\n"
"		const float invOffset = 1.f - (fabs(tOffset) * 1.42f);\n"
"		float vWeight = mix(1.f - scale, 1.f, invOffset);\n"
"\n"
"		__global float *pixel = &channel_IMAGEPIPELINE[gid * 3];\n"
"		pixel[0] *= vWeight;\n"
"		pixel[1] *= vWeight;\n"
"		pixel[2] *= vWeight;\n"
"	}\n"
"}\n";
} }
