
#include <string>

namespace slg { namespace ocl {
std::string KernelSource_sampler_random_funcs =
"#line 2 \"sampler_random_funcs.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Random Sampler Kernel\n"
"//------------------------------------------------------------------------------\n"
"\n"
"#define RANDOMSAMPLER_TOTAL_U_SIZE 2\n"
"\n"
"OPENCL_FORCE_INLINE float RandomSampler_GetSample(\n"
"		__constant const GPUTaskConfiguration* restrict taskConfig,\n"
"		const uint index\n"
"		SAMPLER_PARAM_DECL) {\n"
"	const size_t gid = get_global_id(0);\n"
"	__global float *samplesData = &samplesDataBuff[gid * RANDOMSAMPLER_TOTAL_U_SIZE];\n"
"\n"
"	switch (index) {\n"
"		case IDX_SCREEN_X:\n"
"			return samplesData[IDX_SCREEN_X];\n"
"		case IDX_SCREEN_Y:\n"
"			return samplesData[IDX_SCREEN_Y];\n"
"		default:\n"
"			return Rnd_FloatValue(seed);\n"
"	}\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void RandomSampler_SplatSample(\n"
"		__constant const GPUTaskConfiguration* restrict taskConfig\n"
"		SAMPLER_PARAM_DECL\n"
"		FILM_PARAM_DECL\n"
"		) {\n"
"	const size_t gid = get_global_id(0);\n"
"	__global SampleResult *sampleResult = &sampleResultsBuff[gid];\n"
"\n"
"	Film_AddSample(sampleResult->pixelX, sampleResult->pixelY,\n"
"			sampleResult, 1.f\n"
"			FILM_PARAM);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void RandomSamplerSharedData_GetNewBucket(__global RandomSamplerSharedData *samplerSharedData,\n"
"		const uint bucketCount, uint *newBucketIndex) {\n"
"	*newBucketIndex = atomic_inc(&samplerSharedData->bucketIndex) % bucketCount;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void RandomSampler_InitNewSample(__constant const GPUTaskConfiguration* restrict taskConfig,\n"
"		__global float *filmNoise,\n"
"		__global float *filmUserImportance,\n"
"		const uint filmWidth, const uint filmHeight,\n"
"		const uint filmSubRegion0, const uint filmSubRegion1,\n"
"		const uint filmSubRegion2, const uint filmSubRegion3\n"
"		SAMPLER_PARAM_DECL) {\n"
"	const size_t gid = get_global_id(0);\n"
"	__constant const Sampler *sampler = &taskConfig->sampler;\n"
"	__global RandomSamplerSharedData *samplerSharedData = (__global RandomSamplerSharedData *)samplerSharedDataBuff;\n"
"	__global RandomSample *samples = (__global RandomSample *)samplesBuff;\n"
"	__global RandomSample *sample = &samples[gid];\n"
"	__global float *samplesData = &samplesDataBuff[gid * RANDOMSAMPLER_TOTAL_U_SIZE];\n"
"\n"
"	const uint bucketSize = sampler->sobol.bucketSize;\n"
"	const uint tileSize = sampler->sobol.tileSize;\n"
"	const uint superSampling = sampler->sobol.superSampling;\n"
"	const uint overlapping = sampler->sobol.overlapping;\n"
"	\n"
"	const uint subRegionWidth = filmSubRegion1 - filmSubRegion0 + 1;\n"
"	const uint subRegionHeight = filmSubRegion3 - filmSubRegion2 + 1;\n"
"\n"
"	const uint tiletWidthCount = (subRegionWidth + tileSize - 1) / tileSize;\n"
"	const uint tileHeightCount = (subRegionHeight + tileSize - 1) / tileSize;\n"
"\n"
"	const uint bucketCount = overlapping * (tiletWidthCount * tileSize * tileHeightCount * tileSize + bucketSize - 1) / bucketSize;\n"
"\n"
"	// Pick the pixel to render\n"
"\n"
"	uint bucketIndex = sample->bucketIndex;\n"
"	uint pixelOffset = sample->pixelOffset;\n"
"	uint passOffset = sample->passOffset;\n"
"\n"
"	for (;;) {\n"
"		passOffset++;\n"
"		if (passOffset >= superSampling) {\n"
"			pixelOffset++;\n"
"			passOffset = 0;\n"
"\n"
"			if (pixelOffset >= bucketSize) {\n"
"				// Ask for a new bucket\n"
"				RandomSamplerSharedData_GetNewBucket(samplerSharedData, bucketCount,\n"
"						&bucketIndex);\n"
"\n"
"				sample->bucketIndex = bucketIndex;\n"
"				pixelOffset = 0;\n"
"				passOffset = 0;\n"
"			}\n"
"		}\n"
"\n"
"		// Transform the bucket index in a pixel coordinate\n"
"\n"
"		const uint pixelBucketIndex = (bucketIndex / overlapping) * bucketSize + pixelOffset;\n"
"		const uint mortonCurveOffset = pixelBucketIndex % (tileSize * tileSize);\n"
"		const uint pixelTileIndex = pixelBucketIndex / (tileSize * tileSize);\n"
"\n"
"		const uint subRegionPixelX = (pixelTileIndex % tiletWidthCount) * tileSize + DecodeMorton2X(mortonCurveOffset);\n"
"		const uint subRegionPixelY = (pixelTileIndex / tiletWidthCount) * tileSize + DecodeMorton2Y(mortonCurveOffset);\n"
"		if ((subRegionPixelX >= subRegionWidth) || (subRegionPixelY >= subRegionHeight)) {\n"
"			// Skip the pixels out of the film sub region\n"
"			continue;\n"
"		}\n"
"\n"
"		const uint pixelX = filmSubRegion0 + subRegionPixelX;\n"
"		const uint pixelY = filmSubRegion2 + subRegionPixelY;\n"
"\n"
"		if (filmNoise) {\n"
"			const float adaptiveStrength = sampler->sobol.adaptiveStrength;\n"
"\n"
"			if (adaptiveStrength > 0.f) {\n"
"				// Pixels are sampled in accordance with how far from convergence they are\n"
"				const float noise = filmNoise[pixelX + pixelY * filmWidth];\n"
"\n"
"				// Factor user driven importance sampling too\n"
"				float threshold;\n"
"				if (filmUserImportance) {\n"
"					const float userImportance = filmUserImportance[pixelX + pixelY * filmWidth];\n"
"\n"
"					// Noise is initialized to INFINITY at start\n"
"					if (isinf(noise))\n"
"						threshold = userImportance;\n"
"					else\n"
"						threshold = (userImportance > 0.f) ? Lerp(sampler->sobol.adaptiveUserImportanceWeight, noise, userImportance) : 0.f;\n"
"				} else\n"
"					threshold = noise;\n"
"\n"
"				// The floor for the pixel importance is given by the adaptiveness strength\n"
"				threshold = fmax(threshold, 1.f - adaptiveStrength);\n"
"\n"
"				if (Rnd_FloatValue(seed) > threshold) {\n"
"					// Skip this pixel and try the next one\n"
"					continue;\n"
"				}\n"
"			}\n"
"		}\n"
"\n"
"		// Initialize IDX_SCREEN_X and IDX_SCREEN_Y sample\n"
"\n"
"		samplesData[IDX_SCREEN_X] = pixelX + Rnd_FloatValue(seed);\n"
"		samplesData[IDX_SCREEN_Y] = pixelY + Rnd_FloatValue(seed);\n"
"		break;\n"
"	}\n"
"	\n"
"	// Save the new values\n"
"	sample->pixelOffset = pixelOffset;\n"
"	sample->passOffset = passOffset;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void RandomSampler_NextSample(\n"
"		__constant const GPUTaskConfiguration* restrict taskConfig,\n"
"		__global float *filmNoise,\n"
"		__global float *filmUserImportance,\n"
"		const uint filmWidth, const uint filmHeight,\n"
"		const uint filmSubRegion0, const uint filmSubRegion1,\n"
"		const uint filmSubRegion2, const uint filmSubRegion3\n"
"		SAMPLER_PARAM_DECL) {\n"
"	RandomSampler_InitNewSample(taskConfig,\n"
"			filmNoise,\n"
"			filmUserImportance,\n"
"			filmWidth, filmHeight,\n"
"			filmSubRegion0, filmSubRegion1, filmSubRegion2, filmSubRegion3\n"
"			SAMPLER_PARAM);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE bool RandomSampler_Init(\n"
"		__constant const GPUTaskConfiguration* restrict taskConfig,\n"
"		__global float *filmNoise,\n"
"		__global float *filmUserImportance,\n"
"		const uint filmWidth, const uint filmHeight,\n"
"		const uint filmSubRegion0, const uint filmSubRegion1,\n"
"		const uint filmSubRegion2, const uint filmSubRegion3\n"
"		SAMPLER_PARAM_DECL) {\n"
"	const size_t gid = get_global_id(0);\n"
"	__constant const Sampler *sampler = &taskConfig->sampler;\n"
"	__global RandomSample *samples = (__global RandomSample *)samplesBuff;\n"
"	__global RandomSample *sample = &samples[gid];\n"
"\n"
"	const uint bucketSize = sampler->random.bucketSize;\n"
"	sample->pixelOffset = bucketSize * bucketSize;\n"
"	sample->passOffset = sampler->sobol.superSampling;\n"
"\n"
"	RandomSampler_NextSample(taskConfig,\n"
"			filmNoise,\n"
"			filmUserImportance,\n"
"			filmWidth, filmHeight,\n"
"			filmSubRegion0, filmSubRegion1, filmSubRegion2, filmSubRegion3\n"
"			SAMPLER_PARAM);\n"
"\n"
"	return true;\n"
"}\n";
} }
