
#include <string>

namespace slg { namespace ocl {
std::string KernelSource_sampler_tilepath_funcs =
"#line 2 \"sampler_tilepath_funcs.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// TilePath Sampler Kernel\n"
"//------------------------------------------------------------------------------\n"
"\n"
"#define TILEPATHSAMPLER_TOTAL_U_SIZE 2\n"
"\n"
"OPENCL_FORCE_INLINE __global const uint* restrict TilePathSampler_GetSobolDirectionsPtr(\n"
"		__global TilePathSamplerSharedData *samplerSharedData) {\n"
"	// Sobol directions array is appended at the end of slg::ocl::TilePathSamplerSharedData\n"
"	return (__global uint *)(\n"
"			(__global char *)samplerSharedData +\n"
"			sizeof(TilePathSamplerSharedData));\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float TilePathSampler_GetSample(\n"
"		__constant const GPUTaskConfiguration* restrict taskConfig,\n"
"		const uint index\n"
"		SAMPLER_PARAM_DECL) {\n"
"	const size_t gid = get_global_id(0);\n"
"	__global float *samplesData = &samplesDataBuff[gid * TILEPATHSAMPLER_TOTAL_U_SIZE];\n"
"\n"
"	switch (index) {\n"
"		case IDX_SCREEN_X:\n"
"			return samplesData[IDX_SCREEN_X];\n"
"		case IDX_SCREEN_Y:\n"
"			return samplesData[IDX_SCREEN_Y];\n"
"		default: {\n"
"#if defined(RENDER_ENGINE_RTPATHOCL)\n"
"			return Rnd_FloatValue(seed);\n"
"#else\n"
"			__global TilePathSamplerSharedData *samplerSharedData = (__global TilePathSamplerSharedData *)samplerSharedDataBuff;\n"
"			__global const uint* restrict sobolDirections = TilePathSampler_GetSobolDirectionsPtr(samplerSharedData);\n"
"\n"
"			__global TilePathSample *samples = (__global TilePathSample *)samplesBuff;\n"
"			__global TilePathSample *sample = &samples[gid];\n"
"\n"
"			return SobolSequence_GetSample(sobolDirections, sample->pass + SOBOL_STARTOFFSET,\n"
"					sample->rngPass, sample->rng0, sample->rng1, index);	\n"
"#endif\n"
"		}\n"
"	}\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void TilePathSampler_SplatSample(\n"
"		__constant const GPUTaskConfiguration* restrict taskConfig\n"
"		SAMPLER_PARAM_DECL\n"
"		FILM_PARAM_DECL\n"
"		) {\n"
"	const size_t gid = get_global_id(0);\n"
"	__global SampleResult *sampleResult = &sampleResultsBuff[gid];\n"
"\n"
"#if defined(RENDER_ENGINE_RTPATHOCL)\n"
"	__global TilePathSample *samples = (__global TilePathSample *)samplesBuff;\n"
"	__global TilePathSample *sample = &samples[gid];\n"
"\n"
"	// Check if I'm in preview phase\n"
"	if (sample->pass < taskConfig->renderEngine.rtpathocl.previewResolutionReductionStep) {\n"
"		// I have to copy the current pixel to fill the assigned square\n"
"		for (uint y = 0; y < taskConfig->renderEngine.rtpathocl.previewResolutionReduction; ++y) {\n"
"			for (uint x = 0; x < taskConfig->renderEngine.rtpathocl.previewResolutionReduction; ++x) {\n"
"				// The sample weight is very low so this value is rapidly replaced\n"
"				// during normal rendering\n"
"				const uint px = sampleResult->pixelX + x;\n"
"				const uint py = sampleResult->pixelY + y;\n"
"				// px and py are unsigned so there is no need to check if they are >= 0\n"
"				if ((px < filmWidth) && (py < filmHeight)) {\n"
"					Film_AddSample(px, py,\n"
"							sampleResult, .001f\n"
"							FILM_PARAM);\n"
"				}\n"
"			}\n"
"		}\n"
"	} else\n"
"#endif\n"
"		Film_AddSample(sampleResult->pixelX, sampleResult->pixelY,\n"
"				sampleResult, 1.f\n"
"				FILM_PARAM);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void TilePathSampler_NextSample(\n"
"		__constant const GPUTaskConfiguration* restrict taskConfig,\n"
"		__global float *filmNoise,\n"
"		__global float *filmUserImportance,\n"
"		const uint filmWidth, const uint filmHeight,\n"
"		const uint filmSubRegion0, const uint filmSubRegion1,\n"
"		const uint filmSubRegion2, const uint filmSubRegion3\n"
"		SAMPLER_PARAM_DECL) {\n"
"	// TilePathSampler_NextSample() is not used in TILEPATHSAMPLER\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE bool TilePathSampler_Init(\n"
"		__constant const GPUTaskConfiguration* restrict taskConfig,\n"
"		__global float *filmNoise,\n"
"		__global float *filmUserImportance,\n"
"		const uint filmWidth, const uint filmHeight,\n"
"		const uint filmSubRegion0, const uint filmSubRegion1,\n"
"		const uint filmSubRegion2, const uint filmSubRegion3\n"
"		SAMPLER_PARAM_DECL) {\n"
"	const size_t gid = get_global_id(0);\n"
"	__global TilePathSamplerSharedData *samplerSharedData = (__global TilePathSamplerSharedData *)samplerSharedDataBuff;\n"
"	__global TilePathSample *samples = (__global TilePathSample *)samplesBuff;\n"
"	__global TilePathSample *sample = &samples[gid];\n"
"	__global float *samplesData = &samplesDataBuff[gid * TILEPATHSAMPLER_TOTAL_U_SIZE];\n"
"\n"
"#if defined(RENDER_ENGINE_RTPATHOCL)\n"
"	// 1 thread for each pixel\n"
"\n"
"	uint pixelX, pixelY;\n"
"	if (samplerSharedData->tilePass < taskConfig->renderEngine.rtpathocl.previewResolutionReductionStep) {\n"
"		const uint samplesPerRow = filmWidth / taskConfig->renderEngine.rtpathocl.previewResolutionReduction;\n"
"		const uint subPixelX = gid % samplesPerRow;\n"
"		const uint subPixelY = gid / samplesPerRow;\n"
"\n"
"		pixelX = subPixelX * taskConfig->renderEngine.rtpathocl.previewResolutionReduction;\n"
"		pixelY = subPixelY * taskConfig->renderEngine.rtpathocl.previewResolutionReduction;\n"
"	} else {\n"
"		const uint samplesPerRow = filmWidth / taskConfig->renderEngine.rtpathocl.resolutionReduction;\n"
"		const uint subPixelX = gid % samplesPerRow;\n"
"		const uint subPixelY = gid / samplesPerRow;\n"
"\n"
"		pixelX = subPixelX * taskConfig->renderEngine.rtpathocl.resolutionReduction;\n"
"		pixelY = subPixelY * taskConfig->renderEngine.rtpathocl.resolutionReduction;\n"
"\n"
"		const uint pixelsCount = taskConfig->renderEngine.rtpathocl.resolutionReduction;\n"
"		const uint pixelsCount2 = pixelsCount * pixelsCount;\n"
"\n"
"		// Rendering according a Morton curve\n"
"		const uint pixelIndex = samplerSharedData->tilePass % pixelsCount2;\n"
"		const uint mortonX = DecodeMorton2X(pixelIndex);\n"
"		const uint mortonY = DecodeMorton2Y(pixelIndex);\n"
"\n"
"		pixelX += mortonX;\n"
"		pixelY += mortonY;\n"
"	}\n"
"\n"
"	if ((pixelX >= samplerSharedData->tileWidth) || (pixelY >= samplerSharedData->tileHeight))\n"
"		return false;\n"
"\n"
"	sample->pass = samplerSharedData->tilePass;\n"
"\n"
"	samplesData[IDX_SCREEN_X] = pixelX + Rnd_FloatValue(seed);\n"
"	samplesData[IDX_SCREEN_Y] = pixelY + Rnd_FloatValue(seed);\n"
"#else\n"
"	// aaSamples * aaSamples threads for each pixel\n"
"\n"
"	const uint aaSamples2 = Sqr(samplerSharedData->aaSamples);\n"
"\n"
"	if (gid >= filmWidth * filmHeight * aaSamples2)\n"
"		return false;\n"
"\n"
"	const uint pixelIndex = gid / aaSamples2;\n"
"\n"
"	const uint pixelX = pixelIndex % filmWidth;\n"
"	const uint pixelY = pixelIndex / filmWidth;\n"
"	if ((pixelX >= samplerSharedData->tileWidth) || (pixelY >= samplerSharedData->tileHeight))\n"
"		return false;\n"
"\n"
"	// Initialize rng0, rng1 and rngPass\n"
"	const uint pixelRngGenSeed = (samplerSharedData->tileStartX + pixelX + (samplerSharedData->tileStartY + pixelY) * samplerSharedData->cameraFilmWidth + 1) *\n"
"			(samplerSharedData->multipassIndexToRender + 1);\n"
"	Seed pixelSeed;\n"
"	Rnd_Init(pixelRngGenSeed, &pixelSeed);\n"
"\n"
"	sample->rngPass = Rnd_UintValue(&pixelSeed);\n"
"	sample->rng0 = Rnd_FloatValue(&pixelSeed);\n"
"	sample->rng1 = Rnd_FloatValue(&pixelSeed);\n"
"\n"
"	sample->pass = samplerSharedData->tilePass * aaSamples2 + gid % aaSamples2;\n"
"\n"
"	__global const uint* restrict sobolDirections = TilePathSampler_GetSobolDirectionsPtr(samplerSharedData);\n"
"\n"
"	samplesData[IDX_SCREEN_X] = pixelX + SobolSequence_GetSample(sobolDirections, sample->pass + SOBOL_STARTOFFSET,\n"
"			sample->rngPass, sample->rng0, sample->rng1, IDX_SCREEN_X);\n"
"	samplesData[IDX_SCREEN_Y] = pixelY + SobolSequence_GetSample(sobolDirections, sample->pass + SOBOL_STARTOFFSET,\n"
"			sample->rngPass, sample->rng0, sample->rng1, IDX_SCREEN_Y);\n"
"#endif\n"
"\n"
"	return true;\n"
"}\n";
} }
