
#include <string>

namespace slg { namespace ocl {
std::string KernelSource_sampler_types =
"#line 2 \"sampler_types.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Indices of Sample related u[] array\n"
"//------------------------------------------------------------------------------\n"
"\n"
"#if defined(SLG_OPENCL_KERNEL)\n"
"\n"
"#define IDX_SCREEN_X 0\n"
"#define IDX_SCREEN_Y 1\n"
"#define IDX_EYE_TIME 2\n"
"#define IDX_DOF_X 3\n"
"#define IDX_DOF_Y 4\n"
"#define IDX_BSDF_OFFSET 5\n"
"\n"
"// Relative to IDX_BSDF_OFFSET + PathDepth * VERTEX_SAMPLE_SIZE\n"
"#define IDX_PASSTHROUGH 0\n"
"#define IDX_BSDF_X 1\n"
"#define IDX_BSDF_Y 2\n"
"#define IDX_DIRECTLIGHT_X 3\n"
"#define IDX_DIRECTLIGHT_Y 4\n"
"#define IDX_DIRECTLIGHT_Z 5\n"
"#define IDX_DIRECTLIGHT_W 6\n"
"#define IDX_DIRECTLIGHT_A 7\n"
"#define IDX_RR 8\n"
"\n"
"#define VERTEX_SAMPLE_SIZE 9\n"
"\n"
"#endif\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Sample data types\n"
"//------------------------------------------------------------------------------\n"
"\n"
"typedef struct {\n"
"	unsigned int bucketIndex, pixelOffset, passOffset, pass;\n"
"} RandomSample;\n"
"\n"
"typedef struct {\n"
"	float totalI;\n"
"\n"
"	// Using ushort here totally freeze the ATI driver\n"
"	unsigned int largeMutationCount, smallMutationCount;\n"
"	unsigned int current, proposed, consecutiveRejects;\n"
"\n"
"	float weight;\n"
"\n"
"	SampleResult currentResult;\n"
"} MetropolisSample;\n"
"\n"
"typedef struct {\n"
"	unsigned int bucketIndex, pixelOffset, passOffset, pass;\n"
"\n"
"	Seed rngGeneratorSeed;\n"
"	unsigned int rngPass;\n"
"	float rng0, rng1;\n"
"} SobolSample;\n"
"\n"
"typedef struct {\n"
"	unsigned int rngPass;\n"
"	float rng0, rng1;\n"
"\n"
"	unsigned int pass;\n"
"} TilePathSample;\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Sampler shared data types\n"
"//------------------------------------------------------------------------------\n"
"\n"
"typedef struct {\n"
"	unsigned int bucketIndex;\n"
"} RandomSamplerSharedData;\n"
"\n"
"typedef struct {\n"
"	unsigned int seedBase;\n"
"	unsigned int bucketIndex;\n"
"\n"
"	// This is used to compute the size of appended data at the end\n"
"	// of SobolSamplerSharedData\n"
"	unsigned int filmRegionPixelCount;\n"
"\n"
"	// Plus the a pass field for each pixel\n"
"	// Plus Sobol directions array\n"
"} SobolSamplerSharedData;\n"
"\n"
"typedef struct {\n"
"	// cameraFilmWidth/cameraFilmHeight and filmWidth/filmHeight are usually\n"
"	// the same. They are different when doing tile rendering\n"
"	unsigned int cameraFilmWidth, cameraFilmHeight;\n"
"	unsigned int tileStartX, tileStartY;\n"
"	unsigned int tileWidth, tileHeight;\n"
"	unsigned int tilePass, aaSamples;\n"
"	unsigned int multipassIndexToRender;\n"
"\n"
"	// Plus Sobol directions array\n"
"} TilePathSamplerSharedData;\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Sampler data types\n"
"//------------------------------------------------------------------------------\n"
"\n"
"typedef enum {\n"
"	RANDOM = 0,\n"
"	METROPOLIS = 1,\n"
"	SOBOL = 2,\n"
"	TILEPATHSAMPLER = 3\n"
"} SamplerType;\n"
"\n"
"typedef struct {\n"
"	SamplerType type;\n"
"	union {\n"
"		struct {\n"
"			float adaptiveStrength, adaptiveUserImportanceWeight;\n"
"			unsigned int bucketSize, tileSize, superSampling, overlapping;\n"
"		} random;\n"
"		struct {\n"
"			float adaptiveStrength, adaptiveUserImportanceWeight;\n"
"			unsigned int bucketSize, tileSize, superSampling, overlapping;\n"
"		} sobol;\n"
"		struct {\n"
"			float largeMutationProbability, imageMutationRange;\n"
"			unsigned int maxRejects;\n"
"		} metropolis;\n"
"	};\n"
"} Sampler;\n"
"\n"
"#define SOBOL_BITS 32\n"
"#define SOBOL_MAX_DIMENSIONS 21201\n"
"#define SOBOL_STARTOFFSET 32\n"
"\n"
"#define SAMPLER_PARAM_DECL \\\n"
"		, Seed *seed \\\n"
"		, __global void *samplerSharedDataBuff \\\n"
"		, __global void *samplesBuff \\\n"
"		, __global float *samplesDataBuff \\\n"
"		, __global SampleResult *sampleResultsBuff\n"
"#define SAMPLER_PARAM \\\n"
"		, seed \\\n"
"		, samplerSharedDataBuff \\\n"
"		, samplesBuff \\\n"
"		, samplesDataBuff \\\n"
"		, sampleResultsBuff\n";
} }
