
#include <string>

namespace slg { namespace ocl {
std::string KernelSource_sampleresult_funcs =
"#line 2 \"sampleresult_funcs.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"OPENCL_FORCE_INLINE void SampleResult_ClearRadiance(__global SampleResult *sampleResult) {\n"
"	VSTORE3F(BLACK, sampleResult->radiancePerPixelNormalized[0].c);\n"
"	VSTORE3F(BLACK, sampleResult->radiancePerPixelNormalized[1].c);\n"
"	VSTORE3F(BLACK, sampleResult->radiancePerPixelNormalized[2].c);\n"
"	VSTORE3F(BLACK, sampleResult->radiancePerPixelNormalized[3].c);\n"
"	VSTORE3F(BLACK, sampleResult->radiancePerPixelNormalized[4].c);\n"
"	VSTORE3F(BLACK, sampleResult->radiancePerPixelNormalized[5].c);\n"
"	VSTORE3F(BLACK, sampleResult->radiancePerPixelNormalized[6].c);\n"
"	VSTORE3F(BLACK, sampleResult->radiancePerPixelNormalized[7].c);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void SampleResult_Init(__constant const Film* restrict film,\n"
"		__global SampleResult *sampleResult) {\n"
"	// Initialize only Spectrum fields\n"
"\n"
"	SampleResult_ClearRadiance(sampleResult);\n"
"\n"
"	VSTORE3F(BLACK, sampleResult->directDiffuse.c);\n"
"	VSTORE3F(BLACK, sampleResult->directDiffuseReflect.c);\n"
"	VSTORE3F(BLACK, sampleResult->directDiffuseTransmit.c);\n"
"	VSTORE3F(BLACK, sampleResult->directGlossy.c);\n"
"	VSTORE3F(BLACK, sampleResult->directGlossyReflect.c);\n"
"	VSTORE3F(BLACK, sampleResult->directGlossyTransmit.c);\n"
"	VSTORE3F(BLACK, sampleResult->emission.c);\n"
"	VSTORE3F(BLACK, sampleResult->indirectDiffuse.c);\n"
"	VSTORE3F(BLACK, sampleResult->indirectDiffuseReflect.c);\n"
"	VSTORE3F(BLACK, sampleResult->indirectDiffuseTransmit.c);\n"
"	VSTORE3F(BLACK, sampleResult->indirectGlossy.c);\n"
"	VSTORE3F(BLACK, sampleResult->indirectGlossyReflect.c);\n"
"	VSTORE3F(BLACK, sampleResult->indirectGlossyTransmit.c);\n"
"	VSTORE3F(BLACK, sampleResult->indirectSpecular.c);\n"
"	VSTORE3F(BLACK, sampleResult->indirectSpecularReflect.c);\n"
"	VSTORE3F(BLACK, sampleResult->indirectSpecularTransmit.c);\n"
"	sampleResult->rayCount = 0.f;\n"
"	VSTORE3F(BLACK, sampleResult->irradiance.c);\n"
"	VSTORE3F(BLACK, sampleResult->albedo.c);\n"
"\n"
"	sampleResult->firstPathVertexEvent = NONE;\n"
"	sampleResult->firstPathVertex = true;\n"
"	// sampleResult->lastPathVertex can not be really initialized here without knowing\n"
"	// the max. path depth.\n"
"	sampleResult->lastPathVertex = true;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void SampleResult_AddEmission(__constant const Film* restrict film,\n"
"		__global SampleResult *sampleResult, const uint lightID,\n"
"		const float3 pathThroughput, const float3 incomingRadiance) {\n"
"	const float3 radiance = pathThroughput * incomingRadiance;\n"
"\n"
"	// Avoid out of bound access if the light group doesn't exist. This can happen\n"
"	// with RT modes.\n"
"	const uint id = min(lightID, film->radianceGroupCount - 1u);\n"
"	VADD3F(sampleResult->radiancePerPixelNormalized[id].c, radiance);\n"
"\n"
"	if (sampleResult->firstPathVertex) {\n"
"		VADD3F(sampleResult->emission.c, radiance);\n"
"	} else {\n"
"		sampleResult->indirectShadowMask = 0.f;\n"
"\n"
"		const BSDFEvent firstPathVertexEvent = sampleResult->firstPathVertexEvent;\n"
"		if ((firstPathVertexEvent & (DIFFUSE | REFLECT)) == (DIFFUSE | REFLECT)) {\n"
"			VADD3F(sampleResult->indirectDiffuseReflect.c, radiance);\n"
"		} else if ((firstPathVertexEvent & (DIFFUSE | TRANSMIT)) == (DIFFUSE | TRANSMIT)) {\n"
"			VADD3F(sampleResult->indirectDiffuseTransmit.c, radiance);\n"
"		} else if ((firstPathVertexEvent & (GLOSSY | REFLECT)) == (GLOSSY | REFLECT)) {\n"
"			VADD3F(sampleResult->indirectGlossyReflect.c, radiance);\n"
"		} else if ((firstPathVertexEvent & (GLOSSY | TRANSMIT)) == (GLOSSY | TRANSMIT)) {\n"
"			VADD3F(sampleResult->indirectGlossyTransmit.c, radiance);\n"
"		} else if ((firstPathVertexEvent & (SPECULAR | REFLECT)) == (SPECULAR | REFLECT)) {\n"
"			VADD3F(sampleResult->indirectSpecularReflect.c, radiance);\n"
"		} else if ((firstPathVertexEvent & (SPECULAR | TRANSMIT)) == (SPECULAR | TRANSMIT)) {\n"
"			VADD3F(sampleResult->indirectSpecularTransmit.c, radiance);\n"
"		}\n"
"	}\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE void SampleResult_AddDirectLight(__constant const Film* restrict film,\n"
"		__global SampleResult *sampleResult, const uint lightID,\n"
"		const BSDFEvent bsdfEvent, const float3 pathThroughput, const float3 incomingRadiance,\n"
"		const float lightScale) {\n"
"	const float3 radiance = pathThroughput * incomingRadiance;\n"
"\n"
"	// Avoid out of bound access if the light group doesn't exist. This can happen\n"
"	// with RT modes.\n"
"	const uint id = min(lightID, film->radianceGroupCount - 1u);\n"
"	VADD3F(sampleResult->radiancePerPixelNormalized[id].c, radiance);\n"
"\n"
"	if (sampleResult->firstPathVertex) {\n"
"		sampleResult->directShadowMask = fmax(0.f, sampleResult->directShadowMask - lightScale);\n"
"\n"
"		if ((bsdfEvent & (DIFFUSE | REFLECT)) == (DIFFUSE | REFLECT)) {\n"
"			VADD3F(sampleResult->directDiffuseReflect.c, radiance);\n"
"		} else if ((bsdfEvent & (DIFFUSE | TRANSMIT)) == (DIFFUSE | TRANSMIT)) {\n"
"			VADD3F(sampleResult->directDiffuseTransmit.c, radiance);\n"
"		} else if ((bsdfEvent & (GLOSSY | REFLECT)) == (GLOSSY | REFLECT)) {\n"
"			VADD3F(sampleResult->directGlossyReflect.c, radiance);\n"
"		} else if ((bsdfEvent & (GLOSSY | TRANSMIT)) == (GLOSSY | TRANSMIT)) {\n"
"			VADD3F(sampleResult->directGlossyTransmit.c, radiance);\n"
"		}\n"
"	} else {\n"
"		sampleResult->indirectShadowMask = fmax(0.f, sampleResult->indirectShadowMask - lightScale);\n"
"\n"
"		const BSDFEvent firstPathVertexEvent = sampleResult->firstPathVertexEvent;\n"
"		if ((firstPathVertexEvent & (DIFFUSE | REFLECT)) == (DIFFUSE | REFLECT)) {\n"
"			VADD3F(sampleResult->indirectDiffuseReflect.c, radiance);\n"
"		} else if ((firstPathVertexEvent & (DIFFUSE | TRANSMIT)) == (DIFFUSE | TRANSMIT)) {\n"
"			VADD3F(sampleResult->indirectDiffuseTransmit.c, radiance);\n"
"		} else if ((firstPathVertexEvent & (GLOSSY | REFLECT)) == (GLOSSY | REFLECT)) {\n"
"			VADD3F(sampleResult->indirectGlossyReflect.c, radiance);\n"
"		} else if ((firstPathVertexEvent & (GLOSSY | TRANSMIT)) == (GLOSSY | TRANSMIT)) {\n"
"			VADD3F(sampleResult->indirectGlossyTransmit.c, radiance);\n"
"		} else if ((firstPathVertexEvent & (SPECULAR | REFLECT)) == (SPECULAR | REFLECT)) {\n"
"			VADD3F(sampleResult->indirectSpecularReflect.c, radiance);\n"
"		} else if ((firstPathVertexEvent & (SPECULAR | TRANSMIT)) == (SPECULAR | TRANSMIT)) {\n"
"			VADD3F(sampleResult->indirectSpecularTransmit.c, radiance);\n"
"		}\n"
"\n"
"		VADD3F(sampleResult->irradiance.c, VLOAD3F(sampleResult->irradiancePathThroughput.c) * incomingRadiance);\n"
"	}\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 SampleResult_GetSpectrum(__constant const Film* restrict film,\n"
"		__global SampleResult *sampleResult,\n"
"		float3 filmRadianceGroupScale[FILM_MAX_RADIANCE_GROUP_COUNT]) {\n"
"	float3 c = BLACK;\n"
"	for (uint i = 0; i < film->radianceGroupCount; ++i)\n"
"		c += VLOAD3F(sampleResult->radiancePerPixelNormalized[i].c) * filmRadianceGroupScale[i];\n"
"\n"
"	return c;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float SampleResult_GetRadianceY(__constant const Film* restrict film,\n"
"		__global SampleResult *sampleResult) {\n"
"	float y = 0.f;\n"
"	\n"
"	for (uint i = 0; i < film->radianceGroupCount; ++i)\n"
"		y += Spectrum_Y(VLOAD3F(sampleResult->radiancePerPixelNormalized[i].c));\n"
"\n"
"	return y;\n"
"}\n";
} }
