
#include <string>

namespace slg { namespace ocl {
std::string KernelSource_scene_types =
"#line 2 \"scene_types.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"// Note: keep aligned with the copy in scene.h\n"
"typedef enum {\n"
"	// Mandatory setting: one or the other must be used\n"
"	EYE_RAY = 1,\n"
"	LIGHT_RAY = 2,\n"
"\n"
"	// This is used to disable any type of ray switch\n"
"	GENERIC_RAY = 4,\n"
"	// For the very first eye ray\n"
"	CAMERA_RAY = 8,\n"
"	// For rays used for direct light sampling\n"
"	SHADOW_RAY = 16,\n"
"	// For rays used for indirect light sampling\n"
"	INDIRECT_RAY = 32\n"
"} SceneRayTypeType;\n"
"\n"
"// Note: keep aligned with the copy in scene.h\n"
"typedef int SceneRayType;\n"
"\n"
"typedef struct {\n"
"	unsigned int defaultVolumeIndex;\n"
"} Scene;\n"
"\n"
"#if defined(SLG_OPENCL_KERNEL)\n"
"\n"
"#define SCENE_PARAM_DECL , \\\n"
"		__constant const Scene* restrict scene, \\\n"
"		__global const SceneObject* restrict sceneObjs, \\\n"
"		__global const uint* restrict lightIndexOffsetByMeshIndex, \\\n"
"		__global const uint* restrict lightIndexByTriIndex \\\n"
"		EXTMESH_PARAM_DECL\n"
"#define SCENE_PARAM , \\\n"
"		scene, \\\n"
"		sceneObjs, \\\n"
"		lightIndexOffsetByMeshIndex, \\\n"
"		lightIndexByTriIndex \\\n"
"		EXTMESH_PARAM\n"
"\n"
"#endif\n";
} }
