
#include <string>

namespace slg { namespace ocl {
std::string KernelSource_texture_bilerp_funcs =
"#line 2 \"texture_bilerp_funcs.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Bilerp texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float BilerpTexture_ConstEvaluateFloat(__global const HitPoint *hitPoint,\n"
"		const float v00, const float v01, const float v10, const float v11) {\n"
"	float2 uv = VLOAD2F(&hitPoint->defaultUV.u);\n"
"	uv.x -= Floor2Int(uv.x);\n"
"	uv.y -= Floor2Int(uv.y);\n"
"\n"
"	return lerp(uv.x, lerp(uv.y, v00, v01), lerp(uv.y, v10, v11));\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 BilerpTexture_ConstEvaluateSpectrum(__global const HitPoint *hitPoint,\n"
"		const float3 v00, const float3 v01, const float3 v10, const float3 v11) {\n"
"	float2 uv = VLOAD2F(&hitPoint->defaultUV.u);\n"
"	uv.x -= Floor2Int(uv.x);\n"
"	uv.y -= Floor2Int(uv.y);\n"
"\n"
"	return lerp(uv.x, lerp(uv.y, v00, v01), lerp(uv.y, v10, v11));\n"
"}\n"
"\n";
} }
