
#include <string>

namespace slg { namespace ocl {
std::string KernelSource_texture_others_funcs =
"#line 2 \"texture_others_funcs.cl\"\n"
"\n"
"/***************************************************************************\n"
" * Copyright 1998-2020 by authors (see AUTHORS.txt)                        *\n"
" *                                                                         *\n"
" *   This file is part of LuxCoreRender.                                   *\n"
" *                                                                         *\n"
" * Licensed under the Apache License, Version 2.0 (the \"License\");         *\n"
" * you may not use this file except in compliance with the License.        *\n"
" * You may obtain a copy of the License at                                 *\n"
" *                                                                         *\n"
" *     http://www.apache.org/licenses/LICENSE-2.0                          *\n"
" *                                                                         *\n"
" * Unless required by applicable law or agreed to in writing, software     *\n"
" * distributed under the License is distributed on an \"AS IS\" BASIS,       *\n"
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.*\n"
" * See the License for the specific language governing permissions and     *\n"
" * limitations under the License.                                          *\n"
" ***************************************************************************/\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// ConstFloat texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float ConstFloatTexture_ConstEvaluateFloat(__global const Texture* restrict tex) {\n"
"	return tex->constFloat.value;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 ConstFloatTexture_ConstEvaluateSpectrum(__global const Texture* restrict tex) {\n"
"	return TO_FLOAT3(tex->constFloat.value);\n"
"}\n"
"\n"
"// Note: ConstTexture_Bump() is defined in texture_bump_funcs.cl\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// ConstFloat3 texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float ConstFloat3Texture_ConstEvaluateFloat(__global const Texture* restrict tex) {\n"
"	return Spectrum_Y(VLOAD3F(tex->constFloat3.color.c));\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 ConstFloat3Texture_ConstEvaluateSpectrum(__global const Texture* restrict tex) {\n"
"	return VLOAD3F(tex->constFloat3.color.c);\n"
"}\n"
"\n"
"// Note: ConstTexture_Bump() is defined in texture_bump_funcs.cl\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Scale texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float ScaleTexture_ConstEvaluateFloat(\n"
"		const float tex1, const float tex2) {\n"
"	return tex1 * tex2;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 ScaleTexture_ConstEvaluateSpectrum(\n"
"		const float3 tex1, const float3 tex2) {\n"
"	return tex1 * tex2;\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// FresnelApproxN & FresnelApproxK texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float FresnelApproxNTexture_ConstEvaluateFloat(const float value) {\n"
"	return FresnelApproxN(value);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 FresnelApproxNTexture_ConstEvaluateSpectrum(const float3 value) {\n"
"	return FresnelApproxN3(value);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float FresnelApproxKTexture_ConstEvaluateFloat(const float value) {\n"
"	return FresnelApproxK(value);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 FresnelApproxKTexture_ConstEvaluateSpectrum(const float3 value) {\n"
"	return FresnelApproxK3(value);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Mix texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float MixTexture_ConstEvaluateFloat(const float value1, const float value2,\n"
"		const float amt) {\n"
"	return mix(value1, value2, clamp(amt, 0.f, 1.f));\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 MixTexture_ConstEvaluateSpectrum(const float3 value1, const float3 value2,\n"
"		const float3 amt) {\n"
"	return mix(value1, value2, clamp(amt, 0.f, 1.f));\n"
"}\n"
"\n"
"// Note: MixTexture_Bump() is defined in texture_bump_funcs.cl\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Add texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float AddTexture_ConstEvaluateFloat(const float value1,\n"
"		const float value2) {\n"
"	return value1 + value2;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 AddTexture_ConstEvaluateSpectrum(const float3 value1,\n"
"		const float3 value2) {\n"
"	return value1 + value2;\n"
"}\n"
"\n"
"// Note: AddTexture_Bump() is defined in texture_bump_funcs.cl\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Subtract texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float SubtractTexture_ConstEvaluateFloat(const float value1,\n"
"		const float value2) {\n"
"	return value1 - value2;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 SubtractTexture_ConstEvaluateSpectrum(const float3 value1,\n"
"		const float3 value2) {\n"
"	return value1 - value2;\n"
"}\n"
"\n"
"// Note: SubtractTexture_Bump() is defined in texture_bump_funcs.cl\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// NormalMap texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float NormalMapTexture_ConstEvaluateFloat() {\n"
"    return 0.f;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 NormalMapTexture_ConstEvaluateSpectrum() {\n"
"	return BLACK;\n"
"}\n"
"\n"
"// Note: NormalMapTexture_Bump() is defined in texture_bump_funcs.cl\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// CheckerBoard 2D & 3D texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float CheckerBoard2DTexture_ConstEvaluateFloat(__global const HitPoint *hitPoint,\n"
"		const float value1, const float value2, __global const TextureMapping2D *mapping\n"
"		TEXTURES_PARAM_DECL) {\n"
"	const float2 mapUV = TextureMapping2D_Map(mapping, hitPoint TEXTURES_PARAM);\n"
"\n"
"	return ((Floor2Int(mapUV.x) + Floor2Int(mapUV.y)) % 2 == 0) ? value1 : value2;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 CheckerBoard2DTexture_ConstEvaluateSpectrum(__global const HitPoint *hitPoint,\n"
"		const float3 value1, const float3 value2, __global const TextureMapping2D *mapping\n"
"		TEXTURES_PARAM_DECL) {\n"
"	const float2 mapUV = TextureMapping2D_Map(mapping, hitPoint TEXTURES_PARAM);\n"
"\n"
"	return ((Floor2Int(mapUV.x) + Floor2Int(mapUV.y)) % 2 == 0) ? value1 : value2;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float CheckerBoard3DTexture_ConstEvaluateFloat(__global const HitPoint *hitPoint,\n"
"		const float value1, const float value2, __global const TextureMapping3D *mapping\n"
"		TEXTURES_PARAM_DECL) {\n"
"	// The +DEFAULT_EPSILON_STATIC is there as workaround for planes placed exactly on 0.0\n"
"	const float3 mapP = TextureMapping3D_Map(mapping, hitPoint, NULL TEXTURES_PARAM) +  DEFAULT_EPSILON_STATIC;\n"
"\n"
"	return ((Floor2Int(mapP.x) + Floor2Int(mapP.y) + Floor2Int(mapP.z)) % 2 == 0) ? value1 : value2;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 CheckerBoard3DTexture_ConstEvaluateSpectrum(__global const HitPoint *hitPoint,\n"
"		const float3 value1, const float3 value2, __global const TextureMapping3D *mapping\n"
"		TEXTURES_PARAM_DECL) {\n"
"	// The +DEFAULT_EPSILON_STATIC is there as workaround for planes placed exactly on 0.0\n"
"	const float3 mapP = TextureMapping3D_Map(mapping, hitPoint, NULL TEXTURES_PARAM) +  DEFAULT_EPSILON_STATIC;\n"
"\n"
"	return ((Floor2Int(mapP.x) + Floor2Int(mapP.y) + Floor2Int(mapP.z)) % 2 == 0) ? value1 : value2;\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Cloud texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float CloudTexture_CloudNoise(const float3 p, const float omegaValue, const uint octaves) {\n"
"	// Compute sum of octaves of noise\n"
"	float sum = 0.f, lambda = 1.f, o = 1.f;\n"
"	for (uint i = 0; i < octaves; ++i) {\n"
"		sum += o * Noise3(lambda * p);\n"
"		lambda *= 1.99f;\n"
"		o *= omegaValue;\n"
"	}\n"
"	return sum;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float CloudTexture_NoiseMask(const float3 p, const float radius, const float omega) {\n"
"	return CloudTexture_CloudNoise(p / radius * 1.4f, omega, 1);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 CloudTexture_Turbulence(const float3 p, const float noiseScale,\n"
"		const float noiseOffset, const float variability,\n"
"		const uint octaves, const float radius, const float omega,\n"
"		const float baseFlatness, const float3 sphereCentre) {\n"
"	float3 noiseCoords[3];\n"
"	const float baseFadeDistance = 1.f - baseFlatness;\n"
"\n"
"	noiseCoords[0] = p / noiseScale;\n"
"	noiseCoords[1] = noiseCoords[0] + MAKE_FLOAT3(noiseOffset, noiseOffset, noiseOffset);\n"
"	noiseCoords[2] = noiseCoords[1] + MAKE_FLOAT3(noiseOffset, noiseOffset, noiseOffset);\n"
"\n"
"	float noiseAmount = 1.f;\n"
"\n"
"	if (variability < 1.f)\n"
"		noiseAmount = Lerp(variability, 1.f, CloudTexture_NoiseMask(p + MAKE_FLOAT3(noiseOffset * 4.f, 0.f, 0.f), radius, omega));\n"
"\n"
"	noiseAmount = clamp(noiseAmount, 0.f, 1.f);\n"
"\n"
"	float3 turbulence;\n"
"\n"
"	turbulence.x = CloudTexture_CloudNoise(noiseCoords[0], omega, octaves) - 0.15f;\n"
"	turbulence.y = CloudTexture_CloudNoise(noiseCoords[1], omega, octaves) - 0.15f;\n"
"	turbulence.z = -CloudTexture_CloudNoise(noiseCoords[2], omega, octaves);\n"
"	if (p.z < sphereCentre.z + baseFadeDistance)\n"
"		turbulence.z *= (p.z - sphereCentre.z) / (2.f * baseFadeDistance);\n"
"\n"
"	turbulence *= noiseAmount;\n"
"\n"
"	return turbulence;\n"
"}\n"
"\n"
"OPENCL_FORCE_NOT_INLINE float CloudTexture_CloudShape(const float3 p, const float baseFadeDistance, const float3 sphereCentre, const uint numSpheres, const float radius) {\n"
"/*	if (numSpheres > 0) {\n"
"		if (SphereFunction(p, numSpheres))		//shows cumulus spheres\n"
"			return 1.f;\n"
"		else\n"
"			return 0.f;\n"
"	}\n"
"*/\n"
"	const float3 fromCentre = p - sphereCentre;\n"
"\n"
"	float amount = 1.f - sqrt(fromCentre.x*fromCentre.x + fromCentre.y*fromCentre.y + fromCentre.z*fromCentre.z) / radius;\n"
"	if (amount < 0.f)\n"
"		return 0.f;\n"
"\n"
"	// The base below the cloud's height fades out\n"
"	if (p.z < sphereCentre.z) {\n"
"		if (p.z < sphereCentre.z - radius * 0.4f)\n"
"			return 0.f;\n"
"\n"
"		amount *= 1.f - cos((fromCentre.z + baseFadeDistance) /\n"
"			baseFadeDistance * M_PI_F * 0.5f);\n"
"	}\n"
"	return max(amount, 0.f);\n"
"}\n"
"\n"
"/*\n"
"OPENCL_FORCE_INLINE bool CloudTexture_SphereFunction(const float3 p, uint numSpheres) const {\n"
"// Returns whether a point is inside one of the cumulus spheres\n"
"	for (uint i = 0; i < numSpheres; ++i) {\n"
"		if ((p - spheres[i].position).Length() < spheres[i].radius)\n"
"			return true;\n"
"	}\n"
"	return false;\n"
"}\n"
"*/\n"
"\n"
"OPENCL_FORCE_NOT_INLINE float CloudTexture_ConstEvaluateFloat(__global const HitPoint *hitPoint,\n"
"		const float radius, const uint numSpheres, const uint spheresize, const float sharpness,\n"
"		const float baseFadeDistance, const float baseFlatness, const float variability,\n"
"		const float omega, const float firstNoiseScale, const float noiseOffset, const float turbulenceAmount,\n"
"		const uint numOctaves, __global const TextureMapping3D *mapping\n"
"		TEXTURES_PARAM_DECL) {\n"
"	const float3 mapP = TextureMapping3D_Map(mapping, hitPoint, NULL TEXTURES_PARAM);\n"
"	const float3 sphereCentre = MAKE_FLOAT3(.5f, .5f, 1.f / 3.f);\n"
"	const float amount = CloudTexture_CloudShape(mapP + turbulenceAmount * CloudTexture_Turbulence(mapP, firstNoiseScale, noiseOffset, variability, numOctaves, radius, omega, baseFlatness, sphereCentre), baseFadeDistance, sphereCentre, numSpheres, radius);\n"
"	const float finalValue = pow(amount * pow(10.f, .7f), sharpness);\n"
"\n"
"	return fmin(finalValue, 1.f);\n"
"}\n"
"\n"
"OPENCL_FORCE_NOT_INLINE float3 CloudTexture_ConstEvaluateSpectrum(__global const HitPoint *hitPoint,\n"
"		const float radius, const uint numSpheres, const uint spheresize, const float sharpness,\n"
"		const float baseFadeDistance, const float baseFlatness, const float variability,\n"
"		const float omega, const float firstNoiseScale, const float noiseOffset, const float turbulenceAmount,\n"
"		const uint numOctaves, __global const TextureMapping3D *mapping\n"
"		TEXTURES_PARAM_DECL) {\n"
"\n"
"	const float3 mapP = TextureMapping3D_Map(mapping, hitPoint, NULL TEXTURES_PARAM);\n"
"	const float3 sphereCentre = MAKE_FLOAT3(.5f, .5f, 1.f / 3.f);\n"
"	const float amount = CloudTexture_CloudShape(mapP + turbulenceAmount * CloudTexture_Turbulence(mapP, firstNoiseScale, noiseOffset, variability, numOctaves, radius, omega, baseFlatness, sphereCentre), baseFadeDistance, sphereCentre, numSpheres, radius);\n"
"	const float finalValue = pow(amount * pow(10.f, .7f), sharpness);\n"
"\n"
"	return TO_FLOAT3(min(finalValue, 1.f));\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// FBM texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_NOT_INLINE float FBMTexture_ConstEvaluateFloat(__global const HitPoint *hitPoint,\n"
"	const float omega, const int octaves, __global const TextureMapping3D *mapping\n"
"	TEXTURES_PARAM_DECL) {\n"
"	const float3 mapP = TextureMapping3D_Map(mapping, hitPoint, NULL TEXTURES_PARAM);\n"
"\n"
"	return FBm(mapP, omega, octaves);\n"
"}\n"
"\n"
"OPENCL_FORCE_NOT_INLINE float3 FBMTexture_ConstEvaluateSpectrum(__global const HitPoint *hitPoint,\n"
"	const float omega, const int octaves, __global const TextureMapping3D *mapping\n"
"	TEXTURES_PARAM_DECL) {\n"
"	const float3 mapP = TextureMapping3D_Map(mapping, hitPoint, NULL TEXTURES_PARAM);\n"
"\n"
"	return TO_FLOAT3(FBm(mapP, omega, octaves));\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Marble texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"// Evaluate marble spline at _t_\n"
"__constant float MarbleTexture_c[9][3] = {\n"
"	{ .58f, .58f, .6f},\n"
"	{ .58f, .58f, .6f},\n"
"	{ .58f, .58f, .6f},\n"
"	{ .5f, .5f, .5f},\n"
"	{ .6f, .59f, .58f},\n"
"	{ .58f, .58f, .6f},\n"
"	{ .58f, .58f, .6f},\n"
"	{.2f, .2f, .33f},\n"
"	{ .58f, .58f, .6f}\n"
"};\n"
"\n"
"OPENCL_FORCE_NOT_INLINE float3 MarbleTexture_Evaluate(__global const HitPoint *hitPoint, const float scale,\n"
"		const float omega, const int octaves, const float variation,\n"
"		__global const TextureMapping3D *mapping\n"
"		TEXTURES_PARAM_DECL) {\n"
"	const float3 P = scale * TextureMapping3D_Map(mapping, hitPoint, NULL TEXTURES_PARAM);\n"
"\n"
"	float marble = P.y + variation * FBm(P, omega, octaves);\n"
"	float t = .5f + .5f * sin(marble);\n"
"#define NC  sizeof(MarbleTexture_c) / sizeof(MarbleTexture_c[0])\n"
"#define NSEG (NC-3)\n"
"	const int first = Floor2Int(t * NSEG);\n"
"	t = (t * NSEG - first);\n"
"#undef NC\n"
"#undef NSEG\n"
"#define ASSIGN_CF3(a) MAKE_FLOAT3(a[0], a[1], a[2])\n"
"	const float3 c0 = ASSIGN_CF3(MarbleTexture_c[first]);\n"
"	const float3 c1 = ASSIGN_CF3(MarbleTexture_c[first + 1]);\n"
"	const float3 c2 = ASSIGN_CF3(MarbleTexture_c[first + 2]);\n"
"	const float3 c3 = ASSIGN_CF3(MarbleTexture_c[first + 3]);\n"
"#undef ASSIGN_CF3\n"
"	// Bezier spline evaluated with de Castilejau's algorithm\n"
"	float3 s0 = mix(c0, c1, t);\n"
"	float3 s1 = mix(c1, c2, t);\n"
"	float3 s2 = mix(c2, c3, t);\n"
"	s0 = mix(s0, s1, t);\n"
"	s1 = mix(s1, s2, t);\n"
"	// Extra scale of 1.5 to increase variation among colors\n"
"	return 1.5f * mix(s0, s1, t);\n"
"}\n"
"\n"
"OPENCL_FORCE_NOT_INLINE float MarbleTexture_ConstEvaluateFloat(__global const HitPoint *hitPoint,\n"
"		const float scale, const float omega, const int octaves, const float variation,\n"
"		__global const TextureMapping3D *mapping\n"
"		TEXTURES_PARAM_DECL) {\n"
"	return Spectrum_Y(MarbleTexture_Evaluate(hitPoint, scale, omega, octaves,\n"
"			variation, mapping\n"
"			TEXTURES_PARAM));\n"
"}\n"
"\n"
"OPENCL_FORCE_NOT_INLINE float3 MarbleTexture_ConstEvaluateSpectrum(__global const HitPoint *hitPoint,\n"
"		const float scale, const float omega, const int octaves, const float variation,\n"
"		__global const TextureMapping3D *mapping\n"
"		TEXTURES_PARAM_DECL) {\n"
"	return MarbleTexture_Evaluate(hitPoint, scale, omega, octaves,\n"
"			variation, mapping\n"
"			TEXTURES_PARAM);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Dots texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_NOT_INLINE bool DotsTexture_Evaluate(__global const HitPoint *hitPoint,\n"
"		__global const TextureMapping2D *mapping TEXTURES_PARAM_DECL) {\n"
"	const float2 uv = TextureMapping2D_Map(mapping, hitPoint TEXTURES_PARAM);\n"
"\n"
"	const int sCell = Floor2Int(uv.x + .5f);\n"
"	const int tCell = Floor2Int(uv.y + .5f);\n"
"	// Return _insideDot_ result if point is inside dot\n"
"	if (Noise(sCell + .5f, tCell + .5f, .5f) > 0.f) {\n"
"		const float radius = .35f;\n"
"		const float maxShift = 0.5f - radius;\n"
"		const float sCenter = sCell + maxShift *\n"
"			Noise(sCell + 1.5f, tCell + 2.8f, .5f);\n"
"		const float tCenter = tCell + maxShift *\n"
"			Noise(sCell + 4.5f, tCell + 9.8f, .5f);\n"
"		const float ds = uv.x - sCenter, dt = uv.y - tCenter;\n"
"		if (ds * ds + dt * dt < radius * radius)\n"
"			return true;\n"
"	}\n"
"\n"
"	return false;\n"
"}\n"
"\n"
"OPENCL_FORCE_NOT_INLINE float DotsTexture_ConstEvaluateFloat(__global const HitPoint *hitPoint,\n"
"		const float value1, const float value2, __global const TextureMapping2D *mapping\n"
"		TEXTURES_PARAM_DECL) {\n"
"	return DotsTexture_Evaluate(hitPoint, mapping TEXTURES_PARAM) ? value1 : value2;\n"
"}\n"
"\n"
"OPENCL_FORCE_NOT_INLINE float3 DotsTexture_ConstEvaluateSpectrum(__global const HitPoint *hitPoint,\n"
"		const float3 value1, const float3 value2, __global const TextureMapping2D *mapping\n"
"		TEXTURES_PARAM_DECL) {\n"
"	return DotsTexture_Evaluate(hitPoint, mapping TEXTURES_PARAM) ? value1 : value2;\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Windy texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_NOT_INLINE float WindyTexture_ConstEvaluateFloat(__global const HitPoint *hitPoint,\n"
"		__global const TextureMapping3D *mapping TEXTURES_PARAM_DECL) {\n"
"	const float3 mapP = TextureMapping3D_Map(mapping, hitPoint, NULL TEXTURES_PARAM);\n"
"\n"
"	const float windStrength = FBm(.1f * mapP, .5f, 3);\n"
"	const float waveHeight = FBm(mapP, .5f, 6);\n"
"\n"
"	return fabs(windStrength) * waveHeight;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 WindyTexture_ConstEvaluateSpectrum(__global const HitPoint *hitPoint,\n"
"		__global const TextureMapping3D *mapping TEXTURES_PARAM_DECL) {\n"
"	return TO_FLOAT3(WindyTexture_ConstEvaluateFloat(hitPoint, mapping TEXTURES_PARAM));\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Wrinkled texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_NOT_INLINE float WrinkledTexture_ConstEvaluateFloat(__global const HitPoint *hitPoint,\n"
"		const float omega, const int octaves,\n"
"		__global const TextureMapping3D *mapping TEXTURES_PARAM_DECL) {\n"
"	const float3 mapP = TextureMapping3D_Map(mapping, hitPoint, NULL TEXTURES_PARAM);\n"
"\n"
"	return Turbulence(mapP, omega, octaves);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 WrinkledTexture_ConstEvaluateSpectrum(__global const HitPoint *hitPoint,\n"
"		const float omega, const int octaves,\n"
"		__global const TextureMapping3D *mapping\n"
"		TEXTURES_PARAM_DECL) {\n"
"	return TO_FLOAT3(WrinkledTexture_ConstEvaluateFloat(hitPoint, omega, octaves, mapping TEXTURES_PARAM));\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// UV texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float UVTexture_ConstEvaluateFloat(__global const HitPoint *hitPoint,\n"
"		__global const TextureMapping2D *mapping TEXTURES_PARAM_DECL) {\n"
"	const float2 uv = TextureMapping2D_Map(mapping, hitPoint TEXTURES_PARAM);\n"
"\n"
"	return Spectrum_Y(MAKE_FLOAT3(uv.x - Floor2Int(uv.x), uv.y - Floor2Int(uv.y), 0.f));\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 UVTexture_ConstEvaluateSpectrum(__global const HitPoint *hitPoint,\n"
"		__global const TextureMapping2D *mapping TEXTURES_PARAM_DECL) {\n"
"	const float2 uv = TextureMapping2D_Map(mapping, hitPoint TEXTURES_PARAM);\n"
"\n"
"	return MAKE_FLOAT3(uv.x - Floor2Int(uv.x), uv.y - Floor2Int(uv.y), 0.f);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Band texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_NOT_INLINE float3 BandTexture_ConstEvaluateSpectrum(__global const HitPoint *hitPoint,\n"
"		const InterpolationType interpType,\n"
"		const uint size, __global const float *offsets,\n"
"		__global const Spectrum *values, const float amt) {\n"
"	const float a = clamp(amt, 0.f, 1.f);\n"
"\n"
"	const uint last = size - 1;\n"
"	if (a < offsets[0])\n"
"		return VLOAD3F(values[0].c);\n"
"	else if (a >= offsets[last])\n"
"		return VLOAD3F(values[last].c);\n"
"	else {\n"
"		int p = 0;\n"
"		for (; p <= last; ++p) {\n"
"			if (a < offsets[p])\n"
"				break;\n"
"		}\n"
"\n"
"		const float o1 = offsets[p - 1];\n"
"		const float o0 = offsets[p];\n"
"		const float factor = (a - o1) / (o0 - o1);\n"
"\n"
"		if (interpType == INTERP_NONE)\n"
"			return VLOAD3F(values[p - 1].c);\n"
"		else if (interpType == INTERP_LINEAR) {\n"
"			const float3 p0 = VLOAD3F(values[p - 1].c);\n"
"			const float3 p1 = VLOAD3F(values[p].c);\n"
"\n"
"			return Lerp3(factor, p0, p1);\n"
"		} else if (interpType == INTERP_CUBIC) {\n"
"			const float3 p0 = VLOAD3F(values[max(p - 2, 0)].c);\n"
"			const float3 p1 = VLOAD3F(values[p - 1].c);\n"
"			const float3 p2 = VLOAD3F(values[p].c);\n"
"			const float3 p3 = VLOAD3F(values[min(p + 1, (int)last)].c);\n"
"\n"
"			return Cerp3(factor, p0, p1, p2, p3);\n"
"		} else\n"
"			return BLACK;\n"
"	}\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float BandTexture_ConstEvaluateFloat(__global const HitPoint *hitPoint,\n"
"		const InterpolationType interpType,\n"
"		const uint size, __global const float *offsets,\n"
"		__global const Spectrum *values, const float amt) {\n"
"	return Spectrum_Y(BandTexture_ConstEvaluateSpectrum(hitPoint,\n"
"			interpType, size, offsets, values, amt));\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// WireFrame texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float TriangleHeight(const float a, const float b, const float c) {\n"
"	// Heron's formula for triangle area\n"
"	const float s = (a + b + c) * .5f;\n"
"	const float area = sqrt(s * (s - a) * (s - b) * (s - c));\n"
"\n"
"	// h = (A / a) * 2\n"
"	return (area / a) * 2.f;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE bool WireFrameTexture_Evaluate(__global const HitPoint *hitPoint,\n"
"		const float width\n"
"		TEXTURES_PARAM_DECL) {\n"
"	const uint meshIndex = hitPoint->meshIndex;\n"
"	if (meshIndex == NULL_INDEX)\n"
"		return false;\n"
"	\n"
"	__global const ExtMesh* restrict meshDesc = &meshDescs[meshIndex];\n"
"	__global const Point* restrict iVertices = &vertices[meshDesc->vertsOffset];\n"
"	__global const Triangle* restrict iTriangles = &triangles[meshDesc->trisOffset];\n"
"\n"
"	const uint triIndex = hitPoint->triangleIndex;\n"
"	__global const Triangle* restrict tri = &iTriangles[triIndex];\n"
"	const uint vi0 = tri->v[0];\n"
"	const uint vi1 = tri->v[1];\n"
"	const uint vi2 = tri->v[2];\n"
"	\n"
"	float3 v0 = VLOAD3F(&iVertices[vi0].x);\n"
"	float3 v1 = VLOAD3F(&iVertices[vi1].x);\n"
"	float3 v2 = VLOAD3F(&iVertices[vi2].x);\n"
"	if (meshDesc->type != TYPE_EXT_TRIANGLE) {\n"
"		// Transform to global coordinates\n"
"		v0 = Transform_ApplyPoint(&hitPoint->localToWorld, v0);\n"
"		v1 = Transform_ApplyPoint(&hitPoint->localToWorld, v1);\n"
"		v2 = Transform_ApplyPoint(&hitPoint->localToWorld, v2);\n"
"	}\n"
"	\n"
"	const float e0 = length(v1 - v0);\n"
"	const float e1 = length(v2 - v1);\n"
"	const float e2 = length(v0 - v2);\n"
"\n"
"	const float3 p = VLOAD3F(&hitPoint->p.x);\n"
"	const float b0 = length(p - v0);\n"
"	const float b1 = length(p - v1);\n"
"	const float b2 = length(p - v2);\n"
"\n"
"	const float dist0 = TriangleHeight(e0, b1, b0);\n"
"	if ((dist0 < width) && ((meshDesc->triAOVOffset[0] == NULL_INDEX) || (ExtMesh_GetTriAOV(meshIndex, triIndex, 0 EXTMESH_PARAM) > 0.f)))\n"
"		return true;\n"
"\n"
"	const float dist1 = TriangleHeight(e1, b2, b1);\n"
"	if ((dist1 < width) && ((meshDesc->triAOVOffset[1] == NULL_INDEX) || (ExtMesh_GetTriAOV(meshIndex, triIndex, 1 EXTMESH_PARAM) > 0.f)))\n"
"		return true;\n"
"\n"
"	const float dist2 = TriangleHeight(e2, b0, b2);\n"
"	if ((dist2 < width) && ((meshDesc->triAOVOffset[2] == NULL_INDEX) || (ExtMesh_GetTriAOV(meshIndex, triIndex, 2 EXTMESH_PARAM) > 0.f)))\n"
"		return true;\n"
"\n"
"	return false;\n"
"}\n"
"\n"
"OPENCL_FORCE_NOT_INLINE float WireFrameTexture_ConstEvaluateFloat(__global const HitPoint *hitPoint,\n"
"		const float width, const float value1, const float value2\n"
"		TEXTURES_PARAM_DECL) {\n"
"	return WireFrameTexture_Evaluate(hitPoint, width TEXTURES_PARAM) ? value1 : value2;\n"
"}\n"
"\n"
"OPENCL_FORCE_NOT_INLINE float3 WireFrameTexture_ConstEvaluateSpectrum(__global const HitPoint *hitPoint,\n"
"		const float width, const float3 value1, const float3 value2\n"
"		TEXTURES_PARAM_DECL) {\n"
"	return WireFrameTexture_Evaluate(hitPoint, width TEXTURES_PARAM) ? value1 : value2;\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Divide texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float DivideTexture_ConstEvaluateFloat(const float tex1, const float tex2) {\n"
"	if (tex2 == 0.f)\n"
"		return 0.f;\n"
"	return tex1 / tex2;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 DivideTexture_ConstEvaluateSpectrum(const float3 tex1, const float3 tex2) {\n"
"	if (Spectrum_IsBlack(tex2))\n"
"		return BLACK;\n"
"	return tex1 / tex2;\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Remap texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float RemapTexture_Remap(const float value,\n"
"		const float sourceMin, const float sourceMax,\n"
"		const float targetMin, const float targetMax) {\n"
"	if (sourceMin == sourceMax)\n"
"		return sourceMin;\n"
"\n"
"	return (value - sourceMin)\n"
"	       * (targetMax - targetMin)\n"
"	       / (sourceMax - sourceMin)\n"
"	       + targetMin;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float RemapTexture_ConstEvaluateFloat(\n"
"		const float value, const float sourceMin, const float sourceMax,\n"
"		const float targetMin, const float targetMax) {\n"
"	const float clampedValue = clamp(value, sourceMin, sourceMax);\n"
"	const float result = RemapTexture_Remap(clampedValue, sourceMin, sourceMax, targetMin, targetMax);\n"
"	return clamp(result, targetMin, targetMax);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 RemapTexture_ConstEvaluateSpectrum(\n"
"		const float3 value, const float sourceMin, const float sourceMax,\n"
"		const float targetMin, const float targetMax) {\n"
"	const float3 clampedValue = clamp(value, sourceMin, sourceMax);\n"
"	float3 result;\n"
"	result.x = RemapTexture_Remap(clampedValue.x, sourceMin, sourceMax, targetMin, targetMax);\n"
"	result.y = RemapTexture_Remap(clampedValue.y, sourceMin, sourceMax, targetMin, targetMax);\n"
"	result.z = RemapTexture_Remap(clampedValue.z, sourceMin, sourceMax, targetMin, targetMax);\n"
"	return clamp(result, targetMin, targetMax);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// ObjectID texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float ObjectIDTexture_ConstEvaluateFloat(__global const HitPoint *hitPoint) {\n"
"	return (float)hitPoint->objectID;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 ObjectIDTexture_ConstEvaluateSpectrum(__global const HitPoint *hitPoint) {\n"
"	const float id = hitPoint->objectID;\n"
"	return MAKE_FLOAT3(id, id, id);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// ObjectIDColor texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float3 ObjectIDColorTexture_IDToSpectrum(const uint id) {\n"
"	return MAKE_FLOAT3((id & 0x0000ffu) * ( 1.f / 255.f),\n"
"	                ((id & 0x00ff00u) >> 8) * ( 1.f / 255.f),\n"
"	                ((id & 0xff0000u) >> 16) * ( 1.f / 255.f));\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float ObjectIDColorTexture_ConstEvaluateFloat(__global const HitPoint *hitPoint) {\n"
"	return Spectrum_Y(ObjectIDColorTexture_IDToSpectrum(hitPoint->objectID));\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 ObjectIDColorTexture_ConstEvaluateSpectrum(__global const HitPoint *hitPoint) {\n"
"	return ObjectIDColorTexture_IDToSpectrum(hitPoint->objectID);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// ObjectIDNormalized texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float ObjectIDNormalizedTexture_ConstEvaluateFloat(__global const HitPoint *hitPoint) {\n"
"	return ((float)hitPoint->objectID) * (1.f / 0xffffffffu);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 ObjectIDNormalizedTexture_ConstEvaluateSpectrum(__global const HitPoint *hitPoint) {\n"
"	const float normalized = ((float)hitPoint->objectID) * (1.f / 0xffffffffu);\n"
"	return MAKE_FLOAT3(normalized, normalized, normalized);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// DotProduct texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float DotProductTexture_ConstEvaluateFloat(const float3 tex1,\n"
"		const float3 tex2) {\n"
"	return dot(tex1, tex2);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 DotProductTexture_ConstEvaluateSpectrum(const float3 tex1,\n"
"		const float3 tex2) {\n"
"	const float result = dot(tex1, tex2);\n"
"	return MAKE_FLOAT3(result, result, result);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Greater Than texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float GreaterThanTexture_ConstEvaluateFloat(const float tex1,\n"
"		const float tex2) {\n"
"	return (tex1 > tex2) ? 1.f : 0.f;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 GreaterThanTexture_ConstEvaluateSpectrum(const float tex1,\n"
"		const float tex2) {\n"
"	const float result = (tex1 > tex2) ? 1.f : 0.f;\n"
"	return MAKE_FLOAT3(result, result, result);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Less Than texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float LessThanTexture_ConstEvaluateFloat(const float tex1,\n"
"		const float tex2) {\n"
"	return (tex1 < tex2) ? 1.f : 0.f;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 LessThanTexture_ConstEvaluateSpectrum(const float tex1,\n"
"		const float tex2) {\n"
"	const float result = (tex1 < tex2) ? 1.f : 0.f;\n"
"	return MAKE_FLOAT3(result, result, result);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Power texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float PowerTexture_SafePow(const float base, const float exponent) {\n"
"	if (base < 0.f && exponent != ((int)exponent))\n"
"		return 0.f;\n"
"	return pow(base, exponent);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float PowerTexture_ConstEvaluateFloat(const float base,\n"
"		const float exponent) {\n"
"	return PowerTexture_SafePow(base, exponent);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 PowerTexture_ConstEvaluateSpectrum(const float base,\n"
"		const float exponent) {\n"
"	const float result = PowerTexture_SafePow(base, exponent);\n"
"	return MAKE_FLOAT3(result, result, result);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Position texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float PositionTexture_ConstEvaluateFloat(__global const HitPoint *hitPoint) {\n"
"	// This method doesn't really make sense for a vector - just return the first element\n"
"	return hitPoint->p.x;\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 PositionTexture_ConstEvaluateSpectrum(__global const HitPoint *hitPoint) {\n"
"	return MAKE_FLOAT3(hitPoint->p.x, hitPoint->p.y, hitPoint->p.z);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Split float3 texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float SplitFloat3Texture_ConstEvaluateFloat(const float3 tex,\n"
"		const uint channel) {\n"
"	switch (channel) {\n"
"		case 0:\n"
"			return tex.x;\n"
"		case 1:\n"
"			return tex.y;\n"
"		case 2:\n"
"			return tex.z;\n"
"		default:\n"
"			return 0.f;\n"
"	}\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 SplitFloat3Texture_ConstEvaluateSpectrum(const float3 tex,\n"
"		const uint channel) {\n"
"	float result;\n"
"	switch (channel) {\n"
"		case 0:\n"
"			result = tex.x;\n"
"			break;\n"
"		case 1:\n"
"			result = tex.y;\n"
"			break;\n"
"		case 2:\n"
"			result = tex.z;\n"
"			break;\n"
"		default:\n"
"			result = 0.f;\n"
"			break;\n"
"	}\n"
"\n"
"	return MAKE_FLOAT3 (result, result, result);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Make float3 texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float MakeFloat3Texture_ConstEvaluateFloat(const float tex1,\n"
"		const float tex2, const float tex3) {\n"
"	return Spectrum_Y(MAKE_FLOAT3(tex1, tex2, tex3));\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 MakeFloat3Texture_ConstEvaluateSpectrum(const float tex1,\n"
"		const float tex2, const float tex3) {\n"
"	return MAKE_FLOAT3(tex1, tex2, tex3);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Rounding texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float RoundingTexture_ConstEvaluateFloat(const float tex1, const float tex2) {\n"
"    if(tex1 == tex2 || tex2 == 0) {\n"
"        return tex1;\n"
"    } else {\n"
"        const float innerBound = tex2 * (int) (tex1 / tex2);\n"
"        const float outerBound = (tex1 < 0 ? innerBound - tex2 : innerBound + tex2);\n"
"        return fabs(outerBound - tex1) < fabs(innerBound - tex1) ?\n"
"            outerBound : innerBound;\n"
"    }\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 RoundingTexture_ConstEvaluateSpectrum(const float tex1, const float tex2) {\n"
"    const float result = RoundingTexture_ConstEvaluateFloat(tex1, tex2);\n"
"    return MAKE_FLOAT3(result, result, result);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Modulo texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float ModuloTexture_ConstEvaluateFloat(const float tex1, const float tex2) {\n"
"    if(tex2 == 0) {\n"
"        return 0.f;\n"
"    }\n"
"\n"
"    return fmod(tex1, tex2);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 ModuloTexture_ConstEvaluateSpectrum(const float tex1, const float tex2) {\n"
"    const float result = ModuloTexture_ConstEvaluateFloat(tex1, tex2);\n"
"    return MAKE_FLOAT3(result, result, result);\n"
"}\n"
"\n"
"//------------------------------------------------------------------------------\n"
"// Brightness/Contrast texture\n"
"//------------------------------------------------------------------------------\n"
"\n"
"OPENCL_FORCE_INLINE float BrightContrastTexture_ConstEvaluateFloat(const float tex,\n"
"		const float brightnessTex, const float contrastTex) {\n"
"	const float a = 1.f + contrastTex;\n"
"	const float b = brightnessTex - contrastTex * 0.5f;\n"
"\n"
"	return clamp(tex * a + b, 0.f, INFINITY);\n"
"}\n"
"\n"
"OPENCL_FORCE_INLINE float3 BrightContrastTexture_ConstEvaluateSpectrum(const float3 tex,\n"
"		const float brightnessTex, const float contrastTex) {\n"
"    const float a = 1.f + contrastTex;\n"
"	const float b = brightnessTex - contrastTex * 0.5f;\n"
"\n"
"	return clamp(tex * a + b, 0.f, INFINITY);\n"
"}\n";
} }
